#define VC_STL 1

#include <windows.h>
#include <initguid.h>
#include <setupapi.h>
#include <cfgmgr32.h>
#include <stdio.h>
#if !defined(VC_STL)
#include <OBASIC_list>
using namespace OBASIC_std;
#else
#include <list>
using namespace std;
#endif

#define	SPDRP_DEVICEDESC 0x00000000
#define	SPDRP_HARDWAREID 0x00000001
#define	SPDRP_COMPATIBLEIDS 0x00000002
#define	SPDRP_UNUSED0 0x00000003
#define	SPDRP_SERVICE 0x00000004
#define	SPDRP_UNUSED1 0x00000005
#define	SPDRP_UNUSED2 0x00000006
#define	SPDRP_CLASS 0x00000007
#define	SPDRP_CLASSGUID 0x00000008
#define	SPDRP_DRIVER 0x00000009
#define	SPDRP_CONFIGFLAGS 0x0000000A
#define	SPDRP_MFG 0x0000000B
#define	SPDRP_FRIENDLYNAME 0x0000000C
#define	SPDRP_LOCATION_INFORMATION 0x0000000D
#define	SPDRP_PHYSICAL_DEVICE_OBJECT_NAME 0x0000000E
#define	SPDRP_CAPABILITIES 0x0000000F
#define	SPDRP_UI_NUMBER 0x00000010
#define	SPDRP_UPPERFILTERS 0x00000011
#define	SPDRP_LOWERFILTERS 0x00000012
#define	SPDRP_BUSTYPEGUID 0x00000013
#define	SPDRP_LEGACYBUSTYPE 0x00000014
#define	SPDRP_BUSNUMBER 0x00000015
#define	SPDRP_ENUMERATOR_NAME 0x00000016
#define	SPDRP_SECURITY x00000017
#define	SPDRP_SECURITY_SDS 0x00000018
#define	SPDRP_DEVTYPE 0x00000019
#define	SPDRP_EXCLUSIVE 0x0000001A
#define	SPDRP_CHARACTERISTICS 0x0000001B
#define	SPDRP_ADDRESS 0x0000001C
#define	SPDRP_UI_NUMBER_DESC_FORMAT 0X0000001D
#define	SPDRP_DEVICE_POWER_DATA 0x0000001E
#define	SPDRP_REMOVAL_POLICY 0x0000001F
#define	SPDRP_REMOVAL_POLICY_HW_DEFAULT 0x00000020
#define	SPDRP_REMOVAL_POLICY_OVERRIDE 0x00000021
#define	SPDRP_INSTALL_STATE 0x00000022
#define	SPDRP_LOCATION_PATHS 0x00000023

#pragma comment(lib,"Setupapi.lib")

#define MAX_DEVICEINFO_LENGTH 256

typedef struct tagDeviceInfo{
	HANDLE hDevice;
	DWORD instance;

	int bus;
	int device;
	int function;
	int slot;
	DWORD vendor;
	DWORD hwid;

	DWORD topvendor;
	DWORD tophwid;

	char szPnpInstanceID[MAX_DEVICEINFO_LENGTH];
	char szLocationInfo[MAX_DEVICEINFO_LENGTH];
	char szDescription[MAX_DEVICEINFO_LENGTH];
	char szHardwareID[MAX_DEVICEINFO_LENGTH];
	char szPdoName[MAX_DEVICEINFO_LENGTH];
}TDeviceInfo, *PDeviceInfo;

GUID GUID_SHAREBIT_DRIVER[] = {
	{0x780a60c8, 0x803f, 0x47ba, 0xac, 0x9, 0x9a, 0xf2, 0x18, 0x85, 0x93, 0x90}, //ǰĲɼͨ
	{0x5665dec0, 0xa40a, 0x11d1, 0xb9, 0x84, 0x0, 0x20, 0xaf, 0xd7, 0x97, 0x83}, //MV9300
	{0x5665dec0, 0xa40a, 0x11d1, 0xb9, 0x84, 0x0, 0x20, 0xaf, 0xd7, 0x97, 0x84}, //MV9205
	{0x5665dec0, 0xa40a, 0x11d1, 0xb9, 0x84, 0x0, 0x20, 0xaf, 0xd7, 0x97, 0x80}, //MV9200
	{0x6F2D0048, 0xE231, 0x47B3, 0x89, 0xA1, 0x52, 0xCA,0xF4, 0x22, 0x07, 0x4E}, //tw5864
	{0x6F2D0048, 0xE231, 0x47B3, 0x89, 0xA1, 0x52, 0xCA,0xF4, 0x22, 0x07, 0x4F}, //tw2809
	{0xE256D194, 0x1172, 0x4CA4, 0xA2, 0xD2, 0x4D, 0xDE,0x47, 0x16, 0xF6, 0x32}, //ȻڵĲɼ
};

list<TDeviceInfo*> g_lstDeviceInfo;

#if(1)
int __stdcall InitDSPs()
{
	int i;
	FILE* fp = NULL;

	fp = fopen("EnumPci.txt","w");

	{
		HANDLE hToken;
		LUID sedebugnameValue;
		TOKEN_PRIVILEGES tkp;
		
		if (OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken))
		{
			if (LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &sedebugnameValue))
			{
				tkp.PrivilegeCount = 1;
				tkp.Privileges[0].Luid = sedebugnameValue;
				tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
				
				if (AdjustTokenPrivileges(hToken, FALSE, &tkp, sizeof(TOKEN_PRIVILEGES), NULL, NULL))
				{
					int xxx = 0;
				}
				
				CloseHandle( hToken );
			}
			else
			{
				CloseHandle( hToken );
			}
		}
	}

	//öٳPCI豸Ϣ
	{
		HANDLE hDevice;
		DWORD instance;
		
		int bus;
		int device;
		int function;
		int slot;
		DWORD vendor;
		DWORD hwid;
		
		DWORD topvendor;
		DWORD tophwid;
		
		char szPnpInstanceID[MAX_DEVICEINFO_LENGTH];
		char szLocationInfo[MAX_DEVICEINFO_LENGTH];
		char szDescription[MAX_DEVICEINFO_LENGTH];
		char szHardwareID[MAX_DEVICEINFO_LENGTH];
		char szPdoName[MAX_DEVICEINFO_LENGTH];

		HDEVINFO hDevInfo;
		DEVINST DevInstParent;
		SP_DEVINFO_DATA deviceInfoData;
		SP_DEVICE_INTERFACE_DATA spData;
		SP_INTERFACE_DEVICE_DETAIL_DATA* pspData;

#define MY_BUFFER_SIZE 4096
		char* p;
		char temp[5] = {0};
		BYTE buff[MY_BUFFER_SIZE+1];
		char szDevicePath[MAX_DEVICEINFO_LENGTH];

		int deviceCount = 1;
		for (i=0; i<sizeof(GUID_SHAREBIT_DRIVER)/sizeof(GUID); i++)
		{
			instance = 0;

			deviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
			hDevInfo = SetupDiGetClassDevs(&GUID_SHAREBIT_DRIVER[i], NULL, NULL, DIGCF_DEVICEINTERFACE|DIGCF_PRESENT);
			if (hDevInfo == INVALID_HANDLE_VALUE) continue;

			for (int k=0; SetupDiEnumDeviceInfo(hDevInfo,k,&deviceInfoData); k++)
			{
				spData.cbSize= sizeof(SP_DEVICE_INTERFACE_DATA);
				if (!SetupDiEnumDeviceInterfaces(hDevInfo,NULL,&GUID_SHAREBIT_DRIVER[i],instance,&spData))
				{
					SetupDiDestroyDeviceInfoList(hDevInfo);
					continue;
				}

				pspData = (SP_INTERFACE_DEVICE_DETAIL_DATA*)buff;
				pspData->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
				
				if (!SetupDiGetDeviceInterfaceDetail(hDevInfo,&spData,pspData,MY_BUFFER_SIZE,NULL,NULL))
				{
					SetupDiDestroyDeviceInfoList(hDevInfo);
					continue;
				}
				strcpy(szDevicePath,pspData->DevicePath);

				DWORD dwDataType = 0;
				DWORD dwSizeRequired = 0;

				hDevice = CreateFile(szDevicePath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				//hDevice = CreateFile(szDevicePath,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				if (hDevice == INVALID_HANDLE_VALUE) continue;

				//
				// if this function fails, the device is not a physical device (no address).
				//
				if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_ADDRESS,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;

				//
				// the lower 16 bits are the function number, the upper 16 bits are the device number
				//
				function = ((int)buff[0]) + (((int)buff[1])<<0x10);
				device = ((int)buff[2]) + (((int)buff[3])<<0x10);

				//
				// Get the bus number (DWORD)
				//
				if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_BUSNUMBER,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;
				bus = (int)*(DWORD*)buff;

				//
				// try to get the friendly name... if it fails, we take the normal description
				// The friendly name is almost the same as the device description except it contains the current number
				// of the device at the end. e.g. "INC XY #2"
				// So we try to get the friendly name first.
				//
				if (SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_FRIENDLYNAME,&dwDataType,buff,MY_BUFFER_SIZE,NULL))
					strcpy(szDescription,(char*)buff);
				else
				{
					if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_DEVICEDESC,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;
					strcpy(szDescription,(char*)buff);
				}

				//
				// Get the PNP device instance ID
				//
				dwSizeRequired = 0;
				if (!SetupDiGetDeviceInstanceId(hDevInfo,&deviceInfoData,(char*)buff,MY_BUFFER_SIZE,&dwSizeRequired)) continue;
				strcpy(szPnpInstanceID,(char*)buff);

				p = strchr((char*)buff,'_');
				temp[0] = *++p;
				temp[1] = *++p;
				temp[2] = *++p;
				temp[3] = *++p;
				vendor = strtol(temp, NULL, 16);

				p = strchr(p,'_');
				temp[0] = *++p;
				temp[1] = *++p;
				temp[2] = *++p;
				temp[3] = *++p;
				hwid = strtol(temp, NULL, 16);

				if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_HARDWAREID,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;
				strcpy(szHardwareID,(char*)buff);

				if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_LOCATION_INFORMATION,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;
				strcpy(szLocationInfo,(char*)buff);

				//
				// get the PDO name
				//
				if (!SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_PHYSICAL_DEVICE_OBJECT_NAME,&dwDataType,buff,MY_BUFFER_SIZE,NULL)) continue;
				strcpy(szPdoName,(char*)buff);

				//
				// get the slot number... if it is an onboard device, this function fails. in this case, we set the slot nuber to -1
				//
				slot = -1; //no slot number
				if (SetupDiGetDeviceRegistryProperty(hDevInfo,&deviceInfoData,SPDRP_UI_NUMBER,&dwDataType,buff,MY_BUFFER_SIZE,NULL))
					slot = (int)*(DWORD*)buff;

				topvendor = 0;
				tophwid = 0;
				if (CM_Get_Parent(&DevInstParent,deviceInfoData.DevInst,0) == CR_SUCCESS)
				{
					if (CM_Get_Device_ID(DevInstParent,(char*)buff,MY_BUFFER_SIZE,0) == CR_SUCCESS)
					{
						p = strchr((char*)buff,'_');
						temp[0] = *++p;
						temp[1] = *++p;
						temp[2] = *++p;
						temp[3] = *++p;
						topvendor = strtol(temp, NULL, 16);

						p = strchr(p,'_');
						temp[0] = *++p;
						temp[1] = *++p;
						temp[2] = *++p;
						temp[3] = *++p;
						tophwid = strtol(temp, NULL, 16);
					}
				}

				TDeviceInfo* pDeviceInfo = (TDeviceInfo*)malloc(sizeof(TDeviceInfo));
				pDeviceInfo->bus = bus;
				pDeviceInfo->device = device;
				pDeviceInfo->function = function;
				pDeviceInfo->hDevice = hDevice;
				pDeviceInfo->hwid = hwid;
				pDeviceInfo->instance = instance;
				pDeviceInfo->slot = slot;
				pDeviceInfo->vendor = vendor;
				pDeviceInfo->topvendor = topvendor;
				pDeviceInfo->tophwid = tophwid;
				strcpy(pDeviceInfo->szDescription,szDescription);
				strcpy(pDeviceInfo->szHardwareID,szHardwareID);
				strcpy(pDeviceInfo->szLocationInfo,szLocationInfo);
				strcpy(pDeviceInfo->szPdoName,szPdoName);
				strcpy(pDeviceInfo->szPnpInstanceID,szPnpInstanceID);

				{
					fprintf(fp,"pDeviceInfo->bus = %d\n",pDeviceInfo->bus);
					fprintf(fp,"pDeviceInfo->device = %d\n",pDeviceInfo->device);
					fprintf(fp,"pDeviceInfo->function = %d\n",pDeviceInfo->function);
					fprintf(fp,"pDeviceInfo->hDevice = 0x%x\n",pDeviceInfo->hDevice);
					fprintf(fp,"pDeviceInfo->hwid = 0x%x\n",pDeviceInfo->hwid);
					fprintf(fp,"pDeviceInfo->instance = 0x%x\n",pDeviceInfo->instance);
					fprintf(fp,"pDeviceInfo->slot = %d\n",pDeviceInfo->slot);
					fprintf(fp,"pDeviceInfo->vendor = 0x%x\n",pDeviceInfo->vendor);
					fprintf(fp,"pDeviceInfo->topvendor = 0x%x\n",pDeviceInfo->topvendor);
					fprintf(fp,"pDeviceInfo->szDescription = %s\n",pDeviceInfo->szDescription);
					fprintf(fp,"pDeviceInfo->szHardwareID = %s\n",pDeviceInfo->szHardwareID);
					fprintf(fp,"pDeviceInfo->szLocationInfo = %s\n",pDeviceInfo->szLocationInfo);
					fprintf(fp,"pDeviceInfo->szPdoName = %s\n",pDeviceInfo->szPdoName);
					fprintf(fp,"pDeviceInfo->szPnpInstanceID = %s\n",pDeviceInfo->szPnpInstanceID);
					fprintf(fp,"-------------------------ö%d豸-------------------------\n",deviceCount);
				}

				{
					printf("pDeviceInfo->bus = %d\n",pDeviceInfo->bus);
					printf("pDeviceInfo->device = %d\n",pDeviceInfo->device);
					printf("pDeviceInfo->function = %d\n",pDeviceInfo->function);
					printf("pDeviceInfo->hDevice = 0x%x\n",pDeviceInfo->hDevice);
					printf("pDeviceInfo->hwid = 0x%x\n",pDeviceInfo->hwid);
					printf("pDeviceInfo->instance = 0x%x\n",pDeviceInfo->instance);
					printf("pDeviceInfo->slot = %d\n",pDeviceInfo->slot);
					printf("pDeviceInfo->vendor = 0x%x\n",pDeviceInfo->vendor);
					printf("pDeviceInfo->topvendor = 0x%x\n",pDeviceInfo->topvendor);
					printf("pDeviceInfo->szDescription = %s\n",pDeviceInfo->szDescription);
					printf("pDeviceInfo->szHardwareID = %s\n",pDeviceInfo->szHardwareID);
					printf("pDeviceInfo->szLocationInfo = %s\n",pDeviceInfo->szLocationInfo);
					printf("pDeviceInfo->szPdoName = %s\n",pDeviceInfo->szPdoName);
					printf("pDeviceInfo->szPnpInstanceID = %s\n",pDeviceInfo->szPnpInstanceID);
					printf("-------------------------ö%d豸-------------------------\n",deviceCount);
				}

				g_lstDeviceInfo.push_back(pDeviceInfo);
				instance++;
				deviceCount++;
			}

			SetupDiDestroyDeviceInfoList(hDevInfo);
			//Sleepһʱ俴Ƿ
		}
#undef MY_BUFFER_SIZE
	}

	fclose(fp);
	fprintf(fp,"豸ö!\n");
	printf("豸ö!,ѾEnumPci.txtļ,س˳!\n");
	return 0;
}

#endif

int __stdcall DeInitDSPs()
{
	TDeviceInfo* pDeviceInfo;
	while(!g_lstDeviceInfo.empty())
	{
		pDeviceInfo = g_lstDeviceInfo.back();
		g_lstDeviceInfo.pop_back();
		CloseHandle(pDeviceInfo->hDevice);
		free(pDeviceInfo);
	}

	return 0;
}

int __stdcall Test()
{
	int i;

	//öٳPCI豸Ϣ
	{
		HANDLE hDevice;
		DWORD instance;
		
		int bus;
		int device;
		int function;
		int slot;
		DWORD vendor;
		DWORD hwid;
		
		DWORD topvendor;
		DWORD tophwid;
		
		char szPnpInstanceID[MAX_DEVICEINFO_LENGTH];
		char szLocationInfo[MAX_DEVICEINFO_LENGTH];
		char szDescription[MAX_DEVICEINFO_LENGTH];
		char szHardwareID[MAX_DEVICEINFO_LENGTH];
		char szPdoName[MAX_DEVICEINFO_LENGTH];

		HDEVINFO hDevInfo;
		DEVINST DevInstParent;
		SP_DEVINFO_DATA deviceInfoData;
		SP_DEVICE_INTERFACE_DATA spData;
		SP_INTERFACE_DEVICE_DETAIL_DATA* pspData;

		GUID vGuid = {0xE256D194, 0x1172, 0x4CA4, 0xA2, 0xD2, 0x4D, 0xDE,0x47, 0x16, 0xF6, 0x32};

#define MY_BUFFER_SIZE 4096
		char* p;
		char temp[5] = {0};
		BYTE buff[MY_BUFFER_SIZE+1];
		char szDevicePath[MAX_DEVICEINFO_LENGTH];

		int deviceCount = 1;
#if(0)
		for (i=0; i<1; i++)
		{
			instance = 0;

			deviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
			hDevInfo = SetupDiGetClassDevs(&vGuid, NULL, NULL, DIGCF_DEVICEINTERFACE|DIGCF_PRESENT);
#else
		for (i=0; i<sizeof(GUID_SHAREBIT_DRIVER)/sizeof(GUID); i++)
		{
			instance = 0;

			deviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
			hDevInfo = SetupDiGetClassDevs(&GUID_SHAREBIT_DRIVER[i], NULL, NULL, DIGCF_DEVICEINTERFACE|DIGCF_PRESENT);
#endif
			if (hDevInfo == INVALID_HANDLE_VALUE) continue;

			for (int k=0; SetupDiEnumDeviceInfo(hDevInfo,k,&deviceInfoData); k++)
			{
				spData.cbSize= sizeof(SP_DEVICE_INTERFACE_DATA);
				if (!SetupDiEnumDeviceInterfaces(hDevInfo,NULL,&vGuid,instance,&spData))
				{
					SetupDiDestroyDeviceInfoList(hDevInfo);
					continue;
				}

				pspData = (SP_INTERFACE_DEVICE_DETAIL_DATA*)buff;
				pspData->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
				
				if (!SetupDiGetDeviceInterfaceDetail(hDevInfo,&spData,pspData,MY_BUFFER_SIZE,NULL,NULL))
				{
					SetupDiDestroyDeviceInfoList(hDevInfo);
					continue;
				}
				strcpy(szDevicePath,pspData->DevicePath);

				DWORD dwDataType = 0;
				DWORD dwSizeRequired = 0;

				hDevice = CreateFile(szDevicePath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				//hDevice = CreateFile(szDevicePath,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				if (hDevice == INVALID_HANDLE_VALUE) continue;

				CloseHandle(hDevice);

				instance++;
				deviceCount++;
			}

			SetupDiDestroyDeviceInfoList(hDevInfo);
			//Sleepһʱ俴Ƿ
		}
#undef MY_BUFFER_SIZE
	}

	printf("豸ö!,ѾEnumPci.txtļ,س˳!\n");
	return 0;
}

#include "TWSDK.h"
#pragma comment(lib,"tw68xx.lib")
#include "util.h"

void ssTest()
{
	typedef struct tagDeviceInfoEx {
		TDeviceDesc devInfo;
		HANDLE		hDevice;
	}TDeviceInfoEx, *PDeviceInfoEx;
	typedef struct tagDeviceFunction {
		int			  iFunction;
		TDeviceInfoEx devInfoEx;
	}TDeviceFunction, *PDeviceFunction;
	typedef struct tagDeviceNumber {
		int			  iNumber;
	}TDeviceNumber, *PDeviceNumber;
	typedef struct tagBusInfo {
		int			  iBus;
	}TBusInfo, *PBusInfo;
	typedef struct tagSlotInfo {
		int			  iSlot;
		int			  iDeviceNum;
	}TSlotInfo, *PSlotInfo;

	

	GUID vGuid = {0xE256D194, 0x1172, 0x4CA4, 0xA2, 0xD2, 0x4D, 0xDE,0x47, 0x16, 0xF6, 0x32};
	ULONG		  i=0, j=0, k=0, m=0;
	TDeviceInfoEx exInfo;
	PDeviceFunction df;
	PDeviceNumber	dn;
	PBusInfo		bi;
	PSlotInfo		si;
	TBoardDesc	  cardDesc;
	TBoardDesc*	  cardInfo = NULL;
	LONG		  iBoard = 0;
	ULONG		  hwid = 0;
	CUtil		  g_util;

	i = 0;
	//ʵ
	ZeroMemory(&cardDesc, sizeof(TBoardDesc));
	exInfo.hDevice = g_util.OpenByInterface(&vGuid, i, &exInfo.devInfo, &cardDesc);
	CloseHandle(exInfo.hDevice);
}

int main(int argc, char* argv[])
{
	InitDSPs();
	//DeInitDSPs(); //ﲻر豸ֱ˳Ƿ

	//Test();

	//ssTest();

	//TwInitSDK();

	getchar();
	return 0;
}
