// BlackStripeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "BlackStripeDlg.h"
#include "TWSDK_T.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlackStripeDlg dialog


CBlackStripeDlg::CBlackStripeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlackStripeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlackStripeDlg)
	m_nId = -1;
	m_nVleft = -1;
	m_nVright = -1;
	//}}AFX_DATA_INIT
}


void CBlackStripeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlackStripeDlg)
	DDX_CBIndex(pDX, IDC_COMBO_CHANNEL, m_nId);
	DDX_CBIndex(pDX, IDC_COMBO_VLEFT, m_nVleft);
	DDX_CBIndex(pDX, IDC_COMBO_VRIGHT, m_nVright);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBlackStripeDlg, CDialog)
	//{{AFX_MSG_MAP(CBlackStripeDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_CHANNEL, OnSelchangeComboChannel)
	ON_CBN_SELCHANGE(IDC_COMBO_VLEFT, OnSelchangeComboVleft)
	ON_CBN_SELCHANGE(IDC_COMBO_VRIGHT, OnSelchangeComboVright)
	ON_BN_CLICKED(IDC_BTN_DELAY_DEFAULT, OnBtnDelayDefault)
	ON_BN_CLICKED(IDC_BTN_STRIPE_DEFAULT, OnBtnStripeDefault)
	ON_BN_CLICKED(IDC_BTN_ALL, OnBtnAll)
	ON_BN_CLICKED(IDC_BTN_LEFT, OnBtnLeft)
	ON_BN_CLICKED(IDC_BTN_RIGHT, OnBtnRight)
	ON_BN_CLICKED(IDC_BTN_UP, OnBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, OnBtnDown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlackStripeDlg message handlers

BOOL CBlackStripeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return FALSE;
	}
	
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) {
		return FALSE;
	}
	
	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(m_hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return FALSE;
	}

	TChannelDesc chlDesc;
	TDeviceDesc	 devDesc;
	TF_TwGetChannelDetail fTwGetChannelDetail = (TF_TwGetChannelDetail)GetProcAddress(m_hSdk, "TwGetChannelDetail");
	TF_TwGetDeviceHandle  fTwGetDeviceHandle  = (TF_TwGetDeviceHandle) GetProcAddress(m_hSdk, "TwGetDeviceHandle");
	TF_TwGetDeviceDetail  fTwGetDeviceDetail  = (TF_TwGetDeviceDetail) GetProcAddress(m_hSdk, "TwGetDeviceDetail");
	
	int nChannel = fTwGetChannelCount();
	if(m_nId >= nChannel) {
		return FALSE;
	}

	CComboBox*	pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_CHANNEL);
	CString strTemp;
	for(int i=0; i<nChannel; i++) {
		strTemp.Format(TEXT("%d"), i+1);
		pCombo->InsertString(i, strTemp);
	}
	
	pCombo->SetCurSel(m_nId);

	BOOL   bBlackStripe = FALSE;
	HANDLE hDevice  = NULL;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return FALSE;
	}

	fTwGetChannelDetail(hChannel, &chlDesc);
	hDevice = fTwGetDeviceHandle(chlDesc.nDeviceId);

	fTwGetDeviceDetail(hDevice, &devDesc);
	bBlackStripe = (DEVICEID(devDesc.HardwareId)==0x6864);
	GetDlgItem(IDC_COMBO_VLEFT)->EnableWindow(bBlackStripe);
	GetDlgItem(IDC_COMBO_VRIGHT)->EnableWindow(bBlackStripe);
	GetDlgItem(IDC_BTN_STRIPE_DEFAULT)->EnableWindow(bBlackStripe);

	fTwGetVideoPara(hChannel, vpLeft,	(long*)&m_nVleft);
	fTwGetVideoPara(hChannel, vpRight,	(long*)&m_nVright);

	m_nVleft /= 2;

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CBlackStripeDlg::OnSelchangeComboChannel() 
{
	UpdateData(TRUE);

	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return;
	}
	
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) {
		return;
	}
	
	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(m_hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return;
	}
	
	TChannelDesc chlDesc;
	TDeviceDesc	 devDesc;
	TF_TwGetChannelDetail fTwGetChannelDetail = (TF_TwGetChannelDetail)GetProcAddress(m_hSdk, "TwGetChannelDetail");
	TF_TwGetDeviceHandle  fTwGetDeviceHandle  = (TF_TwGetDeviceHandle) GetProcAddress(m_hSdk, "TwGetDeviceHandle");
	TF_TwGetDeviceDetail  fTwGetDeviceDetail  = (TF_TwGetDeviceDetail) GetProcAddress(m_hSdk, "TwGetDeviceDetail");
	
	BOOL   bBlackStripe = FALSE;
	HANDLE hDevice  = NULL;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwGetChannelDetail(hChannel, &chlDesc);
	hDevice = fTwGetDeviceHandle(chlDesc.nDeviceId);
	
	fTwGetDeviceDetail(hDevice, &devDesc);
	bBlackStripe = (DEVICEID(devDesc.HardwareId)==0x6864);
	GetDlgItem(IDC_COMBO_VLEFT)->EnableWindow(bBlackStripe);
	GetDlgItem(IDC_COMBO_VRIGHT)->EnableWindow(bBlackStripe);
	GetDlgItem(IDC_BTN_STRIPE_DEFAULT)->EnableWindow(bBlackStripe);
	
	fTwGetVideoPara(hChannel, vpLeft,	(long*)&m_nVleft);
	fTwGetVideoPara(hChannel, vpRight,	(long*)&m_nVright);
	
	m_nVleft /= 2;

	UpdateData(FALSE);
}

void CBlackStripeDlg::OnBtnLeft() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	
	long value=0;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}

	fTwGetVideoPara(hChannel, vpHDelay,	&value);
	if(value < 0) value = -value;
	fTwSetVideoPara(hChannel, vpHDelay,	value+1);
}

void CBlackStripeDlg::OnBtnRight() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	
	long value=0;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwGetVideoPara(hChannel, vpHDelay,	&value);
	if(value < 0) value = -value;
	fTwSetVideoPara(hChannel, vpHDelay,	value-1);
}

void CBlackStripeDlg::OnBtnUp() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	
	long value=0;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwGetVideoPara(hChannel, vpVDelay,	&value);
	if(value < 0) value = -value;
	fTwSetVideoPara(hChannel, vpVDelay,	value+1);
}

void CBlackStripeDlg::OnBtnDown() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	
	long value=0;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwGetVideoPara(hChannel, vpVDelay,	&value);
	if(value < 0) value = -value;
	fTwSetVideoPara(hChannel, vpVDelay,	value-1);
}

void CBlackStripeDlg::OnBtnDelayDefault() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	
	long value=0;
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwSetVideoPara(hChannel, vpHDelay,	-1);
	fTwSetVideoPara(hChannel, vpVDelay,	-1);
}

void CBlackStripeDlg::OnSelchangeComboVleft() 
{
	UpdateData(TRUE);

	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return;
	}
	
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	if(fTwSetVideoPara == NULL) {
		return;
	}
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwSetVideoPara(hChannel, vpLeft,	m_nVleft*2);
}

void CBlackStripeDlg::OnSelchangeComboVright() 
{
	UpdateData(TRUE);
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return;
	}
	
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	if(fTwSetVideoPara == NULL) {
		return;
	}
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwSetVideoPara(hChannel, vpRight,	m_nVright);
}

void CBlackStripeDlg::OnBtnStripeDefault() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	m_nVleft = -1;
	m_nVright= -1;
	fTwSetVideoPara(hChannel, vpLeft,  m_nVleft);
	fTwSetVideoPara(hChannel, vpRight, m_nVright);

	UpdateData(FALSE);
}

void CBlackStripeDlg::OnBtnAll() 
{
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(m_hSdk, "TwGetChannelCount");
	
	long hDelay=0, vDelay=0;
	int  nChannels = fTwGetChannelCount();
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwGetVideoPara(hChannel, vpHDelay,	&hDelay);
	fTwGetVideoPara(hChannel, vpVDelay,	&vDelay);

	for(int i=0; i<nChannels; i++) {
		hChannel = fTwChannelOpen(i);
		fTwSetVideoPara(hChannel, vpHDelay, hDelay);
		fTwSetVideoPara(hChannel, vpVDelay, vDelay);
		fTwSetVideoPara(hChannel, vpLeft,   m_nVleft*2);
		fTwSetVideoPara(hChannel, vpRight,  m_nVright);
	}
}
