// BoardPage.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "BoardPage.h"
#include "tw68xxdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef UNICODE
#define lsscanf  swscanf
#else
#define lsscanf  sscanf
#endif // !UNICODE

/////////////////////////////////////////////////////////////////////////////
// CBoardPage dialog


CBoardPage::CBoardPage(CWnd* pParent /*=NULL*/)
	: COptionPage(CBoardPage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoardPage)
	m_strValue = _T("");
	m_strOffset = _T("");
	//}}AFX_DATA_INIT

	m_hBoard = NULL;
}


void CBoardPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoardPage)
	DDX_Text(pDX, IDC_EDIT_VALUE, m_strValue);
	DDV_MaxChars(pDX, m_strValue, 2);
	DDX_Text(pDX, IDC_EDIT_OFFSET, m_strOffset);
	DDV_MaxChars(pDX, m_strOffset, 2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBoardPage, CDialog)
	//{{AFX_MSG_MAP(CBoardPage)
	ON_BN_CLICKED(IDC_BTN_READ, OnBtnRead)
	ON_BN_CLICKED(IDC_BTN_WRITE, OnBtnWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoardPage message handlers

BOOL CBoardPage::SetId(int nId)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwGetBoardHandle fTwGetBoardHandle = (TF_TwGetBoardHandle)GetProcAddress(hSdk, "TwGetBoardHandle");
	TF_TwGetBoardDetail fTwGetBoardDetail = (TF_TwGetBoardDetail)GetProcAddress(hSdk, "TwGetBoardDetail");
	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(hSdk, "TwGetDeviceHandle");
	TF_TwGetDeviceDetail fTwGetDeviceDetail = (TF_TwGetDeviceDetail)GetProcAddress(hSdk, "TwGetDeviceDetail");
	TF_TwGetDevicePciConfigSpaceEx fTwGetDevicePciConfigSpaceEx = (TF_TwGetDevicePciConfigSpaceEx)GetProcAddress(hSdk, "TwGetDevicePciConfigSpaceEx");

	if(fTwGetDevicePciConfigSpaceEx==NULL) {
		return FALSE;
	}

	m_hBoard = fTwGetBoardHandle(nId);

	if(m_hBoard == NULL) {
		return FALSE;
	}

	m_nId = nId;

	ULONG venDev = 0;
	BOOL  bBridge = FALSE;
	fTwGetDevicePciConfigSpaceEx(m_hBoard, 0, 4, (PBYTE)&venDev);
	
	CString strInfo;
	strInfo.Format(TEXT("%04x"), (venDev&0xFFFF));
	GetDlgItem(IDC_EDIT_VENDER)->SetWindowText(strInfo);
	strInfo.Format(TEXT("%04x"), (venDev>>16));
	GetDlgItem(IDC_EDIT_DEVICEID)->SetWindowText(strInfo);

	bBridge = (venDev!=0);
	GetDlgItem(IDC_EDIT_OFFSET)->EnableWindow(bBridge);
	GetDlgItem(IDC_EDIT_VALUE)->EnableWindow(bBridge);
	GetDlgItem(IDC_BTN_WRITE)->EnableWindow(bBridge);
	GetDlgItem(IDC_BTN_READ)->EnableWindow(bBridge);
	if(!bBridge) {
		m_hBoard = NULL;
	}

	return TRUE;
}

void CBoardPage::OnBtnRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	TF_TwGetDevicePciConfigSpaceEx fTwGetDevicePciConfigSpaceEx = (TF_TwGetDevicePciConfigSpaceEx)GetProcAddress(hSdk, "TwGetDevicePciConfigSpaceEx");
	
	if((m_hBoard==NULL) || (fTwGetDevicePciConfigSpaceEx==NULL)) {
		return;
	}

	UpdateData(TRUE);

	int val = 0;
	int offset = 0;
	int i;
	i = lsscanf(m_strOffset, TEXT("%x"), &offset);
	if(i!=1) {
		AfxMessageBox("Invalid offset");
		return;
	}

	fTwGetDevicePciConfigSpaceEx(m_hBoard, offset, 1, (PBYTE)&val);
	m_strValue.Format("%02x", val);

	UpdateData(FALSE);
}

void CBoardPage::OnBtnWrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	TF_TwSetDevicePciConfigSpaceEx fTwSetDevicePciConfigSpaceEx = (TF_TwSetDevicePciConfigSpaceEx)GetProcAddress(hSdk, "TwSetDevicePciConfigSpaceEx");
	
	if((m_hBoard==NULL) || (fTwSetDevicePciConfigSpaceEx==NULL)) {
		return;
	}

	UpdateData(TRUE);
	
	int val = 0;
	int offset = 0;
	int i;
	i = lsscanf(m_strValue, TEXT("%x"), &val);
	if(i!=1) {
		AfxMessageBox("Invalid value");
		return;
	}
	i = lsscanf(m_strOffset, TEXT("%x"), &offset);
	if(i!=1) {
		AfxMessageBox("Invalid offset");
		return;
	}
	
	fTwSetDevicePciConfigSpaceEx(m_hBoard, offset, 1, (PBYTE)&val);
}
