#pragma once
#include "videownd.h"
#include "Thread.h"
#include "Surface.h"
#include "VideoOut.h"
#include "PlayWave.h"
#include "AviWriter.h"
#include "Dinterlace.h"

class CChannel : public CVideoWnd, public CSurface, public CAviWriter, public CThread
{
public:
	CChannel();
	virtual ~CChannel(void);

	BOOL   Open(int width, int height, int pxlFormat=1, BOOL bY41P=FALSE, BOOL bDeinterlace=FALSE);
	void   Close();
	BOOL   OnVideoStream(VOID *DataBuf, int width, int height, __int64 pts, PVOID ctx);
	BOOL   OnAudioStream(VOID *DataBuf, LONG Length, __int64 pts);
	void   ShowVideo(BOOL bShow);
	void   EnableSound(BOOL bEnable) { m_bSound=bEnable; }
	void   EnableDeinterlace(BOOL bEnable);
	void   UpdateStatus();
	BOOL   Save(BOOL bSave, ULONG nFrameRate=25);
	BOOL   IsSaving() { return m_bSaving; }
	void   Snap();
	void   CheckSignal();

	virtual BOOL IsVisible(){ return m_bVisible;}

	static CVideoOut* InitRender();
	static void UninitRender();
	static void InitSound();
	static void UninitSound();

	typedef struct tagFrameData {
		PVOID	pData;
		int		nLen;
		__int64 pts;
	}TFrameData, *PFrameData;

protected:
	virtual void OnSetCurrent();
	virtual UINT Run();

protected:
	BOOL   m_bSound;
	BOOL   m_bSaving;
	ULONG  m_vDuration;
	int	   m_nSnap;
	PBYTE  m_bufTemp[2];
	int    m_nPixelFormat;
	BOOL   m_bSignal;
	BOOL   m_bDeinterlace;

	TFrameData	m_vFrameData;
	TFrameData	m_aFrameData;
	CDinterlace	m_di;

	static CVideoOut m_vOut;
	static CPlayWave m_aOut;
};
