// ChannelPage.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "TW68XXDlg.h"
#include "ChannelPage.h"
#include "inifile.h"
#include "CopyToDlg.h"
#include "OptionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChannelPage dialog


CChannelPage::CChannelPage(CWnd* pParent /*=NULL*/)
	: COptionPage(CChannelPage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChannelPage)
	m_nHeight = 288;
	m_nWidth = 352;
	m_nStandard = 0;
	m_nVideoSize = 2;
	m_nFrameRate = 25;
	m_nFrameRate2 = 25;
	m_nHeight2 = 288;
	m_nWidth2 = 352;
	m_nVideoSize2 = 2;
	m_nPixelFormat = 0;
	m_nPixelFormat2 = 0;
	m_bAudio = FALSE;
	m_bDeinterlace = FALSE;
	m_bOptimizeCIF = FALSE;
	m_nField = -1;
	//}}AFX_DATA_INIT

	m_bField2 = FALSE;
	m_bSwitch = FALSE;
}


void CChannelPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChannelPage)
	DDX_Text(pDX, IDC_EDIT_HEIGHT, m_nHeight);
	DDV_MinMaxInt(pDX, m_nHeight, 0, 576);
	DDX_Text(pDX, IDC_EDIT_WIDTH, m_nWidth);
	DDV_MinMaxInt(pDX, m_nWidth, 0, 720);
	DDX_Radio(pDX, IDC_RADIO_PAL, m_nStandard);
	DDX_Radio(pDX, IDC_RADIO_QCIF, m_nVideoSize);
	DDX_Text(pDX, IDC_EDIT_FRAMERATE, m_nFrameRate);
	DDV_MinMaxInt(pDX, m_nFrameRate, 1, 30);
	DDX_Text(pDX, IDC_EDIT_FRAMERATE_2, m_nFrameRate2);
	DDV_MinMaxInt(pDX, m_nFrameRate2, 1, 30);
	DDX_Text(pDX, IDC_EDIT_HEIGHT_2, m_nHeight2);
	DDV_MinMaxInt(pDX, m_nHeight2, 0, 288);
	DDX_Text(pDX, IDC_EDIT_WIDTH_2, m_nWidth2);
	DDV_MinMaxInt(pDX, m_nWidth2, 0, 720);
	DDX_Radio(pDX, IDC_RADIO_QCIF_2, m_nVideoSize2);
	DDX_Radio(pDX, IDC_RADIO_YUY2, m_nPixelFormat);
	DDX_Radio(pDX, IDC_RADIO_YUY2_2, m_nPixelFormat2);
	DDX_Check(pDX, IDC_CHECK_AUDIO, m_bAudio);
	DDX_Check(pDX, IDC_CHECK_DEINTERLACE, m_bDeinterlace);
	DDX_Check(pDX, IDC_CHECK_OPTMIZECIF, m_bOptimizeCIF);
	DDX_Radio(pDX, IDC_RADIO_EVEN, m_nField);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChannelPage, CDialog)
	//{{AFX_MSG_MAP(CChannelPage)
	ON_BN_CLICKED(IDC_RADIO_PAL, OnRadioPal)
	ON_BN_CLICKED(IDC_RADIO_NTSC, OnRadioNtsc)
	ON_BN_CLICKED(IDC_RADIO_QCIF, OnRadioQcif)
	ON_BN_CLICKED(IDC_RADIO_QVGA, OnRadioQvga)
	ON_BN_CLICKED(IDC_RADIO_CIF, OnRadioCif)
	ON_BN_CLICKED(IDC_RADIO_2CIF, OnRadio2cif)
	ON_BN_CLICKED(IDC_RADIO_VGA, OnRadioVga)
	ON_BN_CLICKED(IDC_RADIO_4CIF, OnRadio4cif)
	ON_EN_CHANGE(IDC_EDIT_HEIGHT, OnChangeEditHeight)
	ON_EN_CHANGE(IDC_EDIT_WIDTH, OnChangeEditWidth)
	ON_BN_CLICKED(IDC_RADIO_QCIF_2, OnRadioQcif2)
	ON_BN_CLICKED(IDC_RADIO_QVGA_2, OnRadioQvga2)
	ON_BN_CLICKED(IDC_RADIO_CIF_2, OnRadioCif2)
	ON_BN_CLICKED(IDC_RADIO_2CIF_2, OnRadio2cif2)
	ON_EN_CHANGE(IDC_EDIT_HEIGHT_2, OnChangeEditHeight2)
	ON_EN_CHANGE(IDC_EDIT_WIDTH_2, OnChangeEditWidth2)
	ON_BN_CLICKED(IDC_RADIO_YV12, OnRadioYv12)
	ON_BN_CLICKED(IDC_RADIO_YV12_2, OnRadioYv122)
	ON_BN_CLICKED(IDC_RADIO_YUY2, OnRadioYuy2)
	ON_BN_CLICKED(IDC_RADIO_YUY2_2, OnRadioYuy22)
	ON_BN_CLICKED(IDC_RADIO_RGB555, OnRadioRgb555)
	ON_BN_CLICKED(IDC_RADIO_RGB565, OnRadioRgb565)
	ON_BN_CLICKED(IDC_RADIO_RGB24, OnRadioRgb24)
	ON_BN_CLICKED(IDC_RADIO_Y41P, OnRadioY41p)
	ON_BN_CLICKED(IDC_RADIO_HALFD1, OnRadioHalfd1)
	ON_BN_CLICKED(IDC_RADIO_D1, OnRadioD1)
	ON_BN_CLICKED(IDC_RADIO_HALFD1_2, OnRadioHalfd12)
	ON_BN_CLICKED(IDC_BTN_STARTCHANNEL, OnBtnStartchannel)
	ON_BN_CLICKED(IDC_BTN_STOPCHANNEL, OnBtnStopchannel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChannelPage message handlers

void CChannelPage::OnCancel() 
{
}

void CChannelPage::OnOK() 
{
}

BOOL CChannelPage::SetId(int nId)
{
	m_nId = nId;

	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return FALSE;
	}
	
	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) {
		return FALSE;
	}
	
	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return FALSE;
	}
	
	int nChannel = fTwGetChannelCount();
	if(m_nId >= nChannel) {
		return FALSE;
	}
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return FALSE;
	}
	
	CString  strPath;
	CIniFile iniFile;
	
	pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	iniFile.Create(strPath + OPTION_FILE);
	strPath.Format(SECTION_CHANNEL, m_nId);

	LONG nValue = 0;
	fTwGetVideoPara(hChannel, vpStandard, &nValue);
	m_nStandard = (nValue==vsStandardNTSC);
	fTwGetVideoPara(hChannel, vpPixelFormat, &nValue);
	switch(nValue) {
	case vpfYUV422Interspersed:
		m_nPixelFormat = 0;
		break;
	case vpfYUV420Planar:
		m_nPixelFormat = 1;
		break;
	case vpfYUV411Interspersed:
		m_nPixelFormat = 2;
		break;
	case vpfRGB15Alpha:
		m_nPixelFormat = 3;
		break;
	case vpfRGB16:
		m_nPixelFormat = 4;
		break;
	case vpfRGB24:
		m_nPixelFormat = 5;
		break;
	default:
		m_nPixelFormat = 0;
		break;
	}
	fTwGetVideoPara(hChannel, vpWidth, (PLONG)&m_nWidth);
	fTwGetVideoPara(hChannel, vpHeight, (PLONG)&m_nHeight);
	fTwGetVideoPara(hChannel, vpFrameRate, (PLONG)&m_nFrameRate);
	fTwGetVideoPara(hChannel, vpOptimizedCIF, (PLONG)&m_bOptimizeCIF);
	fTwGetVideoPara(hChannel, vpField, (PLONG)&m_nField);
	m_nField -= 1;

	nValue = iniFile.ReadInt(SECTION_DEFAULT, KEY_DEINTERLACE, 0);
	m_bDeinterlace = iniFile.ReadInt(strPath, KEY_DEINTERLACE, nValue);

	if(m_nStandard == 0) {
		if((m_nWidth == 176) && (m_nHeight==144)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==288)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==288)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==576)) {
			m_nVideoSize = 5;
		}
		else if((m_nWidth==720) && (m_nHeight==288)) {
			m_nVideoSize = 6;
		}
		else if((m_nWidth==720) && (m_nHeight==576)) {
			m_nVideoSize = 7;
		}
		else {
			m_nVideoSize = -1;
		}
	}
	else {
		if((m_nWidth == 176) && (m_nHeight==120)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==240)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==240)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==480)) {
			m_nVideoSize = 5;
		}
		else if((m_nWidth==720) && (m_nHeight==240)) {
			m_nVideoSize = 6;
		}
		else if((m_nWidth==720) && (m_nHeight==480)) {
			m_nVideoSize = 7;
		}
		else {
			m_nVideoSize = -1;
		}
	}

	TF_TwGetSubDeviceHandle fTwGetSubDeviceHandle = (TF_TwGetSubDeviceHandle)GetProcAddress(hSdk, "TwGetSubDeviceHandle");
	if(fTwGetSubDeviceHandle == NULL) {
		return FALSE;
	}

	TF_TwGetSubDeviceDetail fTwGetSubDeviceDetail = (TF_TwGetSubDeviceDetail)GetProcAddress(hSdk, "TwGetSubDeviceDetail");
	if(fTwGetSubDeviceDetail == NULL) {
		return FALSE;
	}

	TF_TwGetChannelDetail fTwGetChannelDetail = (TF_TwGetChannelDetail)GetProcAddress(hSdk, "TwGetChannelDetail");
	if(fTwGetChannelDetail == NULL) {
		return FALSE;
	}

	TChannelDesc   chlDesc;
	TSubDeviceDesc subDesc;
	HANDLE		   hSubDev = NULL;

	ZeroMemory(&chlDesc, sizeof(chlDesc));
	ZeroMemory(&subDesc, sizeof(subDesc));

	if(fTwGetChannelDetail(hChannel, &chlDesc)) {
		m_bAudio = (iniFile.ReadInt(strPath, KEY_AUDIO, 0) && chlDesc.nAudio);

		GetDlgItem(IDC_CHECK_AUDIO)->EnableWindow(chlDesc.nAudio);
		hSubDev = fTwGetSubDeviceHandle(chlDesc.nSubDeviceId);
		if(fTwGetSubDeviceDetail(hSubDev, &subDesc)) {
			BOOL bField2 = subDesc.bField2;
			if(bField2) {
				fTwGetVideoPara(hChannel, vpPixelFormat2, &nValue);
				switch(nValue) {
				case vpfYUV422Interspersed:
					m_nPixelFormat2 = 0;
					break;
				case vpfYUV420Planar:
					m_nPixelFormat2 = 1;
					break;
				case vpfYUV411Interspersed:
					m_nPixelFormat2 = 2;
					break;
				case vpfRGB15Alpha:
					m_nPixelFormat2 = 3;
					break;
				case vpfRGB16:
					m_nPixelFormat2 = 4;
					break;
				case vpfRGB24:
					m_nPixelFormat2 = 5;
					break;
				default:
					m_nPixelFormat2 = 0;
					break;
				}
				fTwGetVideoPara(hChannel, vpWidth2, (PLONG)&m_nWidth2);
				fTwGetVideoPara(hChannel, vpHeight2, (PLONG)&m_nHeight2);
				fTwGetVideoPara(hChannel, vpFrameRate2, (PLONG)&m_nFrameRate2);
				if(m_nStandard == 0) {
					if((m_nWidth2 == 176) && (m_nHeight2==144)) {
						m_nVideoSize2 = 0;
					}
					else if((m_nWidth2==320) && (m_nHeight2==240)) {
						m_nVideoSize2 = 1;
					}
					else if((m_nWidth2==352) && (m_nHeight2==288)) {
						m_nVideoSize2 = 2;
					}
					else if((m_nWidth2==704) && (m_nHeight2==288)) {
						m_nVideoSize2 = 3;
					}
					else if((m_nWidth2==720) && (m_nHeight2==288)) {
						m_nVideoSize2 = 4;
					}
					else {
						m_nVideoSize2 = -1;
					}
				}
				else {
					if((m_nWidth2 == 176) && (m_nHeight2==120)) {
						m_nVideoSize2 = 0;
					}
					else if((m_nWidth2==320) && (m_nHeight2==240)) {
						m_nVideoSize2 = 1;
					}
					else if((m_nWidth2==352) && (m_nHeight2==240)) {
						m_nVideoSize2 = 2;
					}
					else if((m_nWidth2==704) && (m_nHeight2==240)) {
						m_nVideoSize2 = 3;
					}
					else if((m_nWidth2==720) && (m_nHeight2==240)) {
						m_nVideoSize2 = 4;
					}
					else {
						m_nVideoSize2 = -1;
					}
				}
				EnableField2(TRUE, FALSE, FALSE);
			}
			else {
				m_nPixelFormat2 = -1;
				m_nVideoSize2 = -1;
				m_nWidth2 = 0;
				m_nHeight2= 0;
				m_nFrameRate2 = 1;
				EnableField2(FALSE, (m_nStandard == 0) ? (m_nHeight>288) : (m_nHeight>240), subDesc.iSwitch>1);
			}
		}
	}

	UpdateData(FALSE);

	return TRUE;
}

BOOL CChannelPage::DoApply(int nId) 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	CString  strPath;
	CIniFile iniFile;
	
	pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	iniFile.Create(strPath + OPTION_FILE);

	UpdateData(TRUE);

	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return FALSE;
	}
	
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(hSdk, "TwSetVideoPara");
	if(fTwSetVideoPara == NULL) {
		return FALSE;
	}

	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return FALSE;
	}

	int nChannel = fTwGetChannelCount();
	if(nId >= nChannel) {
		return FALSE;
	}

	HANDLE hChannel = fTwChannelOpen(nId);
	if(hChannel == NULL) {
		return FALSE;
	}

	TF_TwStopVideoCapture fTwStopVideoCapture = (TF_TwStopVideoCapture)GetProcAddress(hSdk, "TwStopVideoCapture");
	TF_TwStopVideoField2 fTwStopVideoField2 = (TF_TwStopVideoField2)GetProcAddress(hSdk, "TwStopVideoField2");
	TF_TwStopAudioCapture fTwStopAudioCapture = (TF_TwStopAudioCapture)GetProcAddress(hSdk, "TwStopAudioCapture");
	TF_TwChannelClose fTwChannelClose = (TF_TwChannelClose)GetProcAddress(hSdk, "TwChannelClose");

	LONG nPixelFormat = vpfYUV422Interspersed;
	TVideoStandard vStandard = m_nStandard==0 ? vsStandardPAL : vsStandardNTSC;

	switch(m_nPixelFormat) {
	case 0:
		nPixelFormat = vpfYUV422Interspersed;
		break;
	case 1:
		nPixelFormat = vpfYUV420Planar;
		break;
	case 2:
		nPixelFormat = vpfYUV411Interspersed;
		break;
	case 3:
		nPixelFormat = vpfRGB15Alpha;
		break;
	case 4:
		nPixelFormat = vpfRGB16;
		break;
	case 5:
		nPixelFormat = vpfRGB24;
		break;
	}

	strPath.Format(SECTION_CHANNEL, nId);
	fTwStopVideoCapture(hChannel);
	fTwStopVideoField2(hChannel);
	fTwStopAudioCapture(hChannel);
	fTwSetVideoPara(hChannel, vpStandard, vStandard);
	if(fTwSetVideoPara(hChannel, vpPixelFormat, nPixelFormat)) {
		iniFile.WriteInt(strPath, KEY_PIXELFORMAT, nPixelFormat);
	}
	else {
		AfxMessageBox(IDS_ERR_PIXELFORMAT);
	}
	fTwSetVideoPara(hChannel, vpWidth, m_nWidth);
	fTwSetVideoPara(hChannel, vpHeight, m_nHeight);
	fTwSetVideoPara(hChannel, vpFrameRate, m_nFrameRate);
	fTwSetVideoPara(hChannel, vpField, m_nField+1);

	iniFile.WriteInt(strPath, KEY_STANDARD, vStandard);
	iniFile.WriteInt(strPath, KEY_FRAMERATE, m_nFrameRate);
	iniFile.WriteInt(strPath, KEY_WIDTH, m_nWidth);
	iniFile.WriteInt(strPath, KEY_HEIGHT, m_nHeight);
	iniFile.WriteInt(strPath, KEY_AUDIO, m_bAudio);

	if(m_nWidth2 != 0) {
		switch(m_nPixelFormat2) {
		case 0:
			nPixelFormat = vpfYUV422Interspersed;
			break;
		case 1:
			nPixelFormat = vpfYUV420Planar;
			break;
		case 2:
			nPixelFormat = vpfYUV411Interspersed;
			break;
		case 3:
			nPixelFormat = vpfRGB15Alpha;
			break;
		case 4:
			nPixelFormat = vpfRGB16;
			break;
		case 5:
			nPixelFormat = vpfRGB24;
			break;
		}
		
		fTwSetVideoPara(hChannel, vpPixelFormat2, nPixelFormat);
		fTwSetVideoPara(hChannel, vpWidth2, m_nWidth2);
		fTwSetVideoPara(hChannel, vpHeight2, m_nHeight2);
		fTwSetVideoPara(hChannel, vpFrameRate2, m_nFrameRate2);

		iniFile.WriteInt(strPath, KEY_FRAMERATE2, m_nFrameRate2);
		iniFile.WriteInt(strPath, KEY_PIXELFORMAT2, nPixelFormat);
		iniFile.WriteInt(strPath, KEY_WIDTH2, m_nWidth2);
		iniFile.WriteInt(strPath, KEY_HEIGHT2, m_nHeight2);
		m_bDeinterlace = FALSE;
		m_bOptimizeCIF = FALSE;
	}

	iniFile.WriteInt(strPath, KEY_DEINTERLACE, m_bDeinterlace);
	iniFile.WriteInt(strPath, KEY_OPTIMIZE_CIF, m_bOptimizeCIF);

	fTwSetVideoPara(hChannel, vpOptimizedCIF, m_bOptimizeCIF);

	return pMainDlg->StartChannel(nId, m_bAudio, m_bDeinterlace);
}

BOOL CChannelPage::Apply()
{
	return DoApply(m_nId);
}

BOOL CChannelPage::Apply2()
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();

	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return FALSE;
	}

	int nChannels = fTwGetChannelCount();

	CCopyToDlg dlg(ITEM_CHANNEL, nChannels);
	if(dlg.DoModal() == IDOK) {
		int i;
		HANDLE hChannel = NULL;
		TF_TwStopVideoCapture fTwStopVideoCapture = (TF_TwStopVideoCapture)GetProcAddress(hSdk, "TwStopVideoCapture");
		TF_TwStopVideoField2 fTwStopVideoField2 = (TF_TwStopVideoField2)GetProcAddress(hSdk, "TwStopVideoField2");
		TF_TwStopAudioCapture fTwStopAudioCapture = (TF_TwStopAudioCapture)GetProcAddress(hSdk, "TwStopAudioCapture");
		TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
		TF_TwChannelClose fTwChannelClose = (TF_TwChannelClose)GetProcAddress(hSdk, "TwChannelClose");

		for(i=0; i<nChannels; i++) {
			if(dlg.m_CopyTo[i]) {
				hChannel = fTwChannelOpen(i);
				if(hChannel == NULL) continue;
				fTwStopVideoCapture(hChannel);
				fTwStopVideoField2(hChannel);
				fTwStopAudioCapture(hChannel);
				fTwChannelClose(hChannel);
			}
		}

		for(i=0; i<nChannels; i++) {
			if(dlg.m_CopyTo[i]) {
				DoApply(i);
			}
		}
	}

	return TRUE;
}

void CChannelPage::OnRadioPal() 
{
	UpdateData(TRUE);

	m_nFrameRate = min(m_nFrameRate, 25);
	m_nFrameRate2= min(m_nFrameRate2, 25);

	switch(m_nVideoSize) {
	case 0:
		m_nHeight = 144;
		break;
	case 2:
	case 3:
	case 6:
		m_nHeight = 288;
		break;
	case 5:
	case 7:
		m_nHeight = 576;
	}

	switch(m_nVideoSize2) {
	case 0:
		m_nHeight2 = 144;
		break;
	case 2:
	case 3:
	case 4:
		m_nHeight2 = 288;
		break;
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioNtsc() 
{
	UpdateData(TRUE);
	
	m_nFrameRate = (m_nFrameRate==25) ? 30 : m_nFrameRate;
	m_nFrameRate2= (m_nFrameRate2==25) ? 30 : m_nFrameRate2;
	
	if(m_nVideoSize < 0) {
		m_nHeight = min(m_nHeight, 480);
	}
	else {
		switch(m_nVideoSize) {
		case 0:
			m_nHeight = 120;
			break;
		case 2:
		case 3:
		case 6:
			m_nHeight = 240;
			break;
		case 5:
		case 7:
			m_nHeight = 480;
		}
	}
	
	if(m_nVideoSize2 < 0) {
		m_nHeight2 = min(m_nHeight2, 240);
	}
	else {
		switch(m_nVideoSize2) {
		case 0:
			m_nHeight2 = 120;
			break;
		case 2:
		case 3:
		case 4:
			m_nHeight2 = 240;
			break;
		}
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioQcif() 
{
	UpdateData(TRUE);

	m_nWidth = 176;
	m_nHeight= (m_nStandard==0) ? 144 : 120;
	
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(FALSE);
	if(!m_bField2) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(TRUE);
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioQvga() 
{
	UpdateData(TRUE);
	
	m_nWidth = 320;
	m_nHeight= 240;
	
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(m_bOptimizeCIF==TRUE);
	if(!m_bField2) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(!m_bSwitch);
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioCif() 
{
	UpdateData(TRUE);
	
	m_nWidth = 352;
	m_nHeight= (m_nStandard==0) ? 288 : 240;
	
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(m_bOptimizeCIF==TRUE);
	if(!m_bField2) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(!m_bSwitch);
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadio2cif() 
{
	UpdateData(TRUE);
	
	m_nWidth = 704;
	m_nHeight= (m_nStandard==0) ? 288 : 240;

	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(m_bOptimizeCIF==TRUE);
	if(!m_bField2) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(!m_bSwitch);
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioVga() 
{
	UpdateData(TRUE);
	
	m_nWidth = 640;
	m_nHeight= 480;
	
	GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ODD)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(FALSE);

	UpdateData(FALSE);
}

void CChannelPage::OnRadio4cif() 
{
	UpdateData(TRUE);
	
	m_nWidth = 704;
	m_nHeight= (m_nStandard==0) ? 576 : 480;
	
	GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ODD)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(FALSE);

	UpdateData(FALSE);
}

void CChannelPage::OnRadioHalfd1() 
{
	UpdateData(TRUE);
	
	m_nWidth = 720;
	m_nHeight= (m_nStandard==0) ? 288 : 240;
	
	if(!m_bField2) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(m_bOptimizeCIF==TRUE);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(!m_bSwitch);
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioD1() 
{
	UpdateData(TRUE);
	
	m_nWidth = 720;
	m_nHeight= (m_nStandard==0) ? 576 : 480;
	
	GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ODD)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(FALSE);
	
	UpdateData(FALSE);
}

void CChannelPage::OnChangeEditHeight() 
{
	UpdateData(TRUE);

	if(m_nStandard == 0) {
		if((m_nWidth == 176) && (m_nHeight==144)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==288)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==288)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==576)) {
			m_nVideoSize = 5;
		}
		else if((m_nWidth==720) && (m_nHeight==288)) {
			m_nVideoSize = 6;
		}
		else if((m_nWidth==720) && (m_nHeight==576)) {
			m_nVideoSize = 7;
		}
		else {
			m_nVideoSize = -1;
		}
	}
	else {
		if((m_nWidth == 176) && (m_nHeight==120)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==240)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==240)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==480)) {
			m_nVideoSize = 5;
		}
		else if((m_nWidth==720) && (m_nHeight==240)) {
			m_nVideoSize = 6;
		}
		else if((m_nWidth==720) && (m_nHeight==480)) {
			m_nVideoSize = 7;
		}
		else {
			m_nVideoSize = -1;
		}
	}

	if(!m_bField2) {
		BOOL bEnable = (m_nStandard == 0) ? (m_nHeight>288) : (m_nHeight>240);
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(bEnable);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(bEnable);
		GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(bEnable && !m_bSwitch);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(bEnable);
	}

	UpdateData(FALSE);
}

void CChannelPage::OnChangeEditWidth() 
{
	UpdateData(TRUE);

	if(m_nStandard == 0) {
		if((m_nWidth == 176) && (m_nHeight==144)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==288)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==288)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==576)) {
			m_nVideoSize = 5;
		}
		else {
			m_nVideoSize = -1;
		}
	}
	else {
		if((m_nWidth == 176) && (m_nHeight==120)) {
			m_nVideoSize = 0;
		}
		else if((m_nWidth==320) && (m_nHeight==240)) {
			m_nVideoSize = 1;
		}
		else if((m_nWidth==352) && (m_nHeight==240)) {
			m_nVideoSize = 2;
		}
		else if((m_nWidth==704) && (m_nHeight==240)) {
			m_nVideoSize = 3;
		}
		else if((m_nWidth==640) && (m_nHeight==480)) {
			m_nVideoSize = 4;
		}
		else if((m_nWidth==704) && (m_nHeight==480)) {
			m_nVideoSize = 5;
		}
		else {
			m_nVideoSize = -1;
		}
	}
	
	UpdateData(FALSE);
}


void CChannelPage::OnRadioQcif2() 
{
	UpdateData(TRUE);
	
	m_nWidth2 = 176;
	m_nHeight2= (m_nStandard==0) ? 144 : 120;
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioQvga2() 
{
	UpdateData(TRUE);
	
	m_nWidth2 = 320;
	m_nHeight2= 240;
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioCif2() 
{
	UpdateData(TRUE);
	
	m_nWidth2 = 352;
	m_nHeight2= (m_nStandard==0) ? 288 : 240;
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadio2cif2() 
{
	UpdateData(TRUE);
	
	m_nWidth2 = 704;
	m_nHeight2= (m_nStandard==0) ? 288 : 240;
	
	UpdateData(FALSE);
}

void CChannelPage::OnRadioHalfd12() 
{
	UpdateData(TRUE);
	
	m_nWidth2 = 720;
	m_nHeight2= (m_nStandard==0) ? 288 : 240;
	
	UpdateData(FALSE);
}

void CChannelPage::OnChangeEditHeight2() 
{
	UpdateData(TRUE);
	
	if(m_nStandard == 0) {
		if((m_nWidth2 == 176) && (m_nHeight2==144)) {
			m_nVideoSize2 = 0;
		}
		else if((m_nWidth2==320) && (m_nHeight2==240)) {
			m_nVideoSize2 = 1;
		}
		else if((m_nWidth2==352) && (m_nHeight2==288)) {
			m_nVideoSize2 = 2;
		}
		else if((m_nWidth2==704) && (m_nHeight2==288)) {
			m_nVideoSize2 = 3;
		}
		else if((m_nWidth2==720) && (m_nHeight2==288)) {
			m_nVideoSize2 = 4;
		}
		else {
			m_nVideoSize2 = -1;
		}
	}
	else {
		if((m_nWidth2 == 176) && (m_nHeight2==120)) {
			m_nVideoSize2 = 0;
		}
		else if((m_nWidth2==320) && (m_nHeight2==240)) {
			m_nVideoSize2 = 1;
		}
		else if((m_nWidth2==352) && (m_nHeight2==240)) {
			m_nVideoSize2 = 2;
		}
		else if((m_nWidth2==704) && (m_nHeight2==240)) {
			m_nVideoSize2 = 3;
		}
		else if((m_nWidth2==720) && (m_nHeight2==240)) {
			m_nVideoSize2 = 4;
		}
		else {
			m_nVideoSize2 = -1;
		}
	}
	
	UpdateData(FALSE);
}

void CChannelPage::OnChangeEditWidth2() 
{
	UpdateData(TRUE);
	
	if(m_nStandard == 0) {
		if((m_nWidth2 == 176) && (m_nHeight2==144)) {
			m_nVideoSize2 = 0;
		}
		else if((m_nWidth2==320) && (m_nHeight2==240)) {
			m_nVideoSize2 = 1;
		}
		else if((m_nWidth2==352) && (m_nHeight2==288)) {
			m_nVideoSize2 = 2;
		}
		else if((m_nWidth2==704) && (m_nHeight2==288)) {
			m_nVideoSize2 = 3;
		}
		else if((m_nWidth2==720) && (m_nHeight2==288)) {
			m_nVideoSize2 = 4;
		}
		else {
			m_nVideoSize2 = -1;
		}
	}
	else {
		if((m_nWidth2 == 176) && (m_nHeight2==120)) {
			m_nVideoSize2 = 0;
		}
		else if((m_nWidth2==320) && (m_nHeight2==240)) {
			m_nVideoSize2 = 1;
		}
		else if((m_nWidth2==352) && (m_nHeight2==240)) {
			m_nVideoSize2 = 2;
		}
		else if((m_nWidth2==704) && (m_nHeight2==240)) {
			m_nVideoSize2 = 3;
		}
		else if((m_nWidth2==720) && (m_nHeight2==240)) {
			m_nVideoSize2 = 4;
		}
		else {
			m_nVideoSize2 = -1;
		}
	}
	
	UpdateData(FALSE);
}

void CChannelPage::EnableField2(BOOL bEnable, BOOL b4Cif, BOOL bSwitch)
{
	//GetDlgItem(IDC_RADIO_YUY2_2)->EnableWindow(bEnable);
	//GetDlgItem(IDC_RADIO_YV12_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_FRAMERATE_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_WIDTH_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_HEIGHT_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_QCIF_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_QVGA_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_CIF_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_2CIF_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_HALFD1_2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_VGA)->EnableWindow(!bEnable);
	GetDlgItem(IDC_RADIO_4CIF)->EnableWindow(!bEnable);
	GetDlgItem(IDC_RADIO_D1)->EnableWindow(!bEnable);
	if(bEnable) {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_RADIO_EVEN)->EnableWindow(!b4Cif);
		GetDlgItem(IDC_RADIO_ODD)->EnableWindow(!b4Cif);
		GetDlgItem(IDC_CHECK_DEINTERLACE)->EnableWindow(b4Cif||(m_bOptimizeCIF==TRUE));
		GetDlgItem(IDC_CHECK_OPTMIZECIF)->EnableWindow(!b4Cif && !bSwitch);
	}
	m_bField2 = bEnable;
	m_bSwitch = bSwitch;
}

void CChannelPage::OnRadioYv12() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioYv122() 
{
	UpdateData(TRUE);
	m_nPixelFormat = m_nPixelFormat2;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioYuy2() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioYuy22() 
{
	UpdateData(TRUE);
	m_nPixelFormat = m_nPixelFormat2;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioRgb555() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioRgb565() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioRgb24() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnRadioY41p() 
{
	UpdateData(TRUE);
	m_nPixelFormat2 = m_nPixelFormat;
	UpdateData(FALSE);
}

void CChannelPage::OnBtnStartchannel() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return;
	}
	
	TF_TwStartVideoCapture fTwStartVideoCapture = (TF_TwStartVideoCapture)GetProcAddress(hSdk, "TwStartVideoCapture");
	if(fTwStartVideoCapture == NULL) {
		return;
	}
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwStartVideoCapture(hChannel);
}

void CChannelPage::OnBtnStopchannel() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return;
	}
	
	TF_TwStopVideoCapture fTwStopVideoCapture = (TF_TwStopVideoCapture)GetProcAddress(hSdk, "TwStopVideoCapture");
	if(fTwStopVideoCapture == NULL) {
		return;
	}
	
	HANDLE hChannel = fTwChannelOpen(m_nId);
	if(hChannel == NULL) {
		return;
	}
	
	fTwStopVideoCapture(hChannel);
}
