/**
***************************************************************************************
*  Copyright (C) 2010, Techwell
*  All rights reserved.
*
*  @file 		ConvertYuvRgb.cpp
*  @brief		Color space convert, copy from ffdshow project
*
*  @version		0.0.0.1
*  @author		liran, copyright by ffdshow
*  @date		2010/06/07
***************************************************************************************
*/

#include "stdafx.h"
#include <windows.h>
#include "inttypes.h"

#ifndef WIN64

#include <stddef.h>
typedef ptrdiff_t stride_t;

#include "convert_yuy2.h"
#include "convert_yv12.h"

#else	//WIN64

#include "color_yuv2rgb.h"

class CColorYuv2rgbInit {
public:
	CColorYuv2rgbInit() {
		yuv2rgb_init();
	}
	~CColorYuv2rgbInit(){}
} g_initColorYuv2rgb;

#endif

#include "ConvertYuvRgb.h"

void CConvertYuvRgb::yuy2_to_rgb24(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
    Tmmx_ConvertYUY2toRGB<0,0>::mmx_ConvertYUY2toRGB(src,dst,src_end,src_pitch,dst_pitch,w<<1,0);
#else
	yuv422_to_rgb24((uint8_t*)dst, (uint8_t*)src, w*h);
#endif
}

void CConvertYuvRgb::yuy2_to_rgb32(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
    Tmmx_ConvertYUY2toRGB<0,1>::mmx_ConvertYUY2toRGB(src,dst,src_end,src_pitch,dst_pitch,w<<1,0);
#else
#endif
}

void CConvertYuvRgb::uyvy_to_rgb24(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
    Tmmx_ConvertYUY2toRGB<1,0>::mmx_ConvertYUY2toRGB(src,dst,src_end,src_pitch,dst_pitch,w<<1,0);
#else
#endif
}

void CConvertYuvRgb::uyvy_to_rgb32(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
    Tmmx_ConvertYUY2toRGB<1,1>::mmx_ConvertYUY2toRGB(src,dst,src_end,src_pitch,dst_pitch,w<<1,0);
#else
#endif
}

void CConvertYuvRgb::rgb24_to_yuy2(const BYTE* src,BYTE* dst,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
	Tmmx_ConvertRGBtoYUY2<true,false>::mmx_ConvertRGBtoYUY2(src,dst,src_pitch,dst_pitch,w,h,0);
#else
#endif
}

void CConvertYuvRgb::rgb32_to_yuy2(const BYTE* src,BYTE* dst,LONG src_pitch,LONG dst_pitch,int w,int h)
{
#ifndef WIN64
	Tmmx_ConvertRGBtoYUY2<false,false>::mmx_ConvertRGBtoYUY2(src,dst,src_pitch,dst_pitch,w,h,0);
#else
#endif
}
