/**
***************************************************************************************
*  Copyright (C) 2010, Techwell
*  All rights reserved.
*
*  @file 		ConvertYuvRgb.H
*  @brief		Color space convert
*
*  @version		0.0.0.1
*  @author		liran
*  @date		2010/06/07
***************************************************************************************
*/

#if !defined(__CONVERTYUVRGB_H_)
#define __CONVERTYUVRGB_H_

class CConvertYuvRgb
{
public:
    CConvertYuvRgb();
    virtual ~CConvertYuvRgb();

	static void yuy2_to_rgb24(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h);
	static void yuy2_to_rgb32(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h);
	static void uyvy_to_rgb24(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h);
	static void uyvy_to_rgb32(const BYTE* src,BYTE* dst,const BYTE* src_end,LONG src_pitch,LONG dst_pitch,int w,int h);

	static void rgb24_to_yuy2(const BYTE* src,BYTE* dst,LONG src_pitch,LONG dst_pitch,int w,int h);
	static void rgb32_to_yuy2(const BYTE* src,BYTE* dst,LONG src_pitch,LONG dst_pitch,int w,int h);
};

#endif // !defined(__CONVERTYUVRGB_H_)
