// CopyToDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "CopyToDlg.h"
#include "OptionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCopyToDlg dialog


CCopyToDlg::CCopyToDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCopyToDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCopyToDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	ZeroMemory(m_CopyTo, sizeof(m_CopyTo));
	m_nType = ITEM_CHANNEL;
}

CCopyToDlg::CCopyToDlg(int nType, int nChannels, CWnd* pParent /*=NULL*/)
: CDialog(CCopyToDlg::IDD, pParent),
m_nType(nType),m_nChannels(nChannels)
{
	//{{AFX_DATA_INIT(CCopyToDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	ZeroMemory(m_CopyTo, sizeof(m_CopyTo));
}

void CCopyToDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCopyToDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCopyToDlg, CDialog)
	//{{AFX_MSG_MAP(CCopyToDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCopyToDlg message handlers

BOOL CCopyToDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if((wParam >= IDC_CHK_CHANNEL1) && (wParam < (IDC_CHK_CHANNEL1+(UINT)min(m_nChannels,MAX_COPYCHANNELS)))) {
		ULONG nChannel = ((ULONG)wParam - IDC_CHK_CHANNEL1);
		m_CopyTo[nChannel] = ((CButton*)GetDlgItem((int)wParam))->GetCheck();
		if(!m_CopyTo[nChannel]) {
			((CButton*)GetDlgItem(IDC_CHK_CHANNEL_ALL))->SetCheck(FALSE);
		}
		else {
			int i;
			for(i=0; i<min(m_nChannels,MAX_COPYCHANNELS); i++) {
				if(!m_CopyTo[i]) {
					break;
				}
			}
			if(i >= m_nChannels) {
				((CButton*)GetDlgItem(IDC_CHK_CHANNEL_ALL))->SetCheck(TRUE);
			}
		}
	}
	else if(wParam == IDC_CHK_CHANNEL_ALL) {
		BOOL bAll = ((CButton*)GetDlgItem((int)wParam))->GetCheck();
		int  i;
		for(i=0; i<min(m_nChannels,MAX_COPYCHANNELS); i++) {
			m_CopyTo[i] = bAll;
			((CButton*)GetDlgItem(IDC_CHK_CHANNEL1+i))->SetCheck(bAll);
		}
	}

	return CDialog::OnCommand(wParam, lParam);
}

BOOL CCopyToDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString strText;
	int 	i;
	UINT	uStrID = (m_nType == ITEM_CHANNEL) ? IDS_CHANNEL_ID : IDS_SUBDEVICE_ID;

	for(i=IDC_CHK_CHANNEL1; i<IDC_CHK_CHANNEL_ALL; i++) {
		strText.Format(uStrID, i-IDC_CHK_CHANNEL1+1);
		SetDlgItemText(i, strText);
	}

	for(i=0; i<min(m_nChannels,MAX_COPYCHANNELS); i++) {
		((CButton*)GetDlgItem(IDC_CHK_CHANNEL1+i))->SetCheck(m_CopyTo[i]);
	}

	for(i=m_nChannels; i<MAX_COPYCHANNELS; i++) {
		GetDlgItem(IDC_CHK_CHANNEL1+i)->EnableWindow(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
