// DevicePage.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "TW68XXDlg.h"
#include "DevicePage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BYTES_SEP	TEXT(' ')

/////////////////////////////////////////////////////////////////////////////
// CDevicePage dialog


CDevicePage::CDevicePage(CWnd* pParent /*=NULL*/)
	: COptionPage(CDevicePage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevicePage)
	m_nGpio = 0;
	m_nGpioBit = 0;
	m_i2cReadAddr = _T("");
	m_i2cReadData = _T("");
	m_i2cWriteData = _T("");
	m_nGpioMode = -1;
	m_nReadBytes = 0;
	m_regVideo = _T("");
	m_valVideo = _T("");
	m_regAudio = _T("");
	m_valAudio = _T("");
	//}}AFX_DATA_INIT

	m_hGpio = NULL;
	m_hI2C  = NULL;
	m_hDevice = NULL;
	m_hDeviceAudio = NULL;
}


void CDevicePage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevicePage)
	DDX_CBIndex(pDX, IDC_COMBO_GPIO, m_nGpio);
	DDX_Text(pDX, IDC_EDIT_GPIO, m_nGpioBit);
	DDV_MinMaxUInt(pDX, m_nGpioBit, 0, 1);
	DDX_Text(pDX, IDC_EDIT_I2CREAD_ADDR, m_i2cReadAddr);
	DDX_Text(pDX, IDC_EDIT_I2CREAD_DATA, m_i2cReadData);
	DDX_Text(pDX, IDC_EDIT_I2CWRITE, m_i2cWriteData);
	DDX_Radio(pDX, IDC_RADIO_GPIO_INPUT, m_nGpioMode);
	DDX_Text(pDX, IDC_EDIT_I2CREAD_BYTES, m_nReadBytes);
	DDV_MinMaxUInt(pDX, m_nReadBytes, 0, 100);
	DDX_Text(pDX, IDC_EDIT_VIDEO_REG_ADDR, m_regVideo);
	DDV_MaxChars(pDX, m_regVideo, 8);
	DDX_Text(pDX, IDC_EDIT_VIDEO_REG_VALUE, m_valVideo);
	DDV_MaxChars(pDX, m_valVideo, 8);
	DDX_Text(pDX, IDC_EDIT_AUDIO_REG_ADDR, m_regAudio);
	DDV_MaxChars(pDX, m_regAudio, 8);
	DDX_Text(pDX, IDC_EDIT_AUDIO_REG_VALUE, m_valAudio);
	DDV_MaxChars(pDX, m_valAudio, 8);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevicePage, CDialog)
	//{{AFX_MSG_MAP(CDevicePage)
	ON_BN_CLICKED(IDC_RADIO_GPIO_OUT0, OnRadioGpioOut0)
	ON_BN_CLICKED(IDC_RADIO_GPIO_OUT1, OnRadioGpioOut1)
	ON_BN_CLICKED(IDC_BTN_GPIO_READ, OnBtnGpioRead)
	ON_CBN_SELCHANGE(IDC_COMBO_GPIO, OnSelchangeComboGpio)
	ON_BN_CLICKED(IDC_BTN_I2CREAD, OnBtnI2cread)
	ON_BN_CLICKED(IDC_BTN_I2CWRITE, OnBtnI2cwrite)
	ON_EN_CHANGE(IDC_EDIT_I2CWRITE, OnChangeEditI2cwrite)
	ON_EN_CHANGE(IDC_EDIT_I2CREAD_ADDR, OnChangeEditI2creadAddr)
	ON_BN_CLICKED(IDC_RADIO_GPIO_INPUT, OnRadioGpioInput)
	ON_BN_CLICKED(IDC_BTN_READ24C02, OnBtnRead24c02)
	ON_BN_CLICKED(IDC_BTN_VIDEO_REG_WRITE, OnBtnVideoRegWrite)
	ON_BN_CLICKED(IDC_BTN_VIDEO_REG_READ, OnBtnVideoRegRead)
	ON_BN_CLICKED(IDC_BTN_AUDIO_REG_WRITE, OnBtnAudioRegWrite)
	ON_BN_CLICKED(IDC_BTN_AUDIO_REG_READ, OnBtnAudioRegRead)
	ON_BN_CLICKED(IDC_BTN_VIDEO_CFG_WRITE, OnBtnVideoCfgWrite)
	ON_BN_CLICKED(IDC_BTN_VIDEO_CFG_READ, OnBtnVideoCfgRead)
	ON_BN_CLICKED(IDC_BTN_AUDIO_CFG_WRITE, OnBtnAudioCfgWrite)
	ON_BN_CLICKED(IDC_BTN_AUDIO_CFG_READ, OnBtnAudioCfgRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevicePage message handlers

void CDevicePage::OnOK() 
{
}

void CDevicePage::OnCancel() 
{
}

void CDevicePage::OnRadioGpioInput() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();

	UpdateData(TRUE);

	TF_TwGPIOEnableOutput fTwGPIOEnableOutput = (TF_TwGPIOEnableOutput)GetProcAddress(hSdk, "TwGPIOEnableOutput");
	fTwGPIOEnableOutput(m_hGpio, m_nGpio, 1, FALSE);
}

void CDevicePage::OnRadioGpioOut0() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	UpdateData(TRUE);

	TF_TwGPIOEnableOutput fTwGPIOEnableOutput = (TF_TwGPIOEnableOutput)GetProcAddress(hSdk, "TwGPIOEnableOutput");
	fTwGPIOEnableOutput(m_hGpio, m_nGpio, 1, TRUE);

	TF_TwGPIOSetBits fTwGPIOSetBits = (TF_TwGPIOSetBits)GetProcAddress(hSdk, "TwGPIOSetBits");
	ULONG bitSet = 0;
	fTwGPIOSetBits(m_hGpio, m_nGpio, 1, &bitSet);
}

void CDevicePage::OnRadioGpioOut1() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();

	UpdateData(TRUE);
	
	TF_TwGPIOEnableOutput fTwGPIOEnableOutput = (TF_TwGPIOEnableOutput)GetProcAddress(hSdk, "TwGPIOEnableOutput");
	fTwGPIOEnableOutput(m_hGpio, m_nGpio, 1, TRUE);
	
	TF_TwGPIOSetBits fTwGPIOSetBits = (TF_TwGPIOSetBits)GetProcAddress(hSdk, "TwGPIOSetBits");
	ULONG bitSet = 1;
	fTwGPIOSetBits(m_hGpio, m_nGpio, 1, &bitSet);
}

void CDevicePage::OnBtnGpioRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwGPIOGetBits fTwGPIOGetBits = (TF_TwGPIOGetBits)GetProcAddress(hSdk, "TwGPIOGetBits");
	fTwGPIOGetBits(m_hGpio, m_nGpio, 1, (PULONG)&m_nGpioBit);
	UpdateData(FALSE);
}

void CDevicePage::OnSelchangeComboGpio() 
{
	UpdateData(TRUE);
	m_nGpioMode = -1;
	UpdateData(FALSE);
}

BOOL CDevicePage::Split(CString line,CString sep,CStringArray &strArr)
{
	INT posi(0);
	CString temp(TEXT(""));
	while((posi=line.Find(sep))>0)
	{
		temp=line.Left(posi);
		if(!temp.IsEmpty())strArr.Add(temp);
		line=line.Right(line.GetLength()-posi-sep.GetLength());
	}
	if(!line.IsEmpty())strArr.Add(line);
	return TRUE;
}

BYTE CDevicePage::Char2Hex(TCHAR cHex)
{
	if((cHex >= _T('0')) && (cHex <= _T('9'))) {
		return (cHex - _T('0'));
	}
	else if((cHex >= _T('A')) && (cHex <= _T('F'))) {
		return (cHex - _T('A') + 10);
	}

	return 0;
}

BYTE CDevicePage::Str2Byte(CString strHex)
{
	return ((Char2Hex(strHex[0])<<4) | ((Char2Hex(strHex[1]))&0x0F));
}

void CDevicePage::OnBtnI2cread() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwI2CRead fTwI2CRead  = (TF_TwI2CRead)GetProcAddress(hSdk, "TwI2CRead");
	UINT nWriteBytes=1;
	BYTE Bytes2Write[100];
	BYTE Bytes2Read[100];

	UpdateData(TRUE);
	ZeroMemory(Bytes2Write, 100);
	ZeroMemory(Bytes2Read, 100);

	CStringArray strBytes;
	CString		 strSep(BYTES_SEP);
	UINT i;
	Split(m_i2cReadAddr, strSep, strBytes);
	nWriteBytes = (UINT)strBytes.GetSize();

	for(i=0; i<nWriteBytes; i++) {
		Bytes2Write[i] = Str2Byte(strBytes.GetAt(i));
	}

	m_i2cReadData = TEXT("");
	if(fTwI2CRead(m_hI2C, nWriteBytes, Bytes2Write, m_nReadBytes, Bytes2Read)) {
		CString strHex;
		for(i=0; i<m_nReadBytes; i++) {
			strHex.Format(TEXT("%02X"), Bytes2Read[i]);
			m_i2cReadData += strHex;
			m_i2cReadData += BYTES_SEP;
		}
	}
	UpdateData(FALSE);
}


void CDevicePage::OnBtnRead24c02() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwI2CRead fTwI2CRead  = (TF_TwI2CRead)GetProcAddress(hSdk, "TwI2CRead");
	UINT nWriteBytes=1;
	BYTE Bytes2Write[100];
	BYTE Bytes2Read[100];
	
	UpdateData(TRUE);
	ZeroMemory(Bytes2Write, 100);
	ZeroMemory(Bytes2Read, 100);
	
	CStringArray strBytes;
	CString		 strSep(BYTES_SEP);
	UINT i;
	Split(m_i2cReadAddr, strSep, strBytes);
	nWriteBytes = (UINT)strBytes.GetSize();
	if(nWriteBytes<1) return;
	for(i=0; i<nWriteBytes; i++) {
		Bytes2Write[i] = Str2Byte(strBytes.GetAt(i));
	}
	
	TF_TwI2CWrite fTwI2CWrite  = (TF_TwI2CWrite)GetProcAddress(hSdk, "TwI2CWrite");
	TF_TwI2CWriteNoStop fTwI2CWriteNoStop  = (TF_TwI2CWriteNoStop)GetProcAddress(hSdk, "TwI2CWriteNoStop");

	m_i2cReadData = TEXT("");
	if(fTwI2CWriteNoStop(m_hI2C, nWriteBytes, Bytes2Write)) {
		Bytes2Write[0] = Bytes2Write[0] | 1;
		if(fTwI2CRead(m_hI2C, 1, Bytes2Write, m_nReadBytes, Bytes2Read)) {
			CString strHex;
			for(i=0; i<m_nReadBytes; i++) {
				strHex.Format(TEXT("%02X"), Bytes2Read[i]);
				m_i2cReadData += strHex;
				m_i2cReadData += BYTES_SEP;
			}
		}
	}
	UpdateData(FALSE);
}

void CDevicePage::OnBtnI2cwrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwI2CWrite fTwI2CWrite  = (TF_TwI2CWrite)GetProcAddress(hSdk, "TwI2CWrite");
	UINT nWriteBytes=1;
	BYTE Bytes2Write[100];
	
	ZeroMemory(Bytes2Write, 100);
	
	CStringArray strBytes;
	CString		 strSep(BYTES_SEP);
	UINT i;
	Split(m_i2cWriteData, strSep, strBytes);
	nWriteBytes = (UINT)strBytes.GetSize();
	
	for(i=0; i<nWriteBytes; i++) {
		Bytes2Write[i] = Str2Byte(strBytes.GetAt(i));
	}

	fTwI2CWrite(m_hI2C, nWriteBytes, Bytes2Write);
}

void CDevicePage::OnChangeEditI2cwrite() 
{
	CString strOld = m_i2cWriteData;
	int i, nPos, nPosEnd;

	((CEdit*)GetDlgItem(IDC_EDIT_I2CWRITE))->GetSel(nPos, nPosEnd);
	UpdateData(TRUE);

	for(i=0; i<m_i2cWriteData.GetLength(); i++) {
		if(m_i2cWriteData[i] == BYTES_SEP) {
			continue;
		}
		else if((m_i2cWriteData[i] >= _T('0')) && (m_i2cWriteData[i] <= _T('9'))) {
			continue;
		}
		else if((m_i2cWriteData[i] >= _T('A')) && (m_i2cWriteData[i] <= _T('F'))) {
			continue;
		}
		else {
			m_i2cWriteData = strOld;
			break;
		}
	}

	for(i=0; i<m_i2cWriteData.GetLength(); i++) {
		if(m_i2cWriteData[i] == BYTES_SEP) {
			m_i2cWriteData.Delete(i);
			i--;
		}
	}

	int nSep = (m_i2cWriteData.GetLength() / 2);
	for(i=0; i<nSep; i++) {
		m_i2cWriteData.Insert((i+1)*2 + i, BYTES_SEP);
	}

	UpdateData(FALSE);

	i = min(m_i2cWriteData.GetLength(), nPos+1);
	((CEdit*)GetDlgItem(IDC_EDIT_I2CWRITE))->SetSel(i, i);
}

void CDevicePage::OnChangeEditI2creadAddr() 
{
	CString strOld = m_i2cReadAddr;
	int i, nPos, nPosEnd;
	
	((CEdit*)GetDlgItem(IDC_EDIT_I2CREAD_ADDR))->GetSel(nPos, nPosEnd);
	UpdateData(TRUE);

	for(i=0; i<m_i2cReadAddr.GetLength(); i++) {
		if(m_i2cReadAddr[i] == BYTES_SEP) {
			continue;
		}
		else if((m_i2cReadAddr[i] >= _T('0')) && (m_i2cReadAddr[i] <= _T('9'))) {
			continue;
		}
		else if((m_i2cReadAddr[i] >= _T('A')) && (m_i2cReadAddr[i] <= _T('F'))) {
			continue;
		}
		else {
			m_i2cReadAddr = strOld;
			break;
		}
	}
	
	for(i=0; i<m_i2cReadAddr.GetLength(); i++) {
		if(m_i2cReadAddr[i] == BYTES_SEP) {
			m_i2cReadAddr.Delete(i);
			i--;
		}
	}
	
	int nSep = (m_i2cReadAddr.GetLength() / 2);
	for(i=0; i<nSep; i++) {
		m_i2cReadAddr.Insert((i+1)*2 + i, BYTES_SEP);
	}
	
	UpdateData(FALSE);
	
	i = min(m_i2cReadAddr.GetLength(), nPos+1);
	((CEdit*)GetDlgItem(IDC_EDIT_I2CREAD_ADDR))->SetSel(i, i);
}

BOOL CDevicePage::SetId(int nId)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();

	TF_TwI2COpen   fTwI2COpen  = (TF_TwI2COpen)GetProcAddress(hSdk, "TwI2COpen");
	TF_TwGPIOOpen  fTwGPIOOpen = (TF_TwGPIOOpen)GetProcAddress(hSdk, "TwGPIOOpen");
	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(hSdk, "TwGetDeviceHandle");
	TF_TwGetDeviceAudioHandle fTwGetDeviceAudioHandle = (TF_TwGetDeviceAudioHandle)GetProcAddress(hSdk, "TwGetDeviceAudioHandle");
	
	if((m_hGpio!=NULL) || (m_hI2C!=NULL)) {
		TF_TwI2CClose  fTwI2CClose = (TF_TwI2CClose)GetProcAddress(hSdk, "TwI2CClose");
		TF_TwGPIOClose fTwGPIOClose= (TF_TwGPIOClose)GetProcAddress(hSdk, "TwGPIOClose");

		fTwI2CClose(m_hI2C);
		fTwGPIOClose(m_hGpio);
	}

	m_nId = nId;
	m_hDevice = fTwGetDeviceHandle(m_nId);
	m_hDeviceAudio = fTwGetDeviceAudioHandle(m_nId);
	if(m_hDevice==NULL) {
		return FALSE;
	}

	m_hGpio = fTwGPIOOpen(m_hDevice);
	m_hI2C  = fTwI2COpen(m_hDevice);

	BOOL bGpio = (m_hGpio!=NULL);
	BOOL bI2C  = (m_hI2C!=NULL);

	GetDlgItem(IDC_BTN_I2CWRITE)->EnableWindow(bI2C);
	GetDlgItem(IDC_EDIT_I2CWRITE)->EnableWindow(bI2C);
	GetDlgItem(IDC_EDIT_I2CREAD_ADDR)->EnableWindow(bI2C);
	GetDlgItem(IDC_EDIT_I2CREAD_BYTES)->EnableWindow(bI2C);
	GetDlgItem(IDC_BTN_I2CREAD)->EnableWindow(bI2C);
	GetDlgItem(IDC_BTN_READ24C02)->EnableWindow(bI2C);

	GetDlgItem(IDC_COMBO_GPIO)->EnableWindow(bGpio);
	GetDlgItem(IDC_RADIO_GPIO_INPUT)->EnableWindow(bGpio);
	GetDlgItem(IDC_RADIO_GPIO_OUT0)->EnableWindow(bGpio);
	GetDlgItem(IDC_RADIO_GPIO_OUT1)->EnableWindow(bGpio);
	GetDlgItem(IDC_BTN_GPIO_READ)->EnableWindow(bGpio);

	BOOL bAudioDevice = (m_hDeviceAudio!=NULL);
	GetDlgItem(IDC_EDIT_AUDIO_REG_ADDR)->EnableWindow(bAudioDevice);
	GetDlgItem(IDC_EDIT_AUDIO_REG_VALUE)->EnableWindow(bAudioDevice);
	GetDlgItem(IDC_BTN_AUDIO_REG_WRITE)->EnableWindow(bAudioDevice);
	GetDlgItem(IDC_BTN_AUDIO_REG_READ)->EnableWindow(bAudioDevice);
	GetDlgItem(IDC_BTN_AUDIO_CFG_READ)->EnableWindow(bAudioDevice);
	GetDlgItem(IDC_BTN_AUDIO_CFG_WRITE)->EnableWindow(bAudioDevice);

	return TRUE;
}

void CDevicePage::OnBtnVideoRegWrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwSetDeviceRegDWORD fTwSetDeviceRegDWORD  = (TF_TwSetDeviceRegDWORD)GetProcAddress(hSdk, "TwSetDeviceRegDWORD");

	UpdateData(TRUE);
	if(m_regVideo.GetLength() == 0) return;
	if(m_valVideo.GetLength() == 0) return;
	nLen = m_regVideo.GetLength();
	for(i=0; i<nLen; i++) {
		uReg |= (Char2Hex(m_regVideo[i]) << ((nLen-i-1)*4));
	}
	nLen = m_valVideo.GetLength();
	for(i=0; i<nLen; i++) {
		uVal |= (Char2Hex(m_valVideo[i]) << ((nLen-i-1)*4));
	}

	fTwSetDeviceRegDWORD(m_hDevice, uReg, uVal);
}

void CDevicePage::OnBtnVideoRegRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwGetDeviceRegDWORD fTwGetDeviceRegDWORD  = (TF_TwGetDeviceRegDWORD)GetProcAddress(hSdk, "TwGetDeviceRegDWORD");
	
	UpdateData(TRUE);
	nLen = m_regVideo.GetLength();
	if(nLen == 0) return;
	for(i=0; i<nLen; i++) {
		uReg |= (Char2Hex(m_regVideo[i]) << ((nLen-i-1)*4));
	}
	
	if(fTwGetDeviceRegDWORD(m_hDevice, uReg, &uVal)) {
		m_valVideo.Format(TEXT("%08X"), uVal);
		UpdateData(FALSE);
	}
}

void CDevicePage::OnBtnAudioRegWrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwSetDeviceRegDWORD fTwSetDeviceRegDWORD  = (TF_TwSetDeviceRegDWORD)GetProcAddress(hSdk, "TwSetDeviceRegDWORD");
	
	UpdateData(TRUE);
	if(m_regAudio.GetLength() == 0) return;
	if(m_valAudio.GetLength() == 0) return;
	nLen = m_regAudio.GetLength();
	for(i=0; i<nLen; i++) {
		uReg |= (Char2Hex(m_regAudio[i]) << ((nLen-i-1)*4));
	}
	nLen = m_valAudio.GetLength();
	for(i=0; i<nLen; i++) {
		uVal |= (Char2Hex(m_valAudio[i]) << ((nLen-i-1)*4));
	}
	
	fTwSetDeviceRegDWORD(m_hDeviceAudio, uReg, uVal);
}

void CDevicePage::OnBtnAudioRegRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwGetDeviceRegDWORD fTwGetDeviceRegDWORD  = (TF_TwGetDeviceRegDWORD)GetProcAddress(hSdk, "TwGetDeviceRegDWORD");
	
	UpdateData(TRUE);
	nLen = m_regAudio.GetLength();
	if(nLen == 0) return;
	for(i=0; i<nLen; i++) {
		uReg |= (Char2Hex(m_regAudio[i]) << ((nLen-i-1)*4));
	}
	
	if(fTwGetDeviceRegDWORD(m_hDeviceAudio, uReg, &uVal)) {
		m_valAudio.Format(TEXT("%08X"), uVal);
		UpdateData(FALSE);
	}
}

void CDevicePage::OnBtnVideoCfgWrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwSetDevicePciConfigSpace fTwSetDevicePciConfigSpace  = (TF_TwSetDevicePciConfigSpace)GetProcAddress(hSdk, "TwSetDevicePciConfigSpace");
	
	UpdateData(TRUE);
	if(m_regVideo.GetLength() == 0) return;
	if(m_valVideo.GetLength() == 0) return;
	nLen = m_regVideo.GetLength();
	for(i=0; i<min(nLen,2); i++) {
		uReg |= (Char2Hex(m_regVideo[i]) << ((nLen-i-1)*4));
	}
	
	nLen = m_valVideo.GetLength();
	for(i=0; i<min(nLen,2); i++) {
		uVal |= (Char2Hex(m_valVideo[i]) << ((nLen-i-1)*4));
	}

	fTwSetDevicePciConfigSpace(m_hDevice, uReg, 1, (PBYTE)&uVal);
}

void CDevicePage::OnBtnVideoCfgRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwGetDevicePciConfigSpace fTwGetDevicePciConfigSpace  = (TF_TwGetDevicePciConfigSpace)GetProcAddress(hSdk, "TwGetDevicePciConfigSpace");
	
	UpdateData(TRUE);
	nLen = m_regVideo.GetLength();
	if(nLen == 0) return;
	for(i=0; i<min(nLen,2); i++) {
		uReg |= (Char2Hex(m_regVideo[i]) << ((nLen-i-1)*4));
	}
	
	if(fTwGetDevicePciConfigSpace(m_hDevice, uReg, 1, (PBYTE)&uVal)) {
		m_valVideo.Format(TEXT("%02X"), uVal);
		UpdateData(FALSE);
	}
}

void CDevicePage::OnBtnAudioCfgWrite() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwSetDevicePciConfigSpace fTwSetDevicePciConfigSpace  = (TF_TwSetDevicePciConfigSpace)GetProcAddress(hSdk, "TwSetDevicePciConfigSpace");
	
	UpdateData(TRUE);
	if(m_regAudio.GetLength() == 0) return;
	if(m_valAudio.GetLength() == 0) return;
	nLen = m_regAudio.GetLength();
	for(i=0; i<min(nLen,2); i++) {
		uReg |= (Char2Hex(m_regAudio[i]) << ((nLen-i-1)*4));
	}
	
	nLen = m_valAudio.GetLength();
	for(i=0; i<min(nLen,2); i++) {
		uVal |= (Char2Hex(m_valAudio[i]) << ((nLen-i-1)*4));
	}
	
	fTwSetDevicePciConfigSpace(m_hDeviceAudio, uReg, 1, (PBYTE)&uVal);
}

void CDevicePage::OnBtnAudioCfgRead() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	ULONG uReg=0, uVal=0;
	int   nLen=0, i;
	TF_TwGetDevicePciConfigSpace fTwGetDevicePciConfigSpace  = (TF_TwGetDevicePciConfigSpace)GetProcAddress(hSdk, "TwGetDevicePciConfigSpace");
	
	UpdateData(TRUE);
	nLen = m_regAudio.GetLength();
	if(nLen == 0) return;
	for(i=0; i<min(nLen,2); i++) {
		uReg |= (Char2Hex(m_regAudio[i]) << ((nLen-i-1)*4));
	}
	
	if(fTwGetDevicePciConfigSpace(m_hDeviceAudio, uReg, 1, (PBYTE)&uVal)) {
		m_valAudio.Format(TEXT("%02X"), uVal);
		UpdateData(FALSE);
	}
}
