// Dinterlace.h: interface for the CDinterlace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DEINTERLACE_H_)
#define __DEINTERLACE_H_

class CDinterlace  
{
public:
	typedef void (__cdecl  MEMCPY_FUNC)(void* pOutput, void* pInput, size_t nSize);
	typedef void (__cdecl  ABCD_FUNC)(BYTE *pIn, BYTE *pOut, LPVOID pinfoDI);
	/** Structure used to transfer all the information used by plugins
		around in one chunk
	*/
	typedef struct tagDeinterlaceInfo
	{
		BYTE *Overlay;
		DWORD OverlayPitch;
		DWORD LineLength;
		int FrameWidth;
		int FrameHeight;
		int FieldHeight;
		MEMCPY_FUNC* pMemcpy;
		ABCD_FUNC* pABCD;
		long CpuFeatureFlags;
		long InputPitch;
	} DeinterlaceInfo;
	
protected:
	DeinterlaceInfo	m_dtInfo;

public:
	CDinterlace();
	virtual ~CDinterlace();

	void Init(int nWidth=704, int nHeight=576, 
			  int nBitCount=16, int nDestPitch=0);
	void Uninit();
	BOOL Deinterlace(PBYTE inData, PBYTE outData);

protected:
	static UINT TestCpu();
	static void memcpySSE(void* Dest, void* Src, size_t nBytes);
	static void memcpyMMX(void *Dest, void *Src, size_t nBytes);
	static void ABCD_3DNOW(BYTE *pIn, BYTE *pOut, LPVOID pInfo);
	static void ABCD_MMX(BYTE *pIn, BYTE *pOut, LPVOID pInfo);
	static void ABCD_SSE(BYTE *pIn, BYTE *pOut, LPVOID pInfo);
};

#endif // !defined(__DEINTERLACE_H_)
