// Field2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "Field2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CField2Dlg dialog


CField2Dlg::CField2Dlg(vector<CField2*>& chlList, CWnd* pParent /*=NULL*/)
	: CDialog(CField2Dlg::IDD, pParent),
	m_chlList(chlList)
{
	//{{AFX_DATA_INIT(CField2Dlg)
	m_nLayout = -1;
	//}}AFX_DATA_INIT

	m_current = 0;
	m_nLayout = -1;
	m_bLarge  = FALSE;
}


void CField2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CField2Dlg)
	DDX_Radio(pDX, IDC_RADIO_4VIDEO, m_nLayout);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CField2Dlg, CDialog)
	//{{AFX_MSG_MAP(CField2Dlg)
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK_STARTFIELD2, OnCheckStartfield2)
	ON_BN_CLICKED(IDC_RADIO_4VIDEO, OnRadio4video)
	ON_BN_CLICKED(IDC_RADIO_9VIDEO, OnRadio9video)
	ON_BN_CLICKED(IDC_RADIO_16VIDEO, OnRadio16video)
	ON_BN_CLICKED(IDC_RADIO_25VIDEO, OnRadio25video)
	ON_BN_CLICKED(IDC_RADIO_36VIDEO, OnRadio36video)
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CField2Dlg message handlers

void CField2Dlg::OnOK() 
{
}

void CField2Dlg::OnCancel() 
{
}

BOOL CField2Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CRect rcClient;
	int	  nLeft, nTop;
	GetClientRect(&rcClient);
	
	nLeft = rcClient.left + 10;
	nTop  = rcClient.bottom - 50;
	
	GetDlgItem(IDC_CHECK_STARTFIELD2)->MoveWindow(rcClient.right-122, nTop-9, 120, 54);
	GetDlgItem(IDC_STATIC_LAYOUT)->MoveWindow(rcClient.left+2, nTop-15, 420, 60);
	GetDlgItem(IDC_RADIO_4VIDEO)->MoveWindow(nLeft+12, nTop+10, 65, 19);
	GetDlgItem(IDC_RADIO_9VIDEO)->MoveWindow(nLeft+92, nTop+10, 65, 19);
	GetDlgItem(IDC_RADIO_16VIDEO)->MoveWindow(nLeft+172, nTop+10, 65, 19);
	GetDlgItem(IDC_RADIO_25VIDEO)->MoveWindow(nLeft+252, nTop+10, 65, 19);
	GetDlgItem(IDC_RADIO_36VIDEO)->MoveWindow(nLeft+332, nTop+10, 65, 19);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CField2Dlg::Init()
{
	CRect rcClient;
	GetClientRect(&rcClient);
	
	int i,  k = 0;
	int nChannel = (int)m_chlList.size();
	int nCurrent = -1;

	if(nChannel <= 0) return;
	
	if(nChannel==1)						{ k = 1; }
	else if(nChannel>1 && nChannel<=4)	{ k = 2; }
	else if(nChannel>4 && nChannel<=9)	{ k = 3; }
	else if(nChannel>9 && nChannel<=16)	{ k = 4; }
	else if(nChannel>16&& nChannel<=25)	{ k = 5; }
	else if(nChannel>25&& nChannel<=36)	{ k = 6; }
	else if(nChannel>26&& nChannel<=49)	{ k = 7; }
	else								{ k = 8; }
	m_nLayout = k - 2;
	GetDlgItem(IDC_RADIO_36VIDEO)->EnableWindow(!(m_nLayout < 4));
	GetDlgItem(IDC_RADIO_25VIDEO)->EnableWindow(!(m_nLayout < 3));
	GetDlgItem(IDC_RADIO_16VIDEO)->EnableWindow(!(m_nLayout < 2));
	GetDlgItem(IDC_RADIO_9VIDEO)->EnableWindow(!(m_nLayout < 1));
	m_chlShow.clear();
	m_bLarge = FALSE;

	int nRightMax = rcClient.right-1;
	int nWidth = rcClient.Width() / k;
	int nHeight= (rcClient.Height()-65) / k;

	for(i=0; i<nChannel; i++) {
		rcClient.left  = 1 + nWidth*(i%k);
		rcClient.top   = 1 + nHeight*(i/k);
		rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
		rcClient.bottom= rcClient.top + nHeight - 1;
		if(m_chlList[i] != NULL) {
			m_chlList[i]->CreateWnd(rcClient, this, i);
			if(nCurrent==-1) {
				nCurrent = i;
			}
		}
		m_chlShow.push_back(m_chlList[i]);
	}

	if((m_chlList[m_current] == NULL) && (nCurrent!=-1)) {
		m_current= nCurrent;
	}

	UpdateData(FALSE);
}

void CField2Dlg::UpdateVideoWnds()
{
	int nChannel = (int)m_chlShow.size();
	if(nChannel > 0) {
		CRect rcClient;
		int i, k = 0;
		
		if(nChannel==1)						{ k = 1; }
		else if(nChannel>1 && nChannel<=4)	{ k = 2; }
		else if(nChannel>4 && nChannel<=9)	{ k = 3; }
		else if(nChannel>9 && nChannel<=16)	{ k = 4; }
		else if(nChannel>16&& nChannel<=25)	{ k = 5; }
		else if(nChannel>25&& nChannel<=36)	{ k = 6; }
		else if(nChannel>26&& nChannel<=49)	{ k = 7; }
		else								{ k = 8; }
		GetClientRect(&rcClient);
		
		int nWidth = rcClient.Width() / k;
		int nHeight= (rcClient.Height()-65) / k;
		int nRightMax = rcClient.right-1;
		
		for(i=0; i<nChannel; i++) {
			rcClient.left  = 1 + nWidth*(i%k);
			rcClient.top   = 1 + nHeight*(i/k);
			rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
			rcClient.bottom= rcClient.top + nHeight - 1;
			if(m_chlShow[i] != NULL) {
				m_chlShow[i]->MoveVideo(rcClient);
			}
		}
		
		if(m_bLarge) {
			GetClientRect(&rcClient);
			nWidth = rcClient.Width();
			nHeight= rcClient.Height()-65;
			rcClient.left  = 1;
			rcClient.top   = 1;
			rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
			rcClient.bottom= rcClient.top + nHeight - 1;
			m_chlList[m_current]->MoveVideo(rcClient);
		}
	}
}

VOID CField2Dlg::SetCurrentChannel(int channel)
{
	if(m_chlList.size() <= 0) {
		return;
	}
	channel = ChannelIndex(channel);
	if(channel < 0) {
		return;
	}
	if((m_current != -1) && (m_chlList[m_current] != NULL) && (channel!=m_current)) {
		m_chlList[m_current]->ShowBorder(FALSE);
	}
	m_current = channel;
	if(m_chlList[m_current] != NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_STARTFIELD2))->SetCheck(m_chlList[m_current]->IsRunning());
	}
}

VOID CField2Dlg::ShowVideoWnds(int channel, BOOL bShow)
{
	CRect rcClient;
	
	if(channel==-1) {
		for(UINT i=0; i<m_chlShow.size(); i++)
		{
			if(m_chlShow[i] != NULL) {
				m_chlShow[i]->ShowVideo(bShow);
			}
		}
		if(bShow) {
			m_chlList[m_current]->ShowBorder(TRUE);
		}
		m_bLarge = !bShow;
		UpdateVideoWnds();
	}
	else if(channel == -3) {
		CRect rc;
		if(bShow) {
			int cxScreen = GetSystemMetrics(SM_CXSCREEN);
			int cyScreen = GetSystemMetrics(SM_CYSCREEN);
			
			GetWindowRect(&rc);
			m_rcNormal= rc;
			rc.top	  = -30;
			rc.left	  = -4;
			rc.right  = cxScreen + 4;
			rc.bottom = cyScreen + 68;
		}
		else {
			rc = m_rcNormal;
		}
		SetWindowPos(&wndTop, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);
		UpdateVideoWnds();
	}
	else {
		if(channel==-2) { channel = m_current; }
		else {
			channel = ChannelIndex(channel);
			if(channel < 0) {
				return;
			}
		}
		m_chlList[channel]->ShowVideo(bShow);
		if(bShow && (channel==m_current)) {
			m_chlList[channel]->ShowBorder(TRUE);
		}
	}
}

void CField2Dlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	int cxScreen = GetSystemMetrics(SM_CXSCREEN);
	int cyScreen = GetSystemMetrics(SM_CYSCREEN);
	
	lpMMI->ptMinTrackSize.x = 920;
	lpMMI->ptMinTrackSize.y = 550;
	lpMMI->ptMaxSize.x		= cxScreen + 10;
	lpMMI->ptMaxSize.y		= cyScreen + 90;
	lpMMI->ptMaxTrackSize.x = cxScreen + 120;
	lpMMI->ptMaxTrackSize.y = cyScreen + 120;
	
	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CField2Dlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if(nType==SIZE_MINIMIZED) {
		return;
	}
	
	CWnd* pField2 = GetDlgItem(IDC_CHECK_STARTFIELD2);
	if(pField2) {
		CRect rcClient;
		int	  nLeft, nTop;
		GetClientRect(&rcClient);
		
		nLeft = rcClient.left + 10;
		nTop  = rcClient.bottom - 50;
		
		pField2->MoveWindow(rcClient.right-122, nTop-9, 120, 54);
		GetDlgItem(IDC_STATIC_LAYOUT)->MoveWindow(rcClient.left+2, nTop-15, 420, 60);
		GetDlgItem(IDC_RADIO_4VIDEO)->MoveWindow(nLeft+12, nTop+10, 65, 19);
		GetDlgItem(IDC_RADIO_9VIDEO)->MoveWindow(nLeft+92, nTop+10, 65, 19);
		GetDlgItem(IDC_RADIO_16VIDEO)->MoveWindow(nLeft+172, nTop+10, 65, 19);
		GetDlgItem(IDC_RADIO_25VIDEO)->MoveWindow(nLeft+252, nTop+10, 65, 19);
		GetDlgItem(IDC_RADIO_36VIDEO)->MoveWindow(nLeft+332, nTop+10, 65, 19);

		rcClient.top = nTop-9;
		InvalidateRect(&rcClient);

		UpdateVideoWnds();
	}
}

void CField2Dlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	UINT i;
	for(i=0; i<m_chlShow.size(); i++) {
		if(m_chlShow[i] != NULL) {
			m_chlShow[i]->MoveTitle();
			m_chlShow[i]->MoveBorder();
		}
	}
}

void CField2Dlg::OnClose() 
{
	UINT i;
	for(i=0; i<m_chlShow.size(); i++) {
		if(m_chlShow[i] != NULL) {
			m_chlShow[i]->Run(FALSE);
		}
	}
	if(m_chlList[m_current] != NULL) {
		m_chlList[m_current]->ShowBorder(FALSE);
	}
	ShowWindow(SW_HIDE);
}

void CField2Dlg::Show()
{
	UINT i;
	ShowWindow(SW_SHOW);
	for(i=0; i<m_chlShow.size(); i++) {
		if(m_chlShow[i] != NULL) {
			m_chlShow[i]->Run(TRUE);
		}
	}
	BringWindowToTop();
	SetCurrentChannel(m_chlList[m_current]->ChannelId());
}

void CField2Dlg::OnCheckStartfield2() 
{
	BOOL bStart = ((CButton*)GetDlgItem(IDC_CHECK_STARTFIELD2))->GetCheck();
	if(m_chlList[m_current] != NULL) {
		m_chlList[m_current]->Run(bStart);
	}
}

void CField2Dlg::OnRadio4video() 
{
	UINT i;
	UINT nOut = 4;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->ShowVideo(FALSE);
		}
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			if(m_chlList[nCurrent+i] != NULL) {
				m_chlList[nCurrent+i]->ShowVideo(TRUE);
			}
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}

	m_nLayout = 0;
	m_bLarge  = FALSE;

	UpdateVideoWnds();
	if((UINT)m_current<m_chlList.size() && m_chlList[m_current]!=NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
	}
}

void CField2Dlg::OnRadio9video() 
{
	UINT i;
	UINT nOut = 9;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->ShowVideo(FALSE);
		}
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			if(m_chlList[nCurrent+i] != NULL) {
				m_chlList[nCurrent+i]->ShowVideo(TRUE);
			}
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}

	m_nLayout = 1;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	if((UINT)m_current<m_chlList.size() && m_chlList[m_current]!=NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
	}
}

void CField2Dlg::OnRadio16video() 
{
	UINT i;
	UINT nOut = 16;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->ShowVideo(FALSE);
		}
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			if(m_chlList[nCurrent+i] != NULL) {
				m_chlList[nCurrent+i]->ShowVideo(TRUE);
			}
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}

	m_nLayout = 2;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	if((UINT)m_current<m_chlList.size() && m_chlList[m_current]!=NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
	}
}

void CField2Dlg::OnRadio25video() 
{
	UINT i;
	UINT nOut = 25;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->ShowVideo(FALSE);
		}
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			if(m_chlList[nCurrent+i] != NULL) {
				m_chlList[nCurrent+i]->ShowVideo(TRUE);
			}
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	
	m_nLayout = 3;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	if((UINT)m_current<m_chlList.size() && m_chlList[m_current]!=NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
	}
}

void CField2Dlg::OnRadio36video() 
{
	UINT i;
	UINT nOut = 36;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->ShowVideo(FALSE);
		}
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			if(m_chlList[nCurrent+i] != NULL) {
				m_chlList[nCurrent+i]->ShowVideo(TRUE);
			}
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			if(m_chlList[i] != NULL) {
				m_chlList[i]->ShowVideo(TRUE);
			}
		}
	}

	m_nLayout = 4;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	if((UINT)m_current<m_chlList.size() && m_chlList[m_current]!=NULL) {
		m_chlList[m_current]->ShowBorder(TRUE);
	}
}

void CField2Dlg::EnableTitle(BOOL bEnable)
{
	UINT i=0; 
	
	for(i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] != NULL) {
			m_chlList[i]->EnableTitle(bEnable);
		}
	}
	
	for(i=0; i<m_chlShow.size(); i++) {
		if((m_chlShow[i] != NULL) && m_chlShow[i]->IsVisible()) {
			m_chlShow[i]->ShowTitle(bEnable, TRUE);
		}
	}
}