// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "tw68xxdlg.h"
#include "OptionDlg.h"
#include "inifile.h"
#include <Shlobj.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog


COptionDlg::COptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionDlg)
	m_strPath = _T("");
	//}}AFX_DATA_INIT

	m_curPage = NULL;
}


void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDlg)
	DDX_Control(pDX, IDC_TREE_BOARD, m_Board);
	DDX_Text(pDX, IDC_EDIT_SAVEPATH, m_strPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	//{{AFX_MSG_MAP(COptionDlg)
	ON_BN_CLICKED(IDC_BTN_CLOSE, OnBtnClose)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_BOARD, OnSelchangedTreeBoard)
	ON_BN_CLICKED(IDC_BTN_APPLY, OnBtnApply)
	ON_BN_CLICKED(IDC_BTN_APPLY2, OnBtnApply2)
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	ON_BN_CLICKED(IDC_CHECK_SHOWTITLE, OnCheckShowtitle)
	ON_BN_CLICKED(IDC_BTN_STARTALL, OnBtnStartall)
	ON_BN_CLICKED(IDC_BTN_STOPALL, OnBtnStopall)
	ON_BN_CLICKED(IDC_BTN_OPTIMIZEON, OnBtnOptimizeOn)
	ON_BN_CLICKED(IDC_BTN_OPTIMIZEOFF, OnBtnOptimizeOff)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDlg message handlers

BOOL COptionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	CString  strPath;
	CIniFile iniFile;
	
	pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	iniFile.Create(strPath + OPTION_FILE);
	iniFile.ReadString(SECTION_DEFAULT, KEY_SAVEPATH, strPath, m_strPath.GetBuffer(MAX_PATH), MAX_PATH);
	m_strPath.ReleaseBuffer();
	UpdateData(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK_SHOWTITLE))->SetCheck(iniFile.ReadInt(SECTION_DEFAULT, KEY_TITLE, 0));

	CRect	 rcOption;
	CStatic* pOption = (CStatic*)GetDlgItem(IDC_STATIC_OPTION);
	pOption->GetWindowRect(&rcOption);
	ScreenToClient(&rcOption);
	m_devPage.Create(IDD_DEVICE_PAGE, this);
	m_devPage.SetWindowPos(&wndTop, rcOption.left, rcOption.top, rcOption.right, rcOption.bottom, SWP_HIDEWINDOW);
	//m_devPage.ShowWindow(SW_SHOW);

	m_subPage.Create(IDD_SUBDEVICE_PAGE, this);
	m_subPage.SetWindowPos(&wndTop, rcOption.left, rcOption.top, rcOption.right, rcOption.bottom, SWP_HIDEWINDOW);

	m_chlPage.Create(IDD_CHANNEL_PAGE, this);
	m_chlPage.SetWindowPos(&wndTop, rcOption.left, rcOption.top, rcOption.right, rcOption.bottom, SWP_HIDEWINDOW);

	m_bodPage.Create(IDD_BOARD_PAGE, this);
	m_bodPage.SetWindowPos(&wndTop, rcOption.left, rcOption.top, rcOption.right, rcOption.bottom, SWP_HIDEWINDOW);

	LoadBoard(MAKEITEM(-1,-1));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL COptionDlg::LoadBoard(ULONG item)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE	    hSdk = pMainDlg->SdkHandle();
	if(hSdk == NULL) {
		return FALSE;
	}
	
	TF_TwGetBoardCount fTwGetBoardCount = (TF_TwGetBoardCount)GetProcAddress(hSdk, "TwGetBoardCount");
	if(fTwGetBoardCount == NULL) {
		return FALSE;
	}
	
	TF_TwGetBoardHandle fTwGetBoardHandle = (TF_TwGetBoardHandle)GetProcAddress(hSdk, "TwGetBoardHandle");
	if(fTwGetBoardHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetBoardDetail fTwGetBoardDetail = (TF_TwGetBoardDetail)GetProcAddress(hSdk, "TwGetBoardDetail");
	if(fTwGetBoardDetail == NULL) {
		return FALSE;
	}
	
	int nBoard = fTwGetBoardCount();
	if(nBoard <= 0) {
		return FALSE;
	}
	
	TF_TwGetDeviceCount fTwGetDeviceCount = (TF_TwGetDeviceCount)GetProcAddress(hSdk, "TwGetDeviceCount");
	if(fTwGetDeviceCount == NULL) {
		return FALSE;
	}
	
	int nDevice = fTwGetDeviceCount();
	if(nDevice <= 0) {
		//return FALSE;
	}

	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(hSdk, "TwGetDeviceHandle");
	if(fTwGetDeviceHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetDeviceDetail fTwGetDeviceDetail = (TF_TwGetDeviceDetail)GetProcAddress(hSdk, "TwGetDeviceDetail");
	if(fTwGetDeviceDetail == NULL) {
		return FALSE;
	}
	
	TF_TwGetSubDeviceCount fTwGetSubDeviceCount = (TF_TwGetSubDeviceCount)GetProcAddress(hSdk, "TwGetSubDeviceCount");
	if(fTwGetSubDeviceCount == NULL) {
		return FALSE;
	}
	
	TF_TwGetSubDeviceHandle fTwGetSubDeviceHandle = (TF_TwGetSubDeviceHandle)GetProcAddress(hSdk, "TwGetSubDeviceHandle");
	if(fTwGetSubDeviceHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetSubDeviceDetail fTwGetSubDeviceDetail = (TF_TwGetSubDeviceDetail)GetProcAddress(hSdk, "TwGetSubDeviceDetail");
	if(fTwGetSubDeviceDetail == NULL) {
		return FALSE;
	}
	
	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		return FALSE;
	}
	
	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		return FALSE;
	}
	
	TF_TwGetChannelDetail fTwGetChannelDetail = (TF_TwGetChannelDetail)GetProcAddress(hSdk, "TwGetChannelDetail");
	if(fTwGetChannelDetail == NULL) {
		return FALSE;
	}
	
	int i = 0;
	CString		strTemp;
	HTREEITEM   hItemBoard=NULL, hItemDevice=NULL, hItemSubDevice=NULL, hItemChannel=NULL;
	TBoardDesc  bodDesc;
	TDeviceDesc devDesc;
	TSubDeviceDesc subDesc;
	TChannelDesc   chlDesc;
	HANDLE		hDevice = NULL;
	HANDLE		hSubDev = NULL;
	HANDLE		hChannel= NULL;

	m_Board.DeleteAllItems();

	for(i=0; i<nBoard; i++) {
		ZeroMemory(&bodDesc, sizeof(TBoardDesc));
		fTwGetBoardDetail(fTwGetBoardHandle(i), &bodDesc);
		strTemp.Format(IDS_BOARD_ID, i+1, bodDesc.nSlot);
		hItemBoard = m_Board.InsertItem(strTemp);
		m_Board.SetItemData(hItemBoard, MAKEITEM(ITEM_BOARD, i));
		for(int j=0; j<bodDesc.nDeviceCount; j++) {
			ZeroMemory(&devDesc, sizeof(TDeviceDesc));
			hDevice = fTwGetDeviceHandle(bodDesc.nFirstDevice+j);
			fTwGetDeviceDetail(hDevice, &devDesc);
			strTemp.Format(IDS_DEVICE_ID, DEVICEID(devDesc.HardwareId), devDesc.nBus, devDesc.DeviceNumber, devDesc.Function);
			hItemDevice = m_Board.InsertItem(strTemp, -1, -1, hItemBoard);
			m_Board.SetItemData(hItemDevice, MAKEITEM(ITEM_DEVICE, bodDesc.nFirstDevice+j));
			for(int k=0; k<devDesc.nSubDevice; k++) {
				ZeroMemory(&subDesc, sizeof(TSubDeviceDesc));
				hSubDev = fTwGetSubDeviceHandle(devDesc.nFirstSubDevice+k);
				fTwGetSubDeviceDetail(hSubDev, &subDesc);
				strTemp.Format(IDS_SUBDEVICE_ID, devDesc.nFirstSubDevice+k+1);
				hItemSubDevice = m_Board.InsertItem(strTemp, -1, -1, hItemDevice);
				m_Board.SetItemData(hItemSubDevice, MAKEITEM(ITEM_SUBDEVICE, devDesc.nFirstSubDevice+k));
				for(int m=0; m<subDesc.nChannels; m++) {
					ZeroMemory(&chlDesc, sizeof(TChannelDesc));
					fTwGetChannelDetail(fTwChannelOpen(subDesc.nFirstChannel+m), &chlDesc);
					strTemp.Format(IDS_CHANNEL_ID, subDesc.nFirstChannel+m+1);
					hItemChannel = m_Board.InsertItem(strTemp, -1, -1, hItemSubDevice);
					m_Board.SetItemData(hItemChannel, MAKEITEM(ITEM_CHANNEL, subDesc.nFirstChannel+m));
				}
			}
		}
	}

	return TRUE;
}

void COptionDlg::OnOK() 
{
}

void COptionDlg::OnCancel() 
{
}

void COptionDlg::OnBtnClose() 
{
	m_devPage.DestroyWindow();
	m_subPage.DestroyWindow();
	m_chlPage.DestroyWindow();
	m_bodPage.DestroyWindow();

	CDialog::OnOK();
}

void COptionDlg::OnSelchangedTreeBoard(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	if(m_curPage != NULL) {
		CRect rcOption;
		m_curPage->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_OPTION)->GetWindowRect(&rcOption);
		ScreenToClient(&rcOption);
		InvalidateRect(&rcOption);
	}

	ULONG ulData = (ULONG)m_Board.GetItemData(pNMTreeView->itemNew.hItem);
	switch(ITEMTYPE(ulData)) {
	case ITEM_BOARD:
		m_curPage = &m_bodPage;
		m_bodPage.SetId(ITEMIDX(ulData));
		break;
		m_curPage = NULL;
		break;
	case ITEM_DEVICE:
		m_curPage = &m_devPage;
		m_devPage.SetId(ITEMIDX(ulData));
		break;
	case ITEM_SUBDEVICE:
		m_curPage = &m_subPage;
		m_subPage.SetId(ITEMIDX(ulData));
		break;
	case ITEM_CHANNEL:
		m_curPage = &m_chlPage;
		m_chlPage.SetId(ITEMIDX(ulData));
		break;
	}

	if(m_curPage != NULL) {
		m_curPage->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC_OPTION)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_PATH)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_SAVEPATH)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_BROWSE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_CHECK_SHOWTITLE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_STARTALL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_STOPALL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_OPTIMIZEON)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_OPTIMIZEOFF)->ShowWindow(SW_HIDE);
	}
	else {
		GetDlgItem(IDC_STATIC_OPTION)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC_PATH)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT_SAVEPATH)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_BROWSE)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_CHECK_SHOWTITLE)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_STARTALL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_STOPALL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_OPTIMIZEON)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_OPTIMIZEOFF)->ShowWindow(SW_SHOW);
	}

	*pResult = 0;
}

void COptionDlg::OnBtnApply() 
{
	if(m_curPage != NULL) {
		m_curPage->Apply();
	}
	else {
		CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
		CString  strPath;
		CIniFile iniFile;
		BOOL	 bShowTitle = ((CButton*)GetDlgItem(IDC_CHECK_SHOWTITLE))->GetCheck();
		
		pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
		strPath.ReleaseBuffer();
		iniFile.Create(strPath + OPTION_FILE);
		iniFile.WriteString(SECTION_DEFAULT, KEY_SAVEPATH, m_strPath);
		iniFile.WriteInt(SECTION_DEFAULT, KEY_TITLE, bShowTitle);
		pMainDlg->EnableTitle(bShowTitle);
	}
	BringWindowToTop();
}

void COptionDlg::OnBtnApply2() 
{
	if(m_curPage != NULL) {
		m_curPage->Apply2();
		BringWindowToTop();
	}
	else {
		OnBtnApply();
	}
}

BOOL COptionDlg::SelFolder(HWND hParent, CString &strFolder)
{
    strFolder.Empty();
	
    LPMALLOC lpMalloc;
	
    if (::SHGetMalloc(&lpMalloc) != NOERROR) return 0;
	
    TCHAR szDisplayName[_MAX_PATH];
    TCHAR szBuffer[_MAX_PATH];
    BROWSEINFO browseInfo;
    browseInfo.hwndOwner = hParent;
    browseInfo.pidlRoot = NULL; // set root at Desktop
    browseInfo.pszDisplayName = szDisplayName;
    browseInfo.lpszTitle = TEXT("Select a folder");
    browseInfo.ulFlags = BIF_RETURNFSANCESTORS|BIF_RETURNONLYFSDIRS;
    browseInfo.lpfn = NULL;
    browseInfo.lParam = 0;
	
    LPITEMIDLIST lpItemIDList;
    if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
    {
        // Get the path of the selected folder from the    item ID list.
        if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
        {
            // At this point, szBuffer contains the path the user chose.
            if (szBuffer[0] == '\0') return 0;
			
            // We have a path in szBuffer! Return it.
            strFolder = szBuffer;
            return TRUE;
        }
        else return TRUE; // strResult is empty
		
        lpMalloc->Free(lpItemIDList);
        lpMalloc->Release();
    }

	return FALSE;
}

void COptionDlg::OnBtnBrowse() 
{
	if(SelFolder(GetSafeHwnd(), m_strPath)) {
		UpdateData(FALSE);
	}
}

void COptionDlg::OnCheckShowtitle() 
{
}

void COptionDlg::OnBtnStartall() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	pMainDlg->TestAll(TRUE);
}

void COptionDlg::OnBtnStopall() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	pMainDlg->TestAll(FALSE);
}

void COptionDlg::OnBtnOptimizeOn() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	pMainDlg->OptimizeCIF(TRUE);
}

void COptionDlg::OnBtnOptimizeOff() 
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	pMainDlg->OptimizeCIF(FALSE);
}
