// PlayWave.h: interface for the CPlayWave class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__PLAYWAVE_H_)
#define __PLAYWAVE_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef USE_DSOUND
#include <dsound.h>
#endif

#include <vector>
#include "ScopedLock.h"

using namespace std;


class CWavePacket;
class CPlayWave
{
protected:
	HANDLE	 m_hThreadPlayWave;
	UINT	 m_uThreadPlayWaveId;
	HWAVEOUT m_hOut;
	int		 m_iAudioBuf;
	BOOL	 m_bPlaying;

#ifdef USE_DSOUND
	LPDIRECTSOUND8	m_pDSnd;
    LPDIRECTSOUNDBUFFER8 m_pDSndBuff;
#endif
	DWORD	 m_dwWritePos;

public:
	CPlayWave();
	virtual  ~CPlayWave();

	BOOL Init(DWORD sample_rate=48000, WORD channels=2, WORD bitsPersample=16);
#ifdef USE_DSOUND
	BOOL Init(DWORD sample_rate, WORD channels, HWND hWnd);
#endif
	void Uninit();
	BOOL OpenDev(WAVEFORMATEX* pfmt,DWORD dwCallback,DWORD dwCallbackInstance,DWORD fdwOpen);
	void CloseDev();
	BOOL Play(BYTE* buf,UINT uSize);
	void Play();
	void Stop();
	BOOL IsPlaying(){return m_bPlaying;}
	
	static UINT CALLBACK Thread_PlayWave(LPVOID pContext);

protected:
	void OnFramePlayDone(LPWAVEHDR hdr);
#ifdef USE_DSOUND
	HRESULT CreateAssistantSoundBuffer(WORD  Channels, DWORD sample_rate, 
									   WORD  bitCount);		/**/
	HRESULT SetPrimaryBufferFormat(DWORD dwPrimaryChannels,DWORD dwPrimaryFreq,
		                           DWORD dwPrimaryBitRate);
#endif

protected:
	vector<CWavePacket*> m_hdrWave;
	CrLockCS			 m_lock;
};

#endif // !defined(__PLAYWAVE_H_)
