// SubDevicePage.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "TW68XXDlg.h"
#include "SubDevicePage.h"
#include "OptionDlg.h"
#include "inifile.h"
#include "CopyToDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSubDevicePage dialog


CSubDevicePage::CSubDevicePage(CWnd* pParent /*=NULL*/)
	: COptionPage(CSubDevicePage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSubDevicePage)
	m_bField2 = FALSE;
	m_bInput1 = TRUE;
	m_bInput2 = FALSE;
	m_bInput3 = FALSE;
	m_bInput4 = FALSE;
	//}}AFX_DATA_INIT

	m_nInput  = 1;
}


void CSubDevicePage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSubDevicePage)
	DDX_Check(pDX, IDC_CHECK_FIELD2, m_bField2);
	DDX_Check(pDX, IDC_CHK_VIDEO_INPUT1, m_bInput1);
	DDX_Check(pDX, IDC_CHK_VIDEO_INPUT2, m_bInput2);
	DDX_Check(pDX, IDC_CHK_VIDEO_INPUT3, m_bInput3);
	DDX_Check(pDX, IDC_CHK_VIDEO_INPUT4, m_bInput4);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSubDevicePage, CDialog)
	//{{AFX_MSG_MAP(CSubDevicePage)
	ON_BN_CLICKED(IDC_CHECK_FIELD2, OnCheckField2)
	ON_BN_CLICKED(IDC_CHK_VIDEO_INPUT1, OnChkVideoInput1)
	ON_BN_CLICKED(IDC_CHK_VIDEO_INPUT2, OnChkVideoInput2)
	ON_BN_CLICKED(IDC_CHK_VIDEO_INPUT3, OnChkVideoInput3)
	ON_BN_CLICKED(IDC_CHK_VIDEO_INPUT4, OnChkVideoInput4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSubDevicePage message handlers

void CSubDevicePage::OnOK() 
{
}

void CSubDevicePage::OnCancel() 
{
}

void CSubDevicePage::OnCheckField2() 
{
	UpdateData(TRUE);
	if(m_bField2) {
		if(m_nInput > 1) {
			if(m_bInput1) {
				m_bInput2=m_bInput3=m_bInput4 = FALSE;
			}
			else if(m_bInput2) {
				m_bInput3=m_bInput4 = FALSE;
			}
			else if(m_bInput3) {
				m_bInput4 = FALSE;
			}
			m_nInput = 1;
			UpdateData(FALSE);
		}
	}
}

void CSubDevicePage::OnChkVideoInput1() 
{
	BOOL bInput = m_bInput1;

	UpdateData(TRUE);
	if(bInput != m_bInput1) {
		if(m_bInput1) {
			m_nInput++;
			if(m_nInput > 1) {
				m_bField2 = FALSE;
				UpdateData(FALSE);
			}
		}
		else {
			m_nInput--;
#if(0)
			if(m_nInput <= 0) {
				m_nInput = 1;
				m_bInput1 = TRUE;
				UpdateData(FALSE);
			}
#endif
		}
	}
}

void CSubDevicePage::OnChkVideoInput2() 
{
	BOOL bInput = m_bInput2;
	
	UpdateData(TRUE);
	if(bInput != m_bInput2) {
		if(m_bInput2) {
			m_nInput++;
			if(m_nInput > 1) {
				m_bField2 = FALSE;
				UpdateData(FALSE);
			}
		}
		else {
			m_nInput--;
#if(0)
			if(m_nInput <= 0) {
				m_nInput = 1;
				m_bInput2 = TRUE;
				UpdateData(FALSE);
			}
#endif
		}
	}
}

void CSubDevicePage::OnChkVideoInput3() 
{
	BOOL bInput = m_bInput3;
	
	UpdateData(TRUE);
	if(bInput != m_bInput3) {
		if(m_bInput3) {
			m_nInput++;
			if(m_nInput > 1) {
				m_bField2 = FALSE;
				UpdateData(FALSE);
			}
		}
		else {
			m_nInput--;
#if(0)
			if(m_nInput <= 0) {
				m_nInput = 3;
				m_bInput1 = TRUE;
				UpdateData(FALSE);
			}
#endif
		}
	}
}

void CSubDevicePage::OnChkVideoInput4() 
{
	BOOL bInput = m_bInput4;
	
	UpdateData(TRUE);
	if(bInput != m_bInput4) {
		if(m_bInput4) {
			m_nInput++;
			if(m_nInput > 1) {
				m_bField2 = FALSE;
				UpdateData(FALSE);
			}
		}
		else {
			m_nInput--;
#if(0)
			if(m_nInput <= 0) {
				m_nInput = 1;
				m_bInput4 = TRUE;
				UpdateData(FALSE);
			}
#endif
		}
	}
}

BOOL CSubDevicePage::SetId(int nId)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE		hSdk = pMainDlg->SdkHandle();

	TF_TwGetSubDeviceHandle fTwGetSubDeviceHandle = (TF_TwGetSubDeviceHandle)GetProcAddress(hSdk, "TwGetSubDeviceHandle");
	if(fTwGetSubDeviceHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetSubDeviceDetail fTwGetSubDeviceDetail = (TF_TwGetSubDeviceDetail)GetProcAddress(hSdk, "TwGetSubDeviceDetail");
	if(fTwGetSubDeviceDetail == NULL) {
		return FALSE;
	}

	TSubDeviceDesc subDesc;
	HANDLE hSubDev = fTwGetSubDeviceHandle(nId);
	ZeroMemory(&subDesc, sizeof(TSubDeviceDesc));
	if(!fTwGetSubDeviceDetail(hSubDev, &subDesc)) {
		return FALSE;
	}

	m_nInput = 0;
	m_bInput1 = (subDesc.VideoInputMask & (1 << (int)viCompositeVideo1)) > 0;
	m_bInput2 = (subDesc.VideoInputMask & (1 << (int)viCompositeVideo2)) > 0;
	m_bInput3 = (subDesc.VideoInputMask & (1 << (int)viCompositeVideo3)) > 0;
	m_bInput4 = (subDesc.VideoInputMask & (1 << (int)viCompositeVideo4)) > 0;
	m_bField2 = subDesc.bField2;
	m_nId = nId;
	m_nInput += m_bInput1 ? 1 : 0;
	m_nInput += m_bInput2 ? 1 : 0;
	m_nInput += m_bInput3 ? 1 : 0;
	m_nInput += m_bInput4 ? 1 : 0;

	CString strAudio;
	if(subDesc.nAudio) {
		strAudio.LoadString(IDS_SUBDEVICE_AUDIO);
	}
	else {
		strAudio.LoadString(IDS_SUBDEVICE_NOAUDIO);
	}
	GetDlgItem(IDC_STATIC_SUBDEVICE_AUDIO)->SetWindowText(strAudio);

	UpdateData(FALSE);

	return TRUE;
}

BOOL CSubDevicePage::Apply()
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	COptionDlg* pParent  = (COptionDlg*)GetParent();

	CString  strPath;
	CIniFile iniFile;
	
	pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	iniFile.Create(strPath + OPTION_FILE);

	strPath.Format(SECTION_SUBDEVICE, m_nId);
	iniFile.WriteInt(strPath, KEY_FIELD2, m_bField2);
	iniFile.WriteInt(strPath, KEY_COMPOSITE1, m_bInput1);
	iniFile.WriteInt(strPath, KEY_COMPOSITE2, m_bInput2);
	iniFile.WriteInt(strPath, KEY_COMPOSITE3, m_bInput3);
	iniFile.WriteInt(strPath, KEY_COMPOSITE4, m_bInput4);

	pMainDlg->UninitSDK();
	pMainDlg->InitSDK();

	return pParent->LoadBoard(MAKEITEM(ITEM_SUBDEVICE, m_nId));
}

BOOL CSubDevicePage::Apply2()
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)AfxGetMainWnd();
	HMODULE hSdk = pMainDlg->SdkHandle();
	
	TF_TwGetSubDeviceCount fTwGetSubDeviceCount = (TF_TwGetSubDeviceCount)GetProcAddress(hSdk, "TwGetSubDeviceCount");
	if(fTwGetSubDeviceCount == NULL) {
		return FALSE;
	}
	
	int nDevices = fTwGetSubDeviceCount();
	
	CCopyToDlg dlg(ITEM_SUBDEVICE, nDevices);
	if(dlg.DoModal() == IDOK) {
		CString  strPath;
		CIniFile iniFile;
		int		 i;
		COptionDlg* pParent  = (COptionDlg*)GetParent();
		
		pMainDlg->GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
		strPath.ReleaseBuffer();
		iniFile.Create(strPath + OPTION_FILE);
		
		for(i=0; i<nDevices; i++) {
			if(dlg.m_CopyTo[i]) {
				strPath.Format(SECTION_SUBDEVICE, i);
				iniFile.WriteInt(strPath, KEY_FIELD2, m_bField2);
				iniFile.WriteInt(strPath, KEY_COMPOSITE1, m_bInput1);
				iniFile.WriteInt(strPath, KEY_COMPOSITE2, m_bInput2);
				iniFile.WriteInt(strPath, KEY_COMPOSITE3, m_bInput3);
				iniFile.WriteInt(strPath, KEY_COMPOSITE4, m_bInput4);
			}
		}
		
		pMainDlg->UninitSDK();
		pMainDlg->InitSDK();
		
		return pParent->LoadBoard(MAKEITEM(ITEM_SUBDEVICE, m_nId));
	}

	return TRUE;
}