// TW68XXDlg.h : ͷļ
//

#pragma once

#include "Channel.h"
#include "Field2.h"
#include "Field2Dlg.h"
#include "LogoWnd.h"
#include <vector>
using namespace std;

#define OPTION_FILE			TEXT("TW68XX.ini")

#define SECTION_DEFAULT		TEXT("Default")
#define SECTION_SUBDEVICE	TEXT("Sub%d")
#define SECTION_CHANNEL		TEXT("Channel%d")

#define KEY_SAVEPATH		TEXT("path")
#define KEY_REORDER			TEXT("order")
#define KEY_STANDARD		TEXT("standard")
#define KEY_COMPOSITE1		TEXT("composite1")
#define KEY_COMPOSITE2		TEXT("composite2")
#define KEY_COMPOSITE3		TEXT("composite3")
#define KEY_COMPOSITE4		TEXT("composite4")
#define KEY_PIXELFORMAT		TEXT("pixelformat")
#define KEY_FRAMERATE		TEXT("framerate")
#define KEY_AUDIO			TEXT("audio")
#define KEY_AUDIO_PACKET	TEXT("audio_packet_length")
#define KEY_TITLE			TEXT("title")
#define KEY_WIDTH			TEXT("width")
#define KEY_HEIGHT			TEXT("height")
#define KEY_BRIGHT			TEXT("bright")
#define KEY_CONTRAST		TEXT("contrast")
#define KEY_SATURATION		TEXT("saturation")
#define KEY_HUE				TEXT("hue")
#define KEY_SHARPNESS		TEXT("sharpness")
#define KEY_OPTIMIZE_CIF	TEXT("optimize_cif")
#define KEY_DEINTERLACE		TEXT("deinterlace")

#define KEY_FIELD2			TEXT("field2")
#define KEY_WIDTH2			TEXT("width2")
#define KEY_HEIGHT2			TEXT("height2")
#define KEY_PIXELFORMAT2	TEXT("pixelformat2")
#define KEY_FRAMERATE2		TEXT("framerate2")

#define DISPLAY_Y41P_TO_YUY2		1

// CTW68XXDlg Ի
class CTW68XXDlg : public CDialog
{
// 
public:
	CTW68XXDlg(CWnd* pParent = NULL);	// ׼캯

// Ի
// Dialog Data
	//{{AFX_DATA(CTW68XXDlg)
	enum { IDD = IDD_TW68XX_DIALOG };
	CSliderCtrl	m_sldSaturation;
	CSliderCtrl	m_sldHue;
	CSliderCtrl	m_sldContrast;
	CSliderCtrl	m_sldBright;
	CSliderCtrl m_sldSharpness;
	int		m_nLayout;
	//}}AFX_DATA
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTW68XXDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧
	//}}AFX_VIRTUAL


// ʵ
protected:
	HICON m_hIcon;

	vector<CChannel*>	m_chlList;
	vector<CChannel*>	m_chlShow;
	vector<CField2*>	m_fd2List;
	vector<CLogoWnd*>	m_wndLogo;
	CSurface			m_sfcLogo;
	int					m_current;
	HMODULE				m_hSdk;
	int					m_nAudio;
	CField2Dlg			m_fd2Dlg;
	BOOL				m_bLarge;
	BOOL				m_bRunning;
	CRect				m_rcNormal;

	TF_TwSetVideoPara	m_fTwSetVideoPara;

	// ɵϢӳ亯
	// Generated message map functions
	//{{AFX_MSG(CTW68XXDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnCheckAudio();
	afx_msg void OnBtnOption();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBtnDefault();
	afx_msg void OnBtnApply2all();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnRadio4video();
	afx_msg void OnRadio9video();
	afx_msg void OnRadio16video();
	afx_msg void OnRadio36video();
	afx_msg void OnRadio25video();
	afx_msg void OnBtnField2();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnCheckSave();
	afx_msg void OnBtnSnap();
	afx_msg void OnBtn2srcsize();
	afx_msg void OnBtnBlackstripe();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void UpdateVideoWnds();
	int  MapPixelFormat(int vFormat);
	BOOL InitLogo();

public:
	BOOL InitSDK();
	void UninitSDK();
	void SetWatchDog(BOOL bEnable);
	void FeedWatchDog(BOOL bFeed);
	HMODULE SdkHandle() { return m_hSdk; }
	void SetCurrentChannel(int channel);
	VOID ShowVideoWnds(int channel, BOOL bShow);
	BOOL StartChannel(int channel, BOOL bAudio, BOOL bDeinterlace);
	void EnableTitle(BOOL bEnable);
	CSurface* LogoSurface() { return &m_sfcLogo; }
	int	 ChannelIndex(int chlId) {
		for(ULONG i=0; i<m_chlList.size(); i++) {
			if(m_chlList[i]->ChannelId() == chlId) {
				return i;
			}
		}
		return -1;
	}
	void TestAll(BOOL bStart);
	void OptimizeCIF(LONG iOn);

	int  ProcVideoStream(int nChannel, VOID *DataBuf, int width, int height, BOOL bField2, __int64 pts);
	int  ProcAudioStream(int nChannel, VOID *DataBuf, LONG Length,  __int64 pts);

	static void Rgb24_to_Rgb555(PBYTE rgb555, PBYTE rgb24, int width, int height);
	static LPCTSTR GetModulePath(LPTSTR path, int len);
	static int __stdcall VideoStreamCallback(int nChannel, VOID *DataBuf, int width, int height, BOOL bField2, void *context, __int64 pts);
	static int __stdcall AudioStreamCallback(int nChannel, VOID *DataBuf, LONG Length, void *Context, __int64 pts);
};
