/**
***************************************************************************************
*  Copyright (C) 2008, Techwell
*  All rights reserved.
*
*  @file 		TWSDK_T.H
*  @brief		TWSDK function type definition
*
*  @version		0.1
*  @author		jack
*  @date		2008/10/20
***************************************************************************************
*/

#ifndef __TWSDK_T_H_
#define __TWSDK_T_H_

#include "TWSDK.h"

typedef BOOL (__stdcall *TF_TwInitSDK)();
typedef VOID (__stdcall *TF_TwUninitSDK)();
typedef VOID (__stdcall *TF_TwGetLastError)();

typedef int  (__stdcall *TF_TwGetBoardCount)();
typedef HANDLE (__stdcall *TF_TwGetBoardHandle)(int nBoard);
typedef BOOL (__stdcall *TF_TwGetBoardDetail)(HANDLE hBoard, TBoardDesc *pBoardDesc);
typedef BOOL (__stdcall *TF_TwGetDevicePciConfigSpaceEx)(HANDLE hBoard, int nOffset, int nBytes, BYTE* pData);
typedef BOOL (__stdcall *TF_TwSetDevicePciConfigSpaceEx)(HANDLE hBoard, int nOffset, int nBytes, BYTE* pData);

typedef int  (__stdcall *TF_TwGetDeviceCount)();
typedef HANDLE (__stdcall *TF_TwGetDeviceHandle)(int nDevice);
typedef HANDLE (__stdcall *TF_TwGetDeviceAudioHandle)(int nDevice);
typedef BOOL (__stdcall *TF_TwGetDeviceDetail)(HANDLE hDevice, TDeviceDesc *pDevDesc);
typedef BOOL (__stdcall *TF_TwGetDeviceRegBYTE)(HANDLE hDevice, ULONG uReg, BYTE* value);
typedef BOOL (__stdcall *TF_TwGetDeviceRegWORD)(HANDLE hDevice, ULONG uReg, USHORT* value);
typedef BOOL (__stdcall *TF_TwGetDeviceRegDWORD)(HANDLE hDevice, ULONG uReg, ULONG* value);
typedef BOOL (__stdcall *TF_TwSetDeviceRegBYTE)(HANDLE hDevice, ULONG uReg, BYTE value);
typedef BOOL (__stdcall *TF_TwSetDeviceRegWORD)(HANDLE hDevice, ULONG uReg, USHORT value);
typedef BOOL (__stdcall *TF_TwSetDeviceRegDWORD)(HANDLE hDevice, ULONG uReg, ULONG value);
typedef BOOL (__stdcall *TF_TwGetDevicePciConfigSpace)(HANDLE hDevice, int nOffset, int nBytes, BYTE* pData);
typedef BOOL (__stdcall *TF_TwSetDevicePciConfigSpace)(HANDLE hDevice, int nOffset, int nBytes, BYTE* pData);

typedef HANDLE (__stdcall *TF_TwI2COpen)(HANDLE hDevice);
typedef VOID (__stdcall *TF_TwI2CClose)(HANDLE hI2C);
typedef BOOL (__stdcall *TF_TwI2CWrite)(HANDLE hI2C, int nBytes, BYTE* cValue);
typedef BOOL (__stdcall *TF_TwI2CWriteNoStop)(HANDLE hI2C, int nBytes, BYTE* cValue);
typedef BOOL (__stdcall *TF_TwI2CRead)(HANDLE hI2C, int nWriteBytes, BYTE* cValue, int nReadBytes, BYTE* pValue);

typedef HANDLE (__stdcall *TF_TwGPIOOpen)(HANDLE hDevice);
typedef VOID (__stdcall *TF_TwGPIOClose)(HANDLE hGpio);
typedef BOOL (__stdcall *TF_TwGPIOEnableOutput)(HANDLE hGpio, int nGpio, int nBits, BOOL bEnable);
typedef BOOL (__stdcall *TF_TwGPIOSetBits)(HANDLE hGpio, int nGpio, int nBits, ULONG *ulValue);
typedef BOOL (__stdcall *TF_TwGPIOGetBits)(HANDLE hGpio, int nGpio, int nBits, ULONG *pValue);

typedef int  (__stdcall *TF_TwGetSubDeviceCount)();
typedef HANDLE (__stdcall *TF_TwGetSubDeviceHandle)(int nSubDevice);
typedef BOOL (__stdcall *TF_TwGetSubDeviceDetail)(HANDLE hSubDevice, TSubDeviceDesc *pSubDevDesc);
typedef BOOL (__stdcall *TF_TwEnableVideoInput)(HANDLE hSubDevice, TVideoInput vInput, BOOL bEnable);
typedef BOOL (__stdcall *TF_TwEnableVideoField2)(HANDLE hSubDevice, BOOL bEnable);

typedef int  (__stdcall *TF_TwGetChannelCount)();
typedef BOOL (__stdcall *TF_TwChangeChannelId)(int nChannel, int nId);
typedef HANDLE (__stdcall *TF_TwChannelOpen)(int nChannel);
typedef BOOL (__stdcall *TF_TwGetChannelDetail)(HANDLE hChannel, TChannelDesc *pChannelDesc);
typedef VOID (__stdcall *TF_TwChannelClose)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwSetVideoPara)(HANDLE hChannel, TVideoPara vPara, LONG lValue);
typedef BOOL (__stdcall *TF_TwGetVideoPara)(HANDLE hChannel, TVideoPara vPara, LONG *pValue);
typedef BOOL (__stdcall *TF_TwStartVideoCapture)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwStopVideoCapture)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwSetAudioPara)(HANDLE hChannel, TAudioPara vPara, LONG lValue);
typedef BOOL (__stdcall *TF_TwGetAudioPara)(HANDLE hChannel, TAudioPara vPara, LONG *pValue);
typedef BOOL (__stdcall *TF_TwStartAudioCapture)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwStopAudioCapture)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwStartVideoField2)(HANDLE hChannel);
typedef BOOL (__stdcall *TF_TwStopVideoField2)(HANDLE hChannel);

typedef BOOL (__stdcall *TF_TwRegisterVideoStreamCallback)(TwVideoStreamCallback VideoStreamCallback, VOID *Context);
typedef BOOL (__stdcall *TF_TwRegisterAudioStreamCallback)(TwAudioStreamCallback AudioStreamCallback, VOID *Context);

#endif //__TWSDK_T_H_