//////////////////////////////////////////////////////////////////////
// Thread.h: interface for the CThread class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__THREAD_H_)
#define __THREAD_H_

enum {EVT_DATA=0, EVT_EXIT, EVT_NUM};

#include "ScopedLock.h"

//------------------
//߳
//------------------
class CThread  
{
public:
	CThread();
	virtual ~CThread();

	virtual BOOL Create();
	virtual void Exit(ULONG maxWait=INFINITE);
	virtual void Clear() {}
	HANDLE	DataEvent(){return m_hEvt[EVT_DATA];}

	static UINT CALLBACK ThreadProc(LPVOID pParam);

protected:
	HANDLE	m_hThread;			//߳̾
	HANDLE	m_hEvt[EVT_NUM];	//¼
	BOOL	m_bExit;

	virtual void OnCreate(){};
	virtual BOOL PrepareRun();
	virtual UINT Run();
	virtual UINT DoWork();
	virtual UINT OnExit();
	virtual BOOL IsExit(){CrScopedLock autoLock(&m_lockExit); return m_bExit;}

private:
	CrLockCS	m_lockExit;
};

#endif // !defined(__THREAD_H_)
