#if !defined(AFX_VIDEOWND_H__5A07F8D2_56C5_46CC_B69C_A89640574ADE__INCLUDED_)
#define AFX_VIDEOWND_H__5A07F8D2_56C5_46CC_B69C_A89640574ADE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// VideoWnd.h : header file
//

#include "Border.h"
#include "Title.h"

#define IDC_VIDEO		5000

/////////////////////////////////////////////////////////////////////////////
// CVideoWnd window

class CVideoWnd : public CStatic
{
// Construction
public:
	CVideoWnd();

public:
	typedef enum{
		VShow_normal = 0,
		VShow_large,
		VShow_full,
		VShow_total
	}VSHOW_STATE;

// Attributes
protected:
	HANDLE  m_hChannel;
	int	    m_nChannel;
	BOOL    m_bVisible;
	int	    m_nFrames;
	int		m_nState;
	CRect	m_rcNormal;
	CBrush	m_bkBrush;
	
	CBorder	m_bdLeft;
	CBorder	m_bdRight;
	CBorder	m_bdTop;
	CBorder	m_bdBottom;
	CTitle	m_Title;
	BOOL	m_bTitle;

	static  BOOL m_bFull;

// Operations
public:
	VOID Init(HANDLE hChannel, int nIndex) {m_hChannel=hChannel; m_nChannel=nIndex;}
	HANDLE ChannelHandle(){return m_hChannel;}
	int	   ChannelId() { return m_nChannel; }
	BOOL CreateWnd(CRect& rc, CWnd* pParentWnd, int nIndex);
	RECT GetNormalRect(){return m_rcNormal;}
	void MoveVideo(CRect rc);
	void ShowBorder(BOOL bShow);
	void MoveBorder();
	void MoveTitle();
	void UpdateTitle(CString strTitle);
	void ShowTitle(BOOL bShow, BOOL bForce=FALSE);
	void EnableTitle(BOOL bEnable) { m_bTitle=bEnable; }
	void Y41PToYuv420p(PBYTE y41p, PBYTE yuv420p, int w, int h);
	void Y41PToYuy2(PBYTE y41p, PBYTE yuy2, int w, int h);
	void Yuv420pToYuy2(PBYTE yuv420p, PBYTE yuy2, int w, int h);
	virtual BOOL IsVisible(){ return ((GetSafeHwnd()==NULL) ? FALSE : IsWindowVisible()); }

protected:
	virtual void OnSetCurrent() {}
	virtual void OnShowNormal();
	virtual void OnShowLarge();
	virtual void OnShowFull();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVideoWnd)
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVideoWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CVideoWnd)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIDEOWND_H__5A07F8D2_56C5_46CC_B69C_A89640574ADE__INCLUDED_)
