// I2C6864.h: interface for the CI2C6864 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__I2C6864_H_)
#define __I2C6864_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "I2C.h"

class CI2C6864 : public CI2C  
{
public:
	// constructor and destructor
	CI2C6864() : m_pMem(NULL), control_word(0), m_shadow_0x85(0xFF) {};
	virtual ~CI2C6864() {};
	
	virtual bool i2cInit(PVOID pMem, HANDLE hLock);
	
	virtual bool I2CSWSetSCL( TLevel );
	virtual int  I2CSWReadSCL( void );
	virtual bool I2CSWSetSDA( TLevel );
	virtual int  I2CSWReadSDA( void );
	
	virtual bool i2cReadData(UCHAR *cWrite, int nWirteBytes, UCHAR* pData, int nReadBytes);
	virtual bool i2cWriteByte(UCHAR addr, UCHAR sub, UCHAR mask, UCHAR val);
	virtual bool i2cReadDataNoLock(UCHAR *cWrite, int nWirteBytes, UCHAR* pData, int nReadBytes);
	virtual bool i2cWriteByteNoLock(UCHAR addr, UCHAR sub, UCHAR mask, UCHAR val);
	
protected:
	KMemoryRange* m_pMem;
	ULONG		  control_word;
	UCHAR		  m_shadow_0x85;
};

#endif // !defined(__I2C6864_H_)
