// TW68XXioctl.h
//
// Define control codes for CTW68XX driver
//

#ifndef __TW68XXioctl__h_
#define __TW68XXioctl__h_

// {E256D194-1172-4ca4-A2D2-4DDE4716F632}
#define TW68XXDevice_CLASS_GUID \
 { 0xe256d194, 0x1172, 0x4ca4, { 0xa2, 0xd2, 0x4d, 0xde, 0x47, 0x16, 0xf6, 0x32 } }

#define IOCTL_COMMAND CTL_CODE(FILE_DEVICE_UNKNOWN, 0x888, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOBUFF_LEN			2000		//IO󳤶---BYTEΪλ
#define IOBUFF_LEN_W		1000		//IO󳤶---WORDΪλ
#define IOBUFF_LEN_DW		500			//IO󳤶---DWORDΪλ
#define IOBUFF_LEN_MAX		8192
#define IOBUFF_LEN_W_MAX	4096
#define IOBUFF_LEN_DW_MAX	2048
#define MAX_PCIMEM_NUM		5			//PCIڴ
#define MAX_IRQ_NUM			5			//IRQ
#define MAX_INTSTATUS		2			//жϼĴĿ
#define MAX_TIMER_NUM		5			//Timer
#define MAX_RW_NUM			20			//IRQдļĴĿ
#define MAX_RW_TIMER		4			//TimerдļĴĿ
#define MAX_COPY_ITEMS		2
#define MAX_DEVICE_NUM		8
#define FLAG_PCI2I2C		0x80000000	//BIT(31) ͨPCI豸I2Cдⲿ豸ļĴ־
#define IS_PCI2I2C(addr)	((addr)&FLAG_PCI2I2C)
#define ADDR_PCI2I2C(addr)	(((addr)&0x00FF0000)>>16)
#define MAKE_PCI2I2C(addr,reg)	((reg)|=FLAG_PCI2I2C|((addr&0xFF)<<16))

typedef enum{
	//ܽӿ
	cmdInit = 0x00000000,			//ʼ
	cmdUninit,						//ʼ
	cmdInitDevice,					//ʼ豸
	cmdUninitDevice,				//ʼ豸
	cmdAppendCrash,					//Crash
	cmdAppendIrq,					//ж
	cmdModifyIrq,					//޸ӹж
	cmdRemoveIrq,					//ɾж
	cmdModifyEvt,					//޸ӹж
	cmdAppendTimer,					//Timer
	cmdRemoveTimer,					//ɾTimer
	cmdModifyTimer,					//޸Timer
	cmdCancelTimer,					//ȡTimer
	cmdAppendI2C,					//I2C豸
	cmdRemoveI2C,					//ɾI2C豸

	//PCI memory (Ĵӿ)
	cmdReadMemBYTEs = 0x00000100,
	cmdReadMemWORDs,
	cmdReadMemDWORDs,
	cmdWriteMemBYTEs,
	cmdWriteMemWORDs,
	cmdWriteMemDWORDs,
	cmdReadPciConfigSpace,
	cmdWritePciConfigSpace,
	cmdReadPciConfigSpaceEx,
	cmdWritePciConfigSpaceEx,

	//ڴ䡢ͷšӳ
	cmdAllocMemory = 0x00000200,	//Ҫڷڴ
	cmdFreeMemory,					//ͷŷڴ
	cmdMapMemory,					//ӳڴ棬Ҫڴַת
	cmdUnmapMemory,					//ӳڴַ
	cmdMapPciMemory,				//ӳPCIڴ浽ָ
	cmdUnmapPciMemory,				//ӳPCIڴַ
}TIoctlCommand;

typedef struct tagIoctlCommandInfo{
	IN  TIoctlCommand	cmd;					//
	IN	HANDLE			hProcess;				//̾
	IN  ULONG			context[1];				//ġʵָʾϸϢ
}TIoctlCommandInfo, *PIoctlCommandInfo;

//ʼϢ
typedef struct tagCmdInitInfo{
	IN	ULONG			toSystem;				//ǷPCIڴӳ䵽ϵͳڴռ
	OUT struct {
		void*			addrBase;				//ַ
		void*			procBase;				//ַӳ䵽̿ռ
		ULONG			len;
	}mem[MAX_PCIMEM_NUM];
}TCmdInitInfo, *PCmdInitInfo;

//ʼ豸
typedef struct tagCmdInitDeviceInfo{
	IN  ULONG			deviceId;
	IN	HANDLE			evtData;				//豸ж֪ͨ¼
	OUT	void*			datShare;				//ڴָ
	OUT	ULONG			lenShare;				//ڴ
}TCmdInitDeviceInfo, *PCmdInitDeviceInfo;

//ʼ豸
typedef struct tagCmdNotifyEventInfo{
	IN  ULONG			deviceId;
	IN	HANDLE			evtData;				//豸ж֪ͨ¼
}TCmdNotifyEventInfo, *PCmdNotifyEventInfo;

//CrashʱҪµϢ
typedef struct tagCrashInfo{
	IN	ULONG			regBase;				//Ĵַ
	IN	ULONG			regCrash;				//ĴƫƵַ
	IN	ULONG			higMask;				//Ҫд1mask bit
	IN  ULONG			lowMask;				//Ҫд0mask bit
}TCrashInfo, *PCrashInfo, TCmdCrashInfo, *PCmdCrashInfo;

//жϢ
typedef struct tagIrqInfo{
	IN	ULONG			irqId;					//жʶ
	IN	ULONG			regBase;				//Ĵַ
	IN	ULONG			mask[MAX_INTSTATUS];	//ж
	IN	ULONG			regMask[MAX_INTSTATUS];	//жĴƫƵַ
	IN	ULONG			regStatus[MAX_INTSTATUS];//ж״̬ĴƫƵַ
	IN  ULONG			regClear[MAX_INTSTATUS];//ж״̬ĴΪ-1Ҫ
	IN  ULONG			regRWBase;				//дĴַ
	IN  ULONG			regI2C;					//I2Cдַ
	IN	ULONG			regRead[MAX_RW_NUM];	//ҪISRзֵļĴƫƵַ,0xFFFFFFFFʱʾû
	IN	ULONG			regWrite[MAX_RW_NUM];	//ҪISRдֵļĴƫƵַ,0xFFFFFFFFʱʾûУҪдֵShareData
	IN	ULONG			mskWrite[MAX_RW_NUM];	//жISRҪдֵļĴ
	IN	ULONG			timerId;				//жISRҪtimer id,0xFFFFFFFFʱʾû
	IN  ULONG			devCopy;				//Copy豸
	IN  ULONG			mskCopy;				//жISRCopyݵ룬ЩжbitʱҪ
	IN	ULONG			freqWrite;				//ǷждĴƵʣжfreqWriteβдһμĴ(ʱ)
	OUT ULONG			status[MAX_INTSTATUS];	//ǰж״̬
}TIrqInfo, *PIrqInfo;

typedef struct tagCmdIrqInfo {
	IN  ULONG			deviceId;				//豸ʶ
	TIrqInfo			irqInfo;
}TCmdIrqInfo, *PCmdIrqInfo;

//TIMERϢ
typedef struct tagTimerInfo{
	IN	LONGLONG		dueTime;				//Timerʱ䳤
	IN	ULONG			regBase;				//Ĵַ
	IN	ULONG			regRead[MAX_RW_TIMER];	//ҪISRзֵļĴƫƵַ,0xFFFFFFFFʱʾû
	IN	ULONG			regWrite[MAX_RW_TIMER];	//ҪISRдֵļĴƫƵַ,0xFFFFFFFFʱʾûУҪдֵShareData
	IN	ULONG			mskWrite[MAX_RW_TIMER];	//жISRҪдֵļĴ
}TTimerInfo, *PTimerInfo;

typedef struct tagCmdTimerInfo {
	IN  ULONG			deviceId;				//豸ʶ
	IN	ULONG			timerId;
	TTimerInfo			tmiInfo;
}TCmdTimerInfo, *PCmdTimerInfo;

//I2CϢ
typedef struct tagCmdI2CInfo {
	IN	ULONG			hwid;					//豸ӲID
	IN  ULONG			memBase;				//豸ڴַ
	IN	HANDLE			hLock;					//ͬ
	IN	ULONG			reserved;
	OUT ULONG			i2cHandle;				//i2c
}TCmdI2CInfo, *PCmdI2CInfo;

//PCIڴBYTEдϢ
typedef struct tagCmdRwMemByteInfo {
	IN	   ULONG		memBase;				//ַ
	IN	   ULONG		memOffset;				//ƫƵַ
	IN OUT ULONG		len;					//ݸ
	IN OUT UCHAR		data[IOBUFF_LEN-12];	//ݻ
}TCmdRwMemByteInfo, *PCmdRwMemByteInfo;

//PCIڴWORDдϢ
typedef struct tagCmdRwMemWordInfo {
	IN	   ULONG		memBase;				//ַ
	IN	   ULONG		memOffset;				//ƫƵַ
	IN OUT ULONG		len;					//ݸ
	IN OUT USHORT		data[IOBUFF_LEN_W-6];	//ݻ
}TCmdRwMemWordInfo, *PCmdRwMemWordInfo;

//PCIڴDWORDдϢ
typedef struct tagCmdRwMemDwordInfo {
	IN	   ULONG		memBase;				//ַ
	IN	   ULONG		memOffset;				//ƫƵַ
	IN OUT ULONG		len;					//ݸ
	IN OUT ULONG		data[IOBUFF_LEN_DW-3];	//ݻ
}TCmdRwMemDwordInfo, *PCmdRwMemDwordInfo;

typedef struct tagBridgeDesc {
	ULONG	bus;
	ULONG	hwid;
	ULONG	device;
	ULONG	function;
}TBridgeDesc, *PBridgeDesc;

//PCIÿռBYTEдϢ
typedef struct tagCmdRwPciConfigSpaceInfo {
	IN	   ULONG		slot;					//slot number
	IN	   TBridgeDesc	bridge;					//bridge info
	IN	   ULONG		offset;					//ƫƵַ
	IN OUT ULONG		len;					//ݸ
	IN OUT UCHAR		data[IOBUFF_LEN-28];	//ݻ
}TCmdRwPciConfigSpaceInfo, *PCmdRwPciConfigSpaceInfo;

//sdkͨŵ¼
typedef	enum tagEventType{
	evt_None,									//Ч¼
	evt_DataIrq,								//ݴж
}TEventType;									

//Copy
typedef struct tagCopyItem {
	ULONG			isCopy;					//ǷҪcopyڴ,DMAPеjumpĿǿISRֹͣɼ
	ULONG			idFrom;					//Դַ
	ULONG			fromOffset;				//Դַƫ
	ULONG			idDest;					//Ŀַ
	ULONG			destOffset;				//Ŀַƫ
	ULONG			cpyLen;					//(ֽ)
	ULONG			maxCount;				//ѭmaxCount0ǵַԶӲѭ
	ULONG			cpyCount;				//Copy
	ULONG			cpyStep;				//ַԶֽ
}TCopyItem;

//ڴݽṹ
typedef struct tagShareData {
	struct {
		ULONG			irqId;					//жʶ
		TEventType		evtId;					//¼
		ULONG			status[MAX_INTSTATUS];	//жid
		ULONG			irqCount;				//жϴ
		LARGE_INTEGER	tkCount;				//жϷʱʱ
		LARGE_INTEGER	tkFreq;					//Perfermance counterƵ
		ULONG			regRead[MAX_RW_NUM];	//жISRзصļĴֵ
		ULONG			regWrite[MAX_RW_NUM];	//жISRҪдֵļĴ
		ULONG			regReadTimer[MAX_RW_TIMER];	//TimerзصļĴֵ
		ULONG			regWriteTimer[MAX_RW_TIMER];//TimerҪдֵļĴ
		ULONG			dueTime;					//Timerʱ
		ULONG			freqWrite;				//ждĴƵʣжfreqWriteβдһμĴ(ʱ)
		ULONG			timerIrq;				//TimerɺǷ֪ͨϲSDK
		ULONG			timerIrqPos;			//(irqId<<16)|status_index
		ULONG			timerIrqMask;			//Timerɺ֪ͨж
	}irqData[MAX_IRQ_NUM];
	TCopyItem			cpyItems[MAX_COPY_ITEMS];	//жISRҪCopy
}TShareData, *PShareData;

//ڴתṹ,ڽڴַתΪڴַ
typedef struct tagMemNode {
	PVOID		addr;							//ʼַ
	ULONG		len;							//
}TMemNode, *PMemNode;

typedef struct tagMemBlock {
	IN  PVOID	vaddr;							//ַʼ
	IN  ULONG	len;							//ܳ
	OUT ULONG	inode;							//ڴ
	union {										//unionƵǰߣΪжnodeʱ˺ߵ
			PMemNode pnodes;					//
		OUT	TMemNode nodes[1];					//
	};
}TMemBlock, *PMemBlock, TCmdMemoryInfo, *PCmdMemoryInfo;

#endif
