// TW68XXioctl.h
//
// Define control codes for CTW68XX driver, for 64bit version
//

#ifndef __TW68XXioctl32__h_
#define __TW68XXioctl32__h_

typedef VOID*POINTER_32 HANDLE32;
typedef VOID*POINTER_32 PVOID32;

typedef struct tagIoctlCommandInfo32{
	IN  ULONG32			cmd;					//
	IN	HANDLE32		hProcess;				//̾
	IN  ULONG32			context[1];				//ġʵָʾϸϢ
}TIoctlCommandInfo32, *PIoctlCommandInfo32;

//ʼϢ
typedef struct tagCmdInitInfo32{
	IN	ULONG32			toSystem;				//ǷPCIڴӳ䵽ϵͳڴռ
	OUT struct {
		PVOID32			addrBase;				//ַ
		PVOID32			procBase;				//ַӳ䵽̿ռ
		ULONG32			len;
	}mem[MAX_PCIMEM_NUM];
}TCmdInitInfo32, *PCmdInitInfo32;

//ʼ豸
typedef struct tagCmdInitDeviceInfo32{
	IN  ULONG32			deviceId;
	IN	HANDLE32		evtData;				//豸ж֪ͨ¼
	OUT	PVOID32			datShare;				//ڴָ
	OUT	ULONG32			lenShare;				//ڴ
}TCmdInitDeviceInfo32, *PCmdInitDeviceInfo32;

//ʼ豸
typedef struct tagCmdNotifyEventInfo32{
	IN  ULONG32			deviceId;
	IN	HANDLE32		evtData;				//豸ж֪ͨ¼
}TCmdNotifyEventInfo32, *PCmdNotifyEventInfo32;

//CrashʱҪµϢ
typedef struct tagCrashInfo32{
	IN	ULONG32			regBase;				//Ĵַ
	IN	ULONG32			regCrash;				//ĴƫƵַ
	IN	ULONG32			higMask;				//Ҫд1mask bit
	IN  ULONG32			lowMask;				//Ҫд0mask bit
}TCrashInfo32, *PCrashInfo32, TCmdCrashInfo32, *PCmdCrashInfo32;

//жϢ
typedef struct tagIrqInfo32{
	IN	ULONG32			irqId;					//жʶ
	IN	ULONG32			regBase;				//Ĵַ
	IN	ULONG32			mask[MAX_INTSTATUS];	//ж
	IN	ULONG32			regMask[MAX_INTSTATUS];	//жĴƫƵַ
	IN	ULONG32			regStatus[MAX_INTSTATUS];//ж״̬ĴƫƵַ
	IN  ULONG32			regClear[MAX_INTSTATUS];//ж״̬ĴΪ-1Ҫ
	IN  ULONG32			regRWBase;				//дĴַ
	IN  ULONG32			regI2C;					//I2Cдַ
	IN	ULONG32			regRead[MAX_RW_NUM];	//ҪISRзֵļĴƫƵַ,0xFFFFFFFFʱʾû
	IN	ULONG32			regWrite[MAX_RW_NUM];	//ҪISRдֵļĴƫƵַ,0xFFFFFFFFʱʾûУҪдֵShareData
	IN	ULONG32			mskWrite[MAX_RW_NUM];	//жISRҪдֵļĴ
	IN	ULONG32			timerId;				//жISRҪtimer id,0xFFFFFFFFʱʾû
	IN  ULONG32			devCopy;				//Copy豸
	IN  ULONG32			mskCopy;				//жISRCopyݵ룬ЩжbitʱҪ
	IN	ULONG32			freqWrite;				//ǷждĴƵʣжfreqWriteβдһμĴ(ʱ)
	OUT ULONG32			status[MAX_INTSTATUS];	//ǰж״̬
}TIrqInfo32, *PIrqInfo32;

typedef struct tagCmdIrqInfo32 {
	IN  ULONG32			deviceId;				//豸ʶ
	TIrqInfo32			irqInfo;
}TCmdIrqInfo32, *PCmdIrqInfo32;

//TIMERϢ
typedef struct tagTimerInfo32{
	IN	LONGLONG		dueTime;				//Timerʱ䳤
	IN	ULONG32			regBase;				//Ĵַ
	IN	ULONG32			regRead[MAX_RW_TIMER];	//ҪISRзֵļĴƫƵַ,0xFFFFFFFFʱʾû
	IN	ULONG32			regWrite[MAX_RW_TIMER];	//ҪISRдֵļĴƫƵַ,0xFFFFFFFFʱʾûУҪдֵShareData
	IN	ULONG32			mskWrite[MAX_RW_TIMER];	//жISRҪдֵļĴ
}TTimerInfo32, *PTimerInfo32;

typedef struct tagCmdTimerInfo32 {
	IN  ULONG32			deviceId;				//豸ʶ
	IN	ULONG32			timerId;
	TTimerInfo32		tmiInfo;
}TCmdTimerInfo32, *PCmdTimerInfo32;

//I2CϢ
typedef struct tagCmdI2CInfo32 {
	IN	ULONG32			hwid;					//豸ӲID
	IN  ULONG32			memBase;				//豸ڴַ
	IN	HANDLE32		hLock;					//ͬ
	IN	ULONG32			reserved;
	OUT ULONG32			i2cHandle;				//i2c
}TCmdI2CInfo32, *PCmdI2CInfo32;

//PCIڴBYTEдϢ
typedef struct tagCmdRwMemByteInfo32 {
	IN	   ULONG32		memBase;				//ַ
	IN	   ULONG32		memOffset;				//ƫƵַ
	IN OUT ULONG32		len;					//ݸ
	IN OUT UCHAR		data[IOBUFF_LEN-12];	//ݻ
}TCmdRwMemByteInfo32, *PCmdRwMemByteInfo32;

//PCIڴWORDдϢ
typedef struct tagCmdRwMemWordInfo32 {
	IN	   ULONG32		memBase;				//ַ
	IN	   ULONG32		memOffset;				//ƫƵַ
	IN OUT ULONG32		len;					//ݸ
	IN OUT USHORT		data[IOBUFF_LEN_W-6];	//ݻ
}TCmdRwMemWordInfo32, *PCmdRwMemWordInfo32;

//PCIڴDWORDдϢ
typedef struct tagCmdRwMemDwordInfo32 {
	IN	   ULONG32		memBase;				//ַ
	IN	   ULONG32		memOffset;				//ƫƵַ
	IN OUT ULONG32		len;					//ݸ
	IN OUT ULONG32		data[IOBUFF_LEN_DW-3];	//ݻ
}TCmdRwMemDwordInfo32, *PCmdRwMemDwordInfo32;

typedef struct tagBridgeDesc32 {
	ULONG32				bus;
	ULONG32				hwid;
	ULONG32				device;
	ULONG32				function;
}TBridgeDesc32, *PBridgeDesc32;

//PCIÿռBYTEдϢ
typedef struct tagCmdRwPciConfigSpaceInfo32 {
	IN	   ULONG32		slot;					//slot number
	IN	   TBridgeDesc32	bridge;				//bridge info
	IN	   ULONG32		offset;					//ƫƵַ
	IN OUT ULONG32		len;					//ݸ
	IN OUT UCHAR		data[IOBUFF_LEN-28];	//ݻ
}TCmdRwPciConfigSpaceInfo32, *PCmdRwPciConfigSpaceInfo32;

//Copy
typedef struct tagCopyItem32 {
	ULONG32				isCopy;					//ǷҪcopyڴ,DMAPеjumpĿǿISRֹͣɼ
	ULONG32				idFrom;					//Դַ
	ULONG32				fromOffset;				//Դַƫ
	ULONG32				idDest;					//Ŀַ
	ULONG32				destOffset;				//Ŀַƫ
	ULONG32				cpyLen;					//(ֽ)
	ULONG32				maxCount;				//ѭmaxCount0ǵַԶӲѭ
	ULONG32				cpyCount;				//Copy
	ULONG32				cpyStep;				//ַԶֽ
}TCopyItem32;

//ڴݽṹ
typedef struct tagShareData32 {
	struct {
		ULONG32			irqId;					//жʶ
		ULONG32			evtId;					//¼
		ULONG32			status[MAX_INTSTATUS];	//жid
		ULONG32			irqCount;				//жϴ
		LARGE_INTEGER	tkCount;				//жϷʱʱ
		LARGE_INTEGER	tkFreq;					//Perfermance counterƵ
		ULONG32			regRead[MAX_RW_NUM];	//жISRзصļĴֵ
		ULONG32			regWrite[MAX_RW_NUM];	//жISRҪдֵļĴ
		ULONG32			regReadTimer[MAX_RW_TIMER];	//TimerзصļĴֵ
		ULONG32			regWriteTimer[MAX_RW_TIMER];//TimerҪдֵļĴ
		ULONG32			dueTime;					//Timerʱ
		ULONG32			freqWrite;				//ждĴƵʣжfreqWriteβдһμĴ(ʱ)
		ULONG32			timerIrq;				//TimerɺǷ֪ͨϲSDK
		ULONG32			timerIrqPos;			//(irqId<<16)|status_index
		ULONG32			timerIrqMask;			//Timerɺ֪ͨж
	}irqData[MAX_IRQ_NUM];
	TCopyItem32			cpyItems[MAX_COPY_ITEMS];	//жISRҪCopy
}TShareData32, *PShareData32;

//ڴתṹ,ڽڴַתΪڴַ
typedef struct tagMemNode32 {
	PVOID32		addr;							//ʼַ
	ULONG32		len;							//
}TMemNode32, *PMemNode32;

//64λ32λDLLʱҪ4ֽڶ룬½ṹ
//64λpnodes8ֽڶ룬SDK32λ4ֽڶ
#pragma pack(push)	//״̬
#pragma pack(4)		//趨Ϊ4ֽڶ

typedef struct tagMemBlock32 {
	IN  PVOID32	vaddr;							//ַʼ
	IN  ULONG32	len;							//ܳ
	OUT ULONG32	inode;							//ڴ
	union {										//unionƵǰߣΪжnodeʱ˺ߵ
			PMemNode32 pnodes;					//
		OUT	TMemNode32 nodes[1];				//
	};
}TMemBlock32, *PMemBlock32, TCmdMemoryInfo32, *PCmdMemoryInfo32;

#pragma pack(pop)	//ָ״̬

#endif
