// TimedCallback.cpp: implementation of the CTimedCallback class.
//
//////////////////////////////////////////////////////////////////////

#include <vdw.h>
#include "TimedCallback.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTimedCallback::CTimedCallback() : KTimedCallback()
{
}

BOOLEAN CTimedCallback::Set(
							LARGE_INTEGER DueTime,
							PKDEFERRED_ROUTINE Callback, 
							PVOID Context,
							PVOID Arg1, 
							PVOID Arg2)
{
	KeInitializeDpc(&m_dpc, Callback, Context);
	m_dpc.SystemArgument1 = Arg1;
	m_dpc.SystemArgument2 = Arg2;
	return KeSetTimer(&m_timer, DueTime, &m_dpc);
}

BOOLEAN CTimedCallback::Set(
							LONGLONG DueTime,
							PKDEFERRED_ROUTINE Callback, 
							PVOID Context,
							PVOID Arg1, 
							PVOID Arg2)
{
	LARGE_INTEGER LargeDueTime;
	
	KeInitializeDpc(&m_dpc, Callback, Context);
	
	LargeDueTime.QuadPart = (ULONGLONG)DueTime;
	m_dpc.SystemArgument1 = Arg1;
	m_dpc.SystemArgument2 = Arg2;
	
	return KeSetTimer(&m_timer, LargeDueTime, &m_dpc);
}


BOOLEAN CTimedCallback::SetPeriodic(
									LARGE_INTEGER DueTime, 
									LONG PeriodmSec,
									PKDEFERRED_ROUTINE Callback, 
									PVOID Context,
									PVOID Arg1, 
									PVOID Arg2)
{
	KeInitializeDpc(&m_dpc, Callback, Context);
	m_dpc.SystemArgument1 = Arg1;
	m_dpc.SystemArgument2 = Arg2;
	return KeSetTimerEx(&m_timer, DueTime, PeriodmSec, &m_dpc);
}		

BOOLEAN CTimedCallback::SetPeriodic(
									LONGLONG DueTime, 
									LONG PeriodmSec,
									PKDEFERRED_ROUTINE Callback, 
									PVOID Context,
									PVOID Arg1, 
									PVOID Arg2)
{
	LARGE_INTEGER LargeDueTime;
	LargeDueTime.QuadPart = (ULONGLONG)DueTime;
	
	KeInitializeDpc(&m_dpc, Callback, Context);
	m_dpc.SystemArgument1 = Arg1;
	m_dpc.SystemArgument2 = Arg2;
	return KeSetTimerEx(&m_timer, LargeDueTime, PeriodmSec, &m_dpc);
}		
