// kdmqueue.h - include file for class KDriverManagedQueue
//=============================================================================
//
// Compuware Corporation
// NuMega Lab
// 9 Townsend West
// Nashua, NH 03060  USA
//
// Copyright (c) 1998 Compuware Corporation. All Rights Reserved.
// Unpublished - rights reserved under the Copyright laws of the
// United States.
//
// U.S. GOVERNMENT RIGHTS-Use, duplication, or disclosure by the
// U.S. Government is subject to restrictions as set forth in 
// Compuware Corporation license agreement and as provided in 
// DFARS 227.7202-1(a) and 227.7202-3(a) (1995), 
// DFARS 252.227-7013(c)(1)(ii)(OCT 1988), FAR 12.212(a) (1995), 
// FAR 52.227-19, or FAR 52.227-14 (ALT III), as applicable.  
// Compuware Corporation.
// 
// This product contains confidential information and trade secrets 
// of Compuware Corporation. Use, disclosure, or reproduction is 
// prohibited without the prior express written permission of Compuware 
// Corporation.
//
//=============================================================================

class KDriverManagedQueue : public KDeviceQueue
{

// Construction
public:
	SAFE_DESTRUCTORS;
	KDriverManagedQueue(void);

// Methods
public:
	NTSTATUS QueueIrp(KIrp I);
	PIRP& CurrentIrp(void);
	VOID NextIrp(KIrp I, CCHAR boost=IO_NO_INCREMENT);
#if _WDM_
	VOID PnpNextIrp(KPnpDevice* pDevice, KIrp I, CCHAR boost=IO_NO_INCREMENT);
#endif // _WDM_
	virtual VOID StartIo(KIrp I) = 0;
	virtual VOID Cancel(KIrp I);

protected:
	static VOID CancelDispatch(PDEVICE_OBJECT pDev, PIRP pIrp);

// Data
public:
	KIrp m_CurrentIrp;
};

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

inline PIRP& KDriverManagedQueue::CurrentIrp(void) 
{
	return m_CurrentIrp.m_Irp;
}

