/**
 ***************************************************************************************
 *  Copyright (C) 2008, Sharebit
 *  All rights reserved.
 *
 *  @file 		AviWriter.h
 *  @brief		дAVIļCAviWriter
 *
 *  @version	0.1
 *  @author		liran
 *	@brief		created
 *  @date		2008/03/06
 ***************************************************************************************
 */

#if !defined(__AVIWRITER_H_)
#define __AVIWRITER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vfw.h>

class CLockCS;
class CAviWriter  
{
public:
	typedef struct tagVideoStreamInfo {
		ULONG width;
		ULONG height;
		ULONG frame_rate;
		ULONG fccHandler;
	}TVideoStreamInfo, *PVideoStreamInfo;
	
	typedef struct tagAudioStreamInfo {
		WAVEFORMATEX wfx;
		ULONG		 sample_size;
		ULONG		 samples_block;
		ULONG		 fccHandler;
	}TAudioStreamInfo, *PAudioStreamInfo;

public:
	CAviWriter();
	virtual ~CAviWriter();

	BOOL Open(LPCTSTR szFileName, PVideoStreamInfo vsi, PAudioStreamInfo asi);
	VOID Close();
	LONG WriteVideo(BYTE *pData, ULONG dwSize, ULONGLONG pts, ULONG duration);
	LONG WriteAudio(BYTE *pData, ULONG dwSize);
	LONG GetSize();

protected:
	BOOL Open(LPCTSTR szFileName);
	BOOL CreateVideoStream(ULONG dwWidth, ULONG dwHeight, ULONG dwFrmRate, ULONG fccHandler);
	BOOL CreateAudioStream(WAVEFORMATEX wfx, ULONG nSampleSize, ULONG fccHandler);

	PAVIFILE    m_pAviFile;
	PAVISTREAM  m_pStreamV;
	PAVISTREAM  m_pStreamA;
	ULONG		m_iFrameRate;
	ULONG		m_iFramesCnt;
	ULONGLONG	m_iLastPts;
	ULONGLONG	m_iLastPtsV;
	ULONG		m_iSamplesV;
	ULONG		m_iSamplesA;
	ULONG		m_iLength;
	BOOL		m_bKeyFramed;
	TCHAR		m_szFileName[MAX_PATH];
	CrLockCS		m_csWrite;
	static int  m_iAviRef;
};

#endif // !defined(__AVIWRITER_H_)
