// D3DDisplay.h: interface for the CD3DDisplay class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_D3DDISPLAY_H__D2B5461A_AF44_411A_8FEA_8439E0FB5628__INCLUDED_)
#define AFX_D3DDISPLAY_H__D2B5461A_AF44_411A_8FEA_8439E0FB5628__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define D3D_YUV422 1
#define D3D_ARGB24 0

#include <d3dx9.h>

class CD3DDisplay  
{
public:
	HRESULT RenderYUYV(BYTE* pSampleBuffer);
	HRESULT RenderARGB(BYTE *pSampleBuffer);
	HRESULT RenderTOSrceen();
	HRESULT Setup2DCamera(int width, int height);
	HRESULT InitGeometry();
	HRESULT CreateTexture(int width, int height);
	HRESULT InitD3D(HWND hWnd, int format, RECT rect);
	void ClearD3D();
	CD3DDisplay();
	virtual ~CD3DDisplay();

private:
	LPDIRECT3D9             m_pD3D; 
    LPDIRECT3DDEVICE9       m_pd3dDevice; 
    LPDIRECT3DTEXTURE9      m_pTextures; 
	LPDIRECT3DVERTEXBUFFER9 m_pVB;			//λͼεĶ㻺ӿָ 

	HWND m_hWnd;
	D3DFORMAT m_Format;
	RECT m_Rect;

	typedef struct tagCustomVertex
	{     
		float x,y,z,rhw;	// 
		DWORD color;		//ɫ 
		float tu,tv;		// 
	}TCustomVertex; 
};

#endif // !defined(AFX_D3DDISPLAY_H__D2B5461A_AF44_411A_8FEA_8439E0FB5628__INCLUDED_)
