// Surface.cpp: implementation of the CSurface class.
//
//////////////////////////////////////////////////////////////////////

#include "Surface.h"

#define SAFE_CLOSE_HANDLE(p) {if(p){CloseHandle(p);(p) = NULL;}}
#define SAFE_RELEASE(p) {if(p) {p->Release();p=NULL;}}

#define DEFAULT_WIDTH	352
#define DEFAULT_HEIGHT	288

extern const DDPIXELFORMAT*	g_pixelformatindex[];

/*
static void GmemcpyMMX(void *Dest, void *Src, size_t nBytes)
{
    __asm {
        mov     esi, dword ptr[Src]
		mov     edi, dword ptr[Dest]
		mov     ecx, nBytes
		shr     ecx, 6                      // nBytes / 64
		align 8
CopyLoop:
        movq    mm0, qword ptr[esi]
		movq    mm1, qword ptr[esi+8*1]
		movq    mm2, qword ptr[esi+8*2]
		movq    mm3, qword ptr[esi+8*3]
		movq    mm4, qword ptr[esi+8*4]
		movq    mm5, qword ptr[esi+8*5]
		movq    mm6, qword ptr[esi+8*6]
		movq    mm7, qword ptr[esi+8*7]
		movq    qword ptr[edi], mm0
		movq    qword ptr[edi+8*1], mm1
		movq    qword ptr[edi+8*2], mm2
		movq    qword ptr[edi+8*3], mm3
		movq    qword ptr[edi+8*4], mm4
		movq    qword ptr[edi+8*5], mm5
		movq    qword ptr[edi+8*6], mm6
		movq    qword ptr[edi+8*7], mm7
		add     esi, 64
		add     edi, 64
		loop CopyLoop
		mov     ecx, nBytes
		and     ecx, 63
		cmp     ecx, 0
		je EndCopyLoop
EndCopyLoop:
		emms
    }
}

static void memcpy_sse(void *dst, void *src, int nQWORDs)
{   
#define   CACHEBLOCK   1024   //һжQWORDs   
	//޸Ĵֵпʵָߵٶ   
	int   n=((int)(nQWORDs/CACHEBLOCK))*CACHEBLOCK;   
	int   m=nQWORDs-n;   
	if   (n)   
	{   
		_asm   //ȿ   
		{   
			mov   esi,   src   
			mov   edi,   dst   
			mov   ecx,   n //Ҫٸ   
			lea   esi,   [esi+ecx*8]   
			lea   edi,   [edi+ecx*8]   
			neg   ecx   
mainloop:   
			mov   eax,   CACHEBLOCK   /   16   
prefetchloop:   
			mov   ebx,   [esi+ecx*8]   //Ԥѭ   
			mov   ebx,   [esi+ecx*8+64] //Ԥѭ   
			add   ecx,   16   
			dec   eax   
			jnz   prefetchloop   
			sub   ecx,   CACHEBLOCK   
			mov   eax,   CACHEBLOCK   /   8   
writeloop:   
			movq   mm0,   qword   ptr   [esi+ecx*8         ]   
			movq   mm1,   qword   ptr   [esi+ecx*8+8   ]   
			movq   mm2,   qword   ptr   [esi+ecx*8+16]   
			movq   mm3,   qword   ptr   [esi+ecx*8+24]   
			movq   mm4,   qword   ptr   [esi+ecx*8+32]   
			movq   mm5,   qword   ptr   [esi+ecx*8+40]   
			movq   mm6,   qword   ptr   [esi+ecx*8+48]   
			movq   mm7,   qword   ptr   [esi+ecx*8+56]   
			
			movntq   qword   ptr   [edi+ecx*8       ],   mm0   
			movntq   qword   ptr   [edi+ecx*8+8   ],   mm1   
			movntq   qword   ptr   [edi+ecx*8+16],   mm2   
			movntq   qword   ptr   [edi+ecx*8+24],   mm3   
			movntq   qword   ptr   [edi+ecx*8+32],   mm4   
			movntq   qword   ptr   [edi+ecx*8+40],   mm5   
			movntq   qword   ptr   [edi+ecx*8+48],   mm6   
			movntq   qword   ptr   [edi+ecx*8+56],   mm7   
			add   ecx,   8   
			dec   eax   
			jnz   writeloop   
			or   ecx,   ecx   
			jnz   mainloop   
		}   
	}   
	if   (m)   
	{   
		_asm   
		{   
			mov   esi,   src   
			mov   edi,   dst   
			mov   ecx,   m   
			mov   ebx,   nQWORDs   
			lea   esi,   [esi+ebx*8]   
			lea   edi,   [edi+ebx*8]   
			neg   ecx   
copyloop:   
			prefetchnta   [esi+ecx*8+512]     //Ԥ   
			movq   mm0,   qword   ptr   [esi+ecx*8       ]   
			movq   mm1,   qword   ptr   [esi+ecx*8+8   ]   
			movq   mm2,   qword   ptr   [esi+ecx*8+16]   
			movq   mm3,   qword   ptr   [esi+ecx*8+24]   
			movq   mm4,   qword   ptr   [esi+ecx*8+32]   
			movq   mm5,   qword   ptr   [esi+ecx*8+40]   
			movq   mm6,   qword   ptr   [esi+ecx*8+48]   
			movq   mm7,   qword   ptr   [esi+ecx*8+56]   
			
			movntq   qword   ptr   [edi+ecx*8       ],   mm0   
			movntq   qword   ptr   [edi+ecx*8+8   ],   mm1   
			movntq   qword   ptr   [edi+ecx*8+16],   mm2   
			movntq   qword   ptr   [edi+ecx*8+24],   mm3   
			movntq   qword   ptr   [edi+ecx*8+32],   mm4   
			movntq   qword   ptr   [edi+ecx*8+40],   mm5   
			movntq   qword   ptr   [edi+ecx*8+48],   mm6   
			movntq   qword   ptr   [edi+ecx*8+56],   mm7   
			add   ecx,   8   
			jnz   copyloop   
			sfence   
			emms   
		}   
	}   
	else   
	{   
		_asm   
		{   
			sfence   
			emms   
		}   
	}   
} 
*/
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
CSurface::CSurface()
{
    m_pdds = NULL;
    m_bColorKeyed = FALSE;
	ZeroMemory(&m_ddsd, sizeof(DDSURFACEDESC2));
}

//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
CSurface::~CSurface()
{
	if(m_pdds) {
		Destroy();
	}
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
HRESULT CSurface::Create( LPDIRECTDRAWSURFACE7 pdds )
{
    m_pdds = pdds;

    if( m_pdds )
    {
        m_pdds->AddRef();

        // Get the DDSURFACEDESC structure for this surface
        m_ddsd.dwSize = sizeof(m_ddsd);
        //m_pdds->GetSurfaceDesc( &m_ddsd );

		HRESULT hr = m_pdds->Lock(NULL, &m_ddsd, DDLOCK_WAIT, NULL);
		if(hr!=NOERROR)
			return hr;
		m_pdds->Unlock(NULL);
    }

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
HRESULT CSurface::Create( LPDIRECTDRAW7 pDD, DDSURFACEDESC2* pddsd )
{
    HRESULT hr=E_FAIL;

	if(!pDD)
		return hr;

    // Create the DDraw surface
    if( FAILED( hr = pDD->CreateSurface( pddsd, &m_pdds, NULL ) ) )
		return hr;

    // Prepare the DDSURFACEDESC structure
	ZeroMemory(&m_ddsd, sizeof(m_ddsd));
    m_ddsd.dwSize = sizeof(m_ddsd);

    // Get the DDSURFACEDESC structure for this surface
    //m_pdds->GetSurfaceDesc( &m_ddsd );

	m_ddsd.dwFlags = DDSD_LPSURFACE;
	m_ddsd.ddsCaps.dwCaps = 0;

	if(FAILED(hr=m_pdds->Lock(NULL, &m_ddsd, DDLOCK_WAIT, NULL)))
		return hr;
	if(m_ddsd.ddpfPixelFormat.dwFourCC == MAKEFOURCC('Y','U','Y','2')) {
		memset(m_ddsd.lpSurface, 0x80, m_ddsd.dwHeight*m_ddsd.lPitch);
	}
	else if(m_ddsd.ddpfPixelFormat.dwFourCC == MAKEFOURCC('U','Y','V','Y')) {
		memset(m_ddsd.lpSurface, 0x08, m_ddsd.dwHeight*m_ddsd.lPitch);
	}
	else {
		memset(m_ddsd.lpSurface, 0x00, m_ddsd.dwHeight*m_ddsd.lPitch);
	}
	m_pdds->Unlock(NULL);

	m_ddsd.ddsCaps.dwCaps = (DDSCAPS_VIDEOMEMORY/*|DDSCAPS_LOCALVIDMEM*/|DDSCAPS_OFFSCREENPLAIN);
	m_ddsd.dwFlags = DDSD_PITCH|DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT|DDSD_PIXELFORMAT;
		
    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
HRESULT CSurface::Create( LPDIRECTDRAW7 pDD, DWORD dwWidth, DWORD dwHeight, 
						  int pixel_format, PVOID lpSurface)
{
	DDSURFACEDESC2 ddsd;
	DWORD flags = lpSurface ? DDSD_LPSURFACE : 0;
	DWORD caps  = lpSurface ? DDSCAPS_SYSTEMMEMORY : 0;

	ZeroMemory(&ddsd, sizeof(ddsd));
	if(pixel_format >= 0) { 
		flags |= DDSD_PIXELFORMAT | (lpSurface ? DDSD_PITCH : 0);
		if(!g_pixelformatindex[pixel_format]) {
			return E_INVALIDARG;
		}
		memcpy(&ddsd.ddpfPixelFormat, g_pixelformatindex[pixel_format], sizeof(DDPIXELFORMAT));
	}

    ddsd.dwSize   = sizeof(ddsd);
	ddsd.dwFlags  = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | flags;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | caps;
	ddsd.dwWidth  = dwWidth;
	ddsd.dwHeight = dwHeight;

	if(flags & DDSD_LPSURFACE) {
		ddsd.lpSurface = lpSurface;
	}
	if(flags & DDSD_PITCH) {
		ddsd.lPitch = dwWidth*ddsd.ddpfPixelFormat.dwYUVBitCount/8;
	}

	return Create(pDD, &ddsd);
}

//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
HRESULT CSurface::Destroy()
{
	m_ddsd.dwWidth = 0;
	m_ddsd.dwHeight= 0;
    SAFE_RELEASE( m_pdds );
	
    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: CSurface::DrawBitmap()
// Desc: Draws a bitmap over an entire DirectDrawSurface, stretching the 
//       bitmap if nessasary
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawBitmap( HBITMAP hBMP, 
                              DWORD dwBMPOriginX, DWORD dwBMPOriginY, 
                              DWORD dwBMPWidth, DWORD dwBMPHeight )
{
    HDC            hDCImage;
    HDC            hDC;
    BITMAP         bmp;
    DDSURFACEDESC2 ddsd;
    HRESULT        hr;

    if( hBMP == NULL || m_pdds == NULL )
        return E_INVALIDARG;

    // Make sure this surface is restored.
    if( FAILED( hr = m_pdds->Restore() ) )
        return hr;

    // Get the surface.description
    ddsd.dwSize  = sizeof(ddsd);
    m_pdds->GetSurfaceDesc( &ddsd );

    if( ddsd.ddpfPixelFormat.dwFlags == DDPF_FOURCC )
        return E_NOTIMPL;

    // Select bitmap into a memoryDC so we can use it.
    hDCImage = CreateCompatibleDC( NULL );
    if( NULL == hDCImage )
        return E_FAIL;

    SelectObject( hDCImage, hBMP );

    // Get size of the bitmap
    GetObject( hBMP, sizeof(bmp), &bmp );

    // Use the passed size, unless zero
    dwBMPWidth  = ( dwBMPWidth  == 0 ) ? bmp.bmWidth  : dwBMPWidth;     
    dwBMPHeight = ( dwBMPHeight == 0 ) ? bmp.bmHeight : dwBMPHeight;

    // Stretch the bitmap to cover this surface
    if( FAILED( hr = m_pdds->GetDC( &hDC ) ) )
        return hr;

    StretchBlt( hDC, 0, 0, 
                ddsd.dwWidth, ddsd.dwHeight, 
                hDCImage, dwBMPOriginX, dwBMPOriginY,
                dwBMPWidth, dwBMPHeight, SRCCOPY );

    if( FAILED( hr = m_pdds->ReleaseDC( hDC ) ) )
        return hr;

    DeleteDC( hDCImage );

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: CSurface::DrawText()
// Desc: Draws a text string on a DirectDraw surface using hFont or the default
//       GDI font if hFont is NULL.  
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawText( HFONT hFont, TCHAR* strText, 
                            DWORD dwOriginX, DWORD dwOriginY,
                            COLORREF crBackground, COLORREF crForeground )
{
    HDC     hDC = NULL;
    HRESULT hr;

    if( m_pdds == NULL || strText == NULL )
        return E_INVALIDARG;

    // Make sure this surface is restored.
    if( FAILED( hr = m_pdds->Restore() ) )
        return hr;

    if( FAILED( hr = m_pdds->GetDC( &hDC ) ) )
        return hr;

    // Set the background and foreground color
    SetBkColor( hDC, crBackground );
    SetTextColor( hDC, crForeground );

    if( hFont )
        SelectObject( hDC, hFont );

    // Use GDI to draw the text on the surface
    TextOut( hDC, dwOriginX, dwOriginY, strText, lstrlen(strText) );

    if( FAILED( hr = m_pdds->ReleaseDC( hDC ) ) )
        return hr;

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: CSurface::ReDrawBitmapOnSurface()
// Desc: Load a bitmap from a file or resource into a DirectDraw surface.
//       normaly used to re-load a surface after a restore.
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawBitmap( TCHAR* strBMP, 
                              DWORD dwDesiredWidth, DWORD dwDesiredHeight  )
{
    HBITMAP hBMP;
    HRESULT hr;

    if( m_pdds == NULL || strBMP == NULL )
        return E_INVALIDARG;

    //  Try to load the bitmap as a resource, if that fails, try it as a file
    hBMP = (HBITMAP) LoadImage( GetModuleHandle(NULL), strBMP, 
                                IMAGE_BITMAP, dwDesiredWidth, dwDesiredHeight, 
                                LR_CREATEDIBSECTION );
    if( hBMP == NULL )
    {
        hBMP = (HBITMAP) LoadImage( NULL, strBMP, IMAGE_BITMAP, 
                                    dwDesiredWidth, dwDesiredHeight, 
                                    LR_LOADFROMFILE | LR_CREATEDIBSECTION );
        if( hBMP == NULL )
            return E_FAIL;
    }

    // Draw the bitmap on this surface
    if( FAILED( hr = DrawBitmap( hBMP, 0, 0, 0, 0 ) ) )
    {
        DeleteObject( hBMP );
        return hr;
    }

    DeleteObject( hBMP );

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------
HRESULT CSurface::SetColorKey( DWORD dwColorKey )
{
    if( NULL == m_pdds )
        return E_POINTER;

    m_bColorKeyed = TRUE;

    DDCOLORKEY ddck;
    ddck.dwColorSpaceLowValue  = ConvertGDIColor( dwColorKey );
    ddck.dwColorSpaceHighValue = ConvertGDIColor( dwColorKey );
    
    return m_pdds->SetColorKey( DDCKEY_SRCBLT, &ddck );
}


//-----------------------------------------------------------------------------
// Name: CSurface::ConvertGDIColor()
// Desc: Converts a GDI color (0x00bbggrr) into the equivalent color on a 
//       DirectDrawSurface using its pixel format.  
//-----------------------------------------------------------------------------
DWORD CSurface::ConvertGDIColor( COLORREF dwGDIColor )
{
    if( m_pdds == NULL )
	    return 0x00000000;

    COLORREF       rgbT;
    HDC            hdc;
    DWORD          dw = CLR_INVALID;
    DDSURFACEDESC2 ddsd;
    HRESULT        hr;

    //  Use GDI SetPixel to color match for us
    if( dwGDIColor != CLR_INVALID && m_pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, dwGDIColor);       // Set our value
        m_pdds->ReleaseDC(hdc);
    }

    // Now lock the surface so we can read back the converted color
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
	ddsd = m_ddsd;
    hr = m_pdds->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
    if( hr == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface; 
        if( ddsd.ddpfPixelFormat.dwRGBBitCount < 32 ) // Mask it to bpp
            dw &= ( 1 << ddsd.ddpfPixelFormat.dwRGBBitCount ) - 1;  
        m_pdds->Unlock(NULL);
    }

    //  Now put the color that was there back.
    if( dwGDIColor != CLR_INVALID && m_pdds->GetDC(&hdc) == DD_OK )
    {
        SetPixel( hdc, 0, 0, rgbT );
        m_pdds->ReleaseDC(hdc);
    }
    
    return dw;    
}


//-----------------------------------------------------------------------------
// Name: CSurface::GetBitMaskInfo()
// Desc: Returns the number of bits and the shift in the bit mask
//-----------------------------------------------------------------------------
HRESULT CSurface::GetBitMaskInfo( DWORD dwBitMask, DWORD* pdwShift, DWORD* pdwBits )
{
    DWORD dwShift = 0;
    DWORD dwBits  = 0; 

    if( pdwShift == NULL || pdwBits == NULL )
        return E_INVALIDARG;

    if( dwBitMask )
    {
        while( (dwBitMask & 1) == 0 )
        {
            dwShift++;
            dwBitMask >>= 1;
        }
    }

    while( (dwBitMask & 1) != 0 )
    {
        dwBits++;
        dwBitMask >>= 1;
    }

    *pdwShift = dwShift;
    *pdwBits  = dwBits;

    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: CSurface::DrawYuy2()
// Desc: copy the yuy2 data to surface
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawYuy2(DDSURFACEDESC2* pddsd, PBYTE data, SIZE srcSize, RECT* rcDest, RECT* rcSrc, BOOL isMirror, LONG lPitch)
{
	if(!pddsd || !pddsd->lpSurface)
		return E_INVALIDARG;

	RECT rcs, rcd;
	
	if(rcDest)	rcd = *rcDest;
	else SetRect(&rcd, 0, 0, pddsd->dwWidth, pddsd->dwHeight);
	if(rcSrc)	rcs = *rcSrc;
	else SetRect(&rcs, 0, 0, srcSize.cx, srcSize.cy);
	if(rcd.left & 1) rcd.left++;

	PBYTE pDest = (PBYTE)pddsd->lpSurface;
	DWORD dwLine= srcSize.cx<<1;
	DWORD  w = min(rcs.right-rcs.left, rcd.right-rcd.left);
	DWORD  h = min(rcs.bottom-rcs.top, rcd.bottom-rcd.top);
	lPitch = (lPitch==0) ? dwLine : lPitch;

	pDest += pddsd->lPitch*rcd.top + (rcd.left<<1);
	data  += lPitch*rcs.top + (rcs.left<<1);

	try {
		if(isMirror) {
			PWORD pd=NULL, ps=NULL;
			data  += w<<1;

			for(DWORD i=0; i<h; i++)
			{
				pd = (PWORD)pDest;
				ps = (PWORD)data;
				for(DWORD j=0; j<w; j++) {
					*pd++ = *ps;
					ps--;
				}
				pDest += pddsd->lPitch;
				data  += lPitch;
				//g_Util.memcpyMMX(pDest, buff, dwLine);
			}
		}
		else {
// PBYTE p = pDest;
// h -= 2;
// w *= 2;
// if ( h )
// {
// 	for(DWORD i=0; i<h-2; i++)
// 	{
// 		memcpy(pDest, data, 4 * (w >> 2));
// 		p = pDest + 4 * (w >> 2);
// 		memcpy(p, data + 4 * (w >> 2), w & 3);
// 		pDest += pddsd->lPitch;
// 		data  += w;
// 	}
// }
// memcpy(pDest, data, 4 * (w >> 2));
// memcpy((pDest + 4 * (w >> 2)), data + 4 * (w >> 2), w & 3);
// memcpy(pDest+pddsd->lPitch, data, w);
			w <<= 1;
			for(DWORD i=0; i<h; i++) {
				//memcpyMMX(pDest, data, w);
				memcpy(pDest, data, w);
				//memcpy_sse(pDest, data, w>>3);

				pDest += pddsd->lPitch;
				data  += lPitch;
				//g_Util.memcpyMMX(pDest, buff, dwLine);
			}
		}
	}
	catch(...){
		throw;
	}

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: CSurface::DrawYv12()
// Desc: copy the yuv12 - YUV420Planner data to surface
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawYv12(DDSURFACEDESC2* pddsd, PBYTE data, SIZE srcSize, RECT* rcDest, RECT* rcSrc, BOOL isMirror, LONG lPitch)
{
	if(!pddsd || !pddsd->lpSurface)
		return E_INVALIDARG;

	RECT rcs, rcd;
	
	if(rcDest)	rcd = *rcDest;
	else SetRect(&rcd, 0, 0, pddsd->dwWidth, pddsd->dwHeight);
	if(rcSrc)	rcs = *rcSrc;
	else SetRect(&rcs, 0, 0, srcSize.cx, srcSize.cy);
	lPitch = (lPitch==0) ? srcSize.cx : lPitch;

	PBYTE lpSurf = (PBYTE)pddsd->lpSurface;
	PBYTE lpY	 = data;
	PBYTE lpV	 = lpY + lPitch  * srcSize.cy;
	PBYTE lpU	 = lpY + lPitch  * srcSize.cy * 5 / 4;
	PBYTE lpY1 = lpSurf;
	PBYTE lpU1 = lpY1 + pddsd->lPitch * pddsd->dwHeight;
	PBYTE lpV1 = lpY1 + pddsd->lPitch * pddsd->dwHeight * 5 / 4;
	DWORD w	   = min(rcs.right-rcs.left, rcd.right-rcd.left);
	DWORD h    = min(rcs.bottom-rcs.top, rcd.bottom-rcd.top);

	// copy data to overlay surface
	if(lpSurf)
	{
		DWORD i = 0;
		
		// fill Y data
		lpY	+= rcs.top*lPitch + rcs.left;
		lpY1+= rcd.top*pddsd->lPitch + rcd.left;
		for(i=0; i<h; i++)
		{
			try {
				memcpy(lpY1, lpY, w);
			}
			catch(...){
				throw;
			}
			lpY  += lPitch;
			lpY1 += pddsd->lPitch;
		}
		
		// fill V, U data
		lpV += rcs.top*lPitch/4 + rcs.left / 2;
		lpV1+= rcd.top*pddsd->lPitch/4 + rcd.left / 2;
		lpU += rcs.top*lPitch/4 + rcs.left / 2;
		lpU1+= rcd.top*pddsd->lPitch/4 + rcd.left / 2;
		for(i=0; i<h/2; i++)
		{
			try {
				memcpy(lpV1, lpV, w / 2);
			}
			catch(...){
				throw;
			}
			lpV  += lPitch / 2;
			lpV1 += pddsd->lPitch / 2;

			try {
				memcpy(lpU1, lpU, w / 2);
			}
			catch(...){
				throw;
			}
			lpU  += lPitch / 2;
			lpU1 += pddsd->lPitch / 2;
		}
	}

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: CSurface::DrawYuy2()
// Desc: copy the yuy2 data to surface
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawYuy2(LPDIRECTDRAWSURFACE7 pSurface, PBYTE data, SIZE srcSize, RECT* rcDest, RECT* rcSrc, BOOL isMirror, LONG lPitch)
{
	HRESULT hr;
    DDSURFACEDESC2 ddsd;

	if(!pSurface)
		return E_INVALIDARG;

    ddsd.dwSize = sizeof(ddsd);
	hr = pSurface->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL );
    if( hr == DD_OK)
    {
		RECT rcs, rcd;
		
		if(rcDest)	rcd = *rcDest;
		else SetRect(&rcd, 0, 0, ddsd.dwWidth, ddsd.dwHeight);
		if(rcSrc)	rcs = *rcSrc;
		else SetRect(&rcs, 0, 0, srcSize.cx, srcSize.cy);
		if(rcd.left & 1) rcd.left++;

		PBYTE pDest = (PBYTE)ddsd.lpSurface;
		DWORD dwLine= srcSize.cx<<1;
		DWORD  w = min(rcs.right-rcs.left, rcd.right-rcd.left);
		DWORD  h = min(rcs.bottom-rcs.top, rcd.bottom-rcd.top);
		lPitch = (lPitch==0) ? dwLine : lPitch;

		pDest += ddsd.lPitch*rcd.top + (rcd.left<<1);
		data  += lPitch*rcs.top + (rcs.left<<1);
		w <<= 1;
		try {
			for(DWORD i=0; i<h; i++)
			{
				//memcpyMMX(pDest, data, w);
				memcpy(pDest, data, w);
				//memcpy_sse(pDest, data, w>>3);

				pDest += ddsd.lPitch;
				data  += lPitch;
				//g_Util.memcpyMMX(pDest, buff, dwLine);
			}
		}
		catch(...){
			pSurface->Unlock(NULL);
			throw;
		}
        
		pSurface->Unlock(NULL);
    }

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: CSurface::DrawYv12()
// Desc: copy the yuv12 - YUV420Planner data to surface
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawYv12(LPDIRECTDRAWSURFACE7 pSurface, PBYTE data, SIZE srcSize, RECT* rcDest, RECT* rcSrc, BOOL isMirror, LONG lPitch)
{
	HRESULT hr;
    DDSURFACEDESC2 ddsd;

	if(!pSurface)
		return E_INVALIDARG;

    ddsd.dwSize = sizeof(ddsd);
	hr = pSurface->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL );
    if( hr == DD_OK)
    {
		RECT rcs, rcd;
		
		if(rcDest)	rcd = *rcDest;
		else SetRect(&rcd, 0, 0, ddsd.dwWidth, ddsd.dwHeight);
		if(rcSrc)	rcs = *rcSrc;
		else SetRect(&rcs, 0, 0, srcSize.cx, srcSize.cy);
		lPitch = (lPitch==0) ? srcSize.cx : lPitch;

		LPBYTE lpSurf = (LPBYTE)ddsd.lpSurface;
		LPBYTE lpY	= data;
		LPBYTE lpV	= lpY + lPitch  * srcSize.cy;
		LPBYTE lpU	= lpY + lPitch  * srcSize.cy * 5 / 4;
		LPBYTE lpY1 = lpSurf;
		LPBYTE lpU1 = lpY1 + ddsd.lPitch * ddsd.dwHeight;
		LPBYTE lpV1 = lpY1 + ddsd.lPitch  * ddsd.dwHeight * 5 / 4;
		DWORD  w = min(rcs.right-rcs.left, rcd.right-rcd.left);
		DWORD  h = min(rcs.bottom-rcs.top, rcd.bottom-rcd.top);
	
		// copy data to overlay surface
		if(lpSurf)
		{
			DWORD i = 0;
			
			// fill Y data
			lpY	+= rcs.top*lPitch + rcs.left;
			lpY1+= rcd.top*ddsd.lPitch + rcd.left;
			for(i=0; i<h; i++)
			{
				try {
					memcpy(lpY1, lpY, w);
				}
				catch(...){
					throw;
				}
				lpY  += lPitch;
				lpY1 += ddsd.lPitch;
			}
			
			// fill V, U data
			lpV += rcs.top*lPitch/4 + rcs.left/2;
			lpV1+= rcd.top*ddsd.lPitch/4 + rcd.left/2;
			lpU += rcs.top*lPitch/4 + rcs.left/2;
			lpU1+= rcd.top*ddsd.lPitch/4 + rcd.left/2;
			for(i=0; i<h/2; i++)
			{
				try {
					memcpy(lpV1, lpV, w / 2);
				}
				catch(...){
					throw;
				}
				lpV  += lPitch / 2;
				lpV1 += ddsd.lPitch / 2;

				try {
					memcpy(lpU1, lpU, w / 2);
				}
				catch(...){
					throw;
				}
				lpU  += lPitch / 2;
				lpU1 += ddsd.lPitch / 2;
			}
		}
        
		pSurface->Unlock(NULL);
    }

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: CSurface::DrawRgb()
// Desc: copy the DrawRgb data to surface
//-----------------------------------------------------------------------------
HRESULT CSurface::DrawRgb(DDSURFACEDESC2* pddsd, PBYTE data, SIZE srcSize, RECT* rcDest, RECT* rcSrc, BOOL isMirror, LONG lPitch)
{
	if(!pddsd || !pddsd->lpSurface)
		return E_INVALIDARG;
	
	RECT rcs, rcd;
	
	if(rcDest)	rcd = *rcDest;
	else SetRect(&rcd, 0, 0, pddsd->dwWidth, pddsd->dwHeight);
	if(rcSrc)	rcs = *rcSrc;
	else SetRect(&rcs, 0, 0, srcSize.cx, srcSize.cy);
	
	PBYTE pDest = (PBYTE)pddsd->lpSurface;
	DWORD dwLine= srcSize.cx*pddsd->ddpfPixelFormat.dwBumpBitCount/8;
	DWORD  w = min(rcs.right-rcs.left, rcd.right-rcd.left);
	DWORD  h = min(rcs.bottom-rcs.top, rcd.bottom-rcd.top);
	lPitch = (lPitch==0) ? dwLine : lPitch;
	
	pDest += pddsd->lPitch*rcd.top + (rcd.left*pddsd->ddpfPixelFormat.dwBumpBitCount/8);
	data  += lPitch*rcs.top + (rcs.left*pddsd->ddpfPixelFormat.dwBumpBitCount/8);
	
	try {
		if(isMirror) {
			PWORD pd=NULL, ps=NULL;
			data  += w*pddsd->ddpfPixelFormat.dwBumpBitCount/8;
			
			for(DWORD i=0; i<h; i++)
			{
				pd = (PWORD)pDest;
				ps = (PWORD)data;
				for(DWORD j=0; j<w; j++) {
					*pd++ = *ps;
					ps--;
				}
				pDest += pddsd->lPitch;
				data  += lPitch;
				//g_Util.memcpyMMX(pDest, buff, dwLine);
			}
		}
		else {
			w *= pddsd->ddpfPixelFormat.dwBumpBitCount/8;
			for(DWORD i=0; i<h; i++) {
				//memcpyMMX(pDest, data, w);
				memcpy(pDest, data, w);
				
				pDest += pddsd->lPitch;
				data  += lPitch;
				//g_Util.memcpyMMX(pDest, buff, dwLine);
			}
		}
	}
	catch(...){
		throw;
	}
	
	return S_OK;
}

BOOL CSurface::CopyData(PBYTE buff)
{
	HRESULT hr;
    DDSURFACEDESC2 ddsd;

	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
	ddsd = m_ddsd;
    hr = m_pdds->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL );
    if( hr == DD_OK)
    {
		PBYTE pSrc = (PBYTE)ddsd.lpSurface;
		DWORD dwLine= ddsd.dwWidth*(ddsd.ddpfPixelFormat.dwYUVBitCount/8);

		try {
			for(DWORD i=0; i<ddsd.dwHeight; i++) {
				memcpy(buff + (ddsd.dwHeight-i-1)*dwLine, pSrc + i*ddsd.lPitch, dwLine);
			}
		}
		catch(...){
			m_pdds->Unlock(NULL);
			throw;
		}
        
		m_pdds->Unlock(NULL);
    }
	else
		return FALSE;

	return TRUE;
}

PVOID CSurface::GetBuffer(DWORD *pitch)
{
	if(!m_pdds)
		return NULL;

	HRESULT hr;
    DDSURFACEDESC2 ddsd;

	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
	ddsd = m_ddsd;
    hr = m_pdds->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL );
    if( hr == DD_OK)
    {
		m_pdds->Unlock(NULL);
		if(pitch)
			*pitch = ddsd.lPitch;
		return ddsd.lpSurface;
    }

	return NULL;
}

HRESULT CSurface::Draw(PBYTE data, BOOL isMirror, LONG lPitch)
{
	HRESULT hr = E_FAIL;

	if(m_pdds == NULL) { return E_FAIL; }
	if(m_pdds->IsLost() == DDERR_SURFACELOST) {
		m_pdds->Restore();
	}
    hr = m_pdds->Lock( NULL, &m_ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );
	if(FAILED(hr)) { return hr; }

	SIZE	srcSize = {m_ddsd.dwWidth, m_ddsd.dwHeight};
	try {
		switch(m_ddsd.ddpfPixelFormat.dwFourCC)
		{
		case MAKEFOURCC('Y','U','Y','2'):
		case MAKEFOURCC('U','Y','V','Y'):
			hr = DrawYuy2(&m_ddsd, data, srcSize, NULL, NULL, isMirror, lPitch);
			break;
		case MAKEFOURCC('Y','V','1','2'):
			hr = DrawYv12(&m_ddsd, data, srcSize, NULL, NULL, isMirror, lPitch);
			break;
		case 0:
			hr = DrawRgb(&m_ddsd, data, srcSize, NULL, NULL, isMirror, lPitch);
			break;
		default:
			break;
		}
	}
	catch(...) {
		m_pdds->Unlock(NULL);
		throw;
	}

	m_pdds->Unlock(NULL);
	return hr;
}

void CSurface::Restore()
{
	if(m_pdds)
	{
		m_pdds->Restore();
		m_pdds->Lock( NULL, &m_ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL );
		m_pdds->Unlock(NULL);
	}
}

HRESULT CSurface::SetSurface(PVOID lpSurface, int width, int height)
{
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize   = sizeof(ddsd);
	ddsd.dwFlags  = DDSD_HEIGHT | DDSD_WIDTH | DDSD_LPSURFACE | DDSD_PITCH;
	ddsd.dwWidth  = width;
	ddsd.dwHeight = height;
	ddsd.lPitch	  = width * 2;
	ddsd.lpSurface= lpSurface;
	
	HRESULT hr = m_pdds->SetSurfaceDesc(&ddsd, 0);
	if(SUCCEEDED(hr))
		m_pdds->GetSurfaceDesc(&m_ddsd);

	return hr;
}

HRESULT CSurface::Draw(LPDIRECTDRAWSURFACE7 pdds, BOOL isMirror)
{
	HRESULT hr = E_FAIL;
	if( pdds )
	{
		RECT rcSrc;

		SetRect(&rcSrc, 0, 0, m_ddsd.dwWidth, m_ddsd.dwHeight);
		hr = m_pdds->Blt( NULL, pdds, &rcSrc, /*DDBLT_ASYNC |*/ DDBLT_WAIT, NULL);
	}

	return hr;
}

HRESULT CSurface::Draw(LPDIRECTDRAWSURFACE7 pdds, RECT* rcSrc, RECT* rcDst, BOOL bSrcClkKey)
{
	HRESULT hr = E_FAIL;
	if( pdds )
	{
		hr = m_pdds->Blt( rcDst, pdds, rcSrc, /*DDBLT_ASYNC |*/ DDBLT_WAIT|(bSrcClkKey?DDBLT_KEYSRC:0), NULL);
	}
	
	return hr;
}
