//////////////////////////////////////////////////////////////////////
// WavePacket.cpp: implementation of the CWavePacket class.
// Ƶ֡
//////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <MMSYSTEM.H>
#include "WavePacket.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWavePacket::CWavePacket() :
m_pBuff(NULL),
m_isAlloc(FALSE),
m_bufLen(0),
m_isBusy(FALSE)
{
	ZeroMemory(&m_hdr, sizeof(WAVEHDR));
}

CWavePacket::~CWavePacket()
{
	Invalidate();
}

//---------------------------------------------------------------
// Append Buffer
//---------------------------------------------------------------
BOOL CWavePacket::Initialize(PBYTE pBuff, ULONG len)
{
	if((m_pBuff != NULL) || (pBuff == NULL)) { 
		return FALSE; 
	}
	
	m_hdr.lpData = (LPSTR)pBuff;
	m_pBuff = pBuff;
	m_isAlloc = FALSE;
	
	memset(m_pBuff, 0, len);
	m_bufLen = len;
	
	return TRUE;
}

//---------------------------------------------------------------
// ڴ
//---------------------------------------------------------------
BOOL CWavePacket::Initialize(ULONG len)
{
	if(m_pBuff != NULL) { 
		return FALSE; 
	}

	m_pBuff = (PBYTE)VirtualAlloc(NULL, len, MEM_RESERVE|MEM_COMMIT, PAGE_READWRITE);
	if(m_pBuff == NULL) {
		return FALSE;
	}

	memset(m_pBuff, 0, len);
	m_bufLen = len;
	m_hdr.lpData = (LPSTR)m_pBuff;
	m_isAlloc = TRUE;
	SetBusy(FALSE);

	return TRUE;
}

//---------------------------------------------------------------
// ͷڴ
//---------------------------------------------------------------
void CWavePacket::Invalidate()
{
	if(m_isAlloc) {
		if(!VirtualFree(m_pBuff, 0, MEM_RELEASE)) {
		}
	}
	m_bufLen= 0;
	m_pBuff = NULL;
	m_isBusy= FALSE;
	m_isAlloc = FALSE;
	ZeroMemory(&m_hdr, sizeof(WAVEHDR));
}
