/*
 * colorspace conversion functions
 *    -- yuv to rgb colorspace conversions
 *
 * (c) 2001-03 Gerd Knorr <kraxel@bytesex.org>
 *
 */

struct ng_video_fmt {
    unsigned int   width;
    unsigned int   height;
    unsigned int   bytesperline;  /* zero for compressed formats */
};

struct ng_video_buf {
    struct ng_video_fmt  fmt;
    size_t               size;
    unsigned char        *data;
};

/* ------------------------------------------------------------------- */
/* packed pixel yuv to gray / rgb                                      */

void
yuv422_to_gray(uint8_t* dest, uint8_t* s, int p);

void
yuv422_to_rgb24(uint8_t* dest, uint8_t* s, int p);

/* ------------------------------------------------------------------- */
/* planar yuv to gray / rgb                                            */

void
yuv42xp_to_gray(void *h, struct ng_video_buf *out, struct ng_video_buf *in);

void
yuv420p_to_rgb24(void *h, struct ng_video_buf *out, struct ng_video_buf *in);

void
yuv422p_to_rgb24(void *h, struct ng_video_buf *out, struct ng_video_buf *in);


/* ------------------------------------------------------------------- */
/* planar -> packed pixel                                              */

#if 0 /* untested */
void
yuv422p_to_yuv422(void *h, struct ng_video_buf *out, struct ng_video_buf *in);
#endif

void yuv2rgb_init(void);
