//////////////////////////////////////////////////////////////////////
// Channel.h: interface for the CChannel class.
// ͨ
//////////////////////////////////////////////////////////////////////

#if !defined(__CHANNEL_H_)
#define __CHANNEL_H_

#include "Plugin.h"

class CSample;
class CChannel 
{
public:
	CChannel();
	virtual ~CChannel();

	VOID		Init(LONG idx) { m_index=idx; }
	VOID		Uninit();
	BOOL		AppendPlugin(CPlugin* plg);
	BOOL		AppendPlugin(ULONG plgId);		
	BOOL		EnablePlugin(ULONG plgId, BOOL enable);
	ULONG		IsEnabled(ULONG plgId){CScopedLock autoLock(&m_lock); 
							return m_plgEnabled&plgId;}
	BOOL		RemovePlugin(ULONG plgId);
	CPlugin*	Plugin(ULONG plgId) { return m_plgList[pluginIdx(plgId)]; }
	LONG		ChannelId(){return m_index;}
	PVOID		ChannelData() { return m_pData; }
	LONG		ChannelDataLen() { return m_nDataLen; }
	VOID		SetChannelData(PVOID pData, LONG nDataLen) {
					m_pData = pData;
					m_nDataLen = nDataLen;
				}
	PVOID		PluginInfo(ULONG plgId) {
					CPlugin* plg = Plugin(plgId);
					if(plg==NULL) { return NULL; }
					return plg->GetPluginInfo();
				}

protected:
	int			pluginIdx(ULONG plgId) {
					int i=1;
					while((plgId>>i) >= 1) i++;
					return (i-1);
				}
	
	LONG		m_index;
	ULONG		m_plgEnabled;
	ULONG		m_plgAdded;
	CPlugin**	m_plgList;
	PVOID		m_pData;
	LONG		m_nDataLen;
	CLockCS		m_lock;
};

#endif // !defined(__CHANNEL_H_)