/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Chipset.h
 *  @brief		оƬCChipset
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__CHIPSET_H_)
#define __CHIPSET_H_

#include "MemRange.h"
#include "DevBase.h"

class CChipset  
{
public:
	CChipset();
	virtual ~CChipset();
	friend class CTSource;

	virtual BOOL Open(HANDLE hDevice, TBoardDesc* cardInfo, TDeviceDesc devInfo);
	virtual void Close();
	virtual PShareData OpenDevice(ULONG deviceId, PULONG lenShare, HANDLE hEvent);
	virtual void CloseDevice(ULONG deviceId);
	TDeviceDesc& DeviceInfo(){return m_devInfo;}
	TBoardDesc*	 CardInfo(){return m_cardInfo;}
	CMemRange*	 PciMemory(int bar){if(bar<MAX_PCIMEM_NUM && bar>=0) return &m_Mem[bar]; return NULL;}

	virtual BOOL CreateDevices() { return FALSE; }
	virtual LONG Devices(int devType){ return 1; }
	virtual HANDLE GetI2C()   {return NULL;}
	virtual HANDLE GetGPIO()  {return NULL;}
	virtual HANDLE CreateI2CuGpio(int sclGpio, int sdaGpio, int nSpeed) { return NULL; }

	BOOL ReadPciConfigSpace(int nOffset, int nLen, PBYTE pData);
	BOOL WritePciConfigSpace(int nOffset, int nLen, PBYTE pData);
	BOOL ReadPciConfigSpaceEx(int nOffset, int nLen, PBYTE pData);
	BOOL WritePciConfigSpaceEx(int nOffset, int nLen, PBYTE pData);
	BOOL FindBridge(PBridgeDesc brg);
	BOOL AllocMemory(ULONG len, PMemBlock memBlock);
	BOOL FreeMemory(PMemBlock memBlock);
	BOOL MapMemory(PMemBlock memBlock);
	BOOL UnmapMemory(PMemBlock memBlock);
	BOOL AppendCrash(TCmdCrashInfo crash);
	BOOL AppendIrq(TCmdIrqInfo irq);
	BOOL ModifyIrq(TCmdIrqInfo irq);
	BOOL RemoveIrq(TCmdIrqInfo irq);
	BOOL ModifyEvt(TCmdNotifyEventInfo evti);
	BOOL AppendTimer(TCmdTimerInfo tmi);
	BOOL RemoveTimer(TCmdTimerInfo tmi);
	BOOL ModifyTimer(TCmdTimerInfo tmi);
	BOOL CancelTimer(TCmdTimerInfo tmi);
	BOOL AppendI2C(TCmdI2CInfo &i2ci);
	BOOL RemoveI2C(TCmdI2CInfo i2ci);
	BOOL UnmapPciMemory(HANDLE hProcess, ULONG pciBase);
	TMemNode MapPciMemory(HANDLE hProcess, ULONG pciBase, ULONG len);

protected:
	virtual BOOL OnInit() { return TRUE; }
	virtual BOOL OnUninit() { return TRUE; }
	virtual BOOL OnOpen() { return TRUE; }
	virtual BOOL OnOpen(TBoardDesc* cardInfo, TDeviceDesc* devInfo);
	virtual BOOL OnOpen(PDeviceCapability devCaps, int iDev, int iType) { return TRUE; }
	virtual BOOL OnClose(){ return TRUE; }

	HANDLE			m_hDevice;		//豸
	TDeviceDesc		m_devInfo;		//豸Ϣ
	TBoardDesc*		m_cardInfo;		//Ϣ
	CMemRange		m_Mem[MAX_PCIMEM_NUM];	//豸PCIӳڴ
	vector<CDevBase*>			m_devList;
	vector<PDeviceCapability>	m_capsListV;
	vector<PDeviceCapability>	m_capsListA;
};

#endif // !defined(__CHIPSET_H_)
