/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev600x.cpp
 *  @brief		Ƶ豸CDev600X֧TW6801TW6804 : ɼԤ¼ݲͬԤʵʱ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev600X.h"
#include "Dev6803.h"
#include "PlgvSource.h"
#include "TW680X.H"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev600X::CDev600X()
{
}

CDev600X::~CDev600X()
{
}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev600X::OnAllocResource()
{
	CSample* pSample = NULL;
	int	i = 0;

	if(!CDev6801::OnAllocResource()) {
		return FALSE;
	}

	//Ԥbuffer
	for(i=0; i<RAWV_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev600X::OnAllocResource()-Ƶpreview CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(RAWV_LEN, pSample->Buffer())) {
			m_bufPreview.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev600X::OnAllocResource()-ӳƵpreview Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktField2);
	}

	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev600X::OnFreeResource()
{
	CSample* pSample = NULL;

	CDev6801::OnFreeResource();

	while(m_bufPreview.size() > 0) {
		pSample = m_bufPreview.back();
		m_pParent->FreeMemory(pSample->Buffer());
		_trace(TEXT("[Ϣ]CDev600X::OnFreeResource()ͷpreview bufferɹ(slot %d,function 0,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		delete pSample;
		m_bufPreview.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev600X::OnOpen()
{
	TCmdIrqInfo		irq;
	TCmdCrashInfo	crash;

	ZeroMemory(m_Share, sizeof(TShareData));

	Init6801();

	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			SetMux((TVideoInput)viInput);
			break;
		}
	}

	SetStandard(TvSourceInfo::default_standard);
	SetFormat(vpfYUV422Interspersed);

	if(m_eScaler == NULL) {
		m_eScaler = new CScaler6801(m_pMem, VF_Even);
	}
	if(m_oScaler == NULL) {
		m_oScaler = new CScaler6801(m_pMem, VF_Odd);
	}
	if((m_oScaler==NULL) || (m_oScaler==NULL)) {
		return FALSE;
	}
	
	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[0] = R_VSTATUS1;
	irq.irqInfo.regRead[2] = R_VDMAP_PP;
	m_pParent->AppendIrq(irq);

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regWrite[0]= R_INTMASK;//(ULONG)-1;
	irq.irqInfo.regWrite[1]= R_VDMAC;//(ULONG)-1;
	irq.irqInfo.mskWrite[0]= R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.mskWrite[1]= R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN;
	m_pParent->AppendIrq(irq);
	
	//crash, Զɾ
	crash.regBase = irq.irqInfo.regBase;
	crash.regCrash= R_VDMAC;
	crash.lowMask = R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN;
	crash.higMask = 0;
	m_pParent->AppendCrash(crash);
	crash.regBase = irq.irqInfo.regBase;
	crash.regCrash= R_INTMASK;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	m_pParent->AppendCrash(crash);
	crash.regBase = irq.irqInfo.regBase;
	crash.regCrash= R_INTSTAT;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	m_pParent->AppendCrash(crash);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev600X::HasSignal()
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	
	BYTE	 vstatus = m_pMem->inb(R_VSTATUS1);
	CPlgvSource* vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	TvSourceInfo vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	BOOL	 bRet = vinfo.signal;
	
	bSignal = !(vstatus & R_VSTATUS1_VDLOSS) && !(vstatus & R_VSTATUS1_NOVIDEO) && (vstatus & R_VSTATUS1_VLOCK);
	if(vinfo.standard == vsStandardPAL) {
		bSignal = bSignal && (vstatus & R_VSTATUS1_HLOCK);
	}

	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 2 : 1)) {
//			_trace("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n", m_chlList[chId]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			bRet = bSignal;
		}
	}
	else {
		vinfo.signal_count = 0;
	}
	
	vsource->SetPluginInfo(&vinfo, setSignal);
	
	return bRet;
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev600X::PrepareRun()
{
	TvDmaProgInfo eDpi, oDpi;
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource = NULL;
	TRect		  rc(0, 0, 0, 0);
	CSample*	  pSample = NULL;	
	ULONG		  flagReset = 0;
	UINT		  i;

	if(m_chlList.size()==0) { return FALSE; }

	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	if(!vinfo.signal) { 
		RunDmap(0);
		return FALSE; 
	}

	//豸Ҫ
	if(vinfo.reset & DEVSET_property) {
		SetBright(vinfo.brightness);
		SetContrast(vinfo.contrast);
		SetSaturation(vinfo.saturation);
		SetHue(vinfo.hue);
		SetSharpness(vinfo.sharpness);
	}
	if(vinfo.reset & DEVSET_hdelay) {
		if(vinfo.hdelay<0)  {
			vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
		}
		vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
		m_eScaler->SetHDelay(abs(vinfo.hdelay));
		m_oScaler->SetHDelay(abs(vinfo.hdelay));
	}
	if(vinfo.reset & DEVSET_vdelay) {
		if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
		//vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW680X_VDELAY_MAX_PAL:TW680X_VDELAY_MAX_NTSC);
		vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
		m_eScaler->SetVDelay(abs(vinfo.vdelay));
		m_oScaler->SetVDelay(abs(vinfo.vdelay));
	}

	flagReset = vinfo.reset & DEVSET_devreset;
	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}

	if(flagReset == 0) { 
		//ʱsdkиDMAPܵĻǷŵISRиĽϺ
		int  iNextDmap = ((m_iDmap+1) % m_bufRaw.size()) * 2;
		int  frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
		BOOL bSkip = FALSE;
		if(vinfo.frame_run & frame_capture) {
			bSkip = !((vinfo.capture.frame_rate_mask>>frame_rate_cnt) & 0x01);
			Skip(iNextDmap + ((vinfo.field==VF_Odd) ? 1 : 0), bSkip);
		}
		if(vinfo.frame_run & frame_preview) {
			bSkip = !((vinfo.preview.frame_rate_mask>>frame_rate_cnt) & 0x01);
			Skip(iNextDmap + ((vinfo.field==VF_Odd) ? 0 : 1), bSkip);
		}

		return TRUE; 
	}

	RunDmap(0);
	vinfo.frame_rate_cnt = m_chlList[m_iChannel]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	if(vinfo.hdelay<0)  {
		vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
	}
	if(vinfo.vdelay< 0) vinfo.vdelay= IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt|VSRC_hdelay|VSRC_vdelay);

	SetStandard(vinfo.standard);
	SetFormat(vinfo.capture.pixel_format);
	m_oScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	m_eScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	vinfo.reset = 0;
	vsource->SetPluginInfo(&vinfo, VSRC_reset);
	vinfo  = *(PvSourceInfo)vsource->GetPluginInfo();

	eDpi.width = vinfo.capture.width;
	eDpi.height= vinfo.capture.height;
	eDpi.pitch = vinfo.capture.pitch;
	eDpi.lineSize = vinfo.capture.pitch;
	eDpi.irq   = FALSE;
	eDpi.interlace = 0;
	eDpi.memBuf= NULL;
	eDpi.offset= 0;
	oDpi.width = vinfo.preview.width;
	oDpi.height= vinfo.preview.height;
	oDpi.pitch = vinfo.preview.pitch;
	oDpi.lineSize = vinfo.preview.pitch;
	oDpi.offset= 0;
	oDpi.irq   = FALSE;
	oDpi.memBuf= NULL;
	oDpi.interlace = 0;
	if(DEVICEID(m_pParent->DeviceInfo().HardwareId) == 0x6804) {
		m_pMem->outd(R_VDMAC, (max(oDpi.width, eDpi.width)>352 && (vinfo.frame_run==frame_both)) ? 0x00000040 : 0x0000A040);
	}
	else {
		m_pMem->outd(R_VDMAC, (max(oDpi.width, eDpi.width)>352 && (vinfo.frame_run==frame_both)) ? 0x00000040 : 0x00002040);
	}
	SetFormat(vinfo.preview.pixel_format);
	
	if(vinfo.field == VF_Even) {
		rc.right   = eDpi.width;
		rc.bottom  = eDpi.height;
		m_oScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
		rc.right   = oDpi.width;
		rc.bottom  = oDpi.height;
		m_eScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
	}
	else {
		rc.right   = eDpi.width;
		rc.bottom  = eDpi.height;
		m_eScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
		rc.right   = oDpi.width;
		rc.bottom  = oDpi.height;
		m_oScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
	}

	for(i=0; i<m_bufRaw.size(); i++) {
		pSample = m_bufRaw[i];
		pSample->SetChannel(m_chlList[m_iChannel]);
		eDpi.memBuf= pSample->Buffer();
		pSample = m_bufPreview[i];
		pSample->SetChannel(m_chlList[m_iChannel]);
		pSample->SetDataSize(vinfo.preview.height*vinfo.preview.pitch);
		oDpi.memBuf= pSample->Buffer();
		if(vinfo.field == VF_Even) {
			if(!Build(i*2, &eDpi)) {
				return FALSE;
			}
			if(!Build(i*2+1, &oDpi)) {
				return FALSE;
			}
		}
		else {
			if(!Build(i*2, &oDpi)) {
				return FALSE;
			}
			if(!Build(i*2+1, &eDpi)) {
				return FALSE;
			}
		}
	}

	if(vinfo.frame_run==frame_capture) {
		for(i=0; i<m_bufRaw.size(); i++) {
			if(vinfo.field == VF_Even) {
				Skip(i*2+1, TRUE);
			}
			else {
				Skip(i*2, TRUE);
			}
		}
	}
	else if(vinfo.frame_run==frame_preview) {
		for(i=0; i<m_bufRaw.size(); i++) {
			if(vinfo.field == VF_Even) {
				Skip(i*2, TRUE);
			}
			else {
				Skip(i*2+1, TRUE);
			}
		}
	}


	return (TRUE+TRUE);
}

//-----------------------------------------------------
// жϴ
//-----------------------------------------------------
long CDev600X::OnIrq()
{
	long isData = -1;
	long iCap=0, iPre=0, iTmp=0;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0;
	CSample* splPreview=NULL;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		//ź״̬
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		if(m_Share->irqData[IRQ_DMPAP].status[0] & R_INT_VDMAPI) {
			dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[2];
			m_iDmap = LastDmaBuffer(dmapAddr, iCap, iPre);
			if(vinfo.field == VF_Odd) {
				iTmp = iPre;
				iPre = iCap;
				iCap = iTmp;
			}
			if(iCap >= 0) {
				m_pSample = m_bufRaw[iCap];
				m_pSample->SetFlag(PLG_vsource);
				isData = TRUE;
			}
			if(iPre >= 0) {
				if(isData) {
					OnData();
				}
				m_pSample = m_bufPreview[iPre];
				m_pSample->SetFlag(PLG_vsource);
				isData = TRUE;
			}
			vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
			vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

			if(vinfo.frame_run == frame_capture) {
				if(m_ifoOptimize.enable && !vinfo.optimize_cif) {
					isData = isData && (PciOptimize() > 0);
					if(!isData) {
						m_pSample = NULL;
					}
				}
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	if(m_Share->irqData[IRQ_ERROR].evtId != evt_None) {
		isData = FALSE;
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_DMAPERR) {
			//dma programд,ֹͣȻ´
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev600X::OnIrqͨ%d豸(slot %d0豸%d)dmaperr\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}

		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_PABORT) {
			//dma programд,ֹͣȻ´
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev600X::OnIrqͨ%d豸(slot %d0豸%d)pci abort\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		
		//fifoݶʧ
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_FFIFO) {
			_trace(TEXT("[Ϣ]ͨ%02dݶʧ\n"), m_chlList[m_iChannel]->ChannelId());
		}

		m_Share->irqData[IRQ_ERROR].evtId   = evt_None;
		m_Share->irqData[IRQ_ERROR].status[0]  = 0;
		m_Share->irqData[IRQ_ERROR].irqCount= 0;
	}
	
	//żж
	if(m_Share->irqData[IRQ_FIELD].evtId != evt_None) {
		if(m_Share->irqData[IRQ_FIELD].status[0] & R_INT_GPINT) {
			TDeviceDesc devInfo;
			for(UINT i=0; i<g_devListV.size(); i++) {
				devInfo = g_devListV[i]->Parent()->DeviceInfo();
				if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==2)) {
					((CDev6803*)g_devListV[i])->OnGpint();
					break;
				}
			}
		}
		m_Share->irqData[IRQ_FIELD].evtId   = evt_None;
		m_Share->irqData[IRQ_FIELD].status[0]  = 0;
		m_Share->irqData[IRQ_FIELD].irqCount= 0;
	}

	return isData;
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev600X::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }

		if(vinfo.frame_run & frame_capture) {
			spl = m_bufRaw[0];
			nTemp = vinfo.capture.pitch*vinfo.capture.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktVideo);
			memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			bRet = vsource->Transmit(spl, NULL);
		}

		if(vinfo.frame_run & frame_preview) {
			spl = m_bufPreview[0];
			nTemp = vinfo.preview.pitch*vinfo.preview.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktField2);
			memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			bRet = vsource->Transmit(spl, NULL);
		}
	}
	
	return bRet;
}