/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev610x.cpp
 *  @brief		Ƶ豸CDev610Xʵ֣֧TW6804 : ɷʵʱ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev610X.h"
#include "Dev6803.h"
#include "PlgvSource.h"
#include "TW680X.H"
#include <mmsystem.h>

#define NOSIGNAL_CHECK_680X	2

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev610X::CDev610X() :
m_iNext(0), 
m_iSync(0),
m_iSignalCheck(0),
m_bDiffSize(FALSE),
m_bSignalChanged(TRUE),
m_bTimer(TRUE),
m_bRestart(FALSE),
m_tkLast(0),
m_irqDiff(0)
{
	ZeroMemory(m_iDmaps, sizeof(m_iDmaps));
	ZeroMemory(m_iIrqs, sizeof(m_iIrqs));
	ZeroMemory(m_tkDiff, sizeof(m_tkDiff));
	ZeroMemory(m_bResync, sizeof(m_bResync));
}

CDev610X::~CDev610X()
{
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev610X::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }
		
		spl = m_bufRaw[i*RAWV_NUM];
		nTemp = vinfo.capture.pitch*vinfo.capture.height;
		if(spl->BufferSize() < nTemp) { continue; }
		spl->SetTimeStamp(timestamp());
		spl->SetType(pktVideo);
		spl->SetChannel(chl);
		memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
		
		bRet = vsource->Transmit(spl, NULL);
		spl->ClearFlag(PLG_vsource);
	}
	
	return bRet;
}

//-------------------------------------------------------
//ʼTW9903
//-------------------------------------------------------
void CDev610X::Init6801()
{
	m_pMem->outb(R_ACNTL,			0x80);
	m_pMem->outd(R_VBIC,			0x00);
	m_pMem->outd(R_INTSTAT,			0xFFFFFFFF);
	m_pMem->outd(R_INTMASK,			0x00000000);
	m_pMem->outd(R_GPIOC,			0x00003000);
	m_pMem->outb(R_VCAPCTL,			0x4F);//0xC3);
	m_pMem->outb(R_REMOCONEN,		0x01);
	m_pMem->outb(R_VSTATUS1,		0x00);
	m_pMem->outb(R_INFORM,			0x40);
	m_pMem->outb(R_OPFORM,			0x04);
	m_pMem->outb(R_GAMMAHDELAY,		0x00);
	m_pMem->outb(R_POLARITY,		0x00);
	m_pMem->outb(R_ACNTL,			0x10);	//disable AGC loop function Աһͨȱ仯ʱһͨҲ仯
	m_pMem->outb(R_CNTRL1,			0xCC);
	m_pMem->outb(R_BRIGHT,			0x00);
	m_pMem->outb(R_CONTRAST,		0x4C);
	m_pMem->outb(R_SHARPNESS,		0x11);//0x54);
	m_pMem->outb(R_SATU,			0x80);
	m_pMem->outb(R_SATV,			0x80);
	m_pMem->outb(R_HUE,				0x00);
	m_pMem->outb(R_SHARP2,			0x53);//0xC6);
	m_pMem->outb(R_VSHARP,			0x84);
	m_pMem->outb(R_CORING,			0xCC);//0x44);	//ˮ
	m_pMem->outb(R_VBICNTL,			0x00);
	m_pMem->outb(R_ACNTL2,			0x0A);
	m_pMem->outb(R_STD,				0x11);
	m_pMem->outb(R_STDR,			0x03);	//=0x7Fڰ׺ͲɫźһһоƬʱͼϹʱֺɫɫʵ
	m_pMem->outb(R_CLMPG,			0x50);
	m_pMem->outb(R_IAGC,			0x82);//0x32);
	m_pMem->outb(R_AGCGAIN,			0xA0);//0x40);
	m_pMem->outb(R_PEAKWT,			0xD8);
	m_pMem->outb(R_CLMPL,			0xBC);
	m_pMem->outb(R_SYNCT,			0xB8);
	m_pMem->outb(R_MISSCNT,			0x34);	//ֵ44Ϊ14ͼȶһ֡ʽ
	m_pMem->outb(R_PCLAMP,			0x2A);//0x28);
	m_pMem->outb(R_VCNTL1,			0x0C);	//طԷʵʱӰܴDETV=1Ǳ
	m_pMem->outb(R_VCNTL2,			0x04);
	m_pMem->outb(R_CKILL,			0x78);//0x68);
	m_pMem->outb(R_COMB,			0x44);
	m_pMem->outb(R_LDLY,			0xF0);
	m_pMem->outb(R_MISC1,			0x14);	//0x54);
	m_pMem->outb(R_LOOP,			0x3D);	//0xFD);
	m_pMem->outb(R_MISC2,			0x10);	//ĴźʱǺ
	m_pMem->outb(R_CLMD,			0xC4);	//YNR -- Y HF noise reduction
	m_pMem->outb(R_IDCNTL,			0x00);
	m_pMem->outb(R_CLCNTL1,			0xA4);	//YCLEN -- Y Clamp ƵӰܴdisableĻźżʧԼͼϷ

	if(DEVICEID(m_pParent->DeviceInfo().HardwareId) == 0x6804) {
		m_pMem->outd(R_VDMAC,		0x0000A000);
	}
	else {
		m_pMem->outd(R_VDMAC,		0x00002000);
	}
}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev610X::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0, iRawV=RAWV_NUM*m_devCaps->ddesc.iSwitch;
	PMemBlock memDmap = NULL;
	
	//DMA program
	for(i=0; i<iRawV; i++) {
		memDmap = new TMemBlock;
		if(memDmap && m_pParent->AllocMemory(DMAP_LEN, memDmap)) {
			m_listDmap.push_back(memDmap);
		}
		else {
			SAFE_DELETE(memDmap);
			return FALSE;
		}
	}
	SetDmapAddr((ULONG)m_listDmap[0]->pnodes[0].addr);
	SetProgAddr((ULONG)m_listDmap[0]->vaddr, (ULONG)m_listDmap[0]->pnodes[0].addr);
	
	//skip dmap buffer
	memDmap = new TMemBlock;
	if(memDmap && m_pParent->AllocMemory(DMAP_LEN_SKIP, memDmap)) {
		m_listDmap.push_back(memDmap);
	}
	else {
		SAFE_DELETE(memDmap);
		return FALSE;
	}
	
	for(i=0; i<iRawV; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6801::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6801::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
	}
	
	return (i==iRawV);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev610X::OnFreeResource()
{
	CSample* pSample = NULL;
	
	for(UINT i=0; i<m_listDmap.size(); i++) {
		m_pParent->FreeMemory(m_listDmap[i]);
		delete m_listDmap[i];
	}
	m_listDmap.clear();
	_trace(TEXT("[Ϣ]CDev6801::OnFreeResource()ͷDMAP bufferɹ(slot %d,function 0,device %d)\n"), 
		m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
	
	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		m_pParent->FreeMemory(pSample->Buffer());
		_trace(TEXT("[Ϣ]CDev6801::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		delete pSample;
		m_bufRaw.pop_back();
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev610X::OnOpen()
{
	TCmdIrqInfo		irq;
	TCmdTimerInfo	tmi;

	ZeroMemory(m_Share, sizeof(TShareData));
	
	Init6801();

	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			SetMux((TVideoInput)viInput);
			break;
		}
	}

	SetStandard(TvSourceInfo::default_standard);
	SetFormat(vpfYUV422Interspersed);
	
	if(m_eScaler == NULL) {
		m_eScaler = new CScaler6801(m_pMem, VF_Even);
	}
	if(m_oScaler == NULL) {
		m_oScaler = new CScaler6801(m_pMem, VF_Odd);
	}
	if((m_oScaler==NULL) || (m_oScaler==NULL)) {
		return FALSE;
	}

	//jack test
// 	if(m_devInfo.DeviceNumber < 3) {
// 		m_bTimer = FALSE;
// 	}

	//TIMER¼
	INIT_TIMERINFO(tmi);
	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.dueTime	 = -10*10000;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	tmi.tmiInfo.regWrite[0] = R_VDMAC;
	tmi.tmiInfo.mskWrite[0] = R_VDMAC_VDMAP_EN;
	if(m_bTimer) {
		m_pParent->AppendTimer(tmi);
	}
	
	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[0] = R_VSTATUS1;
	irq.irqInfo.regRead[1] = R_VSTATUS2;
	irq.irqInfo.regRead[2] = R_INFORM;
	irq.irqInfo.regRead[3] = R_VDMAP_SA;
	irq.irqInfo.regWrite[0]= R_VDMAC;
	irq.irqInfo.regWrite[2]= R_INFORM;
	irq.irqInfo.regWrite[3]= R_VDMAP_SA;
	if(m_bTimer) {
		irq.irqInfo.timerId	 = IRQ_DMPAP;
	}
	else {
		irq.irqInfo.regWrite[4]= R_VDMAC;
	}
	irq.irqInfo.regWrite[5]= R_BRIGHT;
	irq.irqInfo.regWrite[6]= R_CONTRAST;
	irq.irqInfo.regWrite[7]= R_SATU;
	irq.irqInfo.regWrite[8]= R_SATV;
	irq.irqInfo.regWrite[9]= R_HUE;
	irq.irqInfo.mskWrite[0]= R_VDMAC_VDMAP_EN;
	irq.irqInfo.mskWrite[2]= R_INFORM_YSEL;
	irq.irqInfo.mskWrite[3]= 0xFFFFFFFF;
	irq.irqInfo.mskWrite[4]= R_VDMAC_VDMAP_EN;
	m_pParent->AppendIrq(irq);

	//豸жϼ¼
	INIT_IRQINFO(irq)
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[2] = R_INFORM;
	irq.irqInfo.regWrite[0]= R_INTMASK;//(ULONG)-1;
	irq.irqInfo.regWrite[1]= R_VDMAC;//(ULONG)-1;
	irq.irqInfo.mskWrite[0]= R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.mskWrite[1]= R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN;
	m_pParent->AppendIrq(irq);

	m_Share->irqData[IRQ_DMPAP].regWrite[0] = 0;
	m_Share->irqData[IRQ_DMPAP].dueTime = 0;
	if(m_bTimer) {
		m_Share->irqData[IRQ_DMPAP].regWriteTimer[0] = R_VDMAC_VDMAP_EN;
	}
	else {
		m_Share->irqData[IRQ_DMPAP].regWrite[4] = R_VDMAC_VDMAP_EN;
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev610X::OnClose()
{
	TCmdIrqInfo		irq;
	TCmdTimerInfo	tmi;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev610X::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	EnableFieldIrq(FALSE);
	SAFE_DELETE(m_oScaler);
	SAFE_DELETE(m_eScaler);

	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	if(m_bTimer) {
		m_pParent->RemoveTimer(tmi);
	}
	
	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

//-------------------------------------------
// Ӱ豸ֵ
//-------------------------------------------
inline BYTE CDev610X::Brightness(int value)
{
	int val = 0;
	g_util.map(B_MIN, B_MAX, value, B_MIN_6801, B_MAX_6801, &val);
	return (BYTE)val;
}

inline BYTE CDev610X::Contrast(int value)
{
	int val = 0;
	g_util.map(C_MIN, C_MAX, value, C_MIN_6801, C_MAX_6801, &val);
	return (BYTE)val;
}

inline BYTE CDev610X::Hue(int value)
{
	int val = 0;
	g_util.map(H_MIN, H_MAX, value, H_MIN_6801, H_MAX_6801, &val);
	return (BYTE)val;
}

inline BYTE CDev610X::Saturation(int value)
{
	int val = 0;
	g_util.map(S_MIN, S_MAX, value, S_MIN_6801, S_MAX_6801, &val);
	return (BYTE)val;
}

inline BYTE CDev610X::Sharpness(int value)
{
	int val = 0;
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6801, SH_MAX_6801, &val);
	return (BYTE)val;
}

/** 
 ***************************************************************************************
 *  Ƶʽ
 *
 *  @param[in] value -- ʽ, TVideoStandard
 ***************************************************************************************
 */
void CDev610X::SetStandard(int value)
{
	UCHAR cVal = m_pMem->inb(R_STD) & ((UCHAR)~R_STD_STD);
	
	switch(value) {
	case vsStandardNone:
		value = 0x07;
		break;
	case vsStandardNTSC:
		value = 0;
		//m_pMem->outb(R_ACNTL, 0x00);
		m_pMem->outb(R_STDR, 0x01);
		break;
	case vsStandardPAL:
		value = 1;
		m_pMem->outb(R_STDR, 0x02);
		//ĴֵҪرעһ£TW6805ҪϸԡTW6802ϣֵΪ0x10(disable GAC loop)ʱ
		//AGCGAINֵ(ĴR_IAGCR_AGCGAIN)СΪ0x40ʱźżûźţźֱ
		//ɼͼܰAGCGAINֵͼҲǿźû̫Ӱ졣
//  	m_pMem->outb(R_ACNTL, 0x10);
//  	m_pMem->outb(R_IAGC,  0x33);
//  	m_pMem->outb(R_AGCGAIN, 0xF0);
		break;
	default:
		value = 0x07;
		break;
	}
	
	cVal |= (UCHAR)value & R_STD_STD;
	m_pMem->outb(R_STD, cVal);
	if(value == 0x07) {
		m_pMem->outb(R_STDR, 0xFF);
	}
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev610X::RunDmap(UCHAR run)
{
	if(run) { 
		EnableDmaIrq(TRUE);
		NotifyLive(0); 
	}
	else { 
		TCmdTimerInfo tmi;
		INIT_TIMERINFO(tmi);
		tmi.deviceId = m_iDev;
		tmi.timerId  = IRQ_DMPAP;
		m_pParent->CancelTimer(tmi);
		m_iDmap = 0;
	}

	ULONG value = m_pMem->ind(R_VDMAC);
	EnablePciIrq(run);
	
	m_pMem->outd(R_VDMAC, run ? (value|R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN) : 
	(value & ~(R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN)));
}

/** 
 ***************************************************************************************
 *  ȡǰеͨ
 *
 *  @return صǰеͨ
 ***************************************************************************************
 */
inline UINT CDev610X::CurrentChannel(UINT mux)
{
	UINT uCh = 0;

	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(i==mux) {
				break;
			}
			uCh++;
		}
	}

	return  uCh;
}

/** 
 ***************************************************************************************
 *  ȡ¸ͨ
 *
 *  @return ¸ͨ
 ***************************************************************************************
 */
inline int CDev610X::NextVideoInput()
{
	int iNext = 0;
	ULONG vInput= 0;

	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(iNext == m_iNext) {
				vInput = i;
				break;
			}
			iNext++;
		}
	}

	return vInput;
}

/** 
***************************************************************************************
*  ȡ¸Ҫɼͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev610X::NextChannel(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;

	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal || (vinfo.signal_check>=NOSIGNAL_CHECK_680X)) {
			break;
		}
	}
	
	return iNext;
}

/** 
***************************************************************************************
*  ȡ¸Ҫź(ź)ͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev610X::NextCheck(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;
	
	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(!vinfo.signal && (vinfo.signal_check<NOSIGNAL_CHECK_680X)) {
			break;
		}
	}
	
	return iNext;
}

void CDev610X::SetParameters(void* ctx, BOOL bSignalLast)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	TvSourceInfo vInfoLast = *(PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
	BOOL  isPal  = IS_PAL(vinfo->standard);
	BOOL  is4Cif = IS_4CIF((*vinfo));
	BOOL  bResync= m_bResync[m_iNext];
	int   iNexted= 0, j;
	int   iTo = (int)(m_bufRaw.size()/m_chlList.size());
	TRect rc(0, 0, 0, 0);
	LONGLONG tkDiff = 0;
	LONGLONG freq = m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart;

	m_Share->irqData[IRQ_DMPAP].dueTime = -1;
	m_Share->irqData[IRQ_DMPAP].timerIrq= FALSE;
	m_Share->irqData[IRQ_DMPAP].timerIrqPos = 0;
	m_Share->irqData[IRQ_DMPAP].timerIrqMask= 0;

	if(vinfo->signal && vInfoLast.signal) {
		if(freq!=0)  {
			tkDiff = m_tkDiff[m_iChannel] - m_tkDiff[m_iNext];
			if(tkDiff < 0) {
				tkDiff =- tkDiff;
			}
			tkDiff = (tkDiff * 10000 / freq);
			if(is4Cif) {
				if(isPal) {
					if(tkDiff < 460) {
						bResync = TRUE;
					}
					else if(m_bResync[m_iNext]) {
						if(m_chlList.size() > 2) {
							bResync = ((tkDiff%200) < 50);
						}
						else {
							bResync = ((tkDiff%200) < 50) && (tkDiff < 1200);
						}
					}
				}
				else {
					if(tkDiff < 380) {
						bResync = TRUE;
					}
					else if(m_bResync[m_iNext]) {
						freq = tkDiff % 166;
						if(m_chlList.size() > 2) {
							bResync = ((freq < 40) && (freq > 3));
						}
						else {
							bResync = ((freq < 40) && (freq > 3)) && (tkDiff < 1200);
						}
					}
				}
				//_trace("channel %d %d diff %d, %d, %d\n", m_iNext, m_iChannel, (LONG)tkDiff, m_irqDiff, bResync);
				if(m_iChannel != m_iNext) {
					m_bResync[m_iNext] = bResync;
					if(m_bResync[m_iNext]) {
						m_Share->irqData[IRQ_DMPAP].dueTime = 17;
					}
				}
				else {
					m_bResync[m_iNext] = TRUE;
					for(j=0; j<iTo; j++) {
						BuildResync((ULONG)m_listDmap[j + iTo*m_iNext]->vaddr, vinfo->field, m_bResync[m_iNext]);
					}
				}
			}
			else if(isPal) {
				if((tkDiff < 260)  || IS_4CIF(vInfoLast)) {
					bResync = TRUE;
				}
				else if(m_bResync[m_iNext]) {
					if(m_chlList.size() > 2) {
						bResync = ((tkDiff%200) < 50);
					}
					else {
						bResync = ((tkDiff%200) < 50) && (tkDiff < 1000);
					}
				}
				m_bResync[m_iNext] = bResync;
				for(j=0; j<iTo; j++) {
					BuildResync((ULONG)m_listDmap[j + iTo*m_iNext]->vaddr, vinfo->field, m_bResync[m_iNext]);
				}
			}
			else {
				if((tkDiff < 210) || IS_4CIF(vInfoLast)) {
					bResync = TRUE;
				}
				else if(m_bResync[m_iNext]) {
					freq = tkDiff % 166;
					if(m_chlList.size() > 2) {
						bResync = ((freq < 40) && (freq > 3));
					}
					else {
						bResync = ((freq < 40) && (freq > 3)) && (tkDiff < 1000);
					}
				}
				m_bResync[m_iNext] = bResync;
				for(j=0; j<iTo; j++) {
					BuildResync((ULONG)m_listDmap[j + iTo*m_iNext]->vaddr, vinfo->field, m_bResync[m_iNext]);
				}
			}
			//_trace("channel %d %d diff %d, %d, %d\n", m_iNext, m_iChannel, (LONG)tkDiff, m_irqDiff, bResync);
		}
	}
	else {
		if(vinfo->signal) {
			if(!is4Cif) {
				for(j=0; j<iTo; j++) {
					BuildResync((ULONG)m_listDmap[j + iTo*m_iNext]->vaddr, vinfo->field, FALSE);
				}
			}
		}
		else {
			m_Share->irqData[IRQ_DMPAP].dueTime = isPal ? 30 : 26;
			m_Share->irqData[IRQ_DMPAP].timerIrq= TRUE;
			m_Share->irqData[IRQ_DMPAP].timerIrqPos = (IRQ_DMPAP<<16) | 0;
			m_Share->irqData[IRQ_DMPAP].timerIrqMask= R_INT_VDMAPI;
		}
	}

	m_Share->irqData[IRQ_DMPAP].regWrite[2] = NextVideoInput()<<2;
	iNexted = (int)((m_bufRaw.size()/m_chlList.size()) * m_iNext + m_iDmaps[m_iNext]);
	m_Share->irqData[IRQ_DMPAP].regWrite[3] = (ULONG)m_listDmap[iNexted]->pnodes[0].addr;
	
	//ıbirghtnessֱʵȲ
	m_Share->irqData[IRQ_DMPAP].regWrite[5] = Brightness(vinfo->brightness);
	m_Share->irqData[IRQ_DMPAP].regWrite[6] = Contrast(vinfo->contrast);
	m_Share->irqData[IRQ_DMPAP].regWrite[7] = Saturation(vinfo->saturation);
	m_Share->irqData[IRQ_DMPAP].regWrite[8] = m_Share->irqData[IRQ_DMPAP].regWrite[7];
	m_Share->irqData[IRQ_DMPAP].regWrite[9] = Hue(vinfo->hue);
	if(m_bDiffSize) {
		//ͬͨʹòͬСĲɼֱ
		rc.right  = vinfo->capture.width;
		rc.bottom = IS_4CIF((*vinfo)) ? vinfo->capture.height/2 : vinfo->capture.height;
		m_eScaler->VideoFormatChanged((TVideoStandard)vinfo->standard);
		m_oScaler->VideoFormatChanged((TVideoStandard)vinfo->standard);
		m_eScaler->PreScale(rc);
		m_oScaler->PreScale(rc);
		m_Share->irqData[IRQ_DMPAP].regWrite[10] = m_eScaler->HScaleLo();
		m_Share->irqData[IRQ_DMPAP].regWrite[11] = m_eScaler->VScaleLo();
		m_Share->irqData[IRQ_DMPAP].regWrite[12] = m_eScaler->ScaleHi();
		m_Share->irqData[IRQ_DMPAP].regWrite[13] = m_oScaler->HScaleLo();
		m_Share->irqData[IRQ_DMPAP].regWrite[14] = m_oScaler->VScaleLo();
		m_Share->irqData[IRQ_DMPAP].regWrite[15] = m_oScaler->ScaleHi();
	}
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev610X::PrepareRun()
{ 
	TvDmaProgInfo eDpi, oDpi;
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource=NULL;
	TRect		  rc(0, 0, 0, 0);
	ULONG		  flagReset = 0;
	int			  bDiffSize = FALSE;
	int			  iNexted = 0;
	BOOL		  bSignal = FALSE;
	CSample*	  pSample = NULL;
	UINT		  i, iTo, iNum, iSync=0;

	if(m_chlList.size()==0) { return FALSE; }
	m_iChannel= CurrentChannel((m_pMem->inb(R_INFORM)&R_INFORM_YSEL) >> 2);
	if(m_bRestart) {
		m_iNext = NextChannel(m_iChannel);
		SetMux((TVideoInput)NextVideoInput());
		m_iChannel = m_iNext;
		m_bRestart = FALSE;
		flagReset |= DEVSET_field;
	}
	else if(!m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
		if(m_iChannel == m_iSignalCheck) {
			m_iSignalCheck = NextCheck(m_iSignalCheck);
		}
		m_iChannel = NextChannel(m_iChannel);
	}

	if(m_bSignalChanged) { flagReset |= DEVSET_field; }
	for(i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(!vinfo.signal) {	iSync++; }
		if(rc.right!=0) {
			bDiffSize= bDiffSize || (rc.right!=vinfo.capture.width) || (rc.bottom!=vinfo.capture.height);
		}
		rc.right  = vinfo.capture.width;
		rc.bottom = vinfo.capture.height;
		if(i == m_iChannel) {
			bSignal = vinfo.signal;
		}

		if(vinfo.reset & DEVSET_hdelay) {
			if(vinfo.hdelay<0)  {
				vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
			}
			vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
			m_eScaler->SetHDelay(abs(vinfo.hdelay));
			m_oScaler->SetHDelay(abs(vinfo.hdelay));
		}
		if(vinfo.reset & DEVSET_vdelay) {
			if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
			//vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW680X_VDELAY_MAX_PAL:TW680X_VDELAY_MAX_NTSC);
			vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
			m_eScaler->SetVDelay(abs(vinfo.vdelay));
			m_oScaler->SetVDelay(abs(vinfo.vdelay));
		}
		
		flagReset|= vinfo.reset;
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}

	//һdmapһͨ
	m_iNext = NextChannel(m_iChannel);
	if(m_iNext == m_iSignalCheck) {
		m_iSignalCheck = NextCheck(m_iSignalCheck);
	}
	vsource = (CPlgvSource*)m_chlList[m_iNext]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	((PvSourceInfo)vsource->GetPluginInfo())->signal_check = 0;
	SetParameters(&vinfo, bSignal);

	flagReset &= ~(DEVSET_property);
	if(flagReset == 0) { return TRUE; }

	//ֹͣdma
	RunDmap(0);
	iTo = (UINT)(m_bufRaw.size()/m_chlList.size());

	//dma program
	for(i=0; i<m_chlList.size(); i++) {
		m_iIrqs[i] = 0;
		m_tkDiff[i]= 0;
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		eDpi.interlace = IS_4CIF(vinfo);
		eDpi.width = vinfo.capture.width;
		eDpi.height= eDpi.interlace ? vinfo.capture.height/2 : vinfo.capture.height;
		eDpi.pitch = vinfo.capture.pitch;
		eDpi.lineSize = vinfo.capture.width*vinfo.capture.bit_count/8;
		eDpi.irq   = TRUE;
		if(vinfo.hdelay<0)  {
			vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
		}
		if(vinfo.vdelay< 0) vinfo.vdelay= IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
		vsource->SetPluginInfo(&vinfo, VSRC_hdelay|VSRC_vdelay);
		OnBufferFull(m_chlList[i], eDpi.interlace, i*RAWV_NUM, (i+1)*RAWV_NUM);
		for(UINT j=0; j<iTo; j++) {
			iNum = j + iTo*i;
			SetProgAddr((ULONG)m_listDmap[iNum]->vaddr, (ULONG)m_listDmap[iNum]->pnodes[0].addr, DMAP_LEN);
			pSample = m_bufRaw[iNum];
			eDpi.memBuf= pSample->Buffer();
			m_iSync = 0;
			if(!vinfo.signal) {
				if(vinfo.field==VF_Even) {
					BuildSkip(&eDpi, NULL);
				}
				else {
					BuildSkip(NULL, &eDpi);
				}
			}
			else if(!eDpi.interlace) {
				if(vinfo.field == VF_Even) {
					Build(&eDpi, NULL);
				}
				else {
					Build(NULL, &eDpi);
				}
			}
			else {
				//4CIFɼ
				m_iSync++;
				oDpi.width = eDpi.width;
				oDpi.height= eDpi.height;
				oDpi.interlace = TRUE;
				oDpi.pitch = vinfo.capture.pitch*2;
				oDpi.irq   = TRUE;
				oDpi.memBuf= eDpi.memBuf;
				oDpi.lineSize = eDpi.lineSize;
				eDpi.pitch = oDpi.pitch;
				eDpi.irq   = FALSE;
				Build(&eDpi, &oDpi);
			}
		}
	}

	if(bDiffSize != m_bDiffSize) {
		//ͬͨʹòͬСĲɼֱ
		TCmdIrqInfo irq;
		INIT_IRQINFO(irq);
		irq.deviceId = m_iDev;
		irq.irqInfo.irqId	 = IRQ_DMPAP;
		irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
		irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
		irq.irqInfo.regMask[0]  = R_INTMASK;
		irq.irqInfo.regStatus[0]= R_INTSTAT;
		irq.irqInfo.status[0]   = 0;
		irq.irqInfo.regRWBase= irq.irqInfo.regBase;
		irq.irqInfo.regRead[0] = R_VSTATUS1;
		irq.irqInfo.regRead[2] = R_INFORM;
		irq.irqInfo.regRead[3] = R_VDMAP_SA;
		irq.irqInfo.regWrite[0]= R_VDMAC;
		irq.irqInfo.regWrite[2]= R_INFORM;
		irq.irqInfo.regWrite[3]= R_VDMAP_SA;
		if(m_bTimer) {
			irq.irqInfo.timerId = IRQ_DMPAP;
		}
		else {
			irq.irqInfo.regWrite[4]= R_VDMAC;
		}
		irq.irqInfo.regWrite[5]= R_BRIGHT;
		irq.irqInfo.regWrite[6]= R_CONTRAST;
		irq.irqInfo.regWrite[7]= R_SATU;
		irq.irqInfo.regWrite[8]= R_SATV;
		irq.irqInfo.regWrite[9]= R_HUE;
		irq.irqInfo.mskWrite[0]= R_VDMAC_VDMAP_EN;
		irq.irqInfo.mskWrite[2]= R_INFORM_YSEL;
		irq.irqInfo.mskWrite[3]= 0xFFFFFFFF;
		irq.irqInfo.mskWrite[4]= R_VDMAC_VDMAP_EN;
		if(bDiffSize) {
			irq.irqInfo.regWrite[10] = m_eScaler->RegHScaleLo();
			irq.irqInfo.regWrite[11] = m_eScaler->RegVScaleLo();
			irq.irqInfo.regWrite[12] = m_eScaler->RegScaleHi();
			irq.irqInfo.regWrite[13] = m_oScaler->RegHScaleLo();
			irq.irqInfo.regWrite[14] = m_oScaler->RegVScaleLo();
			irq.irqInfo.regWrite[15] = m_oScaler->RegScaleHi();
		}
		m_pParent->ModifyIrq(irq);
		m_bDiffSize = bDiffSize;
	}

	m_bSignalChanged = FALSE;
	m_bRestart = FALSE;
	m_irqDiff = 0;
	m_tkLast= 0;
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	rc.right  = vinfo.capture.width;
	rc.bottom = IS_4CIF(vinfo) ? vinfo.capture.height/2 : vinfo.capture.height;
	m_oScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	m_oScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
	m_eScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	m_eScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
	SetStandard(vinfo.standard);
	SetFormat(vinfo.capture.pixel_format);
	SetBright(vinfo.brightness);
	SetContrast(vinfo.contrast);
	SetSaturation(vinfo.saturation);
	SetHue(vinfo.hue);
	SetSharpness(vinfo.sharpness);
	iNum = (UINT)(m_bufRaw.size()/m_chlList.size());
	iNum = iNum * m_iChannel + m_iDmaps[m_iChannel];
	SetDmapAddr((ULONG)m_listDmap[iNum]->pnodes[0].addr);
// 	_trace(TEXT("[Ϣ]Ƶ豸(%d, %d)ͨ%dеDMAP buffer = %08X\n")), m_cardInfo->nSlot, m_devInfo.DeviceNumber, 
// 		m_iChannel, m_listDmap[iNum]->pnodes[0].addr);

	return (TRUE+TRUE);
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  Ҫźżʱ򵱳ź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev610X::HasSignal()
{
	long iSignal = 0;
	CPlgvSource* vsource = NULL;
	PvSourceInfo vinfo = NULL;

	for(UINT i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = (PvSourceInfo)vsource->GetPluginInfo();

		if(i==m_iSignalCheck && !vinfo->signal) {
			vinfo->signal_check++;
		}
		iSignal += vinfo->signal;
	}

	return iSignal;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
void CDev610X::CheckSignal(BYTE vstatus)
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	CPlgvSource* vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	TvSourceInfo vinfo = *(PvSourceInfo)vsource->GetPluginInfo();

#if(0)
	bSignal = !(vstatus & R_VSTATUS1_VDLOSS) && !(vstatus & R_VSTATUS1_NOVIDEO) && (vstatus & R_VSTATUS1_HLOCK) && 
		   ((vstatus & R_VSTATUS1_SLOCK) || (vstatus&R_VSTATUS1_VLOCK));	//SLOCKڰź
#else
	bSignal = !(vstatus & R_VSTATUS1_VDLOSS) && (vstatus & R_VSTATUS1_HLOCK);
#endif

	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (bSignal ? 1 : 1)) {
			_trace(TEXT("[Ϣ]CheckSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			vinfo.reset|= DEVSET_field;
			setSignal  |= VSRC_signal|VSRC_reset;
			m_bSignalChanged = TRUE;
		}
	}
	else {
		vinfo.signal_count = 0;
	}

	vsource->SetPluginInfo(&vinfo, setSignal);
}

//-----------------------------------------------------
// жϴ
//-----------------------------------------------------
long CDev610X::OnIrq()
{
	LONG  isData = -1;
	ULONG dmapAddr = 0;
	int	  i, iTo, iNum;
	BOOL  isPal=TRUE;
	BOOL  is4Cif = FALSE;

	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		isData = FALSE;
		m_iChannel= CurrentChannel((m_Share->irqData[IRQ_DMPAP].regRead[2] & R_INFORM_YSEL) >> 2);
		dmapAddr = m_Share->irqData[IRQ_DMPAP].regRead[3];
		if(m_Share->irqData[IRQ_DMPAP].status[0] & R_INT_VDMAPI) {
			CPlgvSource* vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
			TvSourceInfo vinfo;

			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			is4Cif = IS_4CIF(vinfo);
			isPal  = IS_PAL(vinfo.standard);

			m_tkDiff[m_iChannel] = m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart;

			m_irqDiff = (LONG)((m_tkDiff[m_iChannel] - m_tkLast) * 10000 / m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart);
			m_tkLast = m_tkDiff[m_iChannel];
			//_trace("ch %d irq time %d %d\n", m_chlList[m_iChannel]->ChannelId(),(LONG)m_irqDiff, vinfo.signal);
			
			if(isPal) {
				if((m_irqDiff > 200) || !vinfo.signal) {
					CheckSignal((BYTE)m_Share->irqData[IRQ_DMPAP].regRead[0]);
				}
			}
			else {
				if((m_irqDiff > 160) || !vinfo.signal) {
					CheckSignal((BYTE)m_Share->irqData[IRQ_DMPAP].regRead[0]);
				}
			}
			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
			vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
			isData = vinfo.signal;

			if(!vinfo.signal) {
				//if(m_irqDiff > 270) {
					//_trace("irq time %d\n", m_irqDiff);
					//RunDmap(0);
					//m_bRestart = TRUE;
				//}
			}
			else if(isPal) {
				if(is4Cif) {
					if(m_irqDiff < 399) {
						//_trace("irq time %d, channel %d drop frame\n", m_irqDiff, m_iChannel);
						isData = FALSE;
					}
				}
				else if(m_irqDiff < 250) {
					//_trace("irq time %d, channel %d drop frame\n", m_irqDiff, m_iChannel);
					isData = FALSE;
				}
			}
			else {
				if(is4Cif) {
					if(m_irqDiff < 330) {
						//_trace("irq time %d, channel %d drop frame\n", m_irqDiff, m_iChannel);
						isData = FALSE;
					}
				}
				else if(m_irqDiff < 210) {
					//_trace("irq time %d, channel %d drop frame\n", m_irqDiff, m_iChannel);
					isData = FALSE;
				}
			}

			m_iSync = 0;
			if(isData) {
				isData = FALSE;
				iNum= (int)(m_bufRaw.size()/m_chlList.size());
				i   = m_iChannel * iNum;
				iTo = i + iNum;
				for(; i<iTo; i++) {
					if((ULONG)m_listDmap[i]->pnodes[0].addr == dmapAddr) {
						m_pSample = m_bufRaw[i];
						m_pSample->SetFlag(PLG_vsource);
						m_pSample->SetChannel(m_chlList[m_iChannel]);
						m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
						isData = TRUE;
						m_iDmaps[m_iChannel] = (m_iDmaps[m_iChannel]+1) % iNum;
						break;
					}
				}
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}
	if(m_Share->irqData[IRQ_ERROR].evtId != evt_None) {
		isData = FALSE;
		m_iChannel= CurrentChannel((m_Share->irqData[IRQ_ERROR].regRead[2] & R_INFORM_YSEL) >> 2);
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_DMAPERR) {
			//dma programд
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev610X::OnIrqͨ%d豸(slot %d0豸%d)dmaperr\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_PABORT) {
			//dma programд,ֹͣȻ´
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev610X::OnIrqͨ%d豸(slot %d0豸%d)pci abort\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		
		//fifoݶʧ
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_FFIFO) {
			_trace(TEXT("[Ϣ]ͨ%02dݶʧ\n"), m_chlList[m_iChannel]->ChannelId());
		}
		
		m_Share->irqData[IRQ_ERROR].evtId   = evt_None;
		m_Share->irqData[IRQ_ERROR].status[0]  = 0;
		m_Share->irqData[IRQ_ERROR].irqCount= 0;
	}
	
	//żж
	if(m_Share->irqData[IRQ_FIELD].evtId != evt_None) {
		if(m_Share->irqData[IRQ_FIELD].status[0] & R_INT_GPINT) {
			TDeviceDesc devInfo;
			for(UINT i=0; i<g_devListV.size(); i++) {
				devInfo = g_devListV[i]->Parent()->DeviceInfo();
				if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==2)) {
					((CDev6803*)g_devListV[i])->OnGpint();
					break;
				}
			}
		}
		m_Share->irqData[IRQ_FIELD].evtId   = evt_None;
		m_Share->irqData[IRQ_FIELD].status[0]  = 0;
		m_Share->irqData[IRQ_FIELD].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// DMA programָ
//-----------------------------------------------------
BOOL CDev610X::ModifyDmap(BOOL bDiffField)
{
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	UINT		 i, iNum, iTo;
	ULONG*		 dmap;
	ULONG		 ip = 0;

	//dma program
	for(i=0; i<m_chlList.size(); i++) {
		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		iTo = (UINT)(m_bufRaw.size()/m_chlList.size());
		for(UINT j=0; j<iTo; j++) {
			iNum = j + iTo*i;
			if(vinfo.signal && !IS_4CIF(vinfo)) {
				dmap = (PULONG)m_listDmap[iNum]->vaddr;
				ip = 0;
				if(bDiffField) {
					if(m_iChannel==i) {
						dmap[ip++] = (vinfo.field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE;
						dmap[ip++] = 0;
						dmap[ip++] = (vinfo.field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE;
						dmap[ip++] = 0;
					}
					else {
						dmap[ip++] = DMAP_DUMMY;//DMAP_SYNCE;
						dmap[ip++] = 0;
						dmap[ip++] = (vinfo.field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE;
						dmap[ip++] = 0;
					}
				}
				else {
					dmap[ip++] = DMAP_DUMMY;
					dmap[ip++] = 0;
					dmap[ip++] = (vinfo.field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE;
					dmap[ip++] = 0;
				}
			}
		}
	}

	return TRUE;
}

//-----------------------------------------------------
// DMA programָ
//-----------------------------------------------------
BOOL CDev610X::BuildSkip(TvDmaProgInfo* eDpi, TvDmaProgInfo* oDpi)
{
	ULONG*	dmap = (ULONG*) m_virProg;
	ULONG	ip = 0;

	if(eDpi) {
		dmap[ip++] = DMAP_SYNCO;
		dmap[ip++] = 0;
		if(!oDpi) {
			dmap[ip++] = DMAP_JUMP | (eDpi->irq ? DMAP_IRQ : 0);
			dmap[ip++] = m_phyProg;
		}
	}

	if(oDpi) {
		dmap[ip++] = DMAP_SYNCE| ((eDpi&&eDpi->irq) ? DMAP_IRQ : 0);
		dmap[ip++] = 0;
		dmap[ip++] = DMAP_JUMP | (oDpi->irq ? DMAP_IRQ : 0);
		dmap[ip++] = m_phyProg;
	}

	return TRUE;
}

//-----------------------------------------------------
// DMA programָ
//-----------------------------------------------------
BOOL CDev610X::Build(TvDmaProgInfo* eDpi, TvDmaProgInfo* oDpi)
{
	ULONG*	dmap = (ULONG*) m_virProg;
	ULONG	ip = 0;
	ULONG	phyWrite; 
	ULONG	lineSize, stride, lenWrite, lenWriten;
	ULONG	page, pageLen;
	ULONG	pageBegin, pageEnd;

	if(dmap == NULL) {
		return FALSE;
	}

	//żdma program
	if(eDpi) {
		if(eDpi->memBuf==NULL) {
			dmap[ip++] = DMAP_SYNCE;
			dmap[ip++] = 0;
		}
		else {
			if(eDpi->memBuf->pnodes == NULL) {
				return FALSE;
			}

			ip = 0;
			phyWrite = (ULONG)eDpi->memBuf->pnodes[0].addr;
			lineSize = eDpi->lineSize;
			stride   = eDpi->pitch;
			lenWrite = 0;
			lenWriten= 0;
			page	 = 0;
			pageLen	 = eDpi->memBuf->pnodes[0].len;
			pageBegin= phyWrite;
			pageEnd	 = pageBegin + pageLen;

			if(eDpi->memBuf->len < (stride*eDpi->height)) {
				//ڴ治
				return FALSE;
			}

			if(m_iSync > 0) {
				dmap[ip++] = eDpi->interlace ? DMAP_SYNCE : DMAP_SYNCO;
				dmap[ip++] = 0;
			}
			else {
				dmap[ip++] = DMAP_DUMMY;
				dmap[ip++] = 0;
			}
			dmap[ip++] = DMAP_SYNCO;
			dmap[ip++] = 0;

			for(int i=0; i<eDpi->height; i++) {
				//ڴ
				dmap[ip++] = DMAP_WRITE | DMAP_SOL | lineSize;
				dmap[ip++] = phyWrite;
				phyWrite  += stride;
			}
		}
		dmap[ip++] = DMAP_JUMP | (eDpi->irq ? DMAP_IRQ : 0);
		dmap[ip++] = (oDpi==NULL) ? m_phyProg : (m_phyProg + (ip+1)*4);
	}

	//泡dma program
	if(oDpi){
		if(oDpi->memBuf==NULL) {
			dmap[ip++] = DMAP_SYNCO;
			dmap[ip++] = 0;
		}
		else {
			if(oDpi->memBuf->pnodes == NULL) {
				return FALSE;
			}

			lineSize = oDpi->lineSize;
			stride   = oDpi->pitch;
			if(oDpi->interlace) {
				phyWrite = (ULONG)oDpi->memBuf->pnodes[0].addr + lineSize;
				pageLen	 = oDpi->memBuf->pnodes[0].len - lineSize;
			}
			else {
				phyWrite = (ULONG)oDpi->memBuf->pnodes[0].addr;
				pageLen	 = oDpi->memBuf->pnodes[0].len;
			}
			lenWrite = 0;
			lenWriten= 0;
			page	 = 0;
			pageBegin= phyWrite;
			pageEnd	 = pageBegin + pageLen;

			if(oDpi->memBuf->len < (stride*oDpi->height)) {
				//ڴ治
				return FALSE;
			}

			if(!oDpi->interlace && (m_iSync>0)) {
				dmap[ip++] = DMAP_SYNCE;
				dmap[ip++] = 0;
			}
			else {
				dmap[ip++] = DMAP_DUMMY;
				dmap[ip++] = 0;
			}
			dmap[ip++] = DMAP_SYNCE;
			dmap[ip++] = 0;
			
			for(int i=0; i<oDpi->height; i++) {
				//ڴ
				dmap[ip++] = DMAP_WRITE | DMAP_SOL | lineSize;
				dmap[ip++] = phyWrite;
				phyWrite  += stride;
			}
		}
		dmap[ip++] = DMAP_JUMP | (oDpi->irq ? DMAP_IRQ : 0);
		dmap[ip++] = m_phyProg;
	}
		
	return TRUE;
}

//-----------------------------------------------------
// DMA program ָͬ
//-----------------------------------------------------
BOOL CDev610X::BuildResync(ULONG virRisc, int field, BOOL bResync)
{
	ULONG*	dmap = (ULONG*) virRisc;
	ULONG	ip = 0;

	dmap[ip++] = bResync ? ((field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE) : DMAP_DUMMY;
	dmap[ip++] = 0;

	return TRUE;
}

//-----------------------------------------------------
// DMA program ָͬ
//-----------------------------------------------------
BOOL CDev610X::BuildSync(ULONG virRisc, int field)
{
	ULONG*	dmap = (ULONG*) virRisc;
	ULONG	ip = 0;
	
	dmap[ip++] = DMAP_DUMMY;
	dmap[ip++] = 0;

	dmap[ip++] = (field==VF_Even) ? DMAP_SYNCO : DMAP_SYNCE;
	dmap[ip++] = 0;
	
	return TRUE;
}