/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev610x.h
 *  @brief		Ƶ豸CDev610X֧TW6804 : ɷʵʱ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__DEV610X_H_)
#define __DEV610X_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Dev6801.h"

class CDev610X : public CDev6801  
{
public:
	CDev610X();
	virtual ~CDev610X();

	virtual long PrepareRun();
	virtual long OnIrq();
	virtual long HasSignal();
	virtual BOOL InsertSample(CSample* pSample);

protected:
	//麯ʼʼ豸
	virtual BOOL OnOpen();
	virtual BOOL OnClose();
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();

	//豸ƺ
	virtual void Init6801();
	virtual void SetStandard(int value);
	virtual void CheckSignal(BYTE vstatus);

	virtual BOOL Build(TvDmaProgInfo* eDpi, TvDmaProgInfo* oDpi);
	BOOL		 BuildSkip(TvDmaProgInfo* eDpi, TvDmaProgInfo* oDpi);
	BOOL		 BuildResync(ULONG virRisc, int field, BOOL bResync);
	BOOL		 BuildSync(ULONG virRisc, int field);
	BOOL		 ModifyDmap(BOOL bDiffField);
	UINT		 CurrentChannel(UINT mux);
	int			 NextVideoInput();
	int			 NextChannel(int iFrom);
	int			 NextCheck(int iFrom);
	void		 SetParameters(void* ctx, BOOL bSignalLast);

	BYTE		 Brightness(int b);
	BYTE		 Contrast(int c);
	BYTE		 Saturation(int s);
	BYTE		 Hue(int h);
	BYTE		 Sharpness(int sh);
	virtual void RunDmap(UCHAR run);

protected:
	int		m_iNext;
	int		m_iSync;
	int		m_iSignalCheck;
	BOOL	m_bDiffSize;
	BOOL	m_bSignalChanged;
	BOOL	m_bTimer;
	BOOL	m_bRestart;
	LONG	m_iDmaps[MAX_610X_SWITCH];
	LONG	m_iIrqs[MAX_610X_SWITCH];
	LONG	m_irqDiff;
	LONGLONG m_tkLast;
	LONGLONG m_tkDiff[MAX_610X_SWITCH];
	BOOL	m_bResync[MAX_610X_SWITCH];
	vector<PMemBlock> m_listDmap;
};

#endif // !defined(__DEV610X_H_)
