/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6801.cpp
 *  @brief		Ƶ豸CDev6801ʵ֣֧TW6801 : СɼһԤ¼ͬɼ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev6801.h"
#include "TW680X.H"
#include "PlgvSource.h"
#include "Dev6803.h"
#include <mmsystem.h>
#include "IniFile.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6801::CDev6801() :
m_oScaler(NULL),
m_eScaler(NULL),
m_tkSignal(0)
{
	CIniFile iniFile;
	TCHAR path[MAX_PATH];
	g_util.GetModulePath(g_hSelfDll, path);
	lstrcat(path, TEXT("TW68XX.ini"));
	iniFile.Create(path);
	m_ifoOptimize.enable = (iniFile.ReadInt(TEXT("SDK"), TEXT("field"), 0) < 0);

	ZeroMemory(&m_memDmap, sizeof(TMemBlock));
}

CDev6801::~CDev6801()
{
}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6801::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	
	if(!m_pParent->AllocMemory(DMAP_LEN, &m_memDmap)) {
		return FALSE;
	}
	SetDmapAddr((ULONG)m_memDmap.pnodes[0].addr);
	SetProgAddr((ULONG)m_memDmap.vaddr, (ULONG)m_memDmap.pnodes[0].addr, DMAP_LEN);

	for(i=0; i<RAWV_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6801::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6801::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6801::OnFreeResource()
{
	CSample* pSample = NULL;

	m_pParent->FreeMemory(&m_memDmap);
	_trace(TEXT("[Ϣ]CDev6801::OnFreeResource()ͷDMAP bufferɹ(slot %d,function 0,device %d)\n"), 
		m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		m_pParent->FreeMemory(pSample->Buffer());
		_trace(TEXT("[Ϣ]CDev6801::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		delete pSample;
		m_bufRaw.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6801::OnOpen()
{
	TCmdIrqInfo		irq;

	ZeroMemory(m_Share, sizeof(TShareData));

	Init6801();

	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			SetMux((TVideoInput)viInput);
			break;
		}
	}
	
	SetStandard(TvSourceInfo::default_standard);
	SetFormat(vpfYUV422Interspersed);
	
	if(m_eScaler == NULL) {
		m_eScaler = new CScaler6801(m_pMem, VF_Even);
	}
	if(m_oScaler == NULL) {
		m_oScaler = new CScaler6801(m_pMem, VF_Odd);
	}
	if((m_oScaler==NULL) || (m_oScaler==NULL)) {
		return FALSE;
	}
	
	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[0] = R_VSTATUS1;
	irq.irqInfo.regRead[2] = R_VDMAP_PP;
	m_pParent->AppendIrq(irq);

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regWrite[0]= R_INTMASK;//(ULONG)-1;
	irq.irqInfo.regWrite[1]= R_VDMAC;//(ULONG)-1;
	irq.irqInfo.mskWrite[0]= R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.mskWrite[1]= R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6801::OnClose()
{
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6801::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	SAFE_DELETE(m_oScaler);
	SAFE_DELETE(m_eScaler);

	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_INT_VDMAPI|R_INT_VDLOSS;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_INT_DMAPERR|R_INT_PPERR|R_INT_PABORT|R_INT_FFIFO;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);
	
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_FIELD;
	irq.irqInfo.mask[0]	 = R_INT_GPINT;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_INTMASK;
	irq.irqInfo.regStatus[0]= R_INTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6801::PrepareRun()
{
	TvDmaProgInfo eDpi, oDpi;
	TvSourceInfo  vinfo;
	TRect		  rc(0, 0, 0, 0);
	CPlgvSource*  vsource = NULL;
	CSample*	  pSample = NULL;
	BOOL		  is4CIF  = FALSE;
	ULONG		  flagReset = 0;
	UINT		  i;
	
	if(m_chlList.size()==0) { return FALSE; }

	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	if(!vinfo.signal) { 
		RunDmap(0);
		return FALSE; 
	}

	is4CIF = IS_4CIF(vinfo) || vinfo.optimize_cif;

	//豸Ҫ
	if(vinfo.reset & DEVSET_property) {
		SetBright(vinfo.brightness);
		SetContrast(vinfo.contrast);
		SetSaturation(vinfo.saturation);
		SetHue(vinfo.hue);
		SetSharpness(vinfo.sharpness);
	}
	if(vinfo.reset & DEVSET_hdelay) {
		if(vinfo.hdelay<0)  {
			vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
		}
		vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
		m_eScaler->SetHDelay(abs(vinfo.hdelay));
		m_oScaler->SetHDelay(abs(vinfo.hdelay));
	}
	if(vinfo.reset & DEVSET_vdelay) {
		if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
		//vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW680X_VDELAY_MAX_PAL:TW680X_VDELAY_MAX_NTSC);
		vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
		m_eScaler->SetVDelay(abs(vinfo.vdelay));
		m_oScaler->SetVDelay(abs(vinfo.vdelay));
	}
	
	if(vinfo.reset & DEVSET_devreset) {
		flagReset |= (vinfo.reset&DEVSET_devreset);
	}

	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}

	if(flagReset == 0) {
		//ʱsdkиDMAPܵĻǷŵISRиĽϺ
		int  frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
		int  iNextDmap = ((m_iDmap+1) % m_bufRaw.size()) * 2;
		BOOL bSkip = !((vinfo.capture.frame_rate_mask>>frame_rate_cnt) & 0x01);
		if(is4CIF) {
			Skip(iNextDmap, bSkip);
			Skip(iNextDmap+1, bSkip);
		}
		else {
			Skip(iNextDmap + ((vinfo.field==VF_Odd) ? 1 : 0), bSkip);
		}
		return TRUE; 
	}

	RunDmap(0);
	vinfo.frame_rate_cnt = m_chlList[m_iChannel]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	if(vinfo.hdelay<0)  {
		vinfo.hdelay = (vinfo.capture.width<208) ? -TW680X_HDELAY_QCIF : -TW680X_HDELAY;
	}
	if(vinfo.vdelay< 0) vinfo.vdelay= IS_PAL(vinfo.standard) ? -TW680X_VDELAY_PAL : -TW680X_VDELAY_NTSC;
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt|VSRC_hdelay|VSRC_vdelay);

	//dma program
	if(is4CIF) {
		eDpi.height= vinfo.capture.height / 2;
		eDpi.pitch = vinfo.capture.pitch  * 2;
	}
	else {
		eDpi.height= vinfo.capture.height;
		eDpi.pitch = vinfo.capture.pitch;
	}
	eDpi.lineSize  = vinfo.capture.pitch;
	eDpi.width = vinfo.capture.width;
	eDpi.offset= 0;
	eDpi.memBuf= NULL;
	oDpi = eDpi;
	oDpi.offset = is4CIF ? oDpi.lineSize : 0;
	rc.right  = eDpi.width;
	rc.bottom = eDpi.height;
	SetStandard(vinfo.standard);
	SetFormat(vinfo.capture.pixel_format);
	m_oScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	m_oScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));
	m_eScaler->VideoFormatChanged((TVideoStandard)vinfo.standard);
	m_eScaler->Scale(rc, abs(vinfo.hdelay), abs(vinfo.vdelay));

	OnBufferFull(m_chlList[m_iChannel], is4CIF, m_iChannel*RAWV_NUM, (m_iChannel+1)*RAWV_NUM);

	//dma program
	for(i=0; i<m_bufRaw.size(); i++) {
		pSample = m_bufRaw[i];
		pSample->SetChannel(m_chlList[m_iChannel]);
		if(is4CIF) {
			eDpi.memBuf= pSample->Buffer();
			oDpi.memBuf = eDpi.memBuf;
		}
		else if(vinfo.field == VF_Even) {
			eDpi.memBuf= pSample->Buffer();
		}
		else {
			oDpi.memBuf= pSample->Buffer();
		}
		if(!Build(i*2, &eDpi)) {
			return FALSE;
		}
		if(!Build(i*2+1, &oDpi)) {
			return FALSE;
		}
	}

	return (TRUE+TRUE);
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6801::OnIrq()
{
	long isData = -1;
	long iEven  = 0;
	long iOdd   = 0;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0;

	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();

		isData = FALSE;
		if(m_Share->irqData[IRQ_DMPAP].status[0] & R_INT_VDMAPI) {
			dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[2];
			m_iDmap = LastDmaBuffer(dmapAddr, iEven, iOdd);
			if(vinfo.field == VF_Even) {
				isData = (iEven >= 0);
				if(isData) {
					m_pSample = m_bufRaw[iEven];
					m_pSample->SetFlag(PLG_vsource);
					m_pSample->SetTimeStamp(timestamp());
					m_pSample->SetChannel(m_chlList[m_iChannel]);
					m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				}
			}
			else {
				isData = (iOdd >= 0);
				if(isData) {
					m_pSample = m_bufRaw[iOdd];
					m_pSample->SetFlag(PLG_vsource);
					m_pSample->SetTimeStamp(timestamp());
					m_pSample->SetChannel(m_chlList[m_iChannel]);
					m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				}
			}

			vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
			vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

			if(m_ifoOptimize.enable && !IS_4CIF(vinfo) && !vinfo.optimize_cif) {
				isData = isData && (PciOptimize() > 0);
				if(!isData) {
					m_pSample = NULL;
				}
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	if(m_Share->irqData[IRQ_ERROR].evtId != evt_None) {
		isData = FALSE;
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_DMAPERR) {
			//dma programд
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev6801::OnIrqͨ%d豸(slot %d%d豸%d)dmaperr\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
		}

		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_PABORT) {
			//dma programд,ֹͣȻ´
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev6801::OnIrqͨ%d豸(slot %d%d豸%d)pci abort\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
		}
		
		//fifoݶʧ
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_INT_FFIFO) {
			_trace(TEXT("[Ϣ]ͨ%02dݶʧ\n"), m_chlList[m_iChannel]->ChannelId());
		}

		m_Share->irqData[IRQ_ERROR].evtId   = evt_None;
		m_Share->irqData[IRQ_ERROR].status[0]  = 0;
		m_Share->irqData[IRQ_ERROR].irqCount= 0;
	}

	//żж
	if(m_Share->irqData[IRQ_FIELD].evtId != evt_None) {
		if(m_Share->irqData[IRQ_FIELD].status[0] & R_INT_GPINT) {
			TDeviceDesc devInfo;
			for(UINT i=0; i<g_devListV.size(); i++) {
				devInfo = g_devListV[i]->Parent()->DeviceInfo();
				if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==2)) {
					((CDev6803*)g_devListV[i])->OnGpint();
					break;
				}
			}
		}
		m_Share->irqData[IRQ_FIELD].evtId   = evt_None;
		m_Share->irqData[IRQ_FIELD].status[0]  = 0;
		m_Share->irqData[IRQ_FIELD].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6801::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
	
	if(m_pSample==NULL) { return FALSE; }

	try {
		NotifyLive(timeGetTime());
		m_pSample->SetTimeStamp(timestamp());
		chl = m_pSample->GetChannel();
		if(chl) {
			plg = chl->Plugin(PLG_vsource);
			ret = plg->Transmit(m_pSample, NULL);
		}
		m_pSample->ClearFlag(PLG_vsource);
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6801::OnData()쳣!"));
	}

	m_pSample = NULL;
	
	return ret;
}

//-------------------------------------------------------
//ʼTW9903
//-------------------------------------------------------
void CDev6801::Init6801()
{
	m_pMem->outb(R_ACNTL,			0x80);
	m_pMem->outd(R_VBIC,			0x00);
	m_pMem->outd(R_INTSTAT,			0xFFFFFFFF);
	m_pMem->outd(R_INTMASK,			0x00000000);
	m_pMem->outd(R_GPIOC,			0x00003000);
	m_pMem->outb(R_VCAPCTL,			0xC3);
	m_pMem->outd(R_VFRAMEDROPCTL,	0x00);
	m_pMem->outb(R_VSTATUS1,		0x00);
	m_pMem->outb(R_INFORM,			0x40);
	m_pMem->outb(R_OPFORM,			0x04);//0x08);
	m_pMem->outb(R_GAMMAHDELAY,		0x00);
	m_pMem->outb(R_POLARITY,		0x00);
	m_pMem->outb(R_ACNTL,			0x00);	
	m_pMem->outb(R_CNTRL1,			0xCD);
	m_pMem->outb(R_BRIGHT,			0x00);
	m_pMem->outb(R_CONTRAST,		0x4C);
	m_pMem->outb(R_SHARPNESS,		0x11);//0x54);
	m_pMem->outb(R_SATU,			0x80);
	m_pMem->outb(R_SATV,			0x80);
	m_pMem->outb(R_HUE,				0x00);
	m_pMem->outb(R_SHARP2,			0x53);//0xC6);
	m_pMem->outb(R_VSHARP,			0x84);
	m_pMem->outb(R_CORING,			0xCC);//0x44);	//ˮ
	m_pMem->outb(R_VBICNTL,			0x00);
	m_pMem->outb(R_ACNTL2,			0x0A);
	m_pMem->outb(R_STD,				0x17);
	m_pMem->outb(R_STDR,			0x03);
	m_pMem->outb(R_CLMPG,			0x50);
	m_pMem->outb(R_IAGC,			0x42);//0x32);
	m_pMem->outb(R_AGCGAIN,			0xF0);//0x40);
	m_pMem->outb(R_PEAKWT,			0xD8);
	m_pMem->outb(R_CLMPL,			0xBC);
	m_pMem->outb(R_SYNCT,			0xB8);
	m_pMem->outb(R_MISSCNT,			0x44);	//ֵ44Ϊ14ͼȶһ֡ʽ
	m_pMem->outb(R_PCLAMP,			0x2A);//0x28);
	m_pMem->outb(R_VCNTL1,			0x08);//0x0C);
	m_pMem->outb(R_VCNTL2,			0x00);
	m_pMem->outb(R_CKILL,			0x78);//0x68);
	m_pMem->outb(R_COMB,			0x44);
	m_pMem->outb(R_LDLY,			0x30);//0xB0);
	m_pMem->outb(R_MISC1,			0x14);//0x54);
	m_pMem->outb(R_LOOP,			0xFD);//0x3D);
	m_pMem->outb(R_MISC2,			0xE0);//0xF0);	//ĴźʱǺ
	m_pMem->outb(R_CLMD,			0x05);//0x35);	//YNR -- Y HF noise reduction
	m_pMem->outb(R_IDCNTL,			0x00);
	m_pMem->outb(R_CLCNTL1,			0x20);	//YCLEN -- Y Clamp ƵӰܴdisableĻźżʧԼͼϷ
	
	m_pMem->outd(R_VBIC,			0x51900000);

	if(DEVICEID(m_pParent->DeviceInfo().HardwareId) == 0x6804) {
		m_pMem->outd(R_VDMAC,		0x0000A000);
	}
	else {
		m_pMem->outd(R_VDMAC,		0x00002000);
	}
}

void CDev6801::SetMux(TVideoInput vInput) 
{
	UCHAR mux = (UCHAR)vInput;
	UCHAR cVal = m_pMem->inb(R_INFORM) & ((UCHAR)~R_INFORM_YSEL);
	cVal |= ((UCHAR)(mux<<2) & R_INFORM_YSEL);
	m_pMem->outb(R_INFORM, cVal);
}

void CDev6801::SetStandard(int value)
{
	UCHAR cVal = m_pMem->inb(R_STD) & ((UCHAR)~R_STD_STD);

	switch(value) {
	case vsStandardNone:
		value = 0x07;
		break;
	case vsStandardNTSC:
		value = 0;
		break;
	case vsStandardPAL:
		value = 1;
		break;
	case vsStandardSECAM:
		value = 2;
		break;
	default:
		value = 0x07;
		break;
	}

	cVal |= (UCHAR)value & R_STD_STD;
	m_pMem->outb(R_STD, 0x07);//cVal);
	if(value == 0x07) {
		m_pMem->outb(R_STDR, 0xFF);
	}
}

void CDev6801::SetFormat(int value)
{
	UCHAR cVal = m_pMem->inb(R_VDMAC) & ((UCHAR)~R_VDMAC_COLORF);
	UCHAR cVal3= 0;
	ULONG hwid = DEVICEID(m_pParent->DeviceInfo().HardwareId);

	switch(value) {
	case vpfRGB15Alpha:
		value = 0x30;
		cVal3 = 0x01;
		break;
	case vpfRGB16:
		value = 0x20;
		cVal3 = 0x01;
		break;
	case vpfRGB24:
		value = 0x10;
		break;
	case vpfYUV422Interspersed:
		value = 0x40;
		break;
	case vpfYUV411Interspersed:
		value = 0x50;
		break;
	default:
		value = 0x40;
		break;
	}
	cVal |= (UCHAR)value & R_VDMAC_COLORF;
	m_pMem->outb(R_VDMAC, cVal);

	cVal = m_pMem->inb(R_VCAPCTL) & ((UCHAR)~R_VCAPCTL_COLORF2);
	cVal |= (UCHAR)value & R_VCAPCTL_COLORF2;
	m_pMem->outb(R_VCAPCTL, cVal);

	if((hwid>=0x6810) && (hwid<0x6814)) {
		cVal = m_pMem->inb(R_VDMAC+2) & 0xFE;
		cVal|= cVal3;
		m_pMem->outb(R_VDMAC+2, cVal);
		cVal = m_pMem->inb(R_VCAPCTL+2) & 0xFE;
		cVal|= cVal3;
		m_pMem->outb(R_VCAPCTL+2, cVal);
	}
}

void CDev6801::SetBright(int value)
{
	int val = 0;
	g_util.map(B_MIN, B_MAX, value, B_MIN_6801, B_MAX_6801, &val);
//	_trace(TEXT("[  ] %03d -> %03d = %02X\n")), value, val, (BYTE)val);
	m_pMem->outb(R_BRIGHT, val);
}

void CDev6801::SetContrast(int value)
{
	int val = 0;
	g_util.map(C_MIN, C_MAX, value, C_MIN_6801, C_MAX_6801, &val);
//	_trace(TEXT("[Աȶ] %03d -> %03d = %02X\n")), value, val, (BYTE)val);
	m_pMem->outb(R_CONTRAST, val);
}

void CDev6801::SetHue(int value)
{
	int val = 0;
	g_util.map(H_MIN, H_MAX, value, H_MIN_6801, H_MAX_6801, &val);
//	_trace(TEXT("[ɫ  ] %03d -> %03d = %02X\n")), value, val, (BYTE)val);
	m_pMem->outb(R_HUE, val);
}

void CDev6801::SetSaturation(int value)
{
	int val = 0;
	g_util.map(S_MIN, S_MAX, value, S_MIN_6801, S_MAX_6801, &val);
//	_trace(TEXT("[Ͷ] %03d -> %03d = %02X\n")), value, val, (BYTE)val);
	m_pMem->outb(R_SATU, val);
	m_pMem->outb(R_SATV, val);
}

void CDev6801::SetSharpness(int value)
{
	int val = 0;
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6801, SH_MAX_6801, &val);
//	_trace(TEXT("[  ] %03d -> %03d = %02X\n")), value, val, (BYTE)val);
	m_pMem->outb(R_VSHARP,	   0x80|val);
}

void CDev6801::SetCaptureField(UCHAR field)
{
	UCHAR val = m_pMem->inb(R_VCAPCTL);
	val &= ~(R_VCAPCTL_CAPEVEN|R_VCAPCTL_CAPODD);
	if(field & VF_Even) {val |= R_VCAPCTL_CAPEVEN;}
	if(field & VF_Odd){val |= R_VCAPCTL_CAPODD;}
	m_pMem->outb(R_VCAPCTL, val);
}

void CDev6801::SetFrameRate(UCHAR field, int value, int standard)
{
	value = (value<<8) / MAX_FRAMERATE(standard);
	if(field & VF_Even) {
		m_pMem->outb(R_VFRAMEDROPCTL+1, (UCHAR)value);
	}
	if(field & VF_Odd) {
		m_pMem->outb(R_VFRAMEDROPCTL, (UCHAR)value);
	}
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev6801::HasSignal()
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	
	BYTE	 vstatus = m_pMem->inb(R_VSTATUS1);
	CPlgvSource* vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	TvSourceInfo vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	BOOL	 bRet = vinfo.signal;
	
	bSignal = !(vstatus & R_VSTATUS1_VDLOSS) && !(vstatus & R_VSTATUS1_NOVIDEO) && (vstatus & R_VSTATUS1_VLOCK);
	if(vinfo.standard == vsStandardPAL) {
		bSignal = bSignal && (vstatus & R_VSTATUS1_HLOCK);
	}
	
	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 2 : 1)) {
//			_trace(TEXT("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			bRet = bSignal;
			OnSignalChanged(bSignal);
		}
	}
	else {
		vinfo.signal_count = 0;
	}
	
	vsource->SetPluginInfo(&vinfo, setSignal);
	
	return bRet;
}

//----------------------------------------------
// ֹ߽fieldж
//----------------------------------------------
void CDev6801::EnableFieldIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_INTMASK);
	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_FIELD) : (value&~R_INT_FIELD));
	m_pMem->outd(R_INTSTAT, R_INT_FIELD);
}

//----------------------------------------------
// ֹ߽Ƶź״̬ж
//----------------------------------------------
void CDev6801::EnableSignalLossIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_INTMASK);
	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_VDLOSS) : (value&~R_INT_VDLOSS));
	m_pMem->outd(R_INTSTAT, R_INT_VDLOSS);
}

//----------------------------------------------
// ֹ߽PCIʱʧƵж
//----------------------------------------------
void CDev6801::EnableFfifoIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_INTMASK);
	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_FFIFO) : (value&~R_INT_FFIFO));
	m_pMem->outd(R_INTSTAT, R_INT_FFIFO);
}

//----------------------------------------------
// DMA programַ
//----------------------------------------------
void CDev6801::SetDmapAddr(ULONG phyAddr)
{
	m_pMem->outd(R_VDMAP_SA, phyAddr);
}

//----------------------------------------------
// ֹ߽DMA programж
//----------------------------------------------
void CDev6801::EnableDmaIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_INTMASK);
	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_VDMAPI|R_INT_DMAPERR) : (value&~(R_INT_VDMAPI|R_INT_DMAPERR)));
	m_pMem->outd(R_INTSTAT, R_INT_VDMAPI|R_INT_DMAPERR);
}

//----------------------------------------------
// ֹ߽PCI errorж
//----------------------------------------------
void CDev6801::EnablePciIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_INTMASK);
	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_PPERR|R_INT_PABORT) : (value&~(R_INT_PPERR|R_INT_PABORT)));
	m_pMem->outd(R_INTSTAT, R_INT_PPERR|R_INT_PABORT);
}

//----------------------------------------------
// ֹ߽GPINTж
//----------------------------------------------
void CDev6801::EnableGpintIrq(UCHAR enable, PCmdIrqInfo irqInfo, PShareData dataShare, PCmdTimerInfo tmiInfo)
{
	ULONG value = m_pMem->ind(R_INTMASK);

	if(enable) {
		//豸жϼ¼
		TCmdIrqInfo irq;
		INIT_IRQINFO(irq);
		irq.deviceId = irqInfo->deviceId;
		irq.irqInfo.irqId	 = irqInfo->irqInfo.irqId;
		irq.irqInfo.mask[0]	 = R_INT_GPINT;
		irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
		irq.irqInfo.regMask[0]  = R_INTMASK;
		irq.irqInfo.regStatus[0]= R_INTSTAT;
		irq.irqInfo.status[0]   = 0;
		irq.irqInfo.regRWBase= (irqInfo->irqInfo.regRWBase==0) ? irq.irqInfo.regBase : irqInfo->irqInfo.regRWBase;
		if(irqInfo->irqInfo.timerId != (ULONG)-1) {
			TCmdTimerInfo tmi;

			irq.irqInfo.timerId  = irqInfo->irqInfo.timerId;
			m_Share->irqData[irq.irqInfo.irqId].dueTime = dataShare->irqData[irq.irqInfo.irqId].dueTime;

			INIT_TIMERINFO(tmi);
			tmi = *tmiInfo;
			for(int i=0; i<MAX_RW_TIMER; i++) {
				m_Share->irqData[irq.irqInfo.irqId].regWriteTimer[i] = dataShare->irqData[irq.irqInfo.irqId].regWriteTimer[i];
			}
			m_pParent->AppendTimer(tmi);
		}

		for(int i=0; i<MAX_RW_NUM; i++) {
			if(irqInfo->irqInfo.regRead[i] != (ULONG)-1) {
				irq.irqInfo.regRead[i]  = irqInfo->irqInfo.regRead[i];
			}
			if(irqInfo->irqInfo.regWrite[i] != (ULONG)-1) {
				irq.irqInfo.regWrite[i] = irqInfo->irqInfo.regWrite[i];
				irq.irqInfo.mskWrite[i] = irqInfo->irqInfo.mskWrite[i];
				m_Share->irqData[irq.irqInfo.irqId].regWrite[i] = dataShare->irqData[irq.irqInfo.irqId].regWrite[i];
			}
		}

		m_pParent->AppendIrq(irq);
	}

	m_pMem->outd(R_INTMASK, enable ? (value|R_INT_GPINT) : (value&~R_INT_GPINT));
	m_pMem->outd(R_INTSTAT, R_INT_GPINT);
}

//----------------------------------------------
// ޸жISRҪдļĴֵ
//----------------------------------------------
void CDev6801::SetGpintIrqShareData(int irqId, int regId, ULONG valWrite)
{
	m_Share->irqData[irqId].regWrite[regId] = valWrite;
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6801::RunDmap(UCHAR run)
{
	ULONG value = m_pMem->ind(R_VDMAC);
	EnablePciIrq(run);

	m_pMem->outd(R_VDMAC, run ? (value|R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN) : (value & ~(R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN)));

	if(run) { 
		EnableDmaIrq(TRUE);
		NotifyLive(0);
		m_ifoOptimize.diff = -1;
	}
	else { 
		m_iDmap = 0;
	}
}
