/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6801.h
 *  @brief		Ƶ豸CDev6801֧TW6801 : СɼһԤ¼ͬɼ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__DEV6801_H_)
#define __DEV6801_H_

#include "Scaler6801.h"
#include "DmaProgram.h"

//6801豸ȵֵķΧ
#define B_MAX_6801		127
#define B_MIN_6801		-128
#define C_MAX_6801		255
#define C_MIN_6801		0
#define S_MAX_6801		255
#define S_MIN_6801		0
#define H_MAX_6801		127
#define H_MIN_6801		-128
#define SH_MAX_6801		7
#define SH_MIN_6801		0

#define TW680X_HDELAY		0x0A
#define TW680X_HDELAY_QCIF	0x16
#define TW680X_VDELAY_PAL	0x18
#define TW680X_VDELAY_NTSC	0x14

class CDev6801 : public CDevBase, public CDmap6801
{
public:
	CDev6801();
	virtual ~CDev6801();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long OnIrq();
	virtual long HasSignal();
	virtual int  DeviceType() {return DEV_video;}

	void  EnableGpintIrq(UCHAR enable, PCmdIrqInfo irqInfo, PShareData dataShare, PCmdTimerInfo tmiInfo);
	void  SetGpintIrqShareData(int irqId, int regId, ULONG valWrite);
	
protected:
	//麯ʼʼ豸
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual BOOL OnClose();

	//豸ƺ
	virtual void Init6801();
	virtual void SetStandard(int value);
	virtual void SetMux(TVideoInput vInput);
	void  SetFormat(int value);
	void  SetBright(int value);
	void  SetContrast(int value);
	void  SetHue(int value);
	void  SetSaturation(int value);
	void  SetSharpness(int value);
	void  SetCaptureField(UCHAR field);
	void  SetFrameRate(UCHAR field, int value, int standard);
	void  EnableFieldIrq(UCHAR enable);
	void  EnableSignalLossIrq(UCHAR enable);
	void  EnableFfifoIrq(UCHAR enable);
	void  EnablePciIrq(UCHAR enable);

	//DMAP
	void  SetDmapAddr(ULONG phyAddr);
	void  EnableDmaIrq(UCHAR enable);
	virtual void RunDmap(UCHAR run);

	CScaler6801*m_oScaler;
	CScaler6801*m_eScaler;
	ULONG		m_tkSignal;
	TMemBlock	m_memDmap;
};

#endif // !defined(__DEV6801_H_)
