/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6802.cpp
 *  @brief		Ƶ豸CDev6802ʵ֣֧TW6802
 *				TW6816/TW6815ֵ֧(mono)8bit16bitʽ,ʿͨaudio clock
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev6802.h"
#include "TW680X.H"
#include "PlgaSource.h"
#include <time.h>

#define IRQ_ADMPAP		0				//audio dma programжʶ
#define IRQ_AERROR		1				//audio errorжʶ

enum {
	apclk = 0,		//pci clock
	avclk,			//video clock XTI
	amclk
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6802::CDev6802()
{
	ZeroMemory(&m_memDmap, sizeof(TMemBlock));
}

CDev6802::~CDev6802()
{

}

//-------------------------------------------
// ڴԴ
//-------------------------------------------
BOOL CDev6802::OnAllocResource()
{
	CSample* pSample = NULL;
	int		 i=0;

	//DMA program
	if(!m_pParent->AllocMemory(ADMAP_LEN, &m_memDmap)) {
		return FALSE;
	}
	
	//DMA audio data
	if(!m_pParent->AllocMemory(RAWA_LEN, &m_memData)) {
		return FALSE;
	}
	
	ZeroMemory(m_memDmap.vaddr, m_memDmap.len);
	SetDmapAddr((ULONG)m_memDmap.pnodes[0].addr);
	SetProgAddr((ULONG)m_memDmap.vaddr, (ULONG)m_memDmap.pnodes[0].addr);
	
	for(i=0; i<RAWA_NUM; i++) {
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6802::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		AppendRawBuffer(pSample);
		m_bufRaw.push_back(pSample);
		pSample->SetType(pktAudio);
	}

	return (i==RAWA_NUM);
}

//-------------------------------------------
// ͷڴԴ
//-------------------------------------------
BOOL CDev6802::OnFreeResource()
{
	CSample* pSample = NULL;

	m_pParent->FreeMemory(&m_memDmap);
	_trace(TEXT("[Ϣ]CDev6802::OnFreeResource()ͷDMAP bufferɹ(slot %d,function 1,device %d)\n"), 
		m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);

	m_pParent->FreeMemory(&m_memData);
	_trace(TEXT("[Ϣ]CDev6802::OnFreeResource()ͷDMA bufferɹ(slot %d,function 1,device %d)\n"), 
		m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
	
	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		delete pSample->Buffer()->pnodes;
		delete pSample;
		m_bufRaw.pop_back();
	}
	
	return TRUE;
}

//-----------------------------------------------------
// ʼ豸
//-----------------------------------------------------
BOOL CDev6802::OnOpen()
{
	TCmdIrqInfo		irq;
	
	ZeroMemory(m_Share, sizeof(TShareData));

	SelectRefClock((UCHAR)avclk);
	//SetSampleRate(33000000, SAMPLE_RATE);	//PCI clock reference
	//SetSampleRate(66000000, SAMPLE_RATE);	//PCI clock reference
	SetSampleRate(27000000, SAMPLE_RATE);	//video clock XTI

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ADMPAP;
	irq.irqInfo.mask[0]	 = R_AINT_ADMAPI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_AINTMASK;
	irq.irqInfo.regStatus[0]= R_AINTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[0] = R_ADMAP_EXE;
	m_pParent->AppendIrq(irq);

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_AERROR;
	irq.irqInfo.mask[0]	 = R_AINT_ADMAPERR|R_AINT_PPERR|R_AINT_PABORT|R_AINT_AFOVFI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_AINTMASK;
	irq.irqInfo.regStatus[0]= R_AINTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regWrite[0]= R_AINTMASK;
	irq.irqInfo.regWrite[1]= R_ADMAC;
	irq.irqInfo.mskWrite[0]= R_AINT_ADMAPERR|R_AINT_PPERR|R_AINT_PABORT|R_AINT_AFOVFI;
	irq.irqInfo.mskWrite[1]= R_ADMAC_ADMAP_EN|R_ADMAC_AFIFO_EN;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

//-----------------------------------------------------
// ʼ豸
//-----------------------------------------------------
BOOL CDev6802::OnClose()
{
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6802::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}

	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ADMPAP;
	irq.irqInfo.mask[0]	 = R_AINT_ADMAPI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_AINTMASK;
	irq.irqInfo.regStatus[0]= R_AINTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_AERROR;
	irq.irqInfo.mask[0]	 = R_AINT_ADMAPERR|R_AINT_PPERR|R_AINT_PABORT|R_AINT_AFOVFI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_AINTMASK;
	irq.irqInfo.regStatus[0]= R_AINTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	return TRUE;
}

//-----------------------------------------------------
// ׼豸紴dma program
//-----------------------------------------------------
long CDev6802::PrepareRun()
{
	UINT i;
	TaDmaProgInfo aDpi;
	CPlgaSource* asource;
	TaSourceInfo ainfo;
	
	if((m_chlList.size()==0) || (m_splList.size()==0)) { return FALSE; }

	CSample*  spl = NULL;
	PMemBlock pmb = NULL;
	PMemNode  pmn = NULL;
	ULONG	  apl = AUDIO_PAGE_LEN;
	for(i=0; i<m_splList.size(); i++) {
		spl = m_splList[i];
		if(spl->Buffer()->inode > 0) { break; }
		pmn = new TMemNode;
		pmn->len   = m_nAudioPktLen;//AUDIO_PACKET_LEN;
		pmn->addr  = (PVOID)((ULONG)m_memData.pnodes[0].addr + i*apl);
		pmb		   = spl->Buffer();
		pmb->vaddr = (PVOID)((ULONG)m_memData.vaddr + i*apl);
		pmb->inode = 1;
		pmb->pnodes= pmn;
	}

	m_iCurSample= 0;
	m_pSample	= m_splList[m_iCurSample];
	m_iChannel  = (m_iChannel+1) % m_chlList.size();
	aDpi.memBuf	= m_pSample->Buffer();
	aDpi.irq	= TRUE;
	aDpi.lines	= AUDIO_LINE_NUM;
	aDpi.line_w = m_nAudioPktLen;//AUDIO_LINE_LEN;

	asource = (CPlgaSource*)m_chlList[m_iChannel]->Plugin(PLG_asource);
	ainfo = *(PaSourceInfo)asource->GetPluginInfo();
	if(ainfo.reset & DEVSET_volume) {
		//SetVolume(ainfo.volume);
		ainfo.reset &= ~DEVSET_volume;
	}
	ainfo.reset = 0;
	asource->SetPluginInfo(&ainfo, ASRC_reset);

	if(!Build(&aDpi)) {	return FALSE; }

	for(i=0; i<m_splList.size(); i++) {
		m_splList[i]->SetChannel(m_chlList[m_iChannel]);
		m_splList[i]->SetFlag(PLG_asource);
	}
	
	return TRUE;
}

//-----------------------------------------------------
// жϴ
//-----------------------------------------------------
long CDev6802::OnIrq()
{
	long isData = -1;

	//DMAPж
	if(m_Share->irqData[IRQ_ADMPAP].evtId != evt_None) {
		if(m_Share->irqData[IRQ_ADMPAP].status[0] & R_AINT_ADMAPI) {
			isData = TRUE;
			m_iDmap = m_Share->irqData[IRQ_ADMPAP].irqCount;
			m_pSample = m_bufRaw[0];
		}

		m_Share->irqData[IRQ_ADMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_ADMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_ADMPAP].irqCount=0;
	}

	if(m_Share->irqData[IRQ_AERROR].evtId != evt_None) {
		TDeviceState state = GetState();
		if(m_Share->irqData[IRQ_AERROR].status[0] & R_AINT_ADMAPERR) {
			//dma programд󣬵ȻݣΪʱһҲADMAPж
			isData = TRUE;
			if(state == DEVSTAT_running) {
				//жISRֹͣУ
				EnableDmaIrq(FALSE);
				RunDmap(0);
				if(m_pSample) {
					//ͷŵǰʹõbuffer
					m_pSample->ClearFlag(PLG_asource);
					InterlockedExchange((PLONG)&m_pSample, NULL);
				}
				SetState(DEVSTAT_readyrun);
				_trace(TEXT("[Ϣ]CDev6802::OnIrqͨ%d豸(slot %d%d豸%d)dmaperr\n"), 
					m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
			}
		}

		//Audio fifo
		if(m_Share->irqData[IRQ_AERROR].status[0] & R_AINT_AFOVFI) {
			//жISRֹͣУ
			if(state == DEVSTAT_running) {
				EnableDmaIrq(FALSE);
				RunDmap(0);
				if(m_pSample) {
					//ͷŵǰʹõbuffer
					m_pSample->ClearFlag(PLG_asource);
					InterlockedExchange((PLONG)&m_pSample, NULL);
				}
				SetState(DEVSTAT_readyrun);
				_trace(TEXT("[Ϣ]CDev6802::OnIrqͨ%d豸(slot %d1豸%d)Audio fifo\n"), 
					m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
			}
		}

		//PCI߲У
		if(m_Share->irqData[IRQ_AERROR].status[0] & R_AINT_PPERR) {
			if(state == DEVSTAT_running) {
				EnableDmaIrq(FALSE);
				RunDmap(0);
				if(m_pSample) {
					//ͷŵǰʹõbuffer
					m_pSample->ClearFlag(PLG_asource);
					InterlockedExchange((PLONG)&m_pSample, NULL);
				}
				SetState(DEVSTAT_readyrun);
			}
			_trace(TEXT("[Ϣ]CDev6802::OnIrqͨ%d豸(slot %d1豸%d)PCI PERR\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}

		//PCI߲abort
		if(m_Share->irqData[IRQ_AERROR].status[0] & R_AINT_PABORT) {
			if(state == DEVSTAT_running) {
				EnableDmaIrq(FALSE);
				RunDmap(0);
				if(m_pSample) {
					//ͷŵǰʹõbuffer
					m_pSample->ClearFlag(PLG_asource);
					InterlockedExchange((PLONG)&m_pSample, NULL);
				}
				SetState(DEVSTAT_readyrun);
			}
			_trace(TEXT("[Ϣ]CDev6802::OnIrqͨ%d豸(slot %d1豸%d)PCI ABORT\n"), 
				m_chlList[m_iChannel]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}

		m_Share->irqData[IRQ_AERROR].evtId   = evt_None;
		m_Share->irqData[IRQ_AERROR].status[0]  = 0;
		m_Share->irqData[IRQ_AERROR].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6802::OnData()
{
	CChannel* chnl = NULL;
	CPlugin*  plgSource = NULL;
	CSample*  dspl = NULL;
	PMemBlock src  = NULL;
	PMemBlock dst  = NULL;
	BOOL	  ret  = FALSE;
	UINT	  i, iCurSample, nOld = m_iCurSample;

	if(m_splList.size() == 0) { return FALSE; }
	if(m_pSample == NULL) { return FALSE; }

	if(m_Share->irqData[IRQ_ADMPAP].regRead[0] != 0) {
		//R_ADMAP_EXEжѾpacketַ
		for(i=0; i<m_splList.size(); i++) {
			if((m_Share->irqData[IRQ_ADMPAP].regRead[0] >= (ULONG)m_splList[i]->Buffer()->pnodes[0].addr) &&
			   (m_Share->irqData[IRQ_ADMPAP].regRead[0] <= (((ULONG)m_splList[i]->Buffer()->pnodes[0].addr)+m_nAudioPktLen))) {
				iCurSample = (i==0) ? (UINT)(m_splList.size()-1) : i-1;
			}
		}
		if(iCurSample!=nOld) {
			_trace(TEXT("ch %d old=%d, cur %d\n"), m_chlList[0]->ChannelId(), nOld, iCurSample);
			//жʧ
			return FALSE;
		}
		m_iCurSample = iCurSample;
	}
	if(m_iDmap > (m_splList.size()-1)) {
		m_iCurSample = (int)((m_iCurSample + (m_iDmap - (m_splList.size()-1))) % m_splList.size());
		m_iDmap = (ULONG)(m_splList.size()-1);
	}

	for(i=0; i<m_iDmap; i++) {
		dspl=g_bufPlgA.usefor(PLG_asource, NULL);
		
		m_pSample = m_splList[m_iCurSample];
		m_iCurSample = (m_iCurSample+1) % m_splList.size();
		if(dspl==NULL) { continue; }

		chnl = m_pSample->GetChannel();
		src=m_pSample->Buffer();
		dst=dspl->Buffer();
		dspl->SetTimeStamp(timestamp());
		dspl->SetDataSize(m_nAudioPktLen);
		dspl->SetChannel(chnl);
		memcpy(dst->vaddr, src->vaddr, m_nAudioPktLen);
		
		if(chnl) {
			plgSource = chnl->Plugin(PLG_asource);
			if(plgSource) {
				ret = plgSource->Transmit(dspl, NULL);
			}
		}
		dspl->ClearFlag(PLG_asource);
	}

	m_pSample = NULL;

	return ret;
}

//----------------------------------------------
// ѡƵɼοʱ
//----------------------------------------------
void CDev6802::SelectRefClock(UCHAR ref_clk)
{
	UCHAR val = m_pMem->inb(R_ACLKS);
	val &= ~R_ACLKS_ACLKSEL;
	val |= ref_clk;
	m_pMem->outb(R_ACLKS,	  val);
}

//----------------------------------------------
// ò
//----------------------------------------------
void CDev6802::SetSampleRate(ULONG clk_ref, ULONG sample_rate)
{
	ULONG hwid = DEVICEID(m_pParent->DeviceInfo().HardwareId);
	ULONGLONG val = 0x1000000;

	if((clk_ref>=33000000) && (clk_ref<=66000000)) {
		if((hwid>=0x6814) && (hwid<=0x6817)) {
			val = (val * 256) / clk_ref;
			sample_rate = (ULONG)(val * sample_rate);
			m_pMem->outd(R_ACORE, sample_rate);
		}
		else {
			sample_rate = ((1<<31) / clk_ref) * sample_rate; //(2<<24) * sample_rate * 128 / 33000000;
			m_pMem->outd(R_APCICLKR, sample_rate);
		}
	}
	else if((hwid>=0x6814) && (hwid<=0x6817)) {
 		m_pMem->outd(R_AVCLKR, 0x00136B07);
	}
	else {
		sample_rate = ((1<<31) / clk_ref) * sample_rate; //(2<<24) * sample_rate * 128 / 33000000;
		m_pMem->outd(R_AVCLKR, sample_rate);
	}
}

void CDev6802::SetBitcount(int bitcount)
{
	ULONG tmp = m_pMem->ind(R_ACTL2);
	if(bitcount == 8) {
		tmp &= ~BIT(4);
	}
	else {
		tmp |= BIT(4);
	}
	m_pMem->outd(R_ACTL2, tmp);
}

void CDev6802::SetVolume(int volume)
{
	volume &= 0xFF;
	m_pMem->outb(R_AGAIN, (BYTE)volume);
}

//----------------------------------------------
// DMA programַ
//----------------------------------------------
void CDev6802::SetDmapAddr(ULONG phyAddr)
{
	m_pMem->outd(R_ADMAP_SA, phyAddr);
}

//----------------------------------------------
// ֹ߽DMA programж
//----------------------------------------------
BOOL CDev6802::EnableDmaIrq(BOOL enable)
{
	ULONG value = m_pMem->ind(R_AINTMASK);
	m_pMem->outd(R_AINTMASK, enable ? (value|R_AINT_ADMAPI|R_AINT_ADMAPERR) : 
									   (value&~(R_AINT_ADMAPI|R_AINT_ADMAPERR)));
	m_pMem->outd(R_AINTSTAT, R_AINT_ADMAPI|R_AINT_ADMAPERR);

	return TRUE;
}

//----------------------------------------------
// ֹ߽fifoж
//----------------------------------------------
void CDev6802::EnableFifoIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_AINTMASK);
	m_pMem->outd(R_AINTMASK, enable ? (value|R_AINT_AFOVFI) : 
									   (value&~R_AINT_AFOVFI));
	m_pMem->outd(R_AINTSTAT, R_AINT_AFOVFI);
}

//----------------------------------------------
// ֹ߽PCI errorж
//----------------------------------------------
void CDev6802::EnablePciIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_AINTMASK);
	m_pMem->outd(R_AINTMASK, enable ? (value|R_AINT_PPERR|R_AINT_PABORT) : 
									   (value&~(R_AINT_PPERR|R_AINT_PABORT)));
	m_pMem->outd(R_AINTSTAT, R_AINT_PPERR|R_AINT_PABORT);
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6802::RunDmap(UCHAR run)
{
	ULONG value = m_pMem->ind(R_ADMAC);
	m_pMem->outb(R_ARSTN, run ? R_ARSTN_ARSTN:0);
	EnablePciIrq(run);
	m_pMem->outd(R_ADMAC, run ? (value|R_ADMAC_ADMAP_EN|R_ADMAC_AFIFO_EN) : 
					(value & ~(R_ADMAC_ADMAP_EN|R_ADMAC_AFIFO_EN)));
	m_pSample = NULL;	
}
