/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6802.h
 *  @brief		Ƶ豸CDev6802֧TW6802
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__DEV6802_H_)
#define __DEV6802_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DevBase.h"
#include "DmaProgram.h"

class CDev6802 : public CDevBase, public CDmap6802
{
public:
	CDev6802();
	virtual ~CDev6802();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long OnIrq();
	virtual int  DeviceType(){return DEV_audio;}
	virtual long Pause(BOOL enable){ return 0; }
	virtual BOOL EnableDmaIrq(BOOL enable);

protected:
	//麯ʼʼ豸
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual BOOL OnClose();
	virtual void RunDmap(UCHAR run);

	//豸ƺ
	void  SelectRefClock(UCHAR ref_clk);
	void  SetSampleRate(ULONG clk_ref, ULONG sample_rate);
	void  SetBitcount(int bitcount);
	void  SetVolume(int volume);

	//DMAP
	void  SetDmapAddr(ULONG phyAddr);
	void  EnablePciIrq(UCHAR enable);
	void  EnableFifoIrq(UCHAR enable);

	TMemBlock	m_memDmap;
	TMemBlock	m_memData;
	int			m_iCurSample;
};

#endif // !defined(__DEV6802_H_)
