/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6803.cpp
 *  @brief		Ƶ豸CDev6803ʵ֣֧TW6803 : for TW6802B TS function
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev6803.h"
#include "TW680X.H"
#include "Dev6801.h"
#include "PlgvSource.h"
#include <mmsystem.h>
#include "Gpio.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6803::CDev6803() :
m_tkSignal(0),
m_nFirstLineStart(0x9A),
m_nLineStart(0xA0)
{
}

CDev6803::~CDev6803()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6803::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	PMemBlock memDmap = NULL;
	
	for(i=0; i<RAWV_NUM; i++) {
		memDmap = new TMemBlock;
		if(memDmap && m_pParent->AllocMemory(DMAP_LEN, memDmap)) {
			m_listDmap.push_back(memDmap);
		}
		else {
			SAFE_DELETE(memDmap);
			return FALSE;
		}
		
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6803::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6803::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	SetDmapAddr((ULONG)m_listDmap[0]->pnodes[0].addr);
	SetProgAddr((ULONG)m_listDmap[0]->vaddr, (ULONG)m_listDmap[0]->pnodes[0].addr);

	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6803::OnFreeResource()
{
	CSample* pSample = NULL;

	for(UINT i=0; i<m_listDmap.size(); i++) {
		m_pParent->FreeMemory(m_listDmap[i]);
		delete m_listDmap[i];
	}
	m_listDmap.clear();
	_trace(TEXT("[Ϣ]CDev6803::OnFreeResource()ͷDMAP bufferɹ(slot %d,function 2,device %d)\n"), 
		m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		m_pParent->FreeMemory(pSample->Buffer());
		_trace(TEXT("[Ϣ]CDev6803::OnFreeResource()ͷDMA bufferɹ(slot %d,function 2,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		delete pSample;
		m_bufRaw.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6803::OnOpen()
{
	TCmdIrqInfo	irq;

	ZeroMemory(m_Share, sizeof(TShareData));

	for(UINT i=0; i<g_devListV.size(); i++) {
		if((g_devListV[i]->Parent()->DeviceInfo().nBoardId==m_pParent->DeviceInfo().nBoardId) &&
		   (g_devListV[i]->Parent()->DeviceInfo().DeviceNumber==m_pParent->DeviceInfo().DeviceNumber)) {
			SetI2C((CI2C*)g_devListV[i]->Parent()->GetI2C());
			break;
		}
	}

	//ʼDecoder
	InitDecoder();
	
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			SetMux((TVideoInput)viInput);
			break;
		}
	}
	
	SetStandard(TvSourceInfo::default_standard);
	SetFormat(vpfYUV422Interspersed);
	
	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_TINTSTAT_TDMAPI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_TINTMASK;
	irq.irqInfo.regStatus[0]= R_TINTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regWrite[0]= R_TDMAC;
	irq.irqInfo.mskWrite[0]= R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
	irq.irqInfo.regWrite[1]= R_VDMAP_SA;
	irq.irqInfo.mskWrite[1]= 0xFFFFFFFF;
	irq.irqInfo.regRead[0] = R_VDMAP_SA;
	m_pParent->AppendIrq(irq);

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_TINTSTAT_TDMAPERR|R_TINTSTAT_PPERR|R_TINTSTAT_PABORT|R_TINTSTAT_TFOVFI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_TINTMASK;
	irq.irqInfo.regStatus[0]= R_TINTSTAT;
	irq.irqInfo.regClear[0] = irq.irqInfo.regStatus[0];
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regWrite[0]= R_TINTMASK;//(ULONG)-1;
	irq.irqInfo.regWrite[1]= R_TDMAC;//(ULONG)-1;
	irq.irqInfo.mskWrite[0]= R_TINTSTAT_TDMAPERR|R_TINTSTAT_PPERR|R_TINTSTAT_PABORT|R_TINTSTAT_TFOVFI;
	irq.irqInfo.mskWrite[1]= R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
	m_pParent->AppendIrq(irq);
	
	m_Share->irqData[IRQ_DMPAP].regWrite[0] = 0;
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = 0;

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6803::OnClose()
{
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6803::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	UninitDecoder();
	
	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = R_TINTSTAT_TDMAPI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_TINTMASK;
	irq.irqInfo.regStatus[0]= R_TINTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);

	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_ERROR;
	irq.irqInfo.mask[0]	 = R_TINTSTAT_TDMAPERR|R_TINTSTAT_PPERR|R_TINTSTAT_PABORT|R_TINTSTAT_TFOVFI;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = R_TINTMASK;
	irq.irqInfo.regStatus[0]= R_TINTSTAT;
	irq.irqInfo.status[0]   = 0;
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

//----------------------------------------------
// DMA programַ
//----------------------------------------------
void CDev6803::SetDmapAddr(ULONG phyAddr)
{
	m_pMem->outd(R_TDMAP_SA, phyAddr);
}

//----------------------------------------------
// ֹ߽DMA programж
//----------------------------------------------
void CDev6803::EnableDmaIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_TINTMASK);
	m_pMem->outd(R_TINTMASK, enable ? (value|R_TINTSTAT_TDMAPI/*|R_TINTSTAT_TDMAPERR*/) : (value&~(R_TINTSTAT_TDMAPI|R_TINTSTAT_TDMAPERR)));
	m_pMem->outd(R_TINTSTAT, R_TINTSTAT_TDMAPI|R_TINTSTAT_TDMAPERR);
}

//----------------------------------------------
// ֹ߽PCI errorж
//----------------------------------------------
void CDev6803::EnablePciIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_TINTMASK);
	m_pMem->outd(R_TINTMASK, enable ? (value|R_TINTSTAT_PPERR|R_TINTSTAT_PABORT) : (value&~(R_TINTSTAT_PPERR|R_TINTSTAT_PABORT)));
	m_pMem->outd(R_INTSTAT, R_TINTSTAT_PPERR|R_TINTSTAT_PABORT);
}

//----------------------------------------------
// ֹ߽PCIʱʧƵж
//----------------------------------------------
void CDev6803::EnableFfifoIrq(UCHAR enable)
{
	ULONG value = m_pMem->ind(R_TINTMASK);
	m_pMem->outd(R_TINTMASK, enable ? (value|R_TINTSTAT_TFOVFI) : (value&~R_TINTSTAT_TFOVFI));
	m_pMem->outd(R_TINTSTAT, R_TINTSTAT_TFOVFI);
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6803::RunDmap(UCHAR run)
{
	ULONG value = m_pMem->ind(R_TDMAC);
	EnablePciIrq(run);
	
	m_pMem->outd(R_TDMAC, run ? (value|R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN) : (value & ~(R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN)));
	
	if(run) { 
		NotifyLive(0); 
	}
	else { 
		m_iDmap = 0;
	}
}

void CDev6803::SetSize(int width, int height)
{
	TDeviceDesc	  devInfo;
	CGpio*		  gpio = NULL;
	ULONG		  val = 0, i;

	for(i=0; i<g_devListV.size(); i++) {
		devInfo = g_devListV[i]->Parent()->DeviceInfo();
		if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==0)) {
			gpio = (CGpio*)g_devListV[i]->Parent()->GetGPIO();
			break;
		}
	}

	if(width == 352) {
		m_nFirstLineStart = 0x9B;
		m_nLineStart = 0xA0;
		if(gpio) {
			val = 0;
			gpio->EnableGpioOutput(true, 0, 1);
			gpio->SetGpioBits(0, 1, &val);
		}
		for(i=0; i<m_bufRaw.size(); i++) {
			ULONG flag = m_bufRaw[i]->Flag();
			if(flag!=0) {
				m_bufRaw[i]->ClearFlag(flag);
			}
			m_bufRaw[i]->SetDataOffset(0);
		}
	}
	else if(width == 320) {
		m_nFirstLineStart = 0x9A;
		m_nLineStart = 0xE0;
		if(gpio) {
			val = 0;
			gpio->EnableGpioOutput(true, 0, 1);
			gpio->SetGpioBits(0, 1, &val);
		}
		for(i=0; i<m_bufRaw.size(); i++) {
			ULONG flag = m_bufRaw[i]->Flag();
			if(flag!=0) {
				m_bufRaw[i]->ClearFlag(flag);
			}
			m_bufRaw[i]->SetDataOffset(0);
		}
	}
	else if(width == 704) {
		m_nFirstLineStart = 0x12C;
		m_nLineStart = 0x140;
		if(gpio) {
			val = 1;
			gpio->EnableGpioOutput(true, 0, 1);
			gpio->SetGpioBits(0, 1, &val);
		}
		//2CIF ɼʱʱλе࣬ɼƫ3ֽ
		for(i=0; i<m_bufRaw.size(); i++) {
			ULONG flag = m_bufRaw[i]->Flag();
			if(flag!=0) {
				m_bufRaw[i]->ClearFlag(flag);
			}
			m_bufRaw[i]->SetDataOffset(3);
		}
	}
	else if(width == 176) {
		m_nFirstLineStart = 0x9A;
		m_nLineStart = 0x200;
		if(gpio) {
			val = 0;
			gpio->EnableGpioOutput(true, 0, 1);
			gpio->SetGpioBits(0, 1, &val);
		}
		for(i=0; i<m_bufRaw.size(); i++) {
			ULONG flag = m_bufRaw[i]->Flag();
			if(flag!=0) {
				m_bufRaw[i]->ClearFlag(flag);
			}
			m_bufRaw[i]->SetDataOffset(0);
		}
	}
}

//-----------------------------------------------------
// 豸
//-----------------------------------------------------
BOOL CDev6803::Run()
{
	if(GetState() == DEVSTAT_readystop) {
		return FALSE;
	}

	//RunDmap(1);
	TDeviceDesc devInfo;
	for(UINT i=0; i<g_devListV.size(); i++) {
		devInfo = g_devListV[i]->Parent()->DeviceInfo();
		if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==0)) {
			TCmdIrqInfo   irq;
			TCmdTimerInfo tmi;
			TShareData dataShare;

			ZeroMemory(&dataShare, sizeof(TShareData));
			INIT_TIMERINFO(tmi);
			INIT_IRQINFO(irq);
			irq.deviceId = m_iDev;
			tmi.deviceId = m_iDev;
			irq.irqInfo.irqId	 = IRQ_FIELD;
			irq.irqInfo.mask[0]	 = 0;
			irq.irqInfo.regBase  = 0;
			irq.irqInfo.regMask[0]  = 0;
			irq.irqInfo.regStatus[0]= 0;
			irq.irqInfo.status[0]   = 0;
			irq.irqInfo.regRWBase= (ULONG)m_pMem->CpuBaseAddress();
#if(1)
			irq.irqInfo.regWrite[0] = R_TDMAC;
			irq.irqInfo.mskWrite[0] = R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
			dataShare.irqData[irq.irqInfo.irqId].regWrite[0] = R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
#else
			irq.irqInfo.timerId  = irq.irqInfo.irqId;
			tmi.tmiInfo.timerId	 = irq.irqInfo.irqId;
			tmi.tmiInfo.regBase  = irq.irqInfo.regRWBase;
			tmi.tmiInfo.dueTime  = -10*10000;
			tmi.tmiInfo.regWrite[0] = R_TDMAC;
			tmi.tmiInfo.mskWrite[0] = R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
			dataShare.irqData[irq.irqInfo.irqId].regWriteTimer[0] = R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
			dataShare.irqData[irq.irqInfo.irqId].dueTime = 20000;
#endif
			((CDev6801*)g_devListV[i])->EnableGpintIrq(TRUE, &irq, &dataShare, &tmi);
			break;
		}
	}

	EnableDmaIrq(TRUE);
	SetState(DEVSTAT_running);

	return TRUE;
}

//-----------------------------------------------------
// ֹͣ豸
//-----------------------------------------------------
BOOL CDev6803::Stop()
{
	TDeviceDesc devInfo;
	for(UINT i=0; i<g_devListV.size(); i++) {
		devInfo = g_devListV[i]->Parent()->DeviceInfo();
		if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==0)) {
			((CDev6801*)g_devListV[i])->EnableGpintIrq(FALSE, NULL, NULL, NULL);
			break;
		}
	}

	return CDevBase::Stop();
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6803::PrepareRun()
{
	TvDmaProgInfo dpi;
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource = NULL;
	CSample*	  pSample = NULL;
	ULONG		  flagReset = 0;
	UINT		  i;
	
	if(m_chlList.size()==0) { return FALSE; }

	vsource = (CPlgvSource*)m_chlList[0]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();

	//豸Ҫ
	if(vinfo.reset & DEVSET_property) {
		SetBright(vinfo.brightness);
		SetContrast(vinfo.contrast);
		SetSaturation(vinfo.saturation);
		SetHue(vinfo.hue);
		SetSharpness(vinfo.sharpness);
	}
	
	if(vinfo.reset & DEVSET_devreset) {
		flagReset |= (vinfo.reset&DEVSET_devreset);
	}

	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}

	if(flagReset == 0) {
		return TRUE; 
	}
	
	vinfo.frame_rate_cnt = m_chlList[0]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

	//dma program
	dpi.height= vinfo.capture.height;
	dpi.pitch = vinfo.capture.pitch;
	dpi.lineSize  = vinfo.capture.pitch;
	dpi.width = vinfo.capture.width;
	dpi.offset= 0;
	dpi.memBuf= NULL;
	dpi.offset = 0;
	SetStandard(vinfo.standard);
	SetSize(vinfo.capture.width, vinfo.capture.height);

	OnBufferFull(m_chlList[m_iChannel], IS_4CIF(vinfo), m_iChannel*RAWV_NUM, (m_iChannel+1)*RAWV_NUM);

	//dma program
	for(i=0; i<m_listDmap.size(); i++) {
		pSample = m_bufRaw[i];
		pSample->SetChannel(m_chlList[0]);
		SetProgAddr((ULONG)m_listDmap[i]->vaddr, (ULONG)m_listDmap[i]->pnodes[0].addr, DMAP_LEN);
		dpi.memBuf = pSample->Buffer();
		if(!Build(i, &dpi)) {
			return FALSE;
		}
	}

	i = 1 % m_listDmap.size();
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_listDmap[i]->pnodes[0].addr;

	return (TRUE+TRUE);
}

void CDev6803::OnGpint()
{
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;

	vsource = (CPlgvSource*)m_chlList[0]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

	TDeviceDesc devInfo;
	BOOL		bSkip = !((vinfo.capture.frame_rate_mask>>vinfo.frame_rate_cnt) & 0x01);
	for(UINT i=0; i<g_devListV.size(); i++) {
		devInfo = g_devListV[i]->Parent()->DeviceInfo();
		if((devInfo.nBoardId==m_pParent->DeviceInfo().nBoardId) && (devInfo.DeviceNumber==m_pParent->DeviceInfo().DeviceNumber) && (devInfo.Function==0)) {
			((CDev6801*)g_devListV[i])->SetGpintIrqShareData(IRQ_FIELD, 0, bSkip ? 0 : R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN);
			break;
		}
	}
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6803::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0;
	UINT  i = 0;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[0]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();

		//ź״̬
		isData = FALSE;
		if(m_Share->irqData[IRQ_DMPAP].status[0] & R_TINTSTAT_TDMAPI) {
			dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[0];
			for(i=0; i<m_listDmap.size(); i++) {
				if((ULONG)m_listDmap[i]->pnodes[0].addr == dmapAddr) {
					m_pSample = m_bufRaw[i];
					m_pSample->SetFlag(PLG_vsource);
					m_pSample->SetTimeStamp(timestamp());
					m_pSample->SetChannel(m_chlList[0]);
					m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					isData = TRUE;
					m_iDmap = i;
					break;
				}
			}

			i = (m_iDmap+2) % m_listDmap.size();
			m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_listDmap[i]->pnodes[0].addr;
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	if(m_Share->irqData[IRQ_ERROR].evtId != evt_None) {
		isData = FALSE;
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_TINTSTAT_TDMAPERR) {
			//dma programд
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev6803::OnIrqͨ%d豸(slot %d%d豸%d)dmaperr\n"), 
				m_chlList[0]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
		}

		if(m_Share->irqData[IRQ_ERROR].status[0] & R_TINTSTAT_PABORT) {
			//dma programд,ֹͣȻ´
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
			isData = -1;
			_trace(TEXT("[Ϣ]CDev6803::OnIrqͨ%d豸(slot %d%d豸%d)pci abort\n"), 
				m_chlList[0]->ChannelId(), m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
		}
		
		//fifoݶʧ
		if(m_Share->irqData[IRQ_ERROR].status[0] & R_TINTSTAT_TFOVFI) {
			_trace(TEXT("[Ϣ]ͨ%02dݶʧ\n"), m_chlList[0]->ChannelId());
		}

		m_Share->irqData[IRQ_ERROR].evtId   = evt_None;
		m_Share->irqData[IRQ_ERROR].status[0]  = 0;
		m_Share->irqData[IRQ_ERROR].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6803::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
	
	if(m_pSample==NULL) { return FALSE; }

	try {
		NotifyLive(timeGetTime());
		m_pSample->SetTimeStamp(timestamp());
		chl = m_pSample->GetChannel();
		if(chl) {
			plg = chl->Plugin(PLG_vsource);
			ret = plg->Transmit(m_pSample, NULL);
		}
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6803::OnData()쳣!"));
	}

	m_pSample->ClearFlag(PLG_vsource);
	m_pSample = NULL;
	
	return ret;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev6803::HasSignal()
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	
	CPlgvSource* vsource = (CPlgvSource*)m_chlList[0]->Plugin(PLG_vsource);
	TvSourceInfo vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	BOOL	 bRet = vinfo.signal;
	
	bSignal = GetSignal();
	
	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 5 : 1)) {
//			_trace(TEXT("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			bRet = bSignal;
		}
	}
	else {
		vinfo.signal_count = 0;
	}
	
	vsource->SetPluginInfo(&vinfo, setSignal);
	
	return bRet;
}

/** 
 ***************************************************************************************
 *  ָDMA program
 *  @param[in] iField
 *  @param[in] dpiDMA programϢַ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6803::Build(int iField, TvDmaProgInfo* dpi)
{
	ULONG*	dmap = (ULONG*) m_virProg;
	ULONG	ip	 = 0;
	ULONG	phyWrite; 
	ULONG	lineSize, stride;

	ZeroMemory(dmap, DMAP_LEN);

	if(dpi->memBuf == NULL) {
		return TRUE;
	}

#if(0)
	lineSize = dpi->lineSize/4;
	stride   = dpi->pitch;
	phyWrite = (ULONG)dpi->memBuf->pnodes[0].addr + dpi->offset;

	for(int i=0; i<dpi->height; i++) {
		dmap[ip++] = DMAP_WRITE | DMAP_SOL | DMAP_STARTINGBYTE((i>0)?m_nLineStart:m_nFirstLineStart) | lineSize;
		dmap[ip++] = phyWrite;
		phyWrite += lineSize;

		dmap[ip++] = DMAP_WRITE | DMAP_SOL | lineSize;
		dmap[ip++] = phyWrite;
		phyWrite += lineSize;

		dmap[ip++] = DMAP_WRITE | DMAP_SOL | lineSize;
		dmap[ip++] = phyWrite;
		phyWrite += lineSize;

		dmap[ip++] = DMAP_WRITE | DMAP_SOL | lineSize;
		dmap[ip++] = phyWrite;
		phyWrite += lineSize;
	}
#else
	lineSize = dpi->lineSize;
	stride   = dpi->pitch;
	phyWrite = (ULONG)dpi->memBuf->pnodes[0].addr + dpi->offset;
	
	for(int i=0; i<dpi->height; i++) {
		dmap[ip++] = DMAP_WRITE | DMAP_SOL | DMAP_STARTINGBYTE((i>0)?m_nLineStart:m_nFirstLineStart) | lineSize;
		dmap[ip++] = phyWrite;
		phyWrite += lineSize;
	}
#endif

	dmap[ip++] = DMAP_DUMMY | DMAP_IRQ;
	dmap[ip++] = 0;

	return TRUE;
}
