/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864.h
 *  @brief		豸CDev6864֧TW6864
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev6864.h"
#include "TW686X.h"
#include "TW6864.h"
#include "Sample.h"
#include "PlgvSource.h"
#include <mmsystem.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864::CDev6864() :
m_iCheck(0),
m_iBadFrames(0),
m_tkLast(0)
{
}

CDev6864::~CDev6864()
{

}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			m_pParent->FreeMemory(pSample->Buffer());
			_trace(TEXT("[Ϣ]CDev6864::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6864::OnClose()
{
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6864::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev);
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

BOOL CDev6864::OnDmaError(ULONG status1, ULONG status2, PVOID ctx)
{
	BOOL bBadFrame = (status1 & (TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev))) != 0;
	BOOL bTimeOut  = status2 & (TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_ERR(m_iDev));

	if(status1 & TW6864_R_DMA_VINT_FIFO(m_iDev)) {
		//ע:Y41PʽΪ720ʱǻTW6864_R_DMA_VINT_FIFO(m_iDev)
		PvSourceInfo vinfo = (PvSourceInfo)ctx;
		if((vinfo->capture.pixel_format==vpfYUV411Interspersed) || (vinfo->preview.pixel_format==vpfYUV411Interspersed)) {
			if(vinfo->capture.width>704) {
				bBadFrame = FALSE;
			}
			else if(!IS_PAL(vinfo->standard) && (vinfo->capture.width==352) && (vinfo->capture.height==240))
			{
				bBadFrame = FALSE;
			}
			if(vinfo->frame_run & frame_preview) {
				if(vinfo->preview.width>704) {
					bBadFrame = FALSE;
				}
				else if(!IS_PAL(vinfo->standard) && (vinfo->preview.width==352) && (vinfo->preview.height==240))
				{
					bBadFrame = FALSE;
				}
			}
		}
	}

	if(bBadFrame || bTimeOut) {
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		NotifyLive(timeGetTime());
		if(bBadFrame) {
			m_iBadFrames++;
			bBadFrame = (m_iBadFrames >= 0);
		}
		if(bBadFrame) {// || bTimeOut) {
			RunDmap(0);
			//RunDmap(1);
			SetState(DEVSTAT_readyrun);
		}
		_trace("[]TW6864 %d-dev %d dropped frame, error=%08X status=%08X\n", m_pParent->DeviceInfo().nBus, m_iDev, status1, status2);
	}

	return bBadFrame;
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6864::PrepareRun()
{
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource = NULL;
	CSample*	  pSample = NULL;
	BOOL		  is4CIF  = FALSE;
	ULONG		  flagReset = 0;
	
	if(!m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
		return FALSE;
	}

	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	if(!vinfo.signal) { 
		RunDmap(0);
		return FALSE; 
	}

	//豸Ҫ
	if(vinfo.reset & DEVSET_bright) {
		P_TW6864->SetBright(m_iDev, vinfo.brightness);
	}
	if(vinfo.reset & DEVSET_contrast) {
		P_TW6864->SetContrast(m_iDev, vinfo.contrast);
	}
	if(vinfo.reset & DEVSET_saturation) {
		P_TW6864->SetSaturation(m_iDev, vinfo.saturation);
	}
	if(vinfo.reset & DEVSET_hue) {
		P_TW6864->SetHue(m_iDev, vinfo.hue);
	}
	if(vinfo.reset & DEVSET_sharpness) {
		P_TW6864->SetSharpness(m_iDev, vinfo.sharpness);
	}
	if(vinfo.reset & (DEVSET_vleft|DEVSET_vright)) {
		if(vinfo.vleft<0)  vinfo.vleft = -TW686X_BS_LEFT;
		if(vinfo.vright<0) vinfo.vright= -TW686X_BS_RIGHT;
		vsource->SetPluginInfo(&vinfo, VSRC_vleft|VSRC_vright);
		P_TW6864->SetBlackStripe(m_iDev, vinfo.vleft, vinfo.vright, vinfo.capture.width);
	}
	if(vinfo.reset & DEVSET_hdelay) {
		if(vinfo.hdelay<0)  vinfo.hdelay = -TW686X_HDELAY_DEFAULT(vinfo.capture.width);
		vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
		P_TW6864->SetHDelay(m_iDev, abs(vinfo.hdelay));
	}
	if(vinfo.reset & DEVSET_vdelay) {
		if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
		vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);
		vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
		P_TW6864->SetVDelay(m_iDev, abs(vinfo.vdelay));
	}

	if(vinfo.reset & (DEVSET_framerate|DEVSET_framerun|DEVSET_field)) {
		//flagReset |= DEVSET_framerate;
		SetFrameRate(&vinfo);
	}
	
	if(vinfo.reset & DEVSET_devreset) {
		flagReset |= (vinfo.reset&DEVSET_devreset);
	}
	
	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}

	//bad framesʱҪBuildܳеͨbad frames
	//ӰDaemonͼ񶼳
#if(0)
	//bad frameʱֻbuilddmaDaemonпͼ
	//bad frameDaemonԽ
	if((m_iBadFrames>0)) {
		Build(&vinfo);
	}
	if((flagReset == 0)){// && (m_iBadFrames<=0)) {
		return TRUE;
	}
#else 
	//bad frameͰdmaķʽDaemonУҲͼ
	if((flagReset == 0) && (m_iBadFrames<=0)) {
		return TRUE;
	}
#endif

	RunDmap(0);
	vinfo.frame_rate_cnt = m_chlList[m_iChannel]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

	is4CIF = IS_4CIF(vinfo);
	P_TW6864->SetStandard(m_iDev, vinfo.standard);
	P_TW6864->SetSize(m_iDev, &vinfo);
	P_TW6864->SetFormat(m_iDev, vinfo.capture.pixel_format);
	P_TW6864->SetVcom(m_iDev, vinfo.capture.width, vinfo.vcom);
		
	vsource->SetPluginInfo(&vinfo, VSRC_vleft|VSRC_vright|VSRC_hdelay|VSRC_vdelay);

	OnBufferFull(m_chlList[m_iChannel], is4CIF, m_iChannel*RAWV_NUM, (m_iChannel+1)*RAWV_NUM);

	Build(&vinfo);

	return TRUE+TRUE;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6864::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
		
	if(m_pSample == NULL) { return FALSE; }

	NotifyLive(timeGetTime());

	try {
		chl = m_pSample->GetChannel();
		if(chl) {
			plg = chl->Plugin(PLG_vsource);
			ret = plg->Transmit(m_pSample, NULL);
		}
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6864::OnData()쳣!"));
	}

	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_vsource);
		m_pSample = NULL;
	}

	return ret;
}

//-------------------------------------------
// ⺯豸ǷͨҪ
//-------------------------------------------
BOOL CDev6864::HasChannelRunning(ULONG runFlag)
{
	BOOL hasRun = FALSE;

	for(UINT i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] && m_chlList[i]->IsEnabled(runFlag)) {
			hasRun = TRUE;
			break;
		}
	}
	
	return hasRun;
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6864::RunDmap(UCHAR run)
{
	CScopedLock autoLock(P_TW6864->RunLock());
	ULONG tmp  = m_pMem->ind(TW6864_R_DMA_CMD);
	ULONG tmp1 = m_pMem->ind(TW6864_R_DMA_CHANNEL_ENABLE);
	int   ch   = m_iDev;
	BOOL  bWait= FALSE;

	if(run) { 
		if(((PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo())->signal) {
			tmp |= (1<<31);  
			tmp |= (1<<ch);
			tmp1|= (1<<ch);
			NotifyLive(0);
		}
		m_Share->cpyItems[0].cpyCount = 0;
		m_Share->cpyItems[1].cpyCount = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount = 0;
		m_Share->irqData[IRQ_DMPAP].status[0]= 0;
		m_Share->irqData[IRQ_DMPAP].status[1]= 0;
		m_iBadFrames = DAEMON_SKIP;
	}
	else { 
		if(!(tmp&(1<<ch)) && !(tmp1&(1<<ch))) { 
			return;
		}
		bWait = (tmp&(1<<ch)) && (tmp1&(1<<ch));
		m_iDmap = 0;
		m_iCheck= 0;
		tmp &= ~(1<<ch);
		tmp1&= ~(1<<ch);
	}

	m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
	if(bWait) {
		for(ch=0; ch<8; ch++) { Sleep(0); }
	}
	m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev6864::HasSignal()
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG	 vstatus = 0;
	BOOL	 bRet = FALSE;
	
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	bRet = vinfo.signal;
	
	vstatus = P_TW6864->GetDecoderStatus(m_iDev);
	bSignal = !(vstatus&BIT(7)) && (vstatus&BIT(6));
	
	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 2 : 1)) {
			_trace(TEXT("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			bRet = bSignal;
			P_TW6864->ResetDaemon();
		}
	}
	else {
		vinfo.signal_count = 0;
	}

	vsource->SetPluginInfo(&vinfo, setSignal);

	return bRet;
}

/** 
 ***************************************************************************************
 *  Y420תYUV420 Plannarʽ
 *  @param[in]  y420Y420ʽ
 *  @param[out] yuv420pYUV420 Plannarʽ
 *  @param[in]  ctxָ룬ڴƵݿȸ߶ȵϢ
 *
 *  @return 豸ŷTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864::Y420ToYuv420p(PBYTE y420, PBYTE yuv420p, BOOL bFiled2, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	PBYTE y = yuv420p;
	PBYTE u = NULL;
	PBYTE v = NULL;
	int   i, j, w = 0, h = 0;

	if(bFiled2) {
		w = vinfo->preview.width;
		h = vinfo->preview.height;
	}
	else {
		w = vinfo->capture.width;
		h = vinfo->capture.height;
	}
	u = yuv420p + (h*w);
	v = u + (h*w/4);

	for(i=0; i<h; i+=2) {
 		for(j=0; j<w*2; j+=4) {
			*u++ = *y420++;
			*y++ = *y420++;
			*v++ = *y420++;
			*y++ = *y420++;
 		}
		memcpy(y, y420, w);
		y420 += w;
		y += w;
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  Y41PתYUV420 Plannarʽ
 *  @param[in]  y41pY41Pʽ
 *  @param[out] yuv420pYUV420 Plannarʽ
 *  @param[in]  ctxָ룬ڴƵݿȸ߶ȵϢ
 *
 *  @return 豸ŷTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864::Y41PToYuv420p(PBYTE y41p, PBYTE yuv420p, BOOL bFiled2, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	PBYTE y = yuv420p;
	PBYTE u = NULL;
	PBYTE v = NULL;
	int   i, j, pitch = 0, w = 0, h = 0;

	if(bFiled2) {
		pitch = vinfo->preview.pitch;
		w = vinfo->preview.width;
		h = vinfo->preview.height;
	}
	else {
		pitch = vinfo->capture.pitch;
		w = vinfo->capture.width;
		h = vinfo->capture.height;
	}
	u = yuv420p + (h*w);
	v = u + (h*w/4);

	for(i=0; i<h; i++) {
 		for(j=0; j<pitch/12; j++) {
			*u++ = *y41p++;
			*y++ = *y41p++;
			*v++ = *y41p++;
			*y++ = *y41p++;

			*u++ = *y41p++;
			*y++ = *y41p++;
			*v++ = *y41p++;
			*y++ = *y41p++;

			*y++ = *y41p++;
			*y++ = *y41p++;
			*y++ = *y41p++;
			*y++ = *y41p++;
		}
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  Y411תYUV420 Plannarʽ
 *  @param[in]  y411Y411ʽ
 *  @param[out] yuv420pYUV420 Plannarʽ
 *  @param[in]  ctxָ룬ڴƵݿȸ߶ȵϢ
 *
 *  @return 豸ŷTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864::Y411ToYuv420p(PBYTE y411, PBYTE yuv420p, BOOL bFiled2, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	PBYTE y = yuv420p;
	PBYTE u = NULL;
	PBYTE v = NULL;
	int   i, j, pitch = 0, w = 0, h = 0;

	if(bFiled2) {
		pitch = vinfo->preview.pitch;
		w = vinfo->preview.width;
		h = vinfo->preview.height;
	}
	else {
		pitch = vinfo->capture.pitch;
		w = vinfo->capture.width;
		h = vinfo->capture.height;
	}
	u = yuv420p + (h*w);
	v = u + (h*w/4);

	for(i=0; i<h; i++) {
 		for(j=0; j<pitch/12; j++) {
			*u++ = *y411++;
			*y++ = *y411++;
			*y++ = *y411++;
			*v++ = *y411++;

			*y++ = *y411++;
			*y++ = *y411++;
			*u++ = *y411++;
			*y++ = *y411++;

			*y++ = *y411++;
			*v++ = *y411++;
			*y++ = *y411++;
			*y++ = *y411++;
		}
	}

	return TRUE;
}