/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864aud.cpp
 *  @brief		豸CDev6864audʵ֣֧TW6864 audio
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/20
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Dev6864aud.h"
#include "PlgaSource.h"
#include <mmsystem.h>
#include "TW6864.h"
#include "Dev6864.h"
#include "TW686x.h"

#define TW6864_ADMA		(m_iDev-TW6864_DMA_NUM)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864aud::CDev6864aud()
{

}

CDev6864aud::~CDev6864aud()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864aud::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	
	for(i=0; i<RAWA_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6864aud::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(AUDIO_PAGE_LEN, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864aud::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktAudio);
	}
	
	if(i > 0) {
		pSample = m_bufRaw[0];
		m_pMem->outd(TW6864_R_CH8to15_CONFIG_REG_P(TW6864_ADMA), (ULONG)pSample->Buffer()->pnodes[0].addr);
		if(RAWA_NUM > 1) {
			pSample = m_bufRaw[1];
		}
		m_pMem->outd(TW6864_R_CH8to15_CONFIG_REG_B(TW6864_ADMA), (ULONG)pSample->Buffer()->pnodes[0].addr);
	}

	return (i==RAWA_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864aud::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		m_pParent->FreeMemory(pSample->Buffer());
		_trace(TEXT("[Ϣ]CDev6864aud::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		delete pSample;
		m_bufRaw.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864aud::OnOpen()
{
	TCmdIrqInfo	irq;

	ZeroMemory(m_Share, sizeof(TShareData));

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_TOUT;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_XINT_ERROR(m_iDev);
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	//irq.irqInfo.regRead[0] = TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRead[1] = TW6864_R_DMA_PB_STATUS;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6864aud::OnClose()
{
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6864aud::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	//豸ɾж
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_DMA(m_iDev);//|TW6864_R_DMA_INT_STATUS_TOUT;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_XINT_ERROR(m_iDev);
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRWBase	= irq.irqInfo.regBase;
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ޸֪ͨ¼
 *
 *  @param hEvent -- ¼
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6864aud::ModifyEvt(HANDLE hEvent)
{
	TCmdNotifyEventInfo evti;

	if(m_pParent == NULL) {
		return FALSE;
	}

	evti.deviceId = m_iDev;
	evti.evtData  = hEvent;

	return m_pParent->ModifyEvt(evti);
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6864aud::PrepareRun()
{
	if(!m_chlList[0]->IsEnabled(PLG_RunAudioDevice)) {
		return FALSE;
	}
	
	CPlgaSource* asource = (CPlgaSource*)m_chlList[0]->Plugin(PLG_asource);
	TaSourceInfo ainfo = *(PaSourceInfo)asource->GetPluginInfo();
	ULONG areset = ainfo.reset;

	if(ainfo.reset & DEVSET_volume) {
		ainfo.reset &= ~DEVSET_volume;
		//P_TW6864->SetVolume(TW6864_ADMA, ainfo.volume);
	}

	ainfo.reset = 0;
	asource->SetPluginInfo(&ainfo, ASRC_reset);

	if(!areset) {
		return TRUE;
	}
	
	P_TW6864->SetAudioParam(ainfo.samplerate, ainfo.bitcount, ainfo.channels);
	P_TW6864->SetAudioDmaLength(m_nAudioPktLen);
	
	RunDmap(0);

	return TRUE+TRUE;
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6864aud::RunDmap(UCHAR run)
{
	CScopedLock autoLock(P_TW6864->RunLock());
	ULONG tmp  = m_pMem->ind(TW6864_R_DMA_CMD);
	ULONG tmp1 = m_pMem->ind(TW6864_R_DMA_CHANNEL_ENABLE);
	int   ch   = m_iDev;
	BOOL  bWait= FALSE;
	
	if(run) { 
		tmp |= (1<<31);  
		tmp |= (1<<ch);
		tmp1|= (1<<ch);
	}
	else { 
		if(!(tmp&(1<<ch)) && !(tmp1&(1<<ch))) { 
			return;
		}
		bWait = (tmp&(1<<ch)) && (tmp1&(1<<ch));
		m_iDmap = 0;
		tmp &= ~(1<<ch);
		tmp1&= ~(1<<ch);
	}
	m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
	if(bWait) {
		for(ch=0; ch<8; ch++) { Sleep(0); }
	}
	m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
}

BOOL CDev6864aud::OnDmaError(ULONG status1, ULONG status2, PVOID ctx)
{
	BOOL bBadFrame = status1 & TW6864_R_DMA_XINT_ERROR(m_iDev);
	BOOL bTimeOut  = status2 & TW6864_R_DMA_INT_STATUS_TOUT;
	if(bBadFrame || bTimeOut) {
		RunDmap(0);
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		SetState(DEVSTAT_readyrun);
		_trace(TEXT("[]TW6864 dev %d dropped audio frame, error=%08X status=%08X\n"), m_iDev, status1, status2);
	}

	return bBadFrame;
}

/** 
***************************************************************************************
*  жϼʹ
*
*  @return жϲݷTRUEûݷFALSE-1
***************************************************************************************
*/
long CDev6864aud::OnIrq()
{
	long isData = -1;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	CPlgaSource* asource;
	TaSourceInfo ainfo;

	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];
		isData = FALSE;

		OnDmaError(fifoStatus, dmaStatus, NULL);

		if(dmaStatus & (1<<m_iDev)) {
			asource = (CPlgaSource*)m_chlList[0]->Plugin(PLG_asource);
			ainfo = *(PaSourceInfo)asource->GetPluginInfo();
			m_iDmap = ((dmapAddr >> m_iDev) & 1);
			m_pSample = m_bufRaw[m_iDmap];
			m_pSample->SetFlag(PLG_asource);
			m_pSample->SetDataSize(m_nAudioPktLen);
			m_pSample->SetChannel(m_chlList[0]);
			m_pSample->SetTimeStamp(timestamp());

			if(ainfo.bitcount == 8) {
				PBYTE pp  = (PBYTE)m_pSample->Buffer()->vaddr;
				for(int i=0; i<m_nAudioPktLen; i++) {
					pp[i] = pp[i] - 128;
				}
			}
		
			isData = TRUE;
		}

		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6864aud::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
	
	if(m_pSample==NULL) { return FALSE; }

	NotifyLive(timeGetTime());
	
	try {
		chl = m_pSample->GetChannel();
		if(chl) {
			plg = chl->Plugin(PLG_asource);
			ret = plg->Transmit(m_pSample, NULL);
		}
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6864aud::OnData()쳣!"));
	}
	
	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_asource);
		m_pSample = NULL;
	}

	return ret;
}