/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864blk.cpp
 *  @brief		豸CDev6864blkʵ֣֧TW6864 block dmaģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/16
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6864.h"
#include "Dev6864blk.h"
#include "PlgvSource.h"
#include "TW686X.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864blk::CDev6864blk()
{

}

CDev6864blk::~CDev6864blk()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864blk::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	TMemBlock mb;
	
	for(i=0; i<RAWV_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6864blk::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864blk::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	if(i != RAWV_NUM) {
		return FALSE;
	}

	for(i=0; i<RAWV_NUM; i++) {
		pSample = new CSample();
		if(pSample == NULL) {
			break;
		}
		if(m_nBufferType==vbtD1) {
			ZeroMemory(&mb, sizeof(TMemBlock));
			mb.inode = 1;
			mb.len  = m_nBufferLen/2;
			mb.vaddr= (PVOID)((ULONG)m_bufRaw[i]->Buffer()->vaddr + mb.len);
			mb.nodes[0].addr = (PVOID)((ULONG)m_bufRaw[i]->Buffer()->pnodes[0].addr + mb.len);
			mb.nodes[0].len  = mb.len;
			pSample->Append(mb);
		}
		else if(!m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			delete pSample;
			break;
		}
		pSample->SetType(m_devCaps->ddesc.bField2 ? pktField2 : pktVideo);
		m_bufField2.push_back(pSample);
	}		
	
	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864blk::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			m_pParent->FreeMemory(pSample->Buffer());
			_trace(TEXT("[Ϣ]CDev6864blk::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}

	while(m_bufField2.size() > 0) {
		pSample = m_bufField2.back();
		if(!pSample->IsAppend()) {
			m_pParent->FreeMemory(pSample->Buffer());
		}
		delete pSample;
		m_bufField2.pop_back();
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864blk::OnOpen()
{
	TCmdIrqInfo	irq;
	ULONG		uConfig = 0;
	int			nStartIdx = 0;//m_iDev*TW6864_DMA_DESCRIPTOR_UNIT;
	int			nNextIdx  = 63;//(m_iDev+1)*TW6864_DMA_DESCRIPTOR_UNIT;
	ULONG		uTemp = 0;
	
	ZeroMemory(m_Share, sizeof(TShareData));
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			P_TW6864->SetMux(m_iDev, (TVideoInput)viInput);
			break;
		}
	}
	
	P_TW6864->SetStandard(m_iDev, TvSourceInfo::default_standard);
	P_TW6864->SetFormat(m_iDev, vpfYUV422Interspersed);

	//ע:طSetSizeVC9ʹٶŻȫŻʱ
	//ԵTW2865ϵĳЩͨҲжϣֻµ
	//P_TW6864->Init286x()ſɾ
	//P_TW6864->SetSize(m_iDev, &vinfo);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uTemp = m_devCaps->ddesc.bField2 ? 3 : 2;
	
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	uConfig |= (uTemp<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );
	
	uConfig = m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev));
	uConfig = (uConfig & ~0x1FF)		| (nStartIdx&0x1FF);			//m_StartIdx
	uConfig = (uConfig & ~(0x3FF<<10))	| ((nNextIdx&0x3FF)<<10);		//m_EndIdx
	uConfig = (uConfig & ~(1<<23))		| ((FALSE&1)<<23);				//m_bHorizontalDecimate
	uConfig = (uConfig & ~(1<<24))		| ((FALSE&1)<<24);				//m_bVerticalDecimate
	uConfig = (uConfig & ~(3<<25))		| ((0&3)<<25);					//m_nDropChannelNum
	uConfig = (uConfig & ~(1<<27))		| ((1&1)<<27);					//m_bDropMasterOrSlave	//((((m_iDev&1)?FALSE:TRUE)&1)<<27)
	uConfig = (uConfig & ~(1<<28))		| ((FALSE&1)<<28);				//m_bDropField			//((bDropField&1)<<28)
	uConfig = (uConfig & ~(1<<29))		| ((FALSE&1)<<29);				//m_bDropOddOrEven
	//uConfig = (uConfig & ~(3<<30))	| ((0&3)<<30);					//m_nCurVideoChannelNum -- mux

	m_pMem->outd(TW6864_R_CH0to7_CONFIG_REG(m_iDev), uConfig);
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), 0);					//0x95555555 for even only, 0xd5555555 for odd only
	
	m_pMem->outd(TW6864_R_DMA_CONFIG,  0x00FF0004);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
													//little endian, bad/vsync protection on

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev);
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.regRWBase	= irq.irqInfo.regBase;
	//irq.irqInfo.regRead[0]	= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRead[1]	= TW6864_R_DMA_PB_STATUS;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

void CDev6864blk::Build(void* ctx)
{
	PMemBlock	pmb = NULL;
	CSample*	spl = NULL;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	BOOL  is4CIF = IS_4CIF(*vinfo) || vinfo->optimize_cif;
	int   nHeight = !is4CIF ? vinfo->capture.height : vinfo->capture.height/2;
	ULONG uTemp, uConfig;

	pmb = m_bufRaw[0]->Buffer();
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
	pmb = m_bufRaw[(RAWV_NUM>1)?1:0]->Buffer();
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_B_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_WHP_0, m_iDev), 
				(vinfo->capture.pitch&0x7FF) |						//line width
				((vinfo->capture.pitch&0x7FF)<<11) |				//pitch
				((nHeight&0x7FF)<<22)								//height
				);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uTemp = !is4CIF ? 3 : 2;
	
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	uConfig |= (uTemp<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );

	//field 2
	if(!is4CIF) {
		spl = m_bufField2[0];
		pmb = spl->Buffer();
		uTemp = spl->IsAppend() ? (ULONG)pmb->nodes[0].addr : (ULONG)pmb->pnodes[0].addr;
		m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_F2_0, m_iDev), uTemp);
		spl = m_bufField2[(RAWV_NUM>1)?1:0];
		pmb = spl->Buffer();
		uTemp = spl->IsAppend() ? (ULONG)pmb->nodes[0].addr : (ULONG)pmb->pnodes[0].addr;
		m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_B_F2_0, m_iDev), uTemp );
		if(vinfo->frame_run & frame_preview) {
			P_TW6864->SetSizeF2(m_iDev, vinfo);
			m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_WHP_F2_0, m_iDev), 
						(vinfo->preview.pitch&0x7FF) |						//line width
						((vinfo->preview.pitch&0x7FF)<<11) |				//pitch
						((vinfo->preview.height&0x7FF)<<22)					//height
						);
		}
		else {
			P_TW6864->SetSizeF2(m_iDev, vinfo);
			m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_WHP_F2_0, m_iDev), 
				(vinfo->capture.pitch&0x7FF) |						//line width
				((vinfo->capture.pitch&0x7FF)<<11) |				//pitch
				((vinfo->capture.height&0x7FF)<<22)					//height
				);
		}
	}
	else {
		P_TW6864->SetSizeF2(m_iDev, vinfo);
		P_TW6864->SetSize(m_iDev, vinfo);
	}
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6864blk::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	CSample*	 pSample = NULL;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  is4CIF = FALSE, isPageB = FALSE, isField2=FALSE;
	BOOL  is420p = FALSE;
	LONG  diff;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];
		diff = (LONG)((m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart-m_tkLast)*10000/m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart);
		m_tkLast = m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart;
		P_TW6864->OnDma(OnDmaError(fifoStatus, dmaStatus, &vinfo));
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		if(dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) {
			is4CIF = IS_4CIF(vinfo) || vinfo.optimize_cif;
			if(diff < (is4CIF ? 6000/MAX_FRAMERATE(vinfo.standard) : (3000/MAX_FRAMERATE(vinfo.standard)))) {
				//_trace("[Ϣ]TW6864 dev %d %d, %d\n", m_iDev, diff, m_Share->irqData[IRQ_DMPAP].irqCount);
			}
			else {
				m_iDmap = (dmapAddr >> m_iDev) & 1;
				isField2 = (dmapAddr & (1<<(24+m_iDev))) ? 1 : 0;
				if(m_devCaps->ddesc.bField2 && (vinfo.frame_run&frame_preview)) {
					if(!isField2) {
						pSample = m_bufRaw[m_iDmap];
						pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					}
					else {
						pSample = m_bufField2[m_iDmap];
						pSample->SetDataSize(vinfo.preview.pitch*vinfo.preview.height);
						pSample->SetType(pktField2);
					}
				}
				else if(is4CIF) {
					pSample = m_bufRaw[m_iDmap];
					pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				}
				else {
					pSample = isField2 ? m_bufField2[m_iDmap] : m_bufRaw[m_iDmap];
					pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					pSample->SetType(pktVideo);
				}
				m_pSample = pSample;
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

				isData = TRUE;
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].status[1]  = 0;
		m_Share->irqData[IRQ_DMPAP].regRead[0] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}

void CDev6864blk::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0, nFps1 = 0;
	BOOL		 bStop = FALSE;
	
	if(vinfo==NULL) {
		vinfo = (PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
		bStop = TRUE;
	}

	nFps = P_TW6864->FpsToken(vinfo->capture.frame_rate);
	if(nFps > MAX_FRAMERATE(vinfo->standard)) { return; }
	if(bStop) {
		RunDmap(0);
	}

	if(m_devCaps->ddesc.bField2) {
		nFps1 = P_TW6864->FpsToken(vinfo->preview.frame_rate);
		if(vinfo->frame_run == frame_both) {
			uRate = P_TW6864->MapFrameRate(nFps, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
		}
		else if(vinfo->frame_run == frame_capture) {
			uRate = P_TW6864->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
		}
		else {
			uRate = P_TW6864->MapFrameRate(0, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
		}
	}
	else {	
		if(IS_4CIF(*vinfo) || vinfo->optimize_cif) {
			uRate = P_TW6864->MapFrameRate(nFps, nFps, (vinfo->standard==vsStandardNTSC), (m_iDev<4));
		}
		else if(vinfo->field==VF_Even) {
			uRate = P_TW6864->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
		}
		else {
			uRate = P_TW6864->MapFrameRate(0, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
		}
	}

	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
	if(bStop) {
		m_iBadFrames = 1;
		SetState(DEVSTAT_readyrun);
	}
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev6864blk::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp = 0;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }

		if(vinfo.frame_run & frame_capture) {
			spl = m_bufRaw[0];
			nTemp = vinfo.capture.pitch*vinfo.capture.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktVideo);
			if(vinfo.capture.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}

		if(vinfo.frame_run & frame_preview) {
			spl = m_bufField2[0];
			nTemp = vinfo.preview.pitch*vinfo.preview.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktField2);
			if(vinfo.preview.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x00, nTemp);
				memset(spl->DataPtr()+nTemp, 0x80, nTemp/2);
			}
			else if(vinfo.preview.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.preview.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}
	}
	
	return bRet;
}