/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864sg.cpp
 *  @brief		豸CDev6864sgʵ֣֧TW6864 scatter gatherģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/16
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6864.h"
#include "Dev6864sg.h"
#include "PlgvSource.h"
#include "TW686X.h"

#define TW6864_CHECKPOINT				BIT(13)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864sg::CDev6864sg()
{

}

CDev6864sg::~CDev6864sg()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sg::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	
	for(i=0; i<RAWV_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6864::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	if(m_nBufferType >= vbtD1) {
		//D1ɼʱDeinterlace
		for(i=0; i<RAWV_NUM; i++) {
			//ԭʼbuffer
			pSample = new CSample();
			if(pSample == NULL) {
				_trace(TEXT("[]CDev6864::OnAllocResource()-ƵRaw CSampleʧ\n"));
				break;
			}
			else if(pSample->Allocate(m_nBufferLen)) {
				m_bufRaw.push_back(pSample);
			}
			else {
				SAFE_DELETE(pSample);
				_trace(TEXT("[]CDev6864::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
				break;
			}
			pSample->SetType(pktVideo);
		}
	}
	
	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @param	[in]isOpenForVerifyǷֻҪУ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sg::OnOpen()
{
	TCmdIrqInfo	irq;
	ULONG		uConfig = 0;
	int			nStartIdx = m_iDev*TW6864_DMA_DESCRIPTOR_UNIT;
	int			nNextIdx  = (m_iDev+1)*TW6864_DMA_DESCRIPTOR_UNIT;

	ZeroMemory(m_Share, sizeof(TShareData));
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			P_TW6864->SetMux(m_iDev, (TVideoInput)viInput);
			break;
		}
	}
	
	P_TW6864->SetStandard(m_iDev, TvSourceInfo::default_standard);
	P_TW6864->SetFormat(m_iDev, vpfYUV422Interspersed);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );
	
	uConfig = m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev));
	uConfig = (uConfig & ~0x1FF)		| (nStartIdx&0x1FF);			//m_StartIdx
	uConfig = (uConfig & ~(0x3FF<<10))	| ((nNextIdx&0x3FF)<<10);		//m_EndIdx
	uConfig = (uConfig & ~(1<<23))		| ((FALSE&1)<<23);				//m_bHorizontalDecimate
	uConfig = (uConfig & ~(1<<24))		| ((FALSE&1)<<24);				//m_bVerticalDecimate
	uConfig = (uConfig & ~(3<<25))		| ((0&3)<<25);					//m_nDropChannelNum
	uConfig = (uConfig & ~(1<<27))		| ((TRUE&1)<<27);				//m_bDropMasterOrSlave	//((((m_iDev&1)?FALSE:TRUE)&1)<<27)
	uConfig = (uConfig & ~(1<<28))		| ((FALSE&1)<<28);				//m_bDropField			//((bDropField&1)<<28)
	uConfig = (uConfig & ~(1<<29))		| ((FALSE&1)<<29);				//m_bDropOddOrEven
	//uConfig = (uConfig & ~(3<<30))	| ((0&3)<<30);					//m_nCurVideoChannelNum -- mux
	
	m_pMem->outd(TW6864_R_CH0to7_CONFIG_REG(m_iDev), uConfig);
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), 0x95555555);			//0x95555555 for even only, 0xd5555555 for odd only
	
	m_pMem->outd(TW6864_R_DMA_CONFIG,  0x00FF0004);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
													//little endian, bad/vsync protection on

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev);
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.mskCopy	 = 0xFF;	//0-7 DMAͨ
	irq.irqInfo.devCopy	 = 0x6864;	
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	//irq.irqInfo.regRead[0] = TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRead[1] = TW6864_R_DMA_PB_STATUS;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

void CDev6864sg::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0, nFps1 = 0;
	BOOL		 bStop = FALSE;
	
	if(vinfo==NULL) {
		vinfo = (PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
		bStop = TRUE;
	}
	
	nFps = P_TW6864->FpsToken(vinfo->capture.frame_rate);
	if(nFps > MAX_FRAMERATE(vinfo->standard)) { return; }
	if(bStop) {
		RunDmap(0);
	}
		
	if(IS_4CIF(*vinfo) || vinfo->optimize_cif) {
		uRate = P_TW6864->MapFrameRate(nFps, nFps, (vinfo->standard==vsStandardNTSC), (m_iDev<4));
	}
	else if(m_devCaps->ddesc.bField2) {
		nFps1 = P_TW6864->FpsToken(vinfo->preview.frame_rate);
		uRate = P_TW6864->MapFrameRate(nFps, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(vinfo->field==VF_Even) {
		uRate = P_TW6864->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6864->MapFrameRate(0, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
	if(bStop) {
		m_iBadFrames = 1;
		SetState(DEVSTAT_readyrun);
	}
}

void CDev6864sg::Build(void* ctx)
{
#define DMA_STATUS_HOST_READY			1
	//DMA Channel config
	PDMADescriptor	pDesc = NULL;
	ULONG phyAddr = 0;
	int   nTemp=0, i=0;
	int	  nStartIdx=0, nNextIdx=0;
	BOOL  bCheckPoint = FALSE;
	int   j=m_iDev;
	int	  nDescriptorOffset=j*TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	int	  nCopyLen=TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	BOOL  is4CIF = FALSE;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	is4CIF = IS_4CIF(*vinfo) || vinfo->optimize_cif;
	nStartIdx = j*TW6864_DMA_DESCRIPTOR_UNIT;
	nNextIdx  = (j+1)*TW6864_DMA_DESCRIPTOR_UNIT;

	if(!is4CIF) {
		for(int k=0; k<TW6864_DMA_PAGETABLE_NUM/2; k++) {
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k);
			bCheckPoint = (k==0);// && (nCh&1);
			phyAddr = (ULONG)m_bufRaw[k%RAWV_NUM]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			bCheckPoint = FALSE;
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorB(k);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
	}
	else {
		for(int k=0; k<RAWV_NUM; k++) {
			bCheckPoint = (k==1);// && (nCh&1);
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorP(k*2);
			phyAddr = (ULONG)m_bufRaw[k]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorB(k*2);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}

			bCheckPoint = FALSE;			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			phyAddr = (ULONG)m_bufRaw[k]->Buffer()->pnodes[0].addr + vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorB(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
		
		memcpy(P_TW6864->GetDMADescriptorP(4)+nStartIdx, P_TW6864->GetDMADescriptorP(0)+nStartIdx, nCopyLen);
		memcpy(P_TW6864->GetDMADescriptorB(4)+nStartIdx, P_TW6864->GetDMADescriptorB(0)+nStartIdx, nCopyLen);
	}

	m_Share->cpyItems[0].isCopy		= FALSE;
	m_Share->cpyItems[0].cpyLen		= nCopyLen;
	m_Share->cpyItems[0].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[0].destOffset	= nDescriptorOffset;
	m_Share->cpyItems[0].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[0].cpyCount	= 0;
	m_Share->cpyItems[0].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
	m_Share->cpyItems[1].isCopy		= FALSE;
	m_Share->cpyItems[1].cpyLen		= nCopyLen;
	m_Share->cpyItems[1].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[1].destOffset	= TW6864_DMA_PAGETABLE_UNIT+ nDescriptorOffset;
	m_Share->cpyItems[1].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[1].cpyCount	= 0;
	m_Share->cpyItems[1].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
}

void CDev6864sg::CheckPoint(BOOL bCheck, int nField)
{
	PDMADescriptor	pDesc = NULL;
	int   i=0;
	int	  nStartIdx=0, nNextIdx=0;
	int   j=m_iDev;
	ULONG uCheck = bCheck ? TW6864_CHECKPOINT : 0;

	nStartIdx = j*TW6864_DMA_DESCRIPTOR_UNIT;
	nNextIdx  = (j+1)*TW6864_DMA_DESCRIPTOR_UNIT;

	pDesc = P_TW6864->GetDMADescriptorP(nField);
	for(i=nStartIdx;i<nNextIdx;i++) {
		if(pDesc[i].ctrl == 0) break;
		pDesc[i].ctrl = (pDesc[i].ctrl & ~TW6864_CHECKPOINT) | uCheck;
	}

	pDesc = P_TW6864->GetDMADescriptorB(nField);
	for(i=nStartIdx;i<nNextIdx;i++) {
		if(pDesc[i].ctrl == 0) break;
		pDesc[i].ctrl = (pDesc[i].ctrl & ~TW6864_CHECKPOINT) | uCheck;
	}
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6864sg::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  is4CIF = FALSE, isPageB = FALSE;
	BOOL  bData  = FALSE;
	CSample* spl = NULL;
	ULONG uCount = 0;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];
		P_TW6864->OnDma(OnDmaError(fifoStatus, dmaStatus, &vinfo));
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		if(dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) {
			is4CIF = IS_4CIF(vinfo) || vinfo.optimize_cif;
			
			isPageB = (dmapAddr >> m_iDev) & 1;
			if(!is4CIF) {
				bData = isPageB;
			}
			else {
				dmaStatus = m_Share->cpyItems[1].cpyCount;
				bData = (dmaStatus>=4) ? (m_iCheck<4) : (m_iCheck>4);
				m_iCheck = m_Share->cpyItems[1].cpyCount;
			}
		}
		
		if(bData) {
			if(!is4CIF) {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*2);
				m_iDmap= ((uCount / 2) + 1) % RAWV_NUM;
				spl = m_bufRaw[m_iDmap];
				spl->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				m_pSample = spl;
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);

				isData = TRUE;
			}
			else {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*4);
				m_iDmap= ((uCount / 4) + 1) % RAWV_NUM;

				spl = m_bufRaw[m_iDmap];
				m_pSample = m_bufRaw[RAWV_NUM+m_iDmap];
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
				m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					
				PBYTE p1 = (PBYTE)spl->Buffer()->vaddr;
				PBYTE p2= p1 + vinfo.capture.pitch*vinfo.capture.height/2;
				PBYTE p = (PBYTE)m_pSample->Buffer()->vaddr;
				for(int h=0; h<vinfo.capture.height/2; h++) {
					memcpy(p, p1, vinfo.capture.pitch);
					p += vinfo.capture.pitch;
					memcpy(p, p2, vinfo.capture.pitch);
					p += vinfo.capture.pitch;
					p1+= vinfo.capture.pitch;
					p2+= vinfo.capture.pitch;
				}

				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				
				isData = TRUE;
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}
