/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864sg2f.cpp
 *  @brief		豸CDev6864sg2fʵ֣֧TW6864 scatter gather -- two fieldģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/28
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6864.h"
#include "Dev6864sg2f.h"
#include "PlgvSource.h"
#include "TW686X.h"
#include <mmsystem.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864sg2f::CDev6864sg2f() :
m_splFiled2(NULL)
{

}

CDev6864sg2f::~CDev6864sg2f()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sg2f::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0;
	
	for(i=0; i<RAWV_NUM; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6864::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(RAWV_LEN, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);

		pSample = new CSample();
		if(pSample == NULL) {
			break;
		}
		else if(m_pParent->AllocMemory(RAWV_LEN, pSample->Buffer())) {
			m_bufField2.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktField2);
	}

	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sg2f::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			m_pParent->FreeMemory(pSample->Buffer());
			_trace(TEXT("[Ϣ]CDev6864sg2f::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}

	while(m_bufField2.size() > 0) {
		pSample = m_bufField2.back();
		delete pSample;
		m_bufField2.pop_back();
	}

	return TRUE;
}

void CDev6864sg2f::Build(void* ctx)
{
#define DMA_STATUS_HOST_READY			1
	//DMA Channel config
	PDMADescriptor	pDesc = NULL;
	ULONG phyAddr = 0;
	int   nTemp=0, i=0;
	int	  nStartIdx=0, nNextIdx=0;
	BOOL  bCheckPoint = FALSE;
	int   j=m_iDev;
	int	  nDescriptorOffset=j*TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	int	  nCopyLen=TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	nStartIdx = j*TW6864_DMA_DESCRIPTOR_UNIT;
	nNextIdx  = (j+1)*TW6864_DMA_DESCRIPTOR_UNIT;
	if(vinfo->frame_run & frame_preview) {
		P_TW6864->SetSizeF2(m_iDev, vinfo);
		for(int k=0; k<RAWV_NUM; k++) {
			bCheckPoint = (k==1);// && (nCh&1);
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k*2);
			phyAddr = (ULONG)m_bufRaw[k]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorB(k*2);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			bCheckPoint = FALSE;			
			nTemp = vinfo->preview.pitch*vinfo->preview.height/2;
			phyAddr = (ULONG)m_bufField2[k]->Buffer()->nodes[0].addr;
			pDesc = P_TW6864->GetDMADescriptorP(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->preview.pitch*vinfo->preview.height/2;
			pDesc = P_TW6864->GetDMADescriptorB(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
		
		memcpy(P_TW6864->GetDMADescriptorP(4)+nStartIdx, P_TW6864->GetDMADescriptorP(0)+nStartIdx, nCopyLen);
		memcpy(P_TW6864->GetDMADescriptorB(4)+nStartIdx, P_TW6864->GetDMADescriptorB(0)+nStartIdx, nCopyLen);
	}
	else {
		P_TW6864->SetSizeF2(m_iDev, vinfo);
		for(int k=0; k<TW6864_DMA_PAGETABLE_NUM/2; k++) {
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k);
			bCheckPoint = (k==0);// && (nCh&1);
			phyAddr = (ULONG)m_bufRaw[k%RAWV_NUM]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			bCheckPoint = FALSE;
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorB(k);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
	}

	m_Share->cpyItems[0].isCopy		= FALSE;
	m_Share->cpyItems[0].cpyLen		= nCopyLen;
	m_Share->cpyItems[0].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[0].destOffset	= nDescriptorOffset;
	m_Share->cpyItems[0].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[0].cpyCount	= 0;
	m_Share->cpyItems[0].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
	m_Share->cpyItems[1].isCopy		= FALSE;
	m_Share->cpyItems[1].cpyLen		= nCopyLen;
	m_Share->cpyItems[1].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[1].destOffset	= TW6864_DMA_PAGETABLE_UNIT+ nDescriptorOffset;
	m_Share->cpyItems[1].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[1].cpyCount	= 0;
	m_Share->cpyItems[1].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6864sg2f::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  bData  = FALSE;
	BOOL  is420p = FALSE;
	ULONG uCount = 0;
	CSample* pSample = NULL;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];
		P_TW6864->OnDma(OnDmaError(fifoStatus, dmaStatus, &vinfo));
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		if(dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) {
			if(vinfo.frame_run & frame_preview) {
				dmaStatus = m_Share->cpyItems[1].cpyCount;
				bData = (dmaStatus>=4) ? (m_iCheck<4) : (m_iCheck>4);
				m_iCheck = m_Share->cpyItems[1].cpyCount;
			}
			else {
				bData = (dmapAddr >> m_iDev) & 1;
			}
		}
		
		if(bData) {
			if(vinfo.frame_run & frame_preview) {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*4);
				m_iDmap= ((uCount / 4) + 1) % RAWV_NUM;
				
				pSample = m_bufRaw[m_iDmap];
				pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				m_pSample = pSample;
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);

				pSample = m_bufField2[m_iDmap];
				pSample->SetDataSize(vinfo.preview.pitch*vinfo.preview.height);
				m_splFiled2 = pSample;
				m_splFiled2->SetFlag(PLG_vsource);
				m_splFiled2->SetTimeStamp(timestamp());
				m_splFiled2->SetChannel(m_chlList[m_iChannel]);
			}
			else {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*2);
				m_iDmap= ((uCount / 2) + 1) % RAWV_NUM;
				pSample = m_bufRaw[m_iDmap];
				pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				m_pSample = pSample;
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
			}

			vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
			vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

			isData = TRUE;
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6864sg2f::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
	
	if((m_pSample==NULL) && (m_splFiled2==NULL)) { return FALSE; }
	
	NotifyLive(timeGetTime());
	
	try {
		if(m_pSample) {
			chl = m_pSample->GetChannel();
			if(chl) {
				plg = chl->Plugin(PLG_vsource);
				ret = plg->Transmit(m_pSample, NULL);
			}
		}
		if(m_splFiled2) {
			chl = m_splFiled2->GetChannel();
			if(chl) {
				plg = chl->Plugin(PLG_vsource);
				ret = plg->Transmit(m_splFiled2, NULL);
			}
		}
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6864::OnData()쳣!"));
	}
	
	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_vsource);
		m_pSample = NULL;
	}
	
	if(m_splFiled2 != NULL) {
		m_splFiled2->ClearFlag(PLG_vsource);
		m_splFiled2 = NULL;
	}
	
	return ret;
}

void CDev6864sg2f::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0, nFps1 = 0;
	BOOL		 bStop = FALSE;

	if(vinfo==NULL) {
		vinfo = (PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
		bStop = TRUE;
	}
	
	nFps = P_TW6864->FpsToken(vinfo->capture.frame_rate);
	if(nFps > MAX_FRAMERATE(vinfo->standard)) { return; }
	if(bStop) {
		RunDmap(0);
	}
	
	nFps1 = P_TW6864->FpsToken(vinfo->preview.frame_rate);
	if(vinfo->frame_run == frame_both) {
		uRate = P_TW6864->MapFrameRate(nFps, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(vinfo->frame_run == frame_capture) {
		uRate = P_TW6864->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6864->MapFrameRate(0, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
	if(bStop) {
		m_iBadFrames = 1;
		SetState(DEVSTAT_readyrun);
	}
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev6864sg2f::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp= 0;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }

		if(vinfo.frame_run & frame_capture) {
			spl = m_bufRaw[0];
			nTemp = vinfo.capture.pitch*vinfo.capture.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktVideo);
			if(vinfo.capture.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}

		if(vinfo.frame_run & frame_preview) {
			spl = m_bufField2[0];
			nTemp = vinfo.preview.pitch*vinfo.preview.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktField2);
			if(vinfo.preview.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.preview.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.preview.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}
	}
	
	return bRet;
}