/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864sgSw.cpp
 *  @brief		豸CDev6864sgSwʵ֣֧TW6864 scatter gather dma, non-realtimeģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/08/12
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6864.h"
#include "Dev6864sgSw.h"
#include "PlgvSource.h"
#include "TW686X.h"
#include <mmsystem.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6864sgSw::CDev6864sgSw() :
m_iNext(0),
m_iSignalCheck(0)
{
	ZeroMemory(m_tkDiff, sizeof(m_tkDiff));
	ZeroMemory(m_bResync, sizeof(m_bResync));
}

CDev6864sgSw::~CDev6864sgSw()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sgSw::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0, iRawV=RAWV_NUM*m_devCaps->ddesc.iSwitch;
	
	for(i=0; i<iRawV; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6864sgSw::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6864sgSw::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	if(i != iRawV) {
		return FALSE;
	}

	if(m_nBufferType >= vbtD1) {
		//D1ɼʱDeinterlace
		for(i=0; i<iRawV; i++) {
			//ԭʼbuffer
			pSample = new CSample();
			if(pSample == NULL) {
				_trace(TEXT("[]CDev6864sgSw::OnAllocResource()-ƵRaw CSampleʧ\n"));
				break;
			}
			else if(pSample->Allocate(m_nBufferLen)) {
				m_bufRaw.push_back(pSample);
			}
			else {
				SAFE_DELETE(pSample);
				_trace(TEXT("[]CDev6864sgSw::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
				break;
			}
			pSample->SetType(pktVideo);
		}
	}
	
	return (i==iRawV);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sgSw::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			m_pParent->FreeMemory(pSample->Buffer());
			_trace(TEXT("[Ϣ]CDev6864sg2f::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȡǰеͨ
 *
 *  @return صǰеͨ
 ***************************************************************************************
 */
inline UINT CDev6864sgSw::CurrentChannel(UINT mux)
{
	UINT uCh = 0;
	
	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(i==mux) {
				break;
			}
			uCh++;
		}
	}
	
	return  uCh;
}

/** 
 ***************************************************************************************
 *  ȡ¸ͨ
 *
 *  @return ¸ͨ
 ***************************************************************************************
 */
inline int CDev6864sgSw::NextVideoInput()
{
	int iNext = 0;
	ULONG vInput= 0;
	
	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(iNext == m_iNext) {
				vInput = i;
				break;
			}
			iNext++;
		}
	}
	
	return vInput;
}

/** 
***************************************************************************************
*  ȡ¸Ҫɼͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev6864sgSw::NextChannel(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;
	
	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal || (vinfo.signal_check>=NOSIGNAL_CHECK)) {
			break;
		}
	}
	
	return iNext;
}

/** 
***************************************************************************************
*  ȡ¸Ҫź(ź)ͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev6864sgSw::NextCheck(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;
	
	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(!vinfo.signal && (vinfo.signal_check<NOSIGNAL_CHECK)) {
			break;
		}
	}
	
	return iNext;
}

inline ULONG CDev6864sgSw::Brightness(int value)
{
	int val = 0;
	g_util.map(B_MIN, B_MAX, value, B_MIN_6864, B_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6864sgSw::Contrast(int value)
{
	int val = 0;
	g_util.map(C_MIN, C_MAX, value, C_MIN_6864, C_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6864sgSw::Hue(int value)
{
	int val = 0;
	g_util.map(H_MIN, H_MAX, value, H_MIN_6864, H_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6864sgSw::Saturation(int value)
{
	int val = 0;
	g_util.map(S_MIN, S_MAX, value, S_MIN_6864, S_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6864sgSw::Sharpness(int value)
{
	int val = 0;
	
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6864, SH_MAX_6864, &val);
	val &= 0x0F;
	val |= 0x10;

	return (ULONG)val;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6864sgSw::OnClose()
{
	TCmdTimerInfo	tmi;
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6864::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}

#if(TW6864_SWITCH_TIMER)
	//TIMER¼
	INIT_TIMERINFO(tmi);
	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	m_pParent->RemoveTimer(tmi);
#endif
	
	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMAALL;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev);
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6864sgSw::OnOpen()
{
	TCmdTimerInfo	tmi;
	TCmdIrqInfo	irq;
	ULONG		uConfig = 0;
	int			nStartIdx = m_iDev*TW6864_DMA_DESCRIPTOR_UNIT;
	int			nNextIdx  = (m_iDev+1)*TW6864_DMA_DESCRIPTOR_UNIT;
	ULONG		uTemp = 0;
	
	ZeroMemory(m_Share, sizeof(TShareData));
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			P_TW6864->SetMux(m_iDev, (TVideoInput)viInput);
			break;
		}
	}
	
	P_TW6864->SetStandard(m_iDev, TvSourceInfo::default_standard);
	P_TW6864->SetFormat(m_iDev, vpfYUV422Interspersed);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );
	
	uConfig = m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev));
	uConfig = (uConfig & ~0x1FF)		| (nStartIdx&0x1FF);			//m_StartIdx
	uConfig = (uConfig & ~(0x3FF<<10))	| ((nNextIdx&0x3FF)<<10);		//m_EndIdx
	uConfig = (uConfig & ~(1<<23))		| ((FALSE&1)<<23);				//m_bHorizontalDecimate
	uConfig = (uConfig & ~(1<<24))		| ((FALSE&1)<<24);				//m_bVerticalDecimate
	uConfig = (uConfig & ~(3<<25))		| ((0&3)<<25);					//m_nDropChannelNum
	uConfig = (uConfig & ~(1<<27))		| ((1&1)<<27);					//m_bDropMasterOrSlave	//((((m_iDev&1)?FALSE:TRUE)&1)<<27)
	uConfig = (uConfig & ~(1<<28))		| ((FALSE&1)<<28);				//m_bDropField			//((bDropField&1)<<28)
	uConfig = (uConfig & ~(1<<29))		| ((FALSE&1)<<29);				//m_bDropOddOrEven
	//uConfig = (uConfig & ~(3<<30))	| ((0&3)<<30);					//m_nCurVideoChannelNum -- mux

	m_pMem->outd(TW6864_R_CH0to7_CONFIG_REG(m_iDev), uConfig);
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), 0);					//0x95555555 for even only, 0xd5555555 for odd only
	
	m_pMem->outd(TW6864_R_DMA_CONFIG,  0x00FF0004);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
													//little endian, bad/vsync protection on
	m_pMem->outd(TW6864_R_LOOP_CTRL,    0x3d);
	m_pMem->outd(TW6864_R_VERTICAL_CTRL,0x24); //0x26 will cause ch0 and ch1 have dma_error.
	P_TW6864->DeviceWrite2864(TW2864_R_LOOP_CTRL, 0x3d);
	P_TW6864->DeviceWrite2864(TW2864_R_VERTICAL_CTRL, 0x24);

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev);
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.mskCopy	 = 0xFF;	//0-7 DMAͨ
	irq.irqInfo.devCopy	 = 0x6864;	
	irq.irqInfo.freqWrite= TRUE;
	//irq.irqInfo.regRead[0]	= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRead[1]	= TW6864_R_DMA_PB_STATUS;
	irq.irqInfo.regWrite[0] = TW6864_R_DMA_CHANNEL_ENABLE;
	irq.irqInfo.mskWrite[0] = 1<<m_iDev;
	if(m_iDev < 4) {
		irq.irqInfo.regRead[2]	= TW6864_R_CHANNEL(TW6864_R_VSTATUS_0, m_iDev);
		irq.irqInfo.regRead[3]	= TW6864_R_CH0to7_CONFIG_REG(m_iDev);

		irq.irqInfo.regWrite[1] = TW6864_R_BRIGHT(m_iDev);
		irq.irqInfo.regWrite[2] = TW6864_R_CONTRAST(m_iDev);
		irq.irqInfo.regWrite[3] = TW6864_R_CH0to7_CONFIG_REG(m_iDev);
		irq.irqInfo.mskWrite[3] = 0xC0000000;
		irq.irqInfo.regWrite[4] = TW6864_R_HUE(m_iDev);
		irq.irqInfo.regWrite[5] = TW6864_R_SAT_U(m_iDev);
		irq.irqInfo.regWrite[6] = TW6864_R_SAT_V(m_iDev);
		irq.irqInfo.regWrite[7] = TW6864_R_SHARPNESS(m_iDev);
		
		irq.irqInfo.regWrite[8] = TW6864_R_SHSCALER_REG(m_iDev);
		irq.irqInfo.regWrite[9] = TW6864_R_VIDEO_SIZE_REG(m_iDev);
		irq.irqInfo.regWrite[10]= TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_0,m_iDev);
		irq.irqInfo.regWrite[11]= TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_0,m_iDev);
		irq.irqInfo.regWrite[12]= TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_0,m_iDev);
		irq.irqInfo.regWrite[16]= TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_F2_0,m_iDev);
		irq.irqInfo.regWrite[17]= TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_F2_0,m_iDev);
		irq.irqInfo.regWrite[18]= TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_F2_0,m_iDev);
	}
	else {
		int ch = m_iDev-4;
		irq.irqInfo.regI2C		= P_TW6864->TW2864Base();
		irq.irqInfo.regRead[2]	= TW2864_R_CHANNEL(TW2864_R_VSTATUS_0, ch);
		irq.irqInfo.regRead[3]	= TW2864_R_VERTICAL_SHARPNESS;
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regRead[2]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regRead[3]);
		
		irq.irqInfo.regWrite[3] = TW2864_R_VERTICAL_SHARPNESS;
		irq.irqInfo.mskWrite[3] = 1<<ch;
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[3]);
		
#if(TW2865_PARAM_INDIVIDUAL)
		irq.irqInfo.regWrite[1] = TW2864_R_CHANNEL(TW2864_R_BRIGHT_0, ch);
		irq.irqInfo.regWrite[2] = TW2864_R_CHANNEL(TW2864_R_CONTRAST_0, ch);
		irq.irqInfo.regWrite[4] = TW2864_R_CHANNEL(TW2864_R_HUE_0, ch);
		irq.irqInfo.regWrite[5] = TW2864_R_CHANNEL(TW2864_R_SAT_U_0, ch);
		irq.irqInfo.regWrite[6] = TW2864_R_CHANNEL(TW2864_R_SAT_V_0, ch);
		irq.irqInfo.regWrite[7] = TW2864_R_CHANNEL(TW2864_R_SHARPNESS_0, ch);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[1]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[2]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[4]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[5]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[6]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[7]);
		
		irq.irqInfo.regWrite[8] = TW6864_R_SHSCALER_REG(m_iDev);
		irq.irqInfo.regWrite[9] = TW6864_R_VIDEO_SIZE_REG(m_iDev);
		
		irq.irqInfo.regWrite[10]= TW2864_R_HSCALE_LO_0+ch*3;
		irq.irqInfo.regWrite[11]= TW2864_R_VSCALE_LO_0+ch*3;
		irq.irqInfo.regWrite[12]= TW2864_R_VHSCALE_HI_0+ch*3;
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[10]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[11]);
		MAKE_PCI2I2C(TW2864_R_I2C_ADDR0, irq.irqInfo.regWrite[12]);
#endif
	}

#if(TW6864_SWITCH_TIMER)
	//TIMER¼
	INIT_TIMERINFO(tmi);
	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.dueTime	 = 0;//-P_TW6864->m_iSwitchDelay*10000;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	tmi.tmiInfo.regWrite[0] = TW6864_R_DMA_CMD;
	tmi.tmiInfo.mskWrite[0] = 1<<m_iDev;
	tmi.tmiInfo.regWrite[2] = TW6864_R_DMA_CMD;
	tmi.tmiInfo.mskWrite[2] = 1<<m_iDev;
	tmi.tmiInfo.regWrite[3] = TW6864_R_DMA_CHANNEL_ENABLE;
	tmi.tmiInfo.mskWrite[3] = 1<<m_iDev;
	m_pParent->AppendTimer(tmi);
	
	irq.irqInfo.timerId		= IRQ_DMPAP;
	
	m_Share->irqData[IRQ_DMPAP].dueTime = (ULONG)-1;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[0] = 0;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[1] = 0;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[2] = 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[3] = 1<<m_iDev;
#else
	irq.irqInfo.regWrite[1] = TW6864_R_DMA_CMD;
	irq.irqInfo.mskWrite[1] = 1<<m_iDev;
	irq.irqInfo.regWrite[18]= TW6864_R_DMA_CMD;
	irq.irqInfo.mskWrite[18]= 1<<m_iDev;
	irq.irqInfo.regWrite[19]= TW6864_R_DMA_CHANNEL_ENABLE;
	irq.irqInfo.mskWrite[19]= 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWrite[18]= 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWrite[19]= 1<<m_iDev;
#endif
	m_pParent->AppendIrq(irq);

	m_Share->irqData[IRQ_DMPAP].regWrite[0] = 0;
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = 0;
	m_Share->irqData[IRQ_DMPAP].regWrite[3] = 0;
	m_Share->irqData[IRQ_DMPAP].freqWrite	= 2;

	return TRUE;
}

//
// ҪD1ɼ(720x480/720x576)ʱϵͳ
// ͨĬź״̬Ϊźţʱ
// ҲͨVDELAYֵ0x14(NTSC)/0x15(PAL)
//
BOOL CDev6864sgSw::OnChannel(CChannel* chl) 
{
	TvSourceInfo vinfo;
	CPlgvSource* vsource = (CPlgvSource*)chl->Plugin(PLG_vsource);
	if(vsource) {
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		vinfo.signal = TRUE;
		vsource->SetPluginInfo(&vinfo, VSRC_signal);
	}
	
	return TRUE;
}

void CDev6864sgSw::SetParameters(void* ctx, BOOL bSignalLast)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	ULONG tmp, tmp1, tmp2;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->capture.width>704)) ? 720 : 704;
	BOOL  is4CIF = IS_4CIF(*vinfo);
	BOOL  isPal = (vinfo->standard==vsStandardPAL);
	int   nHeight = !is4CIF ? vinfo->capture.height : vinfo->capture.height/2;
	LONG  dueTime = -1;
	BOOL  bResync = m_bResync[m_iNext];
	
	if(isPal) {
		if(!bSignalLast) {
			dueTime	= vinfo->signal ? (is4CIF?60:40) : -1;//TW6864_SWITCH_NOSIGNAL;
		}
		else if(P_TW6864->m_iSwitchDelay) {
			dueTime = P_TW6864->m_iSwitchDelay;
		}
		else if(is4CIF) {
			dueTime = 4;
			if((m_tkDiff[m_iNext] > 39900) && (m_tkDiff[m_iNext] < 84000)) {
				if(m_tkDiff[m_iNext] < 43000)		{ dueTime = 15; }
				else if(m_tkDiff[m_iNext] > 83000)	{ dueTime = 25; }
				else if(m_tkDiff[m_iNext] > 62100)	{ dueTime = 15; }
			}
		}
		else if((m_tkDiff[m_iNext] > 20000) && (m_tkDiff[m_iNext] < 66000)) {
			if(m_tkDiff[m_iNext] < 24100)		{ dueTime = 35 - m_tkDiff[m_iNext]/1000; }
			else if(m_tkDiff[m_iNext] > 64000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 62; }
			else if(m_tkDiff[m_iNext] > 59100)	{ dueTime = m_tkDiff[m_iNext]/1000 - 32; }
			else if(m_tkDiff[m_iNext] > 42900)	{ dueTime = -1; }
			else if(m_tkDiff[m_iNext] > 39900)	{ dueTime = 15; }
		}
	}
	else {
		if(!bSignalLast) {
			dueTime	= vinfo->signal ? (is4CIF?48:30) : -1;//TW6864_SWITCH_NOSIGNAL;
		}
		else if(P_TW6864->m_iSwitchDelay) {
			dueTime = P_TW6864->m_iSwitchDelay;
		}
		else if(is4CIF) {
#if(0)
			/*
			 *	NTSC£VDELAYΪ0x16dueTime=-1ʱͲƵfifo errorʱͼײ
			 */
			if(m_tkDiff[m_iNext] < 73000) {
				if(m_tkDiff[m_iNext] < 37000)		{ dueTime = 16; }
				else if(m_tkDiff[m_iNext] > 67000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 50; }
				else if(m_tkDiff[m_iNext] > 60000)	{ dueTime = 2;  }
				else dueTime = -1;
			}
			else if(m_tkDiff[m_iNext] > 81000) {
				if(m_tkDiff[m_iNext] < 86000) {
					dueTime = 40;
				}
			}
			else dueTime = -1;
#else
			dueTime = 16;
#endif
		}
		else {
#if(0)
			if((m_tkDiff[m_iNext] > 16000) && (m_tkDiff[m_iNext] < 69000)) {
				if(m_tkDiff[m_iNext] < 19000)		{ dueTime = 40 - m_tkDiff[m_iNext]/1000; }
				else if(m_tkDiff[m_iNext] > 67000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 30; }
				else if(m_tkDiff[m_iNext] > 55000)	{ dueTime = -1; }
				else if(m_tkDiff[m_iNext] > 49100)	{ dueTime = m_tkDiff[m_iNext]/1000 - 30; }
				else if(m_tkDiff[m_iNext] > 37000)	{ dueTime = -1; }
				else if(m_tkDiff[m_iNext] > 34000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 20; }
			}
#else
			if(m_tkDiff[m_iNext] < 20000) {
				bResync = TRUE;
			}
			else if(m_bResync[m_iNext]) {
				dueTime = m_tkDiff[m_iNext] % 16667;
				if(m_chlList.size() > 2) {
					bResync = (dueTime < 5000);
				}
				else {
					bResync = (dueTime < 5000) && (m_tkDiff[m_iNext] < 100000);
				}
				if(!bResync) {
					bResync = ((16667-dueTime) < 1000);
				}
			}
			m_bResync[m_iNext] = bResync;
			dueTime = bResync ? ((m_tkDiff[m_iNext]>16667)?17:10) : -1;
			//_trace("ch %d diff %d %d %d %d\n", m_iNext, m_tkDiff[m_iNext], m_tkDiff[m_iNext]%33334, m_tkDiff[m_iNext]%16667, bResync);
#endif
		}
	}
	
	if(dueTime <= 0) dueTime=-1;
	m_Share->irqData[IRQ_DMPAP].dueTime = (ULONG)dueTime;
	m_Share->irqData[IRQ_DMPAP].freqWrite	= is4CIF ? 4 : 2;

	//ıbirghtnessֱʵȲ
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = Brightness(vinfo->brightness);
	m_Share->irqData[IRQ_DMPAP].regWrite[2] = Contrast(vinfo->contrast);
	m_Share->irqData[IRQ_DMPAP].regWrite[3] = (m_iDev<4) ? (NextVideoInput()<<30) : ((NextVideoInput()&1)<<(m_iDev-4));
	m_Share->irqData[IRQ_DMPAP].regWrite[4] = Hue(vinfo->hue);
	m_Share->irqData[IRQ_DMPAP].regWrite[5] = Saturation(vinfo->saturation);
	m_Share->irqData[IRQ_DMPAP].regWrite[6] = m_Share->irqData[IRQ_DMPAP].regWrite[5];
	m_Share->irqData[IRQ_DMPAP].regWrite[7] = Sharpness(vinfo->sharpness);

	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->capture.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
	
	//ͬͨʹòͬСĲɼֱ
	//SH_Scaler
	//setup for Black stripe remover
	tmp1 = vinfo->capture.width-abs(vinfo->vleft);	//EndPos
	tmp2 = abs(vinfo->vright);						//StartPos	
	tmp = (tmp1 - tmp2)*(1<<16)/vinfo->capture.width;
	tmp = (tmp2 & 0x1F) | ((tmp1 & 0x3FF) << 5) | (tmp <<15);
	tmp |= (vinfo->vleft>=0) ? TW6864_REMOVE_BLACKSTRIPE : 0;

	m_Share->irqData[IRQ_DMPAP].regWrite[8] = tmp;
	
	tmp = (ULONG)TW6864_VIDEO_SIZE(vinfo->capture.width, nHeight); 
	tmp1 = tmp2 = tmp;

	m_Share->irqData[IRQ_DMPAP].regWrite[9] = tmp;
	
	//H/V Scale
	tmp1 &= 0x7FF; 
	tmp2 = (tmp2>>16)&0x1FF;	 //V
	tmp1 = (maxWidth*256)/tmp1;  //H
	tmp2 = ((isPal?288:240)*256)/tmp2;
	tmp = tmp1 & 0xFF;

	m_Share->irqData[IRQ_DMPAP].regWrite[10]= tmp;

	tmp = tmp2 & 0xFF;
	m_Share->irqData[IRQ_DMPAP].regWrite[11]= tmp;

	tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
	m_Share->irqData[IRQ_DMPAP].regWrite[12]= tmp;

#if(TW6864_SWITCH_TIMER)	//һͨɼD1һͨɼCIFʱҪд
	if(m_iDev < 4) {
		m_Share->irqData[IRQ_DMPAP].regWrite[16]= m_Share->irqData[IRQ_DMPAP].regWrite[10];
		m_Share->irqData[IRQ_DMPAP].regWrite[17]= m_Share->irqData[IRQ_DMPAP].regWrite[11];
		m_Share->irqData[IRQ_DMPAP].regWrite[18]= m_Share->irqData[IRQ_DMPAP].regWrite[12];
	}
#endif
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6864sgSw::PrepareRun()
{
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource = NULL;
	CSample*	  pSample = NULL;
	BOOL		  is4CIF  = FALSE;
	ULONG		  flagReset = 0, flagDelay=0;
	RECT		  rc = {0, 0, 0, 0};
	UINT		  i;
	BOOL		  bSignal = FALSE;
	
	if(m_chlList.size()==0) { return FALSE; }

	if(m_iDev < 4) {
		m_iChannel = CurrentChannel(m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev)) >> 30);
	}
	else {
		i = m_iDev-4;
		m_iChannel = CurrentChannel((m_Share->irqData[IRQ_DMPAP].regWrite[3]>>i) & 1);
	}
	if(!m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
		if(m_iChannel == m_iSignalCheck) {
			m_iSignalCheck = NextCheck(m_iSignalCheck);
		}
		m_iChannel = NextChannel(m_iChannel);
	}
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
	bSignal = vinfo.signal;

	//һdmapһͨ
	m_iNext = NextChannel(m_iChannel);
	if(m_iNext == m_iSignalCheck) {
		m_iSignalCheck = NextCheck(m_iSignalCheck);
	}
	vsource = (CPlgvSource*)m_chlList[m_iNext]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	((PvSourceInfo)vsource->GetPluginInfo())->signal_check = 0;
	SetParameters(&vinfo, bSignal);
	vsource->SetPluginInfo(&vinfo, VSRC_vleft|VSRC_vright|VSRC_hdelay|VSRC_vdelay);

	if(vinfo.reset & DEVSET_devreset) {
		flagReset |= (vinfo.reset&DEVSET_devreset);
	}
	
	if(m_iDev >= 4) {
#if(!TW2865_PARAM_INDIVIDUAL)
		if(vinfo.reset & DEVSET_bright) {
			P_TW6864->SetBright(m_iDev, vinfo.brightness);
		}
		if(vinfo.reset & DEVSET_contrast) {
			P_TW6864->SetContrast(m_iDev, vinfo.contrast);
		}
		if(vinfo.reset & DEVSET_saturation) {
			P_TW6864->SetSaturation(m_iDev, vinfo.saturation);
		}
		if(vinfo.reset & DEVSET_hue) {
			P_TW6864->SetHue(m_iDev, vinfo.hue);
		}
		if(vinfo.reset & DEVSET_sharpness) {
			P_TW6864->SetSharpness(m_iDev, vinfo.sharpness);
		}
#endif
	}
	
	flagDelay = vinfo.reset & (DEVSET_hdelay|DEVSET_vdelay);
	
	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}
	
	if(flagReset == 0) {
		if(flagDelay & DEVSET_hdelay) {
			if(vinfo.hdelay<0)  vinfo.hdelay = -TW686X_HDELAY_DEFAULT(vinfo.capture.width);
			vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
			P_TW6864->SetHDelay(m_iDev, abs(vinfo.hdelay));
		}
		if(flagDelay & DEVSET_vdelay) {
			if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
			vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);
			vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
			P_TW6864->SetVDelay(m_iDev, abs(vinfo.vdelay));
		}
		
		return TRUE;
	}

	RunDmap(0);

	for(i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
		is4CIF = IS_4CIF(vinfo);
		OnBufferFull(m_chlList[i], is4CIF, i*RAWV_NUM, (i+1)*RAWV_NUM);
	}
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_rate_cnt = m_chlList[m_iChannel]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

	is4CIF = IS_4CIF(vinfo);
	P_TW6864->SetStandard(m_iDev, vinfo.standard, FALSE);
	P_TW6864->SetSize(m_iDev, &vinfo);
	P_TW6864->SetFormat(m_iDev, vinfo.capture.pixel_format);
	P_TW6864->SetVcom(m_iDev, vinfo.capture.width, vinfo.vcom);

	vsource->SetPluginInfo(&vinfo, VSRC_vleft|VSRC_vright|VSRC_hdelay|VSRC_vdelay);

#if(TW2865_PARAM_INDIVIDUAL)
	P_TW6864->SetBright(m_iDev, vinfo.brightness);
	P_TW6864->SetContrast(m_iDev, vinfo.contrast);
	P_TW6864->SetSaturation(m_iDev, vinfo.saturation);
	P_TW6864->SetHue(m_iDev, vinfo.hue);
	P_TW6864->SetSharpness(m_iDev, vinfo.sharpness);
#endif
		
	ZeroMemory(m_bResync, sizeof(m_bResync));
	Build(&vinfo);
	
#if(TW6864_SWITCH_NTSC_VDELAY)
	if(!is4CIF) {
		for(i=0; (UINT)i<m_chlList.size(); i++) {
			if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
			vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			if(IS_4CIF(vinfo)) {
				is4CIF = TRUE;
				break;
			}
		}
	}
	if(vinfo.standard == vsStandardNTSC) {
		P_TW6864->SetVerticalDelay(m_iDev, is4CIF?0x16:0x15);
	}
#endif

	return TRUE+TRUE;
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6864sgSw::RunDmap(UCHAR run)
{
	CScopedLock autoLock(P_TW6864->RunLock());
	ULONG tmp  = m_pMem->ind(TW6864_R_DMA_CMD);
	ULONG tmp1 = m_pMem->ind(TW6864_R_DMA_CHANNEL_ENABLE);
	int   ch   = m_iDev;
	BOOL  bWait= FALSE;
	
	if(run) { 
		tmp |= (1<<31);  
		tmp |= (1<<ch);
		tmp1|= (1<<ch);
		m_Share->cpyItems[0].cpyCount = 0;
		m_Share->cpyItems[1].cpyCount = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount = 0;
		NotifyLive(0);
		m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
		m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
		m_iBadFrames = DAEMON_SKIP;
	}
	else { 
		bWait = (tmp&(1<<ch)) && (tmp1&(1<<ch));
		m_iDmap = 0;
		m_iCheck= 0;
		tmp &= ~(1<<ch);
		tmp1&= ~(1<<ch);
		
#if(TW6864_SWITCH_TIMER)
		TCmdTimerInfo tmi;
		INIT_TIMERINFO(tmi);
		tmi.deviceId = m_iDev;
		tmi.timerId  = IRQ_DMPAP;
		m_pParent->CancelTimer(tmi);
#endif
		m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
		if(bWait) {
			for(ch=0; ch<8; ch++) { Sleep(0); }
		}
		m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
	}
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  Ҫźżʱ򵱳ź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev6864sgSw::HasSignal()
{
	long iSignal = 0;
	CPlgvSource* vsource = NULL;
	PvSourceInfo vinfo = NULL;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		
		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = (PvSourceInfo)vsource->GetPluginInfo();
		
		if(i==m_iSignalCheck && !vinfo->signal) {
			vinfo->signal_check++;
		}
		iSignal += vinfo->signal;
	}
	
	return iSignal;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
void CDev6864sgSw::CheckSignal(ULONG vstatus)
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	
	bSignal = !(vstatus&BIT(7)) && (vstatus&BIT(6));
	
	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 1 : 1)) {
			_trace(TEXT("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			P_TW6864->ResetDaemon();
		}
	}
	else {
		vinfo.signal_count = 0;
	}
	
	vsource->SetPluginInfo(&vinfo, setSignal);
}

void CDev6864sgSw::Build(void* ctx)
{
#define DMA_STATUS_HOST_READY			1
	//DMA Channel config
	PDMADescriptor	pDesc = NULL;
	ULONG phyAddr = 0;
	int   nTemp=0, i=0;
	int	  nStartIdx=0, nNextIdx=0;
	BOOL  bCheckPoint = FALSE;
	int   j=m_iDev;
	int	  nDescriptorOffset=j*TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	int	  nCopyLen=TW6864_DMA_DESCRIPTOR_UNIT_LEN;
	BOOL  is4CIF = FALSE;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	is4CIF = IS_4CIF(*vinfo);
	nStartIdx = j*TW6864_DMA_DESCRIPTOR_UNIT;
	nNextIdx  = (j+1)*TW6864_DMA_DESCRIPTOR_UNIT;

	if(!is4CIF) {
		for(int k=0; k<TW6864_DMA_PAGETABLE_NUM/2; k++) {
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k);
			bCheckPoint = (k==0);// && (nCh&1);
			phyAddr = (ULONG)m_bufRaw[k%RAWV_NUM]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			bCheckPoint = FALSE;
			nTemp = vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorB(k);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
	}
	else {
		for(int k=0; k<RAWV_NUM; k++) {
			bCheckPoint = (k==1);// && (nCh&1);
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorP(k*2);
			phyAddr = (ULONG)m_bufRaw[k]->Buffer()->pnodes[0].addr;
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, (i==nStartIdx), bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorB(k*2);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}

			bCheckPoint = FALSE;			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			phyAddr = (ULONG)m_bufRaw[k]->Buffer()->pnodes[0].addr + vinfo->capture.pitch*vinfo->capture.height/2;
			pDesc = P_TW6864->GetDMADescriptorP(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
			
			nTemp = vinfo->capture.pitch*vinfo->capture.height/4;
			pDesc = P_TW6864->GetDMADescriptorB(k*2+1);
			for(i=nStartIdx;i<nNextIdx;i++) {
				if(nTemp == 0) {
					P_TW6864->DISABLE_DESCRIPTOR(&pDesc[i]);
				}
				else if(nTemp > TW6864_DMA_PAGE_LEN) {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, TW6864_DMA_PAGE_LEN, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += TW6864_DMA_PAGE_LEN;
					nTemp -= TW6864_DMA_PAGE_LEN;
				}
				else {
					P_TW6864->FILL_DESCRIPTOR(&pDesc[i], phyAddr, nTemp, 0, TW6864_DMA_DESCRIPTOR_UNIT, FALSE, bCheckPoint, DMA_STATUS_HOST_READY);
					phyAddr += nTemp;
					nTemp = 0;
				}
			}
		}
		
		memcpy(P_TW6864->GetDMADescriptorP(4)+nStartIdx, P_TW6864->GetDMADescriptorP(0)+nStartIdx, nCopyLen);
		memcpy(P_TW6864->GetDMADescriptorB(4)+nStartIdx, P_TW6864->GetDMADescriptorB(0)+nStartIdx, nCopyLen);
	}

	m_Share->cpyItems[0].isCopy		= FALSE;
	m_Share->cpyItems[0].cpyLen		= nCopyLen;
	m_Share->cpyItems[0].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[0].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[0].destOffset	= nDescriptorOffset;
	m_Share->cpyItems[0].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[0].cpyCount	= 0;
	m_Share->cpyItems[0].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
	m_Share->cpyItems[1].isCopy		= FALSE;
	m_Share->cpyItems[1].cpyLen		= nCopyLen;
	m_Share->cpyItems[1].idFrom		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].idDest		= P_TW6864->GetPageTablePhy();
	m_Share->cpyItems[1].fromOffset	= TW6864_DMA_PAGETABLE_LEN + nDescriptorOffset;
	m_Share->cpyItems[1].destOffset	= TW6864_DMA_PAGETABLE_UNIT+ nDescriptorOffset;
	m_Share->cpyItems[1].maxCount	= TW6864_DMA_PAGETABLE_NUM - TW6864_DMA_PAGETABLE;
	m_Share->cpyItems[1].cpyCount	= 0;
	m_Share->cpyItems[1].cpyStep	= TW6864_DMA_PAGETABLE_UNIT;
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6864sgSw::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  is4CIF = FALSE, isPageB = FALSE;
	BOOL  bData  = FALSE;
	CSample* spl = NULL;
	ULONG uCount = 0;
	LONGLONG tkNow = 0;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];

		if(m_iDev < 4) {
			m_iChannel= CurrentChannel(m_Share->irqData[IRQ_DMPAP].regRead[3] >> 30);
		}
		else {
			m_iChannel= CurrentChannel((m_Share->irqData[IRQ_DMPAP].regRead[3] >> (m_iDev-4)) & 1);
			//_trace("-mux = %d\n", m_Share->irqData[IRQ_DMPAP].regWrite[3]);
		}
		if((dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev))) {
			vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			is4CIF = IS_4CIF(vinfo);
			isPageB = (dmapAddr >> m_iDev) & 1;
			if(!is4CIF) {
				bData = isPageB;
			}
			else {
				dmaStatus = m_Share->cpyItems[1].cpyCount;
				bData = (dmaStatus>=4) ? (m_iCheck<4) : (m_iCheck>4);
				m_iCheck = m_Share->cpyItems[1].cpyCount;
			}
			if(bData) {
				tkNow = m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart;
				m_tkDiff[m_iChannel] = (LONG)((tkNow-m_tkLast)*1000000/m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart);
				m_tkLast = tkNow;
				CheckSignal(m_Share->irqData[IRQ_DMPAP].regRead[2]);
				isData = FALSE;
				bData = (m_tkDiff[m_iChannel] > (IS_PAL(vinfo.standard)?24100:20000));
			}
			bData = bData && vinfo.signal;
		}
		
		if(bData) {
			if(!is4CIF) {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*2);
				m_iDmap= ((uCount / 2) + 1) % RAWV_NUM;
				spl = m_bufRaw[m_iDmap];
				spl->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				m_pSample = spl;
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);

				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				isData = TRUE;
			}
			else {
				uCount = m_Share->irqData[IRQ_DMPAP].irqCount % (RAWV_NUM*4);
				m_iDmap= ((uCount / 4) + 1) % RAWV_NUM;

				spl = m_bufRaw[m_iDmap];
				m_pSample = m_bufRaw[RAWV_NUM*m_devCaps->ddesc.iSwitch+m_iDmap];
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
				m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					
				PBYTE p1 = (PBYTE)spl->Buffer()->vaddr;
				PBYTE p2= p1 + vinfo.capture.pitch*vinfo.capture.height/2;
				PBYTE p = (PBYTE)m_pSample->Buffer()->vaddr;
				for(int h=0; h<vinfo.capture.height/2; h++) {
					memcpy(p, p1, vinfo.capture.pitch);
					p += vinfo.capture.pitch;
					memcpy(p, p2, vinfo.capture.pitch);
					p += vinfo.capture.pitch;
					p1+= vinfo.capture.pitch;
					p2+= vinfo.capture.pitch;
				}

				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				
				isData = TRUE;
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}

BOOL CDev6864sgSw::OnDmaError(ULONG status1, ULONG status2, PVOID ctx)
{
	BOOL bBadFrame = status1 & (TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev)|TW6864_R_DMA_XINT_ERROR(m_iDev));
	BOOL bTimeOut  = status2 & (TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_ERR(m_iDev));

	if(status1 & TW6864_R_DMA_VINT_FIFO(m_iDev)) {
		//ע:Y41PʽΪ720ʱǻTW6864_R_DMA_VINT_FIFO(m_iDev)
		PvSourceInfo vinfo = (PvSourceInfo)ctx;
		if(vinfo->capture.pixel_format==vpfYUV411Interspersed) {
			if(vinfo->capture.width>704) {
				bBadFrame = FALSE;
			}
			else if(!IS_PAL(vinfo->standard) && (vinfo->capture.width==352) && (vinfo->capture.height==240))
			{
				bBadFrame = FALSE;
			}
		}
	}
	
	if(bBadFrame || bTimeOut) {
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_iBadFrames++;
		bBadFrame = (m_iBadFrames >= 0);
		if(bTimeOut) {
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
		}
		_trace(TEXT("[]TW6864 dev %d dropped frame, error=%08X status=%08X\n"), m_iDev, status1, status2);
	}

	return bBadFrame;
}

void CDev6864sgSw::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0;
	
	if(vinfo==NULL) { return; }

	nFps = P_TW6864->FpsToken(vinfo->capture.frame_rate);
	if(IS_4CIF(*vinfo)) {
		uRate = P_TW6864->MapFrameRate(nFps, nFps, (vinfo->standard==vsStandardNTSC), (m_iDev<4));
	}
	else if(vinfo->field==VF_Even) {
		uRate = P_TW6864->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6864->MapFrameRate(0, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}

	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev6864sgSw::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp= 0;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }
		if(vinfo.state != plugin_on) { continue; }
		
		spl = m_bufRaw[i*RAWV_NUM];
		nTemp = vinfo.capture.pitch*vinfo.capture.height;
		if(spl->BufferSize() < nTemp) { continue; }
		spl->SetTimeStamp(timestamp());
		spl->SetType(pktVideo);
		spl->SetChannel(chl);
		if(vinfo.capture.pixel_format==vpfYUV420Interspersed) {
			memset(spl->DataPtr(), 0x80, nTemp);
		}
		else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
			memset(spl->DataPtr(), 0x80, nTemp);
		}
		else if(vinfo.capture.pixel_format==vpfRGB16) {
			memset(spl->DataPtr(), 0x00, nTemp);
		}
		else {
			memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
		}
		
		bRet = vsource->Transmit(spl, NULL);
		spl->ClearFlag(PLG_vsource);
	}
	
	return bRet;
}