/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869blkSw.cpp
 *  @brief		豸CDev6869blkSwʵ֣֧TW6869 block dma, non-realtimeģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6869.h"
#include "Dev6869blkSw.h"
#include "PlgvSource.h"
#include "TW686X.h"
#include <mmsystem.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6869blkSw::CDev6869blkSw() :
m_iNext(0),
m_iSignalCheck(0)
{
	ZeroMemory(m_tkDiff, sizeof(m_tkDiff));
	ZeroMemory(m_bResync, sizeof(m_bResync));
}

CDev6869blkSw::~CDev6869blkSw()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869blkSw::OnAllocResource()
{
	CSample*  pSample = NULL;
	int		  i=0, iRawV=m_devCaps->ddesc.iSwitch+1;
	
	for(i=0; i<iRawV; i++) {
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6869blkSw::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6869blkSw::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}

	if(!m_pParent->AllocMemory(RAWV_LEN, m_splTemp.Buffer())) {
		return FALSE;
	}
	
	return (i==iRawV);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869blkSw::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			m_pParent->FreeMemory(pSample->Buffer());
			_trace(TEXT("[Ϣ]CDev6869blkSw::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}

	if(m_splTemp.Buffer()->pnodes != NULL) {
		m_pParent->FreeMemory(m_splTemp.Buffer());
		_trace(TEXT("[Ϣ]CDev6869blkSw::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȡǰеͨ
 *
 *  @return صǰеͨ
 ***************************************************************************************
 */
inline UINT CDev6869blkSw::CurrentChannel(UINT mux)
{
	UINT uCh = 0;
	
	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(i==mux) {
				break;
			}
			uCh++;
		}
	}
	
	return  uCh;
}

/** 
 ***************************************************************************************
 *  ȡ¸ͨ
 *
 *  @return ¸ͨ
 ***************************************************************************************
 */
inline int CDev6869blkSw::NextVideoInput()
{
	int iNext = 0;
	ULONG vInput= 0;
	
	for(ULONG i=0; i<m_devCaps->ddesc.reserved1; i++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(i)) {
			if(iNext == m_iNext) {
				vInput = i;
				break;
			}
			iNext++;
		}
	}
	
	return vInput;
}

/** 
***************************************************************************************
*  ȡ¸Ҫɼͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev6869blkSw::NextChannel(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;
	
	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal || (vinfo.signal_check>=NOSIGNAL_CHECK)) {
			break;
		}
	}
	
	return iNext;
}

/** 
***************************************************************************************
*  ȡ¸Ҫź(ź)ͨ
*
*  @return ¸ͨ
***************************************************************************************
*/
int CDev6869blkSw::NextCheck(int iFrom)
{
	UINT i=0;
	int  iNext=iFrom;
	TvSourceInfo vinfo;
	CPlgvSource* vsource;
	
	for(i=0; i<m_chlList.size(); i++) {
		iNext = (iNext+1) % m_chlList.size();
		if(!m_chlList[iNext]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[iNext]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(!vinfo.signal && (vinfo.signal_check<NOSIGNAL_CHECK)) {
			break;
		}
	}
	
	return iNext;
}

inline ULONG CDev6869blkSw::Brightness(int value)
{
	int val = 0;
	g_util.map(B_MIN, B_MAX, value, B_MIN_6864, B_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6869blkSw::Contrast(int value)
{
	int val = 0;
	g_util.map(C_MIN, C_MAX, value, C_MIN_6864, C_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6869blkSw::Hue(int value)
{
	int val = 0;
	g_util.map(H_MIN, H_MAX, value, H_MIN_6864, H_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6869blkSw::Saturation(int value)
{
	int val = 0;
	g_util.map(S_MIN, S_MAX, value, S_MIN_6864, S_MAX_6864, &val);
	
	return (ULONG)val;
}

inline ULONG CDev6869blkSw::Sharpness(int value)
{
	int val = 0;
	
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6864, SH_MAX_6864, &val);
	val &= 0x0F;
	val |= 0x10;

	return (ULONG)val;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CDev6869blkSw::OnClose()
{
	TCmdTimerInfo	tmi;
	TCmdIrqInfo irq;
	
	//ֹͣ豸
	if(m_state != DEVSTAT_idle) {
		Stop();
		_trace(TEXT("[Ϣ]CDev6864::OnCloseֹͣ(slot %d%d豸%d)\n"), 
			m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().Function, m_pParent->DeviceInfo().DeviceNumber);
	}

#if(TW6864_SWITCH_TIMER)
	//TIMER¼
	INIT_TIMERINFO(tmi);
	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	m_pParent->RemoveTimer(tmi);
#endif
	
	//豸ɾж
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMAALL;
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev);
	m_pParent->RemoveIrq(irq);
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869blkSw::OnOpen()
{
	TCmdTimerInfo	tmi;
	TCmdIrqInfo	irq;
	ULONG		uConfig = 0;
	ULONG		uTemp = 0;
	
	ZeroMemory(m_Share, sizeof(TShareData));
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			P_TW6869->SetMux(m_iDev, (TVideoInput)viInput);
			break;
		}
	}
	
	P_TW6869->SetStandard(m_iDev, TvSourceInfo::default_standard);
	P_TW6869->SetFormat(m_iDev, vpfYUV422Interspersed);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uTemp = m_devCaps->ddesc.bField2 ? 3 : 2;
	
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	uConfig |= (uTemp<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );
	
	uConfig = m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev));
	uConfig = (uConfig & ~0x1FF)		| (0&0x1FF);			//m_StartIdx
	uConfig = (uConfig & ~(0x3FF<<10))	| ((0&0x3FF)<<10);		//m_EndIdx
	uConfig = (uConfig & ~(1<<23))		| ((FALSE&1)<<23);				//m_bHorizontalDecimate
	uConfig = (uConfig & ~(1<<24))		| ((FALSE&1)<<24);				//m_bVerticalDecimate
	uConfig = (uConfig & ~(3<<25))		| ((0&3)<<25);					//m_nDropChannelNum
	uConfig = (uConfig & ~(1<<27))		| ((1&1)<<27);					//m_bDropMasterOrSlave	//((((m_iDev&1)?FALSE:TRUE)&1)<<27)
	uConfig = (uConfig & ~(1<<28))		| ((FALSE&1)<<28);				//m_bDropField			//((bDropField&1)<<28)
	uConfig = (uConfig & ~(1<<29))		| ((FALSE&1)<<29);				//m_bDropOddOrEven
	//uConfig = (uConfig & ~(3<<30))	| ((0&3)<<30);					//m_nCurVideoChannelNum -- mux

	m_pMem->outd(TW6864_R_CH0to7_CONFIG_REG(m_iDev), uConfig);
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), 0);					//0x95555555 for even only, 0xd5555555 for odd only
	
	m_pMem->outd(TW6864_R_DMA_CONFIG,  0x00FF0004);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
													//little endian, bad/vsync protection on

	//R_VERTICAL_CTRLĴ,PALźΪNTSCƵĻͼͳûж
	//R_VERTICAL_CTRLֵС˻Ӱʱͼȶ
	if(m_iDev < 4) {
		m_pMem->outd(TW6864_R_LOOP_CTRL,    0x3d);
		m_pMem->outd(TW6864_R_VERTICAL_CTRL,0x24); //0x26 will cause ch0 and ch1 have dma_error.
	}
	else {
		m_pMem->outd(TW6869_R_LOOP_CTRL,    0x3d);
		m_pMem->outd(TW6869_R_VERTICAL_CTRL,0x24); //0x26 will cause ch0 and ch1 have dma_error.
	}

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev);
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.regRWBase	= irq.irqInfo.regBase;
	//irq.irqInfo.regRead[0]	= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regRead[1]	= TW6864_R_DMA_PB_STATUS;
	irq.irqInfo.regWrite[0] = TW6864_R_DMA_CHANNEL_ENABLE;
	irq.irqInfo.mskWrite[0] = 1<<m_iDev;
	irq.irqInfo.regRead[3]	= TW6864_R_CH0to7_CONFIG_REG(m_iDev);
	irq.irqInfo.regWrite[3] = TW6864_R_CH0to7_CONFIG_REG(m_iDev);
	irq.irqInfo.mskWrite[3] = 0xC0000000;

	if(m_iDev < 4)
	{
		irq.irqInfo.regRead[2]	= TW6864_R_CHANNEL(TW6864_R_VSTATUS_0, m_iDev);
		irq.irqInfo.regWrite[1] = TW6864_R_BRIGHT(m_iDev);
		irq.irqInfo.regWrite[2] = TW6864_R_CONTRAST(m_iDev);
		irq.irqInfo.regWrite[4] = TW6864_R_HUE(m_iDev);
		irq.irqInfo.regWrite[5] = TW6864_R_SAT_U(m_iDev);
		irq.irqInfo.regWrite[6] = TW6864_R_SAT_V(m_iDev);
		irq.irqInfo.regWrite[7] = TW6864_R_SHARPNESS(m_iDev);
		irq.irqInfo.regWrite[10]= TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_0,m_iDev);
		irq.irqInfo.regWrite[11]= TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_0,m_iDev);
		irq.irqInfo.regWrite[12]= TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_0,m_iDev);
		irq.irqInfo.regWrite[16]= TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_F2_0,m_iDev);
		irq.irqInfo.regWrite[17]= TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_F2_0,m_iDev);
		irq.irqInfo.regWrite[18]= TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_F2_0,m_iDev);
	}
	else
	{
		uTemp = m_iDev-4;
		irq.irqInfo.regRead[2]	= TW6864_R_CHANNEL(TW6869_R_VSTATUS_4, uTemp);
		irq.irqInfo.regWrite[1] = TW6864_R_CHANNEL(TW6869_R_BRIGHT_4, uTemp);
		irq.irqInfo.regWrite[2] = TW6864_R_CHANNEL(TW6869_R_CONTRAST_4, uTemp);
		irq.irqInfo.regWrite[4] = TW6864_R_CHANNEL(TW6869_R_HUE_4, uTemp);
		irq.irqInfo.regWrite[5] = TW6864_R_CHANNEL(TW6869_R_SAT_U_4, uTemp);
		irq.irqInfo.regWrite[6] = TW6864_R_CHANNEL(TW6869_R_SAT_V_4, uTemp);
		irq.irqInfo.regWrite[7] = TW6864_R_CHANNEL(TW6869_R_SHARPNESS_4, uTemp);
		irq.irqInfo.regWrite[10]= TW6864_R_CHANNEL(TW6869_R_HSCALE_LO_4,uTemp);
		irq.irqInfo.regWrite[11]= TW6864_R_CHANNEL(TW6869_R_VSCALE_LO_4,uTemp);
		irq.irqInfo.regWrite[12]= TW6864_R_CHANNEL(TW6869_R_VHSCALE_HI_4,uTemp);
		irq.irqInfo.regWrite[16]= TW6864_R_CHANNEL(TW6869_R_HSCALE_LO_F2_4,uTemp);
		irq.irqInfo.regWrite[17]= TW6864_R_CHANNEL(TW6869_R_VSCALE_LO_F2_4,uTemp);
		irq.irqInfo.regWrite[18]= TW6864_R_CHANNEL(TW6869_R_VHSCALE_HI_F2_4,uTemp);
	}

	irq.irqInfo.regWrite[8] = TW6864_R_SHSCALER_REG(m_iDev);
	irq.irqInfo.regWrite[9] = TW6864_R_VIDEO_SIZE_REG(m_iDev);
	irq.irqInfo.regWrite[13]= TW6864_R_BDMA(TW6864_R_BDMA_WHP_0, m_iDev);
	irq.irqInfo.regWrite[14]= TW6864_R_BDMA(TW6864_R_BDMA_WHP_F2_0, m_iDev);
	irq.irqInfo.regWrite[15]= TW6864_R_PHASE_REF_CONFIG;
	irq.irqInfo.mskWrite[15]= (3<<(16+(m_iDev<<1)));

#if(TW6864_SWITCH_TIMER)
	//TIMER¼
	INIT_TIMERINFO(tmi);
	tmi.deviceId = m_iDev;
	tmi.timerId	 = IRQ_DMPAP;
	tmi.tmiInfo.dueTime	 = 0;//-P_TW6869->m_iSwitchDelay*10000;
	tmi.tmiInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	tmi.tmiInfo.regWrite[0] = TW6864_R_DMA_CMD;
	tmi.tmiInfo.mskWrite[0] = 1<<m_iDev;
	//tmi.tmiInfo.regWrite[1] = TW6864_R_DROP_FIELD_REG(m_iDev);
	//tmi.tmiInfo.mskWrite[1] = BIT(30);
	tmi.tmiInfo.regWrite[2] = TW6864_R_DMA_CMD;
	tmi.tmiInfo.mskWrite[2] = 1<<m_iDev;
	tmi.tmiInfo.regWrite[3] = TW6864_R_DMA_CHANNEL_ENABLE;
	tmi.tmiInfo.mskWrite[3] = 1<<m_iDev;
	m_pParent->AppendTimer(tmi);

	irq.irqInfo.timerId		= IRQ_DMPAP;
	irq.irqInfo.regWrite[19]= TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_0, m_iDev);

	m_Share->irqData[IRQ_DMPAP].dueTime = (ULONG)-1;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[0] = 0;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[1] = 0;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[2] = 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWriteTimer[3] = 1<<m_iDev;
#else
	irq.irqInfo.regWrite[1] = TW6864_R_DMA_CMD;
	irq.irqInfo.mskWrite[1] = 1<<m_iDev;
	irq.irqInfo.regWrite[16]= TW6864_R_DROP_FIELD_REG(m_iDev);
	irq.irqInfo.regWrite[17]= TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_0, m_iDev);
	irq.irqInfo.regWrite[18]= TW6864_R_DMA_CMD;
	irq.irqInfo.mskWrite[18]= 1<<m_iDev;
	irq.irqInfo.regWrite[19]= TW6864_R_DMA_CHANNEL_ENABLE;
	irq.irqInfo.mskWrite[19]= 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWrite[16]= FrameRate(FALSE, FALSE, VF_Even);
	m_Share->irqData[IRQ_DMPAP].regWrite[18]= 1<<m_iDev;
	m_Share->irqData[IRQ_DMPAP].regWrite[19]= 1<<m_iDev;
#endif
	m_pParent->AppendIrq(irq);

	m_Share->irqData[IRQ_DMPAP].regWrite[0] = 0;
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = 0;
	m_Share->irqData[IRQ_DMPAP].regWrite[3] = 0;

	return TRUE;
}

//
// ҪD1ɼ(720x480/720x576)ʱϵͳ
// ͨĬź״̬Ϊźţʱ
// ҲͨVDELAYֵ0x14(NTSC)/0x15(PAL)
//
BOOL CDev6869blkSw::OnChannel(CChannel* chl) 
{
	TvSourceInfo vinfo;
	CPlgvSource* vsource = (CPlgvSource*)chl->Plugin(PLG_vsource);
	if(vsource) {
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		vinfo.signal = TRUE;
		vsource->SetPluginInfo(&vinfo, VSRC_signal);
	}

	return TRUE;
}

void CDev6869blkSw::SetParameters(void* ctx, BOOL bSignalLast)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	ULONG tmp, tmp1, tmp2;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->capture.width>704)) ? 720 : 704;
	BOOL  is4CIF = IS_4CIF(*vinfo);
	BOOL  isPal  = IS_PAL(vinfo->standard);
	int   nHeight = !is4CIF ? vinfo->capture.height : vinfo->capture.height/2;
	BOOL  bResync = m_bResync[m_iNext];
	LONG  dueTime = -1;

	m_Share->irqData[IRQ_DMPAP].dueTime = -1;
	m_Share->irqData[IRQ_DMPAP].timerIrq= FALSE;
	m_Share->irqData[IRQ_DMPAP].timerIrqPos = 0;
	m_Share->irqData[IRQ_DMPAP].timerIrqMask= 0;

	if(isPal) {
		if(!bSignalLast) {
			dueTime	= is4CIF ? 40 : 50;
		}
		else if(!vinfo->signal)
		{
			dueTime	= 30;
			m_Share->irqData[IRQ_DMPAP].timerIrq= TRUE;
			m_Share->irqData[IRQ_DMPAP].timerIrqPos = (IRQ_DMPAP<<16) | 0;
			m_Share->irqData[IRQ_DMPAP].timerIrqMask= TW6864_R_DMA_INT_STATUS_DMA(m_iDev);
		}
		else if(m_iChannel == m_iNext)
		{
			dueTime = 30;
		}
		else if(P_TW6869->m_iSwitchDelay) {
			dueTime = P_TW6869->m_iSwitchDelay;
		}
		else if(is4CIF) {
			dueTime = 4;
			if((m_tkDiff[m_iNext] > 39900) && (m_tkDiff[m_iNext] < 84000)) {
				if(m_tkDiff[m_iNext] < 43000)		{ dueTime = 15; }
				else if(m_tkDiff[m_iNext] > 83000)	{ dueTime = 25; }
				else if(m_tkDiff[m_iNext] > 62100)	{ dueTime = 15; }
			}
		}
		else if((m_tkDiff[m_iNext] > 20000) && (m_tkDiff[m_iNext] < 66000)) {
			if(m_tkDiff[m_iNext] < 24100)		{ dueTime = 40 - m_tkDiff[m_iNext]/1000; }
			else if(m_tkDiff[m_iNext] > 64000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 62; }
			else if(m_tkDiff[m_iNext] > 59100)	{ dueTime = m_tkDiff[m_iNext]/1000 - 32; }
			else if(m_tkDiff[m_iNext] > 42900)	{ dueTime = -1; }
			else if(m_tkDiff[m_iNext] > 39900)	{ dueTime = 15; }
		}
	}
	else {
		if(!bSignalLast) {
			dueTime	= 30;
		}
		else if(!vinfo->signal)
		{
			dueTime	= is4CIF ? 20 : 30;
			m_Share->irqData[IRQ_DMPAP].timerIrq= TRUE;
			m_Share->irqData[IRQ_DMPAP].timerIrqPos = (IRQ_DMPAP<<16) | 0;
			m_Share->irqData[IRQ_DMPAP].timerIrqMask= TW6864_R_DMA_INT_STATUS_DMA(m_iDev);
		}
		else if(m_iChannel == m_iNext)
		{
			dueTime = 20;
		}
		else if(P_TW6869->m_iSwitchDelay) {
			dueTime = P_TW6869->m_iSwitchDelay;
		}
		else if(is4CIF) {
#if(0)
			/*
			 *	NTSC£VDELAYΪ0x16dueTime=-1ʱͲƵfifo errorʱͼײ
			 */
			if(m_tkDiff[m_iNext] < 73000) {
				if(m_tkDiff[m_iNext] < 37000)		{ dueTime = 16; }
				else if(m_tkDiff[m_iNext] > 67000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 50; }
				else if(m_tkDiff[m_iNext] > 60000)	{ dueTime = 2;  }
				else dueTime = -1;
			}
			else if(m_tkDiff[m_iNext] > 81000) {
				if(m_tkDiff[m_iNext] < 86000) {
					dueTime = 40;
				}
			}
			else dueTime = -1;
#else
			dueTime = 16;
#endif
		}
		else {
#if(0)
			if((m_tkDiff[m_iNext] > 16000) && (m_tkDiff[m_iNext] < 69000)) {
				if(m_tkDiff[m_iNext] < 19000)		{ dueTime = 40 - m_tkDiff[m_iNext]/1000; }
				else if(m_tkDiff[m_iNext] > 67000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 30; }
				else if(m_tkDiff[m_iNext] > 55000)	{ dueTime = -1; }
				else if(m_tkDiff[m_iNext] > 49100)	{ dueTime = m_tkDiff[m_iNext]/1000 - 30; }
				else if(m_tkDiff[m_iNext] > 37000)	{ dueTime = -1; }
				else if(m_tkDiff[m_iNext] > 34000)	{ dueTime = m_tkDiff[m_iNext]/1000 - 20; }
			}
#else
			if(m_tkDiff[m_iNext] < 20000) {
				bResync = TRUE;
			}
			else if(m_bResync[m_iNext]) {
				dueTime = m_tkDiff[m_iNext] % 16667;
				if(m_chlList.size() > 2) {
					bResync = (dueTime < 5000);
				}
				else {
					bResync = (dueTime < 5000) && (m_tkDiff[m_iNext] < 100000);
				}
				if(!bResync) {
					bResync = ((16667-dueTime) < 1000);
				}
			}
			m_bResync[m_iNext] = bResync;
			dueTime = bResync ? ((m_tkDiff[m_iNext]>16667)?17:10) : -1;
			//_trace("ch %d diff %d %d %d %d\n", m_iNext, m_tkDiff[m_iNext], m_tkDiff[m_iNext]%33334, m_tkDiff[m_iNext]%16667, bResync);
#endif
		}
	}

	if(dueTime <= 0) dueTime=-1;
	m_Share->irqData[IRQ_DMPAP].dueTime = (ULONG)dueTime;
	//m_Share->irqData[IRQ_DMPAP].regWriteTimer[1] = (m_iField[m_iNext] << 30);

	//ıbirghtnessֱʵȲ
	m_Share->irqData[IRQ_DMPAP].regWrite[1] = Brightness(vinfo->brightness);
	m_Share->irqData[IRQ_DMPAP].regWrite[2] = Contrast(vinfo->contrast);
	m_Share->irqData[IRQ_DMPAP].regWrite[3] = (NextVideoInput()<<30);
	m_Share->irqData[IRQ_DMPAP].regWrite[4] = Hue(vinfo->hue);
	m_Share->irqData[IRQ_DMPAP].regWrite[5] = Saturation(vinfo->saturation);
	m_Share->irqData[IRQ_DMPAP].regWrite[6] = m_Share->irqData[IRQ_DMPAP].regWrite[5];
	m_Share->irqData[IRQ_DMPAP].regWrite[7] = Sharpness(vinfo->sharpness);

	//_trace("+mux = %d\n", m_Share->irqData[IRQ_DMPAP].regWrite[3]);

	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->capture.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;

	//ͬͨʹòͬСĲɼֱ
	//SH_Scaler
	//setup for Black stripe remover
	tmp1 = vinfo->capture.width-abs(vinfo->vright); //EndPos
	tmp2 = abs(vinfo->vleft);					   //StartPos	
	tmp = (tmp1 - tmp2)*(1<<16)/vinfo->capture.width;
	tmp = (tmp2 & 0x1F) | ((tmp1 & 0x3FF) << 5) | (tmp <<15);
	tmp |= (vinfo->vleft>=0) ? TW6864_REMOVE_BLACKSTRIPE : 0;

	m_Share->irqData[IRQ_DMPAP].regWrite[8] = tmp;
	
	tmp = (ULONG)TW6864_VIDEO_SIZE(vinfo->capture.width, nHeight); 
	tmp1 = tmp2 = tmp;

	m_Share->irqData[IRQ_DMPAP].regWrite[9] = tmp;
	
	//H/V Scale
	tmp1 &= 0x7FF; 
	tmp2 = (tmp2>>16)&0x1FF;	 //V
	tmp1 = (maxWidth*256)/tmp1;  //H
	tmp2 = ((isPal?288:240)*256)/tmp2;
	tmp = tmp1 & 0xFF;

	m_Share->irqData[IRQ_DMPAP].regWrite[10]= tmp;

	tmp = tmp2 & 0xFF;
	m_Share->irqData[IRQ_DMPAP].regWrite[11]= tmp;

	tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
	m_Share->irqData[IRQ_DMPAP].regWrite[12]= tmp;

	tmp = (vinfo->capture.pitch&0x7FF) |					//line width
		  ((vinfo->capture.pitch&0x7FF)<<11) |				//pitch
		  ((nHeight&0x7FF)<<22);							//height

	m_Share->irqData[IRQ_DMPAP].regWrite[13]= tmp;
	m_Share->irqData[IRQ_DMPAP].regWrite[14]= tmp;

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	//tmp = !is4CIF ? 3 : 2;
	tmp = (!is4CIF || !vinfo->signal) ? 3 : 2;
	m_Share->irqData[IRQ_DMPAP].regWrite[15]= (tmp<<(16+(m_iDev<<1)));

#if(TW6864_SWITCH_TIMER)	//һͨɼD1һͨɼCIFʱҪд
	m_Share->irqData[IRQ_DMPAP].regWrite[16]= m_Share->irqData[IRQ_DMPAP].regWrite[10];
	m_Share->irqData[IRQ_DMPAP].regWrite[17]= m_Share->irqData[IRQ_DMPAP].regWrite[11];
	m_Share->irqData[IRQ_DMPAP].regWrite[18]= m_Share->irqData[IRQ_DMPAP].regWrite[12];
	m_Share->irqData[IRQ_DMPAP].regWrite[19]= (ULONG)m_bufRaw[m_iNext]->Buffer()->pnodes[0].addr;
#else
	m_Share->irqData[IRQ_DMPAP].regWrite[16]= FrameRate(!isPal, is4CIF, vinfo->field);
	m_Share->irqData[IRQ_DMPAP].regWrite[17]= (ULONG)m_bufRaw[m_iNext]->Buffer()->pnodes[0].addr;
#endif
}

/** 
 ***************************************************************************************
 *  ׼豸紴dma program
 *
 *  @return ɹTRUEʧܷFALSEҪ豸򷵻(TRUE+TRUE)
 ***************************************************************************************
 */
long CDev6869blkSw::PrepareRun()
{
	TvSourceInfo  vinfo;
	CPlgvSource*  vsource = NULL;
	CSample*	  pSample = NULL;
	BOOL		  is4CIF  = FALSE;
	ULONG		  flagReset = 0, flagDelay=0;
	RECT		  rc = {0, 0, 0, 0};
	ULONG		  i;
	BOOL		  bSignal = FALSE;
	
	if(m_chlList.size()==0) { return FALSE; }

	m_iChannel = CurrentChannel(m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev)) >> 30);
	if (m_iChannel >= m_chlList.size())	//zxx_20121024
	{
		_trace(TEXT("Waring: m_iChannel = %ld!\n"), m_iChannel);
		return FALSE;
	}
	if(!m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
		if(m_iChannel == m_iSignalCheck) {
			m_iSignalCheck = NextCheck(m_iSignalCheck);
		}
//		m_iChannel = NextChannel(m_iChannel);
	}
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
	bSignal = vinfo.signal;

/*
	if(bSignal) {
		for(i=0; (UINT)i<m_chlList.size(); i++) {
			if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
			vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
			if(!((PvSourceInfo)vsource->GetPluginInfo())->signal) {
				bSignal = FALSE;
				break;
			}
		}
	}
*/

	//һdmapһͨ
	m_iNext = NextChannel(m_iChannel);
	if(m_iNext == m_iSignalCheck) {
		m_iSignalCheck = NextCheck(m_iSignalCheck);
	}
	vsource = (CPlgvSource*)m_chlList[m_iNext]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	((PvSourceInfo)vsource->GetPluginInfo())->signal_check = 0;
	SetParameters(&vinfo, bSignal);
	vsource->SetPluginInfo(&vinfo, VSRC_vleft|VSRC_vright|VSRC_hdelay|VSRC_vdelay);

	if(vinfo.reset & DEVSET_devreset) {
		flagReset |= (vinfo.reset&DEVSET_devreset);
	}

	flagDelay = vinfo.reset & (DEVSET_hdelay|DEVSET_vdelay);

	if(vinfo.reset != 0) {
		vinfo.reset = 0;
		vsource->SetPluginInfo(&vinfo, VSRC_reset);
	}
	
	if(flagReset == 0) {
		if(flagDelay & DEVSET_hdelay) {
			if(vinfo.hdelay<0)  vinfo.hdelay = -TW686X_HDELAY_DEFAULT(vinfo.capture.width);
			vsource->SetPluginInfo(&vinfo, VSRC_hdelay);
			P_TW6869->SetHDelay(m_iDev, abs(vinfo.hdelay));
		}
		if(flagDelay & DEVSET_vdelay) {
			if(vinfo.vdelay<0)  vinfo.vdelay = IS_PAL(vinfo.standard) ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
			vinfo.vdelay = min(vinfo.vdelay, IS_PAL(vinfo.standard)?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);
			vsource->SetPluginInfo(&vinfo, VSRC_vdelay);
			P_TW6869->SetVDelay(m_iDev, abs(vinfo.vdelay));
		}
		
		return TRUE;
	}

	RunDmap(0);

	for(i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
		is4CIF = IS_4CIF(vinfo);
		OnBufferFull(m_chlList[i], is4CIF, i, i+2);
	}
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo   = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_rate_cnt = m_chlList[m_iChannel]->ChannelId() % MAX_FRAMERATE(vinfo.standard);
	vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

	P_TW6869->SetStandard(m_iDev, vinfo.standard, FALSE);
	//P_TW6869->SetSize(m_iDev, vinfo.capture.width, (is4CIF ? vinfo.capture.height/2 : vinfo.capture.height), vinfo.standard);
	P_TW6869->SetFormat(m_iDev, vinfo.capture.pixel_format);
		
	ZeroMemory(m_bResync, sizeof(m_bResync));
	Build(&vinfo);
	//SetFrameRate(&vinfo);

#if(TW6864_SWITCH_NTSC_VDELAY)
	if(!is4CIF) {
		for(i=0; i<m_chlList.size(); i++) {
			if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }
			vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			if(IS_4CIF(vinfo)) {
				is4CIF = TRUE;
				break;
			}
		}
	}
	if(vinfo.standard == vsStandardNTSC) {
		P_TW6869->SetVDelay(m_iDev, is4CIF?0x16:0x15);
	}
#endif

	return TRUE+TRUE;
}

//----------------------------------------------
// лֹͣDMA program
//----------------------------------------------
void CDev6869blkSw::RunDmap(UCHAR run)
{
	CScopedLock autoLock(P_TW6869->RunLock());
	ULONG tmp  = m_pMem->ind(TW6864_R_DMA_CMD);
	ULONG tmp1 = m_pMem->ind(TW6864_R_DMA_CHANNEL_ENABLE);
	int   ch   = m_iDev;
	BOOL  bWait= FALSE;
	
	if(run) { 
		tmp |= (1<<31);  
		tmp |= (1<<ch);
		tmp1|= (1<<ch);
		m_Share->cpyItems[0].cpyCount = 0;
		m_Share->cpyItems[1].cpyCount = 0;
		m_Share->irqData[IRQ_DMPAP].irqCount = 0;
		NotifyLive(0);
		m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
		m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
		m_iBadFrames = DAEMON_SKIP;
	}
	else { 
		bWait = (tmp&(1<<ch)) && (tmp1&(1<<ch));
		m_iDmap = 0;
		m_iCheck= 0;
		tmp &= ~(1<<ch);
		tmp1&= ~(1<<ch);
		
#if(TW6864_SWITCH_TIMER)
		TCmdTimerInfo tmi;
		INIT_TIMERINFO(tmi);
		tmi.deviceId = m_iDev;
		tmi.timerId  = IRQ_DMPAP;
		m_pParent->CancelTimer(tmi);
#endif
		m_pMem->outd(TW6864_R_DMA_CHANNEL_ENABLE, tmp1);  
		if(bWait) {
			for(ch=0; ch<8; ch++) { Sleep(0); }
		}
		m_pMem->outd(TW6864_R_DMA_CMD, tmp);  
	}
}

//-------------------------------------------
// ⺯ֹͣ豸
//-------------------------------------------
BOOL CDev6869blkSw::Stop()
{
	RunDmap(0);
	
	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_vsource);
		m_pSample = NULL;
	}
	
	if(m_bufFull && (m_bufFull->chlFull!=NULL)) {
		for(UINT i=0; i<m_chlList.size(); i++) {
			if(m_bufFull->chlFull == m_chlList[i]) {
				OnBufferFull(m_bufFull->chlFull, FALSE, i, i+2);
				break;
			}
		}
	}
	
	SetState(DEVSTAT_idle);
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  Ҫźżʱ򵱳ź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
long CDev6869blkSw::HasSignal()
{
	long iSignal = 0;
	CPlgvSource* vsource = NULL;
	PvSourceInfo vinfo = NULL;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		if(!m_chlList[i]->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource = (CPlgvSource*)m_chlList[i]->Plugin(PLG_vsource);
		vinfo = (PvSourceInfo)vsource->GetPluginInfo();
		
		if(i==m_iSignalCheck && !vinfo->signal) {
			vinfo->signal_check++;
		}
		iSignal += vinfo->signal;
	}
	
	return iSignal;
}

/** 
 ***************************************************************************************
 *  ⺯Ƿź
 *  ʹR_VSTATUS1_SLOCKʱе߽ϰʱܼΪź
 *
 *  @return źŷTRUE򷵻FALSE
 ***************************************************************************************
 */
void CDev6869blkSw::CheckSignal(ULONG vstatus)
{
	BOOL	 bSignal = FALSE;
	ULONG	 setSignal = VSRC_signal_count;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	
	vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	
	bSignal = !(vstatus&BIT(7)) && (vstatus&BIT(6));
	
	if(bSignal!=vinfo.signal) {
		vinfo.signal_count++;
		if(vinfo.signal_count > (vinfo.signal ? 1 : 1)) {
			_trace(TEXT("[Ϣ]HasSignalͨ%dź״̬ı%d >> %d\n"), m_chlList[m_iChannel]->ChannelId(), vinfo.signal, bSignal);
			vinfo.signal= bSignal;
			vinfo.signal_count = 0;
			setSignal  |= VSRC_signal;
			P_TW6869->ResetDaemon();
		}
	}
	else {
		vinfo.signal_count = 0;
	}
	
	vsource->SetPluginInfo(&vinfo, setSignal);
}

void CDev6869blkSw::Build(void* ctx)
{
	PMemBlock	pmb = NULL;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	BOOL  is4CIF = IS_4CIF(*vinfo);
	int   nHeight = !is4CIF ? vinfo->capture.height : vinfo->capture.height/2;
	ULONG uTemp, uConfig;

	pmb = m_bufRaw[m_iChannel]->Buffer();
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_B_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
	m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_WHP_0, m_iDev), 
				(vinfo->capture.pitch&0x7FF) |						//line width
				((vinfo->capture.pitch&0x7FF)<<11) |				//pitch
				((nHeight&0x7FF)<<22)								//height
				);
	pmb = m_bufRaw[m_iChannel+1]->Buffer();
#if(TW6864_SWITCH_TIMER)
	m_Share->irqData[IRQ_DMPAP].regWrite[19]= (ULONG)pmb->pnodes[0].addr;
#else
	m_Share->irqData[IRQ_DMPAP].regWrite[17]= (ULONG)pmb->pnodes[0].addr;
#endif

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uTemp = !is4CIF ? 3 : 2;
	
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	uConfig |= (uTemp<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );

	//field 2
	P_TW6869->SetSizeF2(m_iDev, vinfo);
	P_TW6869->SetSize(m_iDev, vinfo);
	if(!is4CIF) {
		pmb = m_splTemp.Buffer();
		m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_P_F2_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
		m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_ADDR_B_F2_0, m_iDev), (ULONG)pmb->pnodes[0].addr );
		m_pMem->outd( TW6864_R_BDMA(TW6864_R_BDMA_WHP_F2_0, m_iDev), 
			(vinfo->capture.pitch&0x7FF) |						//line width
			((vinfo->capture.pitch&0x7FF)<<11) |				//pitch
			((nHeight&0x7FF)<<22)								//height
			);
	}
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6869blkSw::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  isPageB = FALSE, isField2=FALSE;
	LONGLONG tkNow = 0;
	CSample* pSample = NULL;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		//fifoStatus= m_Share->irqData[IRQ_DMPAP].regRead[0];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[1];
		isData = FALSE;
		m_iChannel= CurrentChannel(m_Share->irqData[IRQ_DMPAP].regRead[3] >> 30);
		if (m_iChannel >= m_chlList.size())	//zxx_20121024
		{
			_trace(TEXT("Warning: m_iChannel = %ld!\n"), m_iChannel);
			return isData;
		}

		tkNow = m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart;
		m_tkDiff[m_iChannel] = (LONG)((tkNow-m_tkLast)*1000000/m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart);
		m_tkLast = tkNow;

 		//if(m_iChannel==0) {
 		//	_trace("irq diff %d %d %d %d %d\n", m_iDev, m_tkDiff[0], m_tkDiff[1], m_tkDiff[2], m_tkDiff[3]);
 		//}

		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		
		CheckSignal(m_Share->irqData[IRQ_DMPAP].regRead[2]);
		OnDmaError(fifoStatus, dmaStatus, &vinfo);
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];

		if((dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) && vinfo.signal) {
			m_iDmap = (dmapAddr >> m_iDev) & 1;
			isField2 = (dmapAddr & (1<<(24+m_iDev))) ? 1 : 0;
			if(isField2 || (m_iDmap>0)) {
				//ʱд
				_trace(TEXT("error : device %d ch %d get a filed 2 buffer ...\n"), m_iDev, m_iChannel);
			}
			else {
				isData = (m_tkDiff[m_iChannel] > (IS_PAL(vinfo.standard)?24100:20000));
				if(isData) {
					isData = TRUE;
					pSample = m_bufRaw[m_iChannel + m_iDmap];
					pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
					m_pSample = pSample;
					m_pSample->SetFlag(PLG_vsource);
					m_pSample->SetTimeStamp(timestamp());
					m_pSample->SetChannel(m_chlList[m_iChannel]);
					vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
					vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				}
				else {
					//_trace("ch %d dropped frame\n", m_iChannel);
				}
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}

BOOL CDev6869blkSw::OnDmaError(ULONG status1, ULONG status2, PVOID ctx)
{
	BOOL bBadFrame = (status1 & (TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev))) != 0;
	BOOL bTimeOut  = status2 & (TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_ERR(m_iDev));

	if(bBadFrame || bTimeOut) {
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_iBadFrames++;
		bBadFrame = (m_iBadFrames >= 0);
		if(bTimeOut) {
			RunDmap(0);
			SetState(DEVSTAT_readyrun);
		}
		_trace("[]TW6864 dev %d ch %d dropped frame, error=%08X status=%08X\n", m_iDev, m_iChannel, status1, status2);
	}

	return bBadFrame;
}

void CDev6869blkSw::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0;
	
	if(vinfo==NULL) { return; }
	
	nFps = MAX_FRAMERATE(vinfo->standard);
	if(IS_4CIF(*vinfo)) {
		uRate = P_TW6869->MapFrameRate(nFps, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(vinfo->field==VF_Even) {
		uRate = P_TW6869->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6869->MapFrameRate(0, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
}

ULONG CDev6869blkSw::FrameRate(BOOL isNTSC, BOOL is4CIF, int iFiled)
{
	ULONG		 uRate = 0;
	int			 nFps  = 0;
	
	nFps = isNTSC ? 30 : 25;
	if(is4CIF) {
		uRate = P_TW6869->MapFrameRate(nFps, nFps, isNTSC, (m_iDev<4));
	}
	else if(iFiled==VF_Even) {
		uRate = P_TW6869->MapFrameRate(nFps, 0, isNTSC, FALSE);
	}
	else {
		uRate = P_TW6869->MapFrameRate(0, nFps, isNTSC, FALSE);
	}
	
	return uRate;
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev6869blkSw::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp= 0;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }
		
		spl = m_bufRaw[i];
		nTemp = vinfo.capture.pitch*vinfo.capture.height;
		if(spl->BufferSize() < nTemp) { continue; }
		spl->SetTimeStamp(timestamp());
		spl->SetType(pktVideo);
		spl->SetChannel(chl);
		if(vinfo.capture.pixel_format==vpfYUV420Interspersed) {
			memset(spl->DataPtr(), 0x80, nTemp);
		}
		else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
			memset(spl->DataPtr(), 0x80, nTemp);
		}
		else if(vinfo.capture.pixel_format==vpfRGB16) {
			memset(spl->DataPtr(), 0x00, nTemp);
		}
		else {
			memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
		}
		bRet = vsource->Transmit(spl, NULL);
		spl->ClearFlag(PLG_vsource);
	}
	
	return bRet;
}