/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869sg.cpp
 *  @brief		豸CDev6869sgʵ֣֧TW6869 scatter gatherģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6869.h"
#include "Dev6869sg.h"
#include "PlgvSource.h"
#include "TW686X.h"

#define TW6864_CHECKPOINT				BIT(13)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6869sg::CDev6869sg()
{

}

CDev6869sg::~CDev6869sg()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869sg::OnAllocResource()
{
	CSample*  pSample = NULL;
	PMemBlock pmb = NULL;
	int		  i=0;
	
	for(i=0; i<RAWV_NUM; i++) {
		//page table P
		pmb = new TMemBlock;
		ZeroMemory(pmb, sizeof(TMemBlock));
		if(pmb == NULL) {
			break;
		}
		if(m_pParent->AllocMemory(TW6864_DMA_PAGETABLE_UNIT, pmb)) {
			ZeroMemory(pmb->vaddr, TW6864_DMA_PAGETABLE_UNIT);
			m_memDmapP.push_back(pmb);
		}
		else {
			SAFE_DELETE(pmb);
			break;
		}

		//page table P
		pmb = new TMemBlock;
		ZeroMemory(pmb, sizeof(TMemBlock));
		if(pmb == NULL) {
			break;
		}
		if(m_pParent->AllocMemory(TW6864_DMA_PAGETABLE_UNIT, pmb)) {
			ZeroMemory(pmb->vaddr, TW6864_DMA_PAGETABLE_UNIT);
			m_memDmapB.push_back(pmb);
		}
		else {
			SAFE_DELETE(pmb);
			break;
		}
		
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6869sg::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
#if(!defined(CONTIG_FRAME_BUFFER))
		else if(pSample->Allocate(m_nBufferLen) && m_pParent->MapMemory(pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
#else
		else if(m_pParent->AllocMemory(m_nBufferLen, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
#endif
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6869sg::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);
	}
	
	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869sg::OnFreeResource()
{
	CSample* pSample = NULL;

	while(m_bufRaw.size() > 0) {
		pSample = m_bufRaw.back();
		if(pSample->Buffer()->pnodes != NULL) {
			if(pSample->IsAllocated()) {
				m_pParent->UnmapMemory(pSample->Buffer());
			}
			else {
				m_pParent->FreeMemory(pSample->Buffer());
			}
			_trace(TEXT("[Ϣ]CDev6869sg::OnFreeResource()ͷDMA bufferɹ(slot %d,function 0,device %d)\n"), 
				m_pParent->CardInfo()->nSlot, m_pParent->DeviceInfo().DeviceNumber);
		}
		delete pSample;
		m_bufRaw.pop_back();
	}

	while(m_memDmapP.size() > 0) {
		m_pParent->FreeMemory(m_memDmapP.back());
		delete m_memDmapP.back();
		m_memDmapP.pop_back();
	}

	while(m_memDmapB.size() > 0) {
		m_pParent->FreeMemory(m_memDmapB.back());
		delete m_memDmapB.back();
		m_memDmapB.pop_back();
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @param	[in]isOpenForVerifyǷֻҪУ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869sg::OnOpen()
{
	TCmdIrqInfo	irq;
	ULONG		uConfig = 0;
	int			nStartIdx = 0;
	int			nNextIdx  = TW6864_DMA_PAGETABLE_UNIT/8 - 1;
	UINT page_table_p[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE0, TW6869_R_DMA_PAGE_TABLE2, TW6869_R_DMA_PAGE_TABLE4, TW6869_R_DMA_PAGE_TABLE6,
		TW6869_R_DMA_PAGE_TABLE8, TW6869_R_DMA_PAGE_TABLEA, TW6869_R_DMA_PAGE_TABLEC, TW6869_R_DMA_PAGE_TABLEE
	};
	UINT page_table_b[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE1, TW6869_R_DMA_PAGE_TABLE3, TW6869_R_DMA_PAGE_TABLE5, TW6869_R_DMA_PAGE_TABLE7,
		TW6869_R_DMA_PAGE_TABLE9, TW6869_R_DMA_PAGE_TABLEB, TW6869_R_DMA_PAGE_TABLED, TW6869_R_DMA_PAGE_TABLEF
	};
	
	ZeroMemory(m_Share, sizeof(TShareData));
	for(ULONG viInput=viCompositeVideo1; viInput<m_devCaps->ddesc.reserved1; viInput++) {
		if(m_devCaps->ddesc.VideoInputMask & INPUT_MASK(viInput)) {
			P_TW6869->SetMux(m_iDev, (TVideoInput)viInput);
			break;
		}
	}
	
	P_TW6869->SetStandard(m_iDev, TvSourceInfo::default_standard);
	P_TW6869->SetFormat(m_iDev, vpfYUV422Interspersed);

	/*
	 * 0 -- scatter gather, 2 -- frame block mode, 3 -- field block mode
	 */
	uConfig  = m_pMem->ind( TW6864_R_PHASE_REF_CONFIG );
	uConfig &= ~(3<<(16+(m_iDev<<1)));
	m_pMem->outd( TW6864_R_PHASE_REF_CONFIG, uConfig );
	
	uConfig = m_pMem->ind(TW6864_R_CH0to7_CONFIG_REG(m_iDev));
	uConfig = (uConfig & ~0x1FF)		| (nStartIdx&0x1FF);			//m_StartIdx
	uConfig = (uConfig & ~(0x3FF<<11))	| ((nNextIdx&0x3FF)<<11);		//m_EndIdx
	uConfig = (uConfig & ~(1<<23))		| ((FALSE&1)<<23);				//m_bHorizontalDecimate
	uConfig = (uConfig & ~(1<<24))		| ((FALSE&1)<<24);				//m_bVerticalDecimate
	uConfig = (uConfig & ~(3<<25))		| ((0&3)<<25);					//m_nDropChannelNum
	uConfig = (uConfig & ~(1<<27))		| ((TRUE&1)<<27);				//m_bDropMasterOrSlave	//((((m_iDev&1)?FALSE:TRUE)&1)<<27)
	uConfig = (uConfig & ~(1<<28))		| ((FALSE&1)<<28);				//m_bDropField			//((bDropField&1)<<28)
	uConfig = (uConfig & ~(1<<29))		| ((FALSE&1)<<29);				//m_bDropOddOrEven
	//uConfig = (uConfig & ~(3<<30))	| ((0&3)<<30);					//m_nCurVideoChannelNum -- mux
	
	m_pMem->outd(TW6864_R_CH0to7_CONFIG_REG(m_iDev), uConfig);
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), 0x95555555);			//0x95555555 for even only, 0xd5555555 for odd only
	
	m_pMem->outd(TW6864_R_DMA_CONFIG,  0x00FF0004);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
													//little endian, bad/vsync protection on

	//豸жϼ¼
	INIT_IRQINFO(irq);
	irq.deviceId = m_iDev;
	irq.irqInfo.irqId	 = IRQ_DMPAP;
	irq.irqInfo.mask[0]	 = TW6864_R_DMA_INT_STATUS_TOUT|TW6864_R_DMA_INT_STATUS_DMA(m_iDev)|TW6864_R_DMA_INT_STATUS_ERR(m_iDev);
	irq.irqInfo.regBase  = (ULONG)m_pMem->CpuBaseAddress();
	irq.irqInfo.regMask[0]  = (ULONG)-1;
	irq.irqInfo.regStatus[0]= TW6864_R_DMA_INT_STATUS;
	irq.irqInfo.status[0]   = 0;
	irq.irqInfo.regStatus[1]= TW6864_R_DMA_INT_ERROR;
	irq.irqInfo.regMask[1]  = (ULONG)-1;
	irq.irqInfo.mask[1]		= TW6864_R_DMA_VINT_FIFO(m_iDev)|TW6864_R_DMA_VINT_FLOW(m_iDev);
	irq.irqInfo.status[1]   = 0;
	irq.irqInfo.regRWBase= irq.irqInfo.regBase;
	irq.irqInfo.regRead[0] = TW6864_R_DMA_PB_STATUS;
	irq.irqInfo.regRead[1] = page_table_p[m_iDev];
	irq.irqInfo.regRead[2] = page_table_b[m_iDev];
	irq.irqInfo.regWrite[1]= page_table_p[m_iDev];
	irq.irqInfo.mskWrite[1]= 0xFFFFFFFF;
	irq.irqInfo.regWrite[2]= page_table_b[m_iDev];
	irq.irqInfo.mskWrite[2]= 0xFFFFFFFF;
	m_pParent->AppendIrq(irq);

	return TRUE;
}

void CDev6869sg::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0, nFps1 = 0;
	BOOL		 bStop = FALSE;
	
	if(vinfo==NULL) {
		vinfo = (PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
		bStop = TRUE;
	}
	
	nFps = P_TW6869->FpsToken(vinfo->capture.frame_rate);
	if(nFps > MAX_FRAMERATE(vinfo->standard)) { return; }
	if(bStop) {
		RunDmap(0);
	}
		
	if(IS_4CIF(*vinfo) || vinfo->optimize_cif) {
		uRate = P_TW6869->MapFrameRate(nFps, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(m_devCaps->ddesc.bField2) {
		nFps1 = P_TW6869->FpsToken(vinfo->preview.frame_rate);
		uRate = P_TW6869->MapFrameRate(nFps, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(vinfo->field==VF_Even) {
		uRate = P_TW6869->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6869->MapFrameRate(0, nFps, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
	if(bStop) {
		m_iBadFrames = 1;
		SetState(DEVSTAT_readyrun);
	}
}

void CDev6869sg::Build(void* ctx)
{
	UINT i=0;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	UINT page_table_p[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE0, TW6869_R_DMA_PAGE_TABLE2, TW6869_R_DMA_PAGE_TABLE4, TW6869_R_DMA_PAGE_TABLE6,
		TW6869_R_DMA_PAGE_TABLE8, TW6869_R_DMA_PAGE_TABLEA, TW6869_R_DMA_PAGE_TABLEC, TW6869_R_DMA_PAGE_TABLEE
	};
	UINT page_table_b[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE1, TW6869_R_DMA_PAGE_TABLE3, TW6869_R_DMA_PAGE_TABLE5, TW6869_R_DMA_PAGE_TABLE7,
		TW6869_R_DMA_PAGE_TABLE9, TW6869_R_DMA_PAGE_TABLEB, TW6869_R_DMA_PAGE_TABLED, TW6869_R_DMA_PAGE_TABLEF
	};
	
	if(IS_4CIF(*vinfo)) {
		for(i=0; i<m_bufRaw.size(); i++) {
			Build(m_memDmapP[i], m_bufRaw[i]->Buffer(), 0, vinfo);
			Build(m_memDmapB[i], m_bufRaw[i]->Buffer(), vinfo->capture.pitch, vinfo);
		}
		m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[1%m_bufRaw.size()]->pnodes[0].addr;
		m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapB[0]->pnodes[0].addr;
		m_pMem->outd(page_table_p[m_iDev], (ULONG)m_memDmapP[0]->pnodes[0].addr);
		m_pMem->outd(page_table_b[m_iDev], (ULONG)m_memDmapB[0]->pnodes[0].addr);
	}
	else {
		for(i=0; i<m_bufRaw.size(); i++) {
			Build(m_memDmapP[i], m_bufRaw[i]->Buffer(), 0, vinfo);
			Build(m_memDmapB[i], m_bufRaw[i]->Buffer(), 0, vinfo);
		}
		m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[2%m_bufRaw.size()]->pnodes[0].addr;
		m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapP[1%m_bufRaw.size()]->pnodes[0].addr;
		m_pMem->outd(page_table_p[m_iDev], (ULONG)m_memDmapP[0]->pnodes[0].addr);
		m_pMem->outd(page_table_b[m_iDev], (ULONG)m_memDmapP[1%m_bufRaw.size()]->pnodes[0].addr);
	}
}

void CDev6869sg::Build(PMemBlock pmbPageTable, PMemBlock pmbBuffer, ULONG offset, void* ctx)
{
#define DMA_STATUS_HOST_READY			1
	//DMA Channel config
	PDMADescriptor	pDesc = (PDMADescriptor)pmbPageTable->vaddr;
	ULONG phyAddr = 0;
	int   nTemp=0, i=0;
	BOOL  is4CIF = FALSE;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	is4CIF = IS_4CIF(*vinfo) || vinfo->optimize_cif;
	ZeroMemory(pmbPageTable->vaddr, TW6864_DMA_PAGE_LEN);

	if(!is4CIF) {
		i = 0;
		nTemp = vinfo->capture.pitch * vinfo->capture.height;
		if(pmbBuffer->inode > 1) {
			while(nTemp > 0) {
				phyAddr = (ULONG)pmbBuffer->pnodes[i].addr;
				P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, min(nTemp,TW6864_DMA_PAGE_LEN), 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
				pDesc++;
				nTemp -= TW6864_DMA_PAGE_LEN;
				i++;
			}
		}
		else {
			phyAddr = (ULONG)pmbBuffer->pnodes[0].addr;
			while(nTemp > 0) {
				P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, min(nTemp,TW6864_DMA_PAGE_LEN), 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
				pDesc++;
				phyAddr += TW6864_DMA_PAGE_LEN;
				nTemp -= TW6864_DMA_PAGE_LEN;
				i++;
			}
		}
	}
	else {
		int stride = vinfo->capture.pitch*2;
		int k=0;

		if(pmbBuffer->inode > 1) {
			phyAddr = (ULONG)pmbBuffer->pnodes[k].addr + offset;
			nTemp = TW6864_DMA_PAGE_LEN - offset;
			for(i=0; i<vinfo->capture.height/2; i++) {
				if(nTemp >= vinfo->capture.pitch) {
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, vinfo->capture.pitch, 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
					pDesc++;
					phyAddr += stride;
					nTemp -= stride;
					if(nTemp <= 0) {
						k++;
						phyAddr = (ULONG)pmbBuffer->pnodes[k].addr;
						phyAddr += -nTemp;
						nTemp += TW6864_DMA_PAGE_LEN;
					}
				}
				else {
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, nTemp, 0, 0, 0, 1, DMA_STATUS_HOST_READY);
					pDesc++;

					k++;
					phyAddr = (ULONG)pmbBuffer->pnodes[k].addr;
					nTemp = (vinfo->capture.pitch - nTemp);
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, nTemp, 0, 0, 0, 1, DMA_STATUS_HOST_READY);
					pDesc++;
					nTemp += vinfo->capture.pitch;
					phyAddr += nTemp;
					nTemp = TW6864_DMA_PAGE_LEN - nTemp;
				}
			}
		}
		else {
			phyAddr = (ULONG)pmbBuffer->pnodes[k].addr + offset;
			nTemp = offset % TW6864_DMA_PAGE_LEN;
			for(i=0; i<vinfo->capture.height/2; i++) {
				k = TW6864_DMA_PAGE_LEN - nTemp; 
				if(k >= vinfo->capture.pitch) {
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, vinfo->capture.pitch, 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
					pDesc++;
				}
				else {
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, k, 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
					pDesc++;
					P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr+k, vinfo->capture.pitch-k, 0, 0, 0, 1, DMA_STATUS_HOST_READY);
					pDesc++;
				}
				phyAddr += stride;
				nTemp = (nTemp+stride) % TW6864_DMA_PAGE_LEN;
			}
		}
	}
}

UINT CDev6869sg::LastDmaBuffer(BOOL isPageB, ULONG dmap)
{
	UINT i = 0, iRet=0;

	if(isPageB) {
		for(i=0; i<m_memDmapB.size(); i++) {
			if(dmap == (ULONG)m_memDmapB[i]->pnodes[0].addr) {
				iRet = i;
				break;
			}
		}
	}
	else {
		for(i=0; i<m_memDmapP.size(); i++) {
			if(dmap == (ULONG)m_memDmapP[i]->pnodes[0].addr) {
				iRet = i;
				break;
			}
		}
	}

	return iRet;
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6869sg::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  is4CIF = FALSE, isPageB = FALSE;
	BOOL  bData  = FALSE;
	UINT iNext = 0;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[0];
		P_TW6869->OnDma(OnDmaError(fifoStatus, dmaStatus, &vinfo));
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];

		if(dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) {
			is4CIF = IS_4CIF(vinfo) || vinfo.optimize_cif;
			isPageB = (dmapAddr >> m_iDev) & 1;

			if(is4CIF) {
				bData = isPageB;
				if(isPageB) {
					iNext = (m_iDmap+2) % m_bufRaw.size();
					m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[iNext]->pnodes[0].addr;
				}
				else {
					m_iDmap = LastDmaBuffer(isPageB, m_Share->irqData[IRQ_DMPAP].regRead[isPageB+1]);
					iNext = (m_iDmap+1) % m_bufRaw.size();
					m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapB[iNext]->pnodes[0].addr;
				}
			}
			else {
				m_iDmap = LastDmaBuffer(FALSE, m_Share->irqData[IRQ_DMPAP].regRead[isPageB+1]);
				iNext = (m_iDmap+3) % m_bufRaw.size();
				m_Share->irqData[IRQ_DMPAP].regWrite[(!isPageB)+1] = (ULONG)m_memDmapP[iNext]->pnodes[0].addr;
				bData = TRUE;
			}
		}
		
		if(bData) {
			if(!is4CIF) {
				m_pSample = m_bufRaw[m_iDmap];
				m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

				isData = TRUE;
			}
			else {
				m_pSample = m_bufRaw[m_iDmap];
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);
				m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);

				vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
				vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);
				
				isData = TRUE;
			}
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0]  = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}
