/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869sg2f.cpp
 *  @brief		豸CDev6869sg2fʵ֣֧TW6869 scatter gather -- two fieldģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6869.h"
#include "Dev6869sg2f.h"
#include "PlgvSource.h"
#include "TW686X.h"
#include <mmsystem.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDev6869sg2f::CDev6869sg2f() :
m_splFiled2(NULL),
m_iDmapPreview(0)
{

}

CDev6869sg2f::~CDev6869sg2f()
{

}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869sg2f::OnAllocResource()
{
	CSample*  pSample = NULL;
	PMemBlock pmb = NULL;
	int		  i=0;
	
	for(i=0; i<RAWV_NUM; i++) {
		//page table P
		pmb = new TMemBlock;
		ZeroMemory(pmb, sizeof(TMemBlock));
		if(pmb == NULL) {
			break;
		}
		if(m_pParent->AllocMemory(TW6864_DMA_PAGETABLE_UNIT, pmb)) {
			ZeroMemory(pmb->vaddr, TW6864_DMA_PAGETABLE_UNIT);
			m_memDmapP.push_back(pmb);
		}
		else {
			SAFE_DELETE(pmb);
			break;
		}
		
		//page table P
		pmb = new TMemBlock;
		ZeroMemory(pmb, sizeof(TMemBlock));
		if(pmb == NULL) {
			break;
		}
		if(m_pParent->AllocMemory(TW6864_DMA_PAGETABLE_UNIT, pmb)) {
			ZeroMemory(pmb->vaddr, TW6864_DMA_PAGETABLE_UNIT);
			m_memDmapB.push_back(pmb);
		}
		else {
			SAFE_DELETE(pmb);
			break;
		}
		
		//ԭʼbuffer
		pSample = new CSample();
		if(pSample == NULL) {
			_trace(TEXT("[]CDev6869sg2f::OnAllocResource()-ƵRaw CSampleʧ\n"));
			break;
		}
#if(!defined(CONTIG_FRAME_BUFFER))
		else if(pSample->Allocate(RAWV_LEN) && m_pParent->MapMemory(pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
#else
		else if(m_pParent->AllocMemory(RAWV_LEN, pSample->Buffer())) {
			m_bufRaw.push_back(pSample);
		}
#endif
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6869sg2f::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktVideo);

		pSample = new CSample();
		if(pSample == NULL) {
			break;
		}
#if(!defined(CONTIG_FRAME_BUFFER))
		else if(pSample->Allocate(RAWV_LEN) && m_pParent->MapMemory(pSample->Buffer())) {
			m_bufField2.push_back(pSample);
		}
#else
		else if(m_pParent->AllocMemory(RAWV_LEN, pSample->Buffer())) {
			m_bufField2.push_back(pSample);
		}
#endif
		else {
			SAFE_DELETE(pSample);
			_trace(TEXT("[]CDev6869sg2f::OnAllocResource()-ӳƵRaw Sampleڴʧ\n"));
			break;
		}
		pSample->SetType(pktField2);
	}

	return (i==RAWV_NUM);
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDev6869sg2f::OnFreeResource()
{
	CSample* pSample = NULL;

	CDev6869sg::OnFreeResource();

	while(m_bufField2.size() > 0) {
		pSample = m_bufField2.back();
		delete pSample;
		m_bufField2.pop_back();
	}

	return TRUE;
}

void CDev6869sg2f::Build(void* ctx)
{
	UINT i=0;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	UINT page_table_p[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE0, TW6869_R_DMA_PAGE_TABLE2, TW6869_R_DMA_PAGE_TABLE4, TW6869_R_DMA_PAGE_TABLE6,
		TW6869_R_DMA_PAGE_TABLE8, TW6869_R_DMA_PAGE_TABLEA, TW6869_R_DMA_PAGE_TABLEC, TW6869_R_DMA_PAGE_TABLEE
	};
	UINT page_table_b[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE1, TW6869_R_DMA_PAGE_TABLE3, TW6869_R_DMA_PAGE_TABLE5, TW6869_R_DMA_PAGE_TABLE7,
		TW6869_R_DMA_PAGE_TABLE9, TW6869_R_DMA_PAGE_TABLEB, TW6869_R_DMA_PAGE_TABLED, TW6869_R_DMA_PAGE_TABLEF
	};
	
	for(i=0; i<m_bufRaw.size(); i++) {
		Build(m_memDmapP[i], m_bufRaw[i]->Buffer(), 0, vinfo);
		Build(m_memDmapB[i], m_bufField2[i]->Buffer(), 1, vinfo);
	}
	
	m_pMem->outd(page_table_p[m_iDev], (ULONG)m_memDmapP[0]->pnodes[0].addr);
	if(vinfo->frame_run & frame_preview) {
		m_pMem->outd(page_table_b[m_iDev], (ULONG)m_memDmapB[0]->pnodes[0].addr);
		m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[1%m_bufRaw.size()]->pnodes[0].addr;
		m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapB[0]->pnodes[0].addr;
	}
	else {
		m_pMem->outd(page_table_b[m_iDev], (ULONG)m_memDmapP[0]->pnodes[0].addr);
		m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[2%m_bufRaw.size()]->pnodes[0].addr;
		m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapP[1%m_bufRaw.size()]->pnodes[0].addr;
	}

	P_TW6869->SetSizeF2(m_iDev, vinfo);
	m_iDmapPreview = 0;
}

void CDev6869sg2f::Build(PMemBlock pmbPageTable, PMemBlock pmbBuffer, ULONG offset, void* ctx)
{
#define DMA_STATUS_HOST_READY			1
	//DMA Channel config
	PDMADescriptor	pDesc = (PDMADescriptor)pmbPageTable->vaddr;
	ULONG phyAddr = 0;
	int   nTemp=0, i=0;
	PvSourceInfo vinfo = (PvSourceInfo)ctx;

	if(offset) {
		nTemp = vinfo->capture.pitch * vinfo->capture.height;
	}
	else {
		nTemp = vinfo->preview.pitch * vinfo->preview.height;
	}
	if(pmbBuffer->inode > 1) {
		i = 0;
		while(nTemp > 0) {
			phyAddr = (ULONG)pmbBuffer->pnodes[i].addr;
			P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, min(nTemp,TW6864_DMA_PAGE_LEN), 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
			pDesc++;
			nTemp -= TW6864_DMA_PAGE_LEN;
			i++;
		}
	}
	else {
		phyAddr = (ULONG)pmbBuffer->pnodes[0].addr;
		while(nTemp > 0) {
			P_TW6869->FILL_DESCRIPTOR(pDesc, phyAddr, min(nTemp,TW6864_DMA_PAGE_LEN), 0, 0, (i==0), 1, DMA_STATUS_HOST_READY);
			pDesc++;
			phyAddr += TW6864_DMA_PAGE_LEN;
			nTemp -= TW6864_DMA_PAGE_LEN;
			i++;
		}
	}
}

/** 
 ***************************************************************************************
 *  жϼʹ
 *
 *  @return жϲݷTRUEûݷFALSE-1
 ***************************************************************************************
 */
long CDev6869sg2f::OnIrq()
{
	long isData = -1;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	ULONG dmapAddr = 0, dmaStatus=0, fifoStatus=0;
	BOOL  isPageB= FALSE;
	UINT  iNext = 0;
	
	//DMAPж
	if(m_Share->irqData[IRQ_DMPAP].evtId != evt_None) {
		vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		isData = FALSE;
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		fifoStatus= m_Share->irqData[IRQ_DMPAP].status[1];
		dmapAddr  = m_Share->irqData[IRQ_DMPAP].regRead[0];
		P_TW6869->OnDma(OnDmaError(fifoStatus, dmaStatus, &vinfo));
		dmaStatus = m_Share->irqData[IRQ_DMPAP].status[0];
		if(dmaStatus & TW6864_R_DMA_INT_STATUS_DMA(m_iDev)) {
			isPageB = (dmapAddr >> m_iDev) & 1;
			if((vinfo.frame_run & frame_preview) && isPageB) {
				m_iDmapPreview = LastDmaBuffer(isPageB, m_Share->irqData[IRQ_DMPAP].regRead[isPageB+1]);
				m_splFiled2 = m_bufField2[m_iDmapPreview];
				m_splFiled2->SetDataSize(vinfo.preview.pitch*vinfo.preview.height);
				m_splFiled2->SetFlag(PLG_vsource);
				m_splFiled2->SetTimeStamp(timestamp());
				m_splFiled2->SetChannel(m_chlList[m_iChannel]);

				iNext = (m_iDmapPreview+1) % m_bufRaw.size();
				m_Share->irqData[IRQ_DMPAP].regWrite[2] = (ULONG)m_memDmapB[iNext]->pnodes[0].addr;
			}
			else {
				m_iDmap = LastDmaBuffer(FALSE, m_Share->irqData[IRQ_DMPAP].regRead[isPageB+1]);
				m_pSample = m_bufRaw[m_iDmap];
				m_pSample->SetDataSize(vinfo.capture.pitch*vinfo.capture.height);
				m_pSample->SetFlag(PLG_vsource);
				m_pSample->SetTimeStamp(timestamp());
				m_pSample->SetChannel(m_chlList[m_iChannel]);

				if(vinfo.frame_run & frame_preview) {
					iNext = (m_iDmap+1) % m_bufRaw.size();
					m_Share->irqData[IRQ_DMPAP].regWrite[1] = (ULONG)m_memDmapP[iNext]->pnodes[0].addr;
				}
				else {
					iNext = (m_iDmap+3) % m_bufRaw.size();
					m_Share->irqData[IRQ_DMPAP].regWrite[(!isPageB)+1] = (ULONG)m_memDmapP[iNext]->pnodes[0].addr;
				}
			}

			vinfo.frame_rate_cnt = (vinfo.frame_rate_cnt+1) % MAX_FRAMERATE(vinfo.standard);
			vsource->SetPluginInfo(&vinfo, VSRC_rate_cnt);

			isData = TRUE;
		}
		m_Share->irqData[IRQ_DMPAP].evtId   = evt_None;
		m_Share->irqData[IRQ_DMPAP].status[0] = 0;
		m_Share->irqData[IRQ_DMPAP].status[1] = 0;
		//m_Share->irqData[IRQ_DMPAP].irqCount= 0;
	}

	return isData;
}

//-----------------------------------------------------
// CTSourceַ֡
//-----------------------------------------------------
BOOL CDev6869sg2f::OnData()
{
	CChannel* chl = NULL;
	CPlugin*  plg = NULL;
	BOOL	  ret = FALSE;
	
	if((m_pSample==NULL) && (m_splFiled2==NULL)) { return FALSE; }
	
	NotifyLive(timeGetTime());
	
	try {
		if(m_pSample) {
			chl = m_pSample->GetChannel();
			if(chl) {
				plg = chl->Plugin(PLG_vsource);
				ret = plg->Transmit(m_pSample, NULL);
			}
		}
		if(m_splFiled2) {
			chl = m_splFiled2->GetChannel();
			if(chl) {
				plg = chl->Plugin(PLG_vsource);
				ret = plg->Transmit(m_splFiled2, NULL);
			}
		}
	}
	catch(...) {
		//ﲶ׽쳣ҪĿǲ쳣ʱܹͷŴsample
		_trace(TEXT("[쳣]CDev6869sg2f::OnData()쳣!"));
	}
	
	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_vsource);
		m_pSample = NULL;
	}
	
	if(m_splFiled2 != NULL) {
		m_splFiled2->ClearFlag(PLG_vsource);
		m_splFiled2 = NULL;
	}
	
	return ret;
}

void CDev6869sg2f::SetFrameRate(void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG		 uRate = 0;
	int			 nFps  = 0, nFps1 = 0;
	BOOL		 bStop = FALSE;

	if(vinfo==NULL) {
		vinfo = (PvSourceInfo)m_chlList[m_iChannel]->Plugin(PLG_vsource)->GetPluginInfo();
		bStop = TRUE;
	}
	
	nFps = P_TW6869->FpsToken(vinfo->capture.frame_rate);
	if(nFps > MAX_FRAMERATE(vinfo->standard)) { return; }
	if(bStop) {
		RunDmap(0);
	}
	
	nFps1 = P_TW6869->FpsToken(vinfo->preview.frame_rate);
	if(vinfo->frame_run == frame_both) {
		uRate = P_TW6869->MapFrameRate(nFps, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else if(vinfo->frame_run == frame_capture) {
		uRate = P_TW6869->MapFrameRate(nFps, 0, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	else {
		uRate = P_TW6869->MapFrameRate(0, nFps1, (vinfo->standard==vsStandardNTSC), FALSE);
	}
	
	m_pMem->outd(TW6864_R_DROP_FIELD_REG(m_iDev), uRate); //0x95555555 for even only, 0xd5555555 for odd only
	if(bStop) {
		m_iBadFrames = 1;
		SetState(DEVSTAT_readyrun);
	}
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDev6869sg2f::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp= 0;
	
	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }

		if(vinfo.frame_run & frame_capture) {
			spl = m_bufRaw[0];
			nTemp = vinfo.capture.pitch*vinfo.capture.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktVideo);
			if(vinfo.capture.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.capture.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}

		if(vinfo.frame_run & frame_preview) {
			spl = m_bufField2[0];
			nTemp = vinfo.preview.pitch*vinfo.preview.height;
			if(spl->BufferSize() < nTemp) { continue; }
			spl->SetTimeStamp(timestamp());
			spl->SetChannel(chl);
			spl->SetType(pktField2);
			if(vinfo.preview.pixel_format==vpfYUV420Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.preview.pixel_format==vpfYUV411Interspersed) {
				memset(spl->DataPtr(), 0x80, nTemp);
			}
			else if(vinfo.preview.pixel_format==vpfRGB16) {
				memset(spl->DataPtr(), 0x00, nTemp);
			}
			else {
				memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
			}
			bRet = vsource->Transmit(spl, NULL);
		}
	}
	
	return bRet;
}