/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869sgSw.h
 *  @brief		豸CDev6869sgSw֧TW6869 scatter gather dma, non-realtimeģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#if !defined(__DEV6869SGSW_H_)
#define __DEV6869SGSW_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Dev6869.h"

class CDev6869sgSw : public CDev6869  
{
public:
	CDev6869sgSw();
	virtual ~CDev6869sgSw();

	virtual long PrepareRun();
	virtual long OnIrq();
	virtual long HasSignal();
	virtual BOOL InsertSample(CSample* pSample);
	virtual void SetFrameRate(void* ctx);
	virtual BOOL OnDmaError(ULONG status1, ULONG status2, PVOID ctx);
	
protected:
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual BOOL OnClose();
	virtual void Build(void* ctx);
	virtual void Build(PMemBlock pmbPageTable, PMemBlock pmbBuffer, ULONG offset, void* ctx);
	virtual void RunDmap(UCHAR run);
	virtual BOOL OnChannel(CChannel* chl);
	
	virtual void CheckSignal(ULONG vstatus);
	virtual void SetParameters(void* ctx, BOOL bSignalLast);
	UINT		 CurrentChannel(UINT mux);
	int			 NextVideoInput();
	int			 NextChannel(int iFrom);
	int			 NextCheck(int iFrom);
	ULONG		 Brightness(int b);
	ULONG		 Contrast(int c);
	ULONG		 Saturation(int s);
	ULONG		 Hue(int h);
	ULONG		 Sharpness(int sh);
	
	int			 m_iSignalCheck;
	int			 m_iNext;
	LONG		 m_tkDiff[4];
	BOOL		 m_bResync[4];
	
	vector<PMemBlock> m_memDmapP;
	vector<PMemBlock> m_memDmapB;
};

#endif // !defined(__DEV6869SGSW_H_)
