/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		DevBase.cpp
 *  @brief		豸CDevBaseʵ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "DevBase.h"
#include "PlgvSource.h"
#include "PlgaSource.h"

int	 CDevBase::m_nAudioPktLen= AUDIO_PACKET_LEN;
int  CDevBase::m_nBufferType = vbtD1;
int  CDevBase::m_nBufferLen	 = RAWV_LEN_4CIF;
CDevBase::TBufferFull*	CDevBase::m_bufFull = NULL;
LONGLONG CDevBase::m_tkOptimize = 0;
LONG CDevBase::m_tkPeriod = OPTIMIZE_PERIOD;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDevBase::CDevBase() :
m_pParent(NULL),
m_pMem(NULL),
m_tkLive(0),
m_Share(NULL),
m_state(DEVSTAT_idle),
m_stateTo(DEVSTAT_idle),
m_stateOld(DEVSTAT_idle),
m_iChannel(0),
m_iDmap(0),
m_pSample(NULL),
m_devCaps(NULL),
m_iDev(0)
{
	m_ifoOptimize.enable = FALSE;
}

CDevBase::~CDevBase()
{

}

//-------------------------------------------
// 豸˺Ҫ
//-------------------------------------------
BOOL CDevBase::Open(CChipset* pParent, PDeviceCapability devCaps, HANDLE hEvent, int iDev)
{
	CSample* pSample = NULL;
	int vlen = 0;

	if((pParent == NULL) || (devCaps==NULL)) {
		return FALSE;
	}

	m_pMem	 = pParent->PciMemory(0);
	m_devCaps= devCaps;
	m_Share  = pParent->OpenDevice(iDev, NULL, hEvent);
	m_iDev	 = iDev;
	m_pParent= pParent;

	m_ifoOptimize.diff = -1;

	if(m_Share == NULL) {
		return FALSE;
	}

	if(!OnOpen()) {
		return FALSE;
	}
	
	if(!OnAllocResource()) {
		return FALSE;
	}

	if(m_nBufferType == vbtD1_preview) {
		if(m_bufFull == NULL) {
			m_bufFull = new TBufferFull;
			m_bufFull->chlFullTo = NULL;
			m_bufFull->chlFull = NULL;
			m_bufFull->chpAlloc= m_pParent;
			for(int i=0; i<RAWV_NUM; i++) {
				pSample = new CSample();
				if(pSample == NULL) {
					return FALSE;
				}
				else if(m_pParent->AllocMemory(RAWV_LEN_4CIF, pSample->Buffer())) {
					m_bufFull->splList.push_back(pSample);
				}
				else {
					SAFE_DELETE(pSample);
					return FALSE;
				}
				pSample->SetType(pktVideo);
			}
		}
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
void CDevBase::Close()
{
	CSample* pSample = NULL;
	
	OnClose();

	if(m_bufFull != NULL) {
		if(m_pParent == m_bufFull->chpAlloc) {
			while(m_bufFull->splList.size() > 0) {
				pSample = m_bufFull->splList.back();
				m_pParent->FreeMemory(pSample->Buffer());
				delete pSample;
				m_bufFull->splList.pop_back();
			}
			delete m_bufFull;
			m_bufFull = NULL;
		}
	}

	OnFreeResource();

	m_pParent->CloseDevice(m_iDev);

	m_pMem	  = NULL;
	m_pParent = NULL;
	m_pSample = NULL;
	m_Share	  = NULL;
}

/** 
 ***************************************************************************************
 *  ڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDevBase::OnAllocResource()
{
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ͷڴԴ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDevBase::OnFreeResource()
{
	return TRUE;
}

/** 
***************************************************************************************
*  ⺯ʹû߹黹ȫBuffer
*  Ҫĳһͨʱɼߴͼ
*
*  @param[in] chlҪȫBufferͨ
*  @param[in] bFullʹû߹黹ȫBuffer
*  @param[in] nBeginʼBufferm_bufRawе
*  @param[in] nEndBufferm_bufRawе
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDevBase::OnBufferFull(CChannel* chl, BOOL bFull, int nBegin, int nEnd)
{
	int i, j=0;
	CSample* pSample = NULL;
	
	if(m_bufFull == NULL) {
		return FALSE;
	}
	
	if(m_bufFull->chlFullTo != chl) {
		return FALSE;
	}
	if(!bFull)	 {
		m_bufFull->chlFull = NULL;
		m_bufFull->chlFullTo = NULL;
	}
	else if(m_bufFull->chlFullTo == m_bufFull->chlFull) {
		return TRUE;
	}
	else {
		m_bufFull->chlFull = m_bufFull->chlFullTo;
	}

	for(i=nBegin; i<nEnd; i++) {
		pSample = m_bufRaw[i];
		m_bufRaw[i] = m_bufFull->splList[j];
		m_bufFull->splList[j]= pSample;
		j++;
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ׼ʼ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDevBase::OnClose()
{
	return TRUE;
}

/** 
 ***************************************************************************************
 *  豸ͨ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDevBase::CreateChannels()
{
	CPlugin*  source;
	CChannel* channel;
	int		  j;
	
	if(m_devCaps->ddesc.iSwitch < 1) {
		return FALSE;
	}
	
	//Ƶ豸ӵͨ
	if(DeviceType() == DEV_audio) {
		channel = new CChannel();
		if(channel == NULL) { return FALSE; }
		
		channel->Init((LONG)g_chlList.size());
			
		source = new CPlgaSource();
		if(source == NULL) { return FALSE; }

		((CPlgaSource*)source)->Init(this);
		if(!channel->AppendPlugin(source)) { 
			source->Uninit();
			delete source;
			return FALSE;
		}
		channel->AppendPlugin(PLG_arawcbk);
		m_chlList.push_back(channel);
		g_chlList.push_back(channel);
	}
	else {
		//Ƶ豸ͨ
		for(j=0; j<m_devCaps->ddesc.iSwitch; j++) {
			channel = new CChannel();
			if(channel == NULL) { return FALSE; }

			channel->Init((LONG)g_chlList.size());
			
			//Դ
			source = new CPlgvSource();
			if(source == NULL) { return FALSE; }

			((CPlgvSource*)source)->Init(this);
			if(!channel->AppendPlugin(source)) {
				source->Uninit();
				delete source;
				return FALSE;
			}
			
			//ӻص
			channel->AppendPlugin(PLG_vrawcbk);
			
			m_chlList.push_back(channel);
			g_chlList.push_back(channel);

			OnChannel(channel);
		}
	}
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  豸ͨ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CDevBase::Append2Channel(CChannel* channel)
{
	CPlugin*  source;
	
	//Ƶ豸ӵͨ
	if(DeviceType() == DEV_audio) {
		source = new CPlgaSource();
		if(source == NULL) { return FALSE; }
		
		((CPlgaSource*)source)->Init(this);
		if(!channel->AppendPlugin(source)) { 
			source->Uninit();
			delete source;
			return FALSE;
		}
		channel->AppendPlugin(PLG_arawcbk);
	}
	else {
	
		//Ƶ豸Դ
		source = new CPlgvSource();
		if(source == NULL) { return FALSE; }
		
		((CPlgvSource*)source)->Init(this);
		if(!channel->AppendPlugin(source)) {
			source->Uninit();
			delete source;
			return FALSE;
		}
		
		//ӻص
		channel->AppendPlugin(PLG_vrawcbk);
	}
	
	m_chlList.push_back(channel);
	
	return TRUE;
}

//-------------------------------------------
// ⺯׼豸
//-------------------------------------------
long CDevBase::PrepareRun()
{
	return TRUE;
}

//-------------------------------------------
// ⺯豸
//-------------------------------------------
BOOL CDevBase::Run()
{
	if(GetState() == DEVSTAT_readystop) {
		return FALSE;
	}

	if(DeviceType() == DEV_video) {
		if(m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
			EnableDmaIrq(TRUE);
			RunDmap(1);
			SetState(DEVSTAT_running);
		}
	}
	else {
		EnableDmaIrq(TRUE);
		RunDmap(1);
		SetState(DEVSTAT_running);
	}
	
	return TRUE;
}

//-------------------------------------------
// ⺯ֹͣ豸
//-------------------------------------------
BOOL CDevBase::Stop()
{
	EnableDmaIrq(FALSE);
	RunDmap(0);
	
	if(m_pSample != NULL) {
		m_pSample->ClearFlag(PLG_vsource);
		m_pSample = NULL;
	}
	
	if(DeviceType() == DEV_video) {
		if(m_bufFull && (m_bufFull->chlFull!=NULL)) {
			for(ULONG i=0; i<m_chlList.size(); i++) {
				if(m_bufFull->chlFull == m_chlList[i]) {
					OnBufferFull(m_bufFull->chlFull, FALSE, i*RAWV_NUM, (i+1)*RAWV_NUM);
					break;
				}
			}
		}
	}
	
	SetState(DEVSTAT_idle);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ͣ/豸
 *
 *  @param[in] enableTRUEΪͣ豸Ϊ豸
 *
 *  @return TRUE
 ***************************************************************************************
 */
long CDevBase::Pause(BOOL enable)
{
	TDeviceState state = GetState();
	
	if(state < DEVSTAT_paused) { return TRUE; }
	
	if(enable) {
		state = DEVSTAT_paused;
	}
	else if(state==DEVSTAT_paused) {
		long iPrepare = PrepareRun();
		if(!iPrepare) {
			//ûźŻ׼ʧܣ´μеĻ
			state = DEVSTAT_readyrun;
		}
		else {
			if(iPrepare>TRUE) {
				if(m_chlList[m_iChannel]->IsEnabled(PLG_RunVideoDevice)) {
					RunDmap(1);
				}
			}
			state = DEVSTAT_running;
		}
	}
	
	SetState(state);
	
	return TRUE;
}

//-------------------------------------------
// ⺯ʹ豸DMAж
//-------------------------------------------
BOOL CDevBase::EnableDmaIrq(BOOL enable)
{
	return TRUE;
}

//-------------------------------------------
// ⺯豸һ״̬
//-------------------------------------------
BOOL CDevBase::SetStateTo(TDeviceState dstat)
{
	CScopedLock autolock(&m_stateLock);
	m_stateTo = dstat;
	return TRUE;
}

//-------------------------------------------
// ⺯豸һ״̬
//-------------------------------------------
BOOL CDevBase::UpdateState()
{
	CScopedLock autolock(&m_stateLock);
	if(m_stateTo > DEVSTAT_idle) {
		if(m_stateTo==DEVSTAT_readyrun) {
			m_stateOld = m_state;
			m_state  = m_stateTo;
		}
		else if(m_stateTo==DEVSTAT_readystop) {
			m_stateOld = m_state;
			m_state  = m_stateTo;
		}
		m_stateTo= DEVSTAT_idle; 
	}

	return TRUE;
}

//-------------------------------------------
// ⺯ͨݷַ
//-------------------------------------------
BOOL CDevBase::OnData()
{
	return TRUE;
}

//-------------------------------------------
// ⺯жϴ
//-------------------------------------------
long CDevBase::OnIrq()
{
	return FALSE;
}

void CDevBase::OnSignalChanged(BOOL bSignal)
{
}

//-------------------------------------------
// ⺯޸֪ͨ¼
//-------------------------------------------
BOOL CDevBase::ModifyEvt(HANDLE hEvent)
{
	TCmdNotifyEventInfo evti;

	if(m_pParent == NULL) {
		return FALSE;
	}

	evti.deviceId = m_iDev;
	evti.evtData  = hEvent;

	return m_pParent->ModifyEvt(evti);
}


//-------------------------------------------
// ⺯豸ǷͨҪ
//-------------------------------------------
BOOL CDevBase::HasChannelRunning(ULONG runFlag)
{
	BOOL hasRun = FALSE;
	for(UINT i=0; i<m_chlList.size(); i++) {
		if(m_chlList[i] && m_chlList[i]->IsEnabled(runFlag)) {
			hasRun = TRUE;
			break;
		}
	}
	
	return hasRun;
}

//-------------------------------------------
// ʱ
//-------------------------------------------
ULONGLONG CDevBase::timestamp()
{
	FILETIME t;
	GetSystemTimeAsFileTime(&t);
	
	return ((((ULONGLONG)t.dwHighDateTime)<<32) | t.dwLowDateTime);
}

/** 
***************************************************************************************
*  ⺯һsample豸ΪԴ
*  Ҫźʱհ
*
*  @param[in] pSampleҪԴ
*
*  @return ɹTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDevBase::InsertSample(CSample* pSample)
{
	CChannel* chl = NULL;
	CSample*  spl = NULL;
	CPlgvSource* vsource = NULL;
	TvSourceInfo vinfo;
	BOOL bRet = FALSE;
	int  nTemp= 0;

	if(m_bufRaw.size() <= 0) { return FALSE; }

	spl = m_bufRaw[0];
	if(spl == NULL) { return FALSE; }
	spl->SetTimeStamp(timestamp());
	spl->SetType(pktVideo);

	for(UINT i=0; i<m_chlList.size(); i++) {
		chl = m_chlList[i];
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { continue; }

		vsource= (CPlgvSource*)chl->Plugin(PLG_vsource);
		vinfo	= *(PvSourceInfo)vsource->GetPluginInfo();
		if(vinfo.signal) { continue; }
	
		nTemp = vinfo.capture.pitch*vinfo.capture.height;
		if(spl->BufferSize() < nTemp) { continue; }
		spl->SetChannel(chl);
		if(vinfo.capture.pixel_format==vpfYUV420Planar) {
			nTemp = vinfo.capture.width*vinfo.capture.height;
			memset(spl->DataPtr(), 0x00, nTemp);
			memset(spl->DataPtr()+nTemp, 0x80, nTemp/2);
		}
		else if(vinfo.capture.pixel_format==vpfYUV411Interspersed) {
			memset(spl->DataPtr(), 0x80, nTemp);
		}
		else if(vinfo.capture.pixel_format==vpfRGB16) {
			memset(spl->DataPtr(), 0x00, nTemp);
		}
		else {
			memcpy(spl->DataPtr(), pSample->DataPtr(), nTemp);
		}

		bRet = vsource->Transmit(spl, NULL);
		spl->ClearFlag(PLG_vsource);
	}
	
	return bRet;
}

/** 
***************************************************************************************
*  鿴豸Ƿ񻹻ţû豸
*  @param[in] tkNowǰʱ
*
*  @return 豸ŷTRUE򷵻FALSE
***************************************************************************************
*/
BOOL CDevBase::CheckLive(ULONG tkNow)
{
	BOOL bLive = (((tkNow-min(tkNow, m_tkLive))<1000) || (m_tkLive==0));
	if(!bLive) {
		_trace(TEXT("[]slot %d, dev %d fucntion %d stopped, state=%08X, diff=%d, evt=%d\n"), m_pParent->CardInfo()->nSlot, 
			m_pParent->DeviceInfo().DeviceNumber, m_pParent->DeviceInfo().Function, GetState(), (tkNow - m_tkLive), m_Share->irqData[IRQ_DMPAP].evtId);
		
		m_tkLive = tkNow;
		Stop();
		
		if(DeviceType() == DEV_video) {
			CPlgvSource* vsource;
			TvSourceInfo vinfo;

			if  (m_iChannel < m_chlList.size())	//zxx_20121024
			{
			vsource = (CPlgvSource*)m_chlList[m_iChannel]->Plugin(PLG_vsource);
			vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
			vinfo.reset |= DEVSET_capturesize;
			vsource->SetPluginInfo(&vinfo, VSRC_reset);
		}
			else
			{
				_trace(TEXT("Waring: m_iChannel = %ld!\n"), m_iChannel);
				return bLive;
			}
		}
		SetState(DEVSTAT_readyrun);
	}
	else if(m_tkLive==0) {
		m_tkLive = tkNow;
	}
	
	return bLive;
}

//-------------------------------------------
// PCIŻ
//-------------------------------------------
LONG CDevBase::PciOptimize()
{
#define OPTIMIZE_EQ	10

	LONGLONG freq=1, tkNow, tkDiff;
	long	 diff;
	ULONG	 i, j, k, uI;
	long	 iTemp=0;
	long	 tkField;
	CDevBase*	 dev = NULL;
	CPlgvSource* vsource = (CPlgvSource*)m_chlList[0]->Plugin(PLG_vsource);
	TvSourceInfo vinfo;
	vector<long> otDiff, etDiff;
	vector<ULONG> otDevs, etDevs;
	static LONGLONG tkLast = 0;

	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	if(!vinfo.signal) { return TRUE; }
	tkField = IS_PAL(vinfo.standard) ? 200 : 167;

	tkNow = m_Share->irqData[IRQ_DMPAP].tkCount.QuadPart;
	freq = m_Share->irqData[IRQ_DMPAP].tkFreq.QuadPart;
	if(m_tkOptimize==0) { 
		m_tkOptimize = tkNow;
		if(tkLast == 0) {
			tkLast = tkNow;
		}
	}
	tkDiff = (tkNow - m_tkOptimize) * 10000 / freq;
	if(tkDiff > 36000000) {
		m_tkOptimize = tkNow;	
		tkDiff = 0;
	}
	m_ifoOptimize.diff = (long)(tkDiff % (tkField*2 + 1));
	if(((tkNow - tkLast) * 1000 / freq) < m_tkPeriod) {
		return (m_tkPeriod>OPTIMIZE_PERIOD_PASS);
	}
	tkLast = tkNow;
	if(m_tkPeriod < OPTIMIZE_PERIOD_MAX) {
		m_tkPeriod += OPTIMIZE_PERIOD;
	}
	tkField += 1;

	for(i=0; (UINT)i<g_devListV.size(); i++) {
		dev = g_devListV[i];
		vsource = (CPlgvSource*)dev->m_chlList[0]->Plugin(PLG_vsource);
		vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
		if(!dev->m_ifoOptimize.enable) { continue; }
		if(!vinfo.signal) { continue; }
		if(IS_4CIF(vinfo) || vinfo.optimize_cif) { continue; }
		if(vinfo.frame_run & frame_preview)	{ continue; }
		if(dev->m_ifoOptimize.diff < 0) { continue; }

		//diffС
		diff = dev->m_ifoOptimize.diff;
		if(diff < tkField) {
			for(j=0; j<otDiff.size(); j++) {
				if(diff <= otDiff[j]) {
					otDiff.insert(otDiff.begin()+j, diff);
					otDevs.insert(otDevs.begin()+j, i);
					break;
				}
			}
			if(j == otDiff.size()) {
				otDiff.push_back(diff);
				otDevs.push_back(i);
			}
		} 
		else {
			diff = diff-tkField;
			for(j=0; j<etDiff.size(); j++) {
				if(diff <= etDiff[j]) {
					etDiff.insert(etDiff.begin()+j, diff);
					etDevs.insert(etDevs.begin()+j, i);
					break;
				}
			}
			if(j == etDiff.size()) {
				etDiff.push_back(diff);
				etDevs.push_back(i);
			}
		}
	}

#ifdef _DBG
	_trace("\n");
	int tkTemp1=0, tkTemp2=0;
	for(i=1; i<otDiff.size(); i++) {
		tkTemp1 += otDiff[i] - otDiff[i-1];
	}
	for(k=0; k<g_devListV.size(); k++) {
		for(i=0; i<otDevs.size(); i++) {
			if(otDevs[i] == k) {
				_trace("%03d-%02d ", otDiff[i], otDevs[i]);
				break;
			}
		}
	}
	_trace("\n");
	for(i=1; i<etDiff.size(); i++) {
		tkTemp2 += etDiff[i] - etDiff[i-1];
	}
	for(k=0; k<g_devListV.size(); k++) {
		for(i=0; i<etDevs.size(); i++) {
			if(etDevs[i] == k) {
				_trace("%03d-%02d ", etDiff[i], etDevs[i]);
				break;
			}
		}
	}
	_trace("\n");
	_trace("point %d/%d %d/%d\n", otDiff.size(), etDiff.size(), tkTemp1, tkTemp2);
#endif

//	DbgCountRun(pci, 5, return (m_tkPeriod>OPTIMIZE_PERIOD_PASS);)

	iTemp = 0;
	k = 1;
	while((otDiff.size()+etDiff.size()) > 1) {
		iTemp = OPTIMIZE_EQ*k;
		k++;

		//ͬһߵͨʱڰ볡ʱûҪֿ
		if(iTemp > (tkField/2)) {
			break;
		}

		//ʱͬɾ
		for(uI=0; uI<otDiff.size(); uI++) {
			for(j=0; j<etDiff.size(); j++) {
				diff = etDiff[j] - otDiff[uI];
				if(abs(diff) < iTemp) {
					//_trace("2 same %d=%d %d\n", diff, otDevs[uI], etDevs[j]);
					otDevs.erase(otDevs.begin()+uI);
					otDiff.erase(otDiff.begin()+uI);
					etDevs.erase(etDevs.begin()+j);
					etDiff.erase(etDiff.begin()+j);
					uI--;
					break;
				}
				else if(diff > 0) {
					break;
				}
			}
		}

		//ͬһʱͬͽӽֿͨ
		for(uI=0; uI<otDiff.size(); uI++) {
			j = uI+1;
			if(j >= otDiff.size()) { break;	}
			if((otDiff[j]-otDiff[uI]) < iTemp) {
				dev = g_devListV[otDevs[j]];
				vsource= (CPlgvSource*)dev->m_chlList[0]->Plugin(PLG_vsource);
				vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
				vinfo.field = VF_Both - vinfo.field;
				vsource->SetPluginInfo(&vinfo, VSRC_field);
				//_trace("1 same %d=%d %d\n", diff, otDevs[uI], otDevs[j]);
				otDevs.erase(otDevs.begin()+j);
				otDiff.erase(otDiff.begin()+j);
				otDevs.erase(otDevs.begin()+uI);
				otDiff.erase(otDiff.begin()+uI);
				uI--;
			}
		}

		for(uI=0; uI<etDiff.size(); uI++) {
			j = uI+1;
			if(j >= etDiff.size()) { break;	}
			if((etDiff[j]-etDiff[uI]) < iTemp) {
				dev = g_devListV[etDevs[j]];
				vsource= (CPlgvSource*)dev->m_chlList[0]->Plugin(PLG_vsource);
				vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
				vinfo.field = VF_Both - vinfo.field;
				vsource->SetPluginInfo(&vinfo, VSRC_field);
				//_trace("0 same %d=%d %d\n", diff, etDevs[uI], etDevs[j]);
				etDevs.erase(etDevs.begin()+j);
				etDiff.erase(etDiff.begin()+j);
				etDevs.erase(etDevs.begin()+uI);
				etDiff.erase(etDiff.begin()+uI);
				uI--;
			}
		}

		//һͷһβȽ,ֵtkFieldķֿ
		for(uI=0; uI<otDiff.size(); uI++) {
			if(etDiff.size() <= 0) { break; }
			diff = tkField - (etDiff.back() + otDiff[uI]);
			if(abs(diff) < iTemp) {
				dev = g_devListV[etDevs.back()];
				vsource= (CPlgvSource*)dev->m_chlList[0]->Plugin(PLG_vsource);
				vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
				vinfo.field = VF_Both - vinfo.field;
				vsource->SetPluginInfo(&vinfo, VSRC_field);
				//_trace("0 same %d=%d %d\n", diff, otDevs[uI], etDevs.back());
				otDevs.erase(otDevs.begin()+uI);
				otDiff.erase(otDiff.begin()+uI);
				etDevs.pop_back();
				etDiff.pop_back();
				uI--;
			}
			else {
				break;
			}
		}
	}
	
	return (m_tkPeriod>OPTIMIZE_PERIOD_PASS);
}
