//////////////////////////////////////////////////////////////////////
// Gpio.h: interface for the CGpio class.
// GPIO
//////////////////////////////////////////////////////////////////////

#if !defined(__GPIO_H_)
#define __GPIO_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// GPIO modes
typedef enum { 
	GPIO_NORMAL,
    GPIO_SPI_OUTPUT,
    GPIO_SPI_INPUT ,
    GPIO_DEBUG_TEST,
} TGpioMode;

class CGpio 
{
protected:
	TGpioMode	_gpio_mode;

public:
	CGpio() {};
	virtual ~CGpio() {};

	virtual bool InitGpio(TGpioMode) = 0;
	virtual bool InitGpio(PVOID pMem) = 0;
	virtual bool EnableGpioOutput(bool enable, int gpio, int bits) = 0;
	virtual bool SetGpioBits(int gpio, int bits, ULONG* value) = 0;
	virtual bool GetGpioBits(int gpio, int bits, ULONG* pValue) = 0;
};

#endif // !defined(__GPIO_H_)
