/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Gpio680x.h
 *  @brief		CGpio680Xʵ,֧TW680x GPIO
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/06
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Gpio680X.h"
#include "TW680X.H"

//////////////////////////////////////////////////////////////////////
// class CGpio680X ʵ
//////////////////////////////////////////////////////////////////////

//-------------------------------------------------------------------
// ʼGPIO
//-------------------------------------------------------------------
bool CGpio680X::InitGpio(TGpioMode mode)
{
	ULONG old = m_pMem->ind(R_GPIOC) & ~R_GPIOC_GPMODE;

	switch(mode) {
	case GPIO_NORMAL:	  { m_pMem->outd(R_GPIOC, old); break; }
	case GPIO_SPI_OUTPUT: { m_pMem->outd(R_GPIOC, old|0x01); break; }
	case GPIO_SPI_INPUT:  { m_pMem->outd(R_GPIOC, old|0x04); break; }
	default: return false;
	}

	_gpio_mode = mode;
	return true;
}

//-------------------------------------------------------------------
// GPIO
//-------------------------------------------------------------------
bool CGpio680X::EnableGpioOutput(bool enable, int gpio, int bits)
{
	ULONG mask= ((1 << bits) - 1) << gpio;
	ULONG old = m_pMem->ind(R_GPOE);
	m_pMem->outd(R_GPOE, enable ? (old|mask) : (old&~mask));

	return true;
}

//-------------------------------------------------------------------
// GPIOƽ
//-------------------------------------------------------------------
bool CGpio680X::SetGpioBits(int gpio, int bits, ULONG* value)
{
	ULONG mask= ((1 << bits) - 1) << gpio;
	ULONG old = m_pMem->ind(R_GPDATA) & ~mask;
	m_pMem->outd(R_GPDATA, old|(*value<<gpio));

	return true;
}

//-------------------------------------------------------------------
// ȡGPIOƽ
//-------------------------------------------------------------------
bool CGpio680X::GetGpioBits(int gpio, int bits, ULONG* pValue)
{
	*pValue = ((m_pMem->ind(R_GPDATA) & (((1 << bits) - 1) << gpio)) >> gpio);

	return true;
}