/**
 ***************************************************************************************
 *  Copyright (C) 2011, Intersil
 *  All rights reserved.
 *
 *  @file 		Gpio6869.h
 *  @brief		GPIOCGpio6869֧TW6869 GPIO
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2011/05/09
 ***************************************************************************************
 */

#if !defined(__GPIO6869_H_)
#define __GPIO6869_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Gpio.h"

class CGpio6869 : public CGpio  
{
public:
	CGpio6869(CMemRange* pMem) : m_pMem(pMem), m_lock(NULL) {};
	virtual ~CGpio6869() {};

	void InitGpio(CLock* syncLock) { m_lock=syncLock; }
	
	virtual bool InitGpio(TGpioMode mode){ return true; }
	virtual bool InitGpio(PVOID pMem) { m_pMem=(CMemRange*)pMem; return true; }
	virtual bool EnableGpioOutput(bool enable, int gpio, int bits);
	virtual bool SetGpioBits(int gpio, int bits, ULONG* value);
	virtual bool GetGpioBits(int gpio, int bits, ULONG* pValue);
	
protected:
	CMemRange* m_pMem;
	CLock*	   m_lock;
};

#endif // !defined(__GPIO6869_H_)
