/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Gpio686x.cpp
 *  @brief		GPIOCGpio686xʵ֣֧TW686x GPIO
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/01/05
 ***************************************************************************************
 */

#include "stdafx.h"
#include "Gpio686x.h"
#include "TW686X.h"
#include "Thread.h"

//-------------------------------------------------------------------
// GPIO
//-------------------------------------------------------------------
bool CGpio686x::EnableGpioOutput(bool enable, int gpio, int bits)
{
	CScopedLock autoLock(m_lock);

	ULONG mask= ((1 << bits) - 1) << (gpio+16);
	ULONG old = m_pMem->ind(TW6864_R_GPIO_REG);
	m_pMem->outd(TW6864_R_GPIO_REG, enable ? (old&~mask) : (old|mask));
	
	return true;
}

//-------------------------------------------------------------------
// GPIOƽ
//-------------------------------------------------------------------
bool CGpio686x::SetGpioBits(int gpio, int bits, ULONG* value)
{
	CScopedLock autoLock(m_lock);

	ULONG mask= ((1 << bits) - 1) << gpio;
	ULONG old = m_pMem->ind(TW6864_R_GPIO_REG) & ~mask;
	m_pMem->outd(TW6864_R_GPIO_REG, old|(((*value)<<gpio) & 0x0000FFFF));
	
	return true;
}

//-------------------------------------------------------------------
// ȡGPIOƽ
//-------------------------------------------------------------------
bool CGpio686x::GetGpioBits(int gpio, int bits, ULONG* pValue)
{
	CScopedLock autoLock(m_lock);

	*pValue = (((m_pMem->ind(TW6864_R_GPIO_REG) & 0x0000FFFF) & (((1 << bits) - 1) << gpio)) >> gpio);
	
	return true;
}