/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Gpio686x.h
 *  @brief		GPIOCGpio686x֧TW686x GPIO
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/01/05
 ***************************************************************************************
 */

#if !defined(__GPIO686X_H_)
#define __GPIO686X_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Gpio.h"

class CGpio686x : public CGpio  
{
public:
	CGpio686x(CMemRange* pMem) : m_pMem(pMem), m_lock(NULL) {};
	virtual ~CGpio686x() {};

	void InitGpio(CLock* syncLock) { m_lock=syncLock; }
	
	virtual bool InitGpio(TGpioMode mode){ return true; }
	virtual bool InitGpio(PVOID pMem) { m_pMem=(CMemRange*)pMem; return true; }
	virtual bool EnableGpioOutput(bool enable, int gpio, int bits);
	virtual bool SetGpioBits(int gpio, int bits, ULONG* value);
	virtual bool GetGpioBits(int gpio, int bits, ULONG* pValue);
	
protected:
	CMemRange* m_pMem;
	CLock*	   m_lock;
};

#endif // !defined(__GPIO686X_H_)
