/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		MemRange.cpp
 *  @brief		PCIĴдCMemRangeʵ
 *				ַʽ
 *				1DeviceIoControl֪ͨʵʶд
 *				2PCIڴռӳ䵽̿ռֱӶдm_bDirectAccess=1
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "MemRange.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMemRange::CMemRange() :
m_hDev(NULL),
m_pPBase(NULL),
m_pVBase(NULL),
m_uLen(0),
m_bDirectAccess(TRUE)
{

}

CMemRange::~CMemRange()
{

}

UCHAR CMemRange::inb(ULONG Offset)
{
	if(m_bDirectAccess) {
		return m_pVBase ? *((UCHAR*)m_pVBase + Offset) : 0;
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemByteInfo cmdInfo   = (PCmdRwMemByteInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return 0;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemBYTEs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			return 0;
		}

		return cmdInfo->data[0];
	}
}

VOID CMemRange::inb(ULONG Offset, PUCHAR buf, ULONG count)
{
	if(m_bDirectAccess) {
		if(m_pVBase) {
			memcpy(buf, m_pVBase, count);
		}
		else {
			ZeroMemory(buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemByteInfo cmdInfo   = (PCmdRwMemByteInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemBYTEs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			ZeroMemory(buf, count);
		}

		memcpy(buf, cmdInfo->data, cmdInfo->len);
	}
}

VOID CMemRange::outb(ULONG Offset, UCHAR data)
{
	if(m_bDirectAccess) {
		if(m_pVBase) {
			*((UCHAR*)m_pVBase + Offset) = data;
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemByteInfo cmdInfo   = (PCmdRwMemByteInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemBYTEs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		cmdInfo->data[0]= data;
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

VOID CMemRange::outb(ULONG Offset, PUCHAR buf, ULONG count)
{
	if(m_bDirectAccess) {
		if(m_pVBase) {
			memcpy((UCHAR*)m_pVBase + Offset, buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemByteInfo cmdInfo   = (PCmdRwMemByteInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemBYTEs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		memcpy(cmdInfo->data, buf, count);
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

USHORT CMemRange::inw(ULONG Offset)
{
	if(m_bDirectAccess) {
		return m_pVBase ? *(USHORT*)((UCHAR*)m_pVBase + Offset) : 0;
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemWordInfo cmdInfo   = (PCmdRwMemWordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return 0;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemWORDs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			return 0;
		}

		return cmdInfo->data[0];
	}
}

VOID CMemRange::inw(ULONG Offset, PUSHORT buf, ULONG count)
{
	if(m_bDirectAccess) {
		count *= sizeof(USHORT);
		if(m_pVBase) {
			memcpy(buf, m_pVBase, count);
		}
		else {
			ZeroMemory(buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemWordInfo cmdInfo   = (PCmdRwMemWordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemWORDs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			ZeroMemory(buf, count*sizeof(USHORT));
		}

		memcpy(buf, cmdInfo->data, cmdInfo->len);
	}
}

VOID CMemRange::outw(ULONG Offset, USHORT data)
{
	if(m_bDirectAccess) {
		if(m_pVBase) {
			*(USHORT*)((UCHAR*)m_pVBase + Offset) = data;
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemWordInfo cmdInfo   = (PCmdRwMemWordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemWORDs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		cmdInfo->data[0]= data;
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

VOID CMemRange::outw(ULONG Offset, PUSHORT buf, ULONG count)
{
	if(m_bDirectAccess) {
		count *= sizeof(USHORT);
		if(m_pVBase) {
			memcpy((UCHAR*)m_pVBase + Offset, buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemWordInfo cmdInfo   = (PCmdRwMemWordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemWORDs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		memcpy(cmdInfo->data, buf, count*sizeof(USHORT));
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

ULONG CMemRange::ind(ULONG Offset)
{
	if(m_bDirectAccess) {
		return m_pVBase ? *(ULONG*)((UCHAR*)m_pVBase + Offset) : 0;
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemDwordInfo cmdInfo   = (PCmdRwMemDwordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return 0;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemDWORDs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			return 0;
		}

		return cmdInfo->data[0];
	}
}

VOID CMemRange::ind(ULONG Offset, PULONG buf, ULONG count)
{
	if(m_bDirectAccess) {
		count *= sizeof(ULONG);
		if(m_pVBase) {
			memcpy(buf, m_pVBase, count);
		}
		else {
			ZeroMemory(buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemDwordInfo cmdInfo   = (PCmdRwMemDwordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdReadMemDWORDs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		if(!DeviceIoControl( m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN,
							 ioBuff, IOBUFF_LEN, &bytesRet, NULL)) {
			ZeroMemory(buf, count*sizeof(ULONG));
		}

		memcpy(buf, cmdInfo->data, cmdInfo->len);
	}
}

VOID CMemRange::outd(ULONG Offset, ULONG data)
{
	if(m_bDirectAccess) {
		if(m_pVBase) {
			*(ULONG*)((UCHAR*)m_pVBase + Offset) = data;
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemDwordInfo cmdInfo   = (PCmdRwMemDwordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemDWORDs;
		cmdInfo->len	= 1;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		cmdInfo->data[0]= data;
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

VOID CMemRange::outd(ULONG Offset, PULONG buf, ULONG count)
{
	if(m_bDirectAccess) {
		count *= sizeof(ULONG);
		if(m_pVBase) {
			memcpy((UCHAR*)m_pVBase + Offset, buf, count);
		}
	}
	else {
		ULONG ioBuff[IOBUFF_LEN_DW];
		PIoctlCommandInfo ioctlInfo = (PIoctlCommandInfo)ioBuff;
		PCmdRwMemDwordInfo cmdInfo   = (PCmdRwMemDwordInfo)ioctlInfo->context;
		ULONG bytesRet = 0;
		int i=0;

		if(!m_hDev) {
			return;
		}
		
		//ʼ豸
		ZeroMemory(ioBuff, IOBUFF_LEN);
		ioctlInfo->cmd	= cmdWriteMemDWORDs;
		cmdInfo->len	= count;
		cmdInfo->memBase= (ULONG)m_pPBase;
		cmdInfo->memOffset = Offset;
		memcpy(cmdInfo->data, buf, count*sizeof(ULONG));
		DeviceIoControl(m_hDev, IOCTL_COMMAND, ioBuff, IOBUFF_LEN, ioBuff, IOBUFF_LEN, &bytesRet, NULL);
	}
}

VOID CMemRange::Dump2File(LPCTSTR szFile)
{
	if(m_bDirectAccess) {
		ULONG  iWriten = 0;
		HANDLE hFile = ::CreateFile(szFile, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);   
		if(hFile == INVALID_HANDLE_VALUE) {	return; }

		::WriteFile(hFile, m_pVBase, m_uLen, &iWriten, NULL);
		::CloseHandle(hFile);
	}
}