// PlgaSource.cpp: implementation of the CPlgaSource class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PlgaSource.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPlgaSource::CPlgaSource() :
m_dev(NULL)
{
	ZeroMemory(&m_info, sizeof(TaSourceInfo));
	m_info.reset = TRUE;
	m_info.volume= 10;
	m_info.channels = 1;
	m_info.bitcount = 8;
	m_info.samplerate = 8000;
}

CPlgaSource::~CPlgaSource()
{
}

//---------------------------------------------------------------------
// 
//---------------------------------------------------------------------
BOOL CPlgaSource::SetPluginInfo(PPluginInfo plgInfo, ULONGLONG flag)
{
	PaSourceInfo info = (PaSourceInfo)plgInfo;
	
	if(info==NULL) { return FALSE; }
	if(flag & ASRC_packet_count) m_info.packet_count = info->packet_count;
	if(flag & PLGSET_state) m_info.state = info->state;
	if(flag & ASRC_reset)	m_info.reset = info->reset;
	if(flag & ASRC_volume) {
		m_info.reset |= DEVSET_volume;
		m_info.volume = info->volume;
	}
	if(flag & ASRC_samplerate) {
		if(m_info.samplerate != info->samplerate) {
			m_info.reset |= DEVSET_samplerate;
			m_info.samplerate = info->samplerate;
		}
	}
	if(flag & ASRC_bitcount) {
		if(m_info.bitcount != info->bitcount) {
			m_info.reset |= DEVSET_bitcount;
			m_info.bitcount = info->bitcount;
		}
	}
	if(flag & ASRC_channels) {
		if(m_info.channels != info->channels) {
			m_info.reset |= DEVSET_channels;
			m_info.channels = info->channels;
		}
	}

	return TRUE;
}

//---------------------------------------------------------------------
// ݴ
//---------------------------------------------------------------------
BOOL CPlgaSource::Transmit(CSample* pSampleIn, CSample* pSampleOut)
{
	CChannel* chl = pSampleIn->GetChannel();
	ULONG hwid = DEVICEID(m_dev->Parent()->DeviceInfo().HardwareId);

	if(((hwid==0x6802) || (hwid==0x6805)) || ((hwid>=0x6814) && (hwid<=0x6817))) {
		PBYTE pp  = (PBYTE)pSampleIn->Buffer()->vaddr;
		PBYTE pBuf= pp;
		int   i=0;

		if(pSampleIn->Buffer()->inode > 1) {
 			for(i = 0; i < AUDIO_LINE_NUM; i++) {
				memcpy(pBuf, pp, AUDIO_LINE_LEN);
				pBuf += AUDIO_LINE_LEN;
 				pp   += AUDIO_PAGE_LEN;
 			}
		}
		pSampleIn->SetIndex(m_info.packet_count);
		m_info.packet_count++;
	}

	pSampleIn->SetType(pktAudio);

	//֡뵽ӦĶ
	if(chl->IsEnabled(PLG_arawcbk)) {
		pSampleIn->SetFlag(PLG_arawcbk);
		g_cbkListA.push_back(pSampleIn);
	}

	return TRUE;
}
