/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		PlgaSource.h
 *  @brief		豸ԴCPlgaSource
 *
 *  @version	0.2.0.0
 *  @author		liran
 *  @date		2009/03/06
 ***************************************************************************************
 */

#if !defined(__PLGASOURCE_H_)
#define __PLGASOURCE_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Plugin.h"

enum {
	DEVSET_volume		= 0x10000000,
	DEVSET_samplerate	= 0x20000000,
	DEVSET_bitcount		= 0x40000000,
	DEVSET_channels		= 0x80000000,
};

#define ASRC_reset				0x00000002
#define ASRC_packet_count		0x00000004
#define ASRC_volume				0x00000008
#define ASRC_samplerate			0x00000010
#define ASRC_bitcount			0x00000020
#define ASRC_channels			0x00000040

struct tagaSourceInfo : public TPluginInfo {
	ULONG	reset;
	ULONG	packet_count;			//Ƶ
	LONG	volume;
	LONG	samplerate;
	LONG	bitcount;
	LONG	channels;
};
typedef struct tagaSourceInfo TaSourceInfo, *PaSourceInfo;

class CPlgaSource : public CPlugin  
{
public:
	CPlgaSource();
	virtual ~CPlgaSource();

	void Init(CDevBase* dev){m_dev=dev;}
	CDevBase* Device(){return m_dev;}
	
	virtual ULONG		PluginId(){return PLG_asource;}
	virtual PPluginInfo GetPluginInfo(){return &m_info;}
	virtual BOOL		SetPluginInfo(PPluginInfo plgInfo, ULONGLONG flag);
	virtual BOOL		Transmit(CSample* pSampleIn, CSample* pSampleOut);
	virtual void		Uninit(){};

protected:
	CDevBase*	 m_dev;
	TaSourceInfo m_info;
};

#endif // !defined(__PLGASOURCE_H_)
