/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Plugin.h
 *  @brief		CPlugin
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__PLUGIN_H_)
#define __PLUGIN_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PLGSET_state	0x00000001
#define PLGSET_all		0xFFFFFFFF	//еĲ

enum {plugin_idle, plugin_off, plugin_ready, plugin_on};
typedef struct tagPluginInfo {
	long	state;
}TPluginInfo, *PPluginInfo;

class CSample;
class CChannel;

class CPlugin  
{
public:
	CPlugin() : m_channel(NULL), m_isTransmit(FALSE) {};
	virtual ~CPlugin() {};

	virtual void		Init(CChannel* channel){m_channel=channel;}
	virtual void		Uninit(){m_isTransmit=FALSE;m_channel=NULL;}
	virtual ULONG		PluginId()	= 0;
	virtual PPluginInfo GetPluginInfo() = 0;
	virtual BOOL		SetPluginInfo(PPluginInfo plgInfo, ULONGLONG flag) = 0;
	virtual BOOL		Transmit(CSample* pSampleIn, CSample* pSampleOut) = 0;
	virtual CChannel*	Channel(){return m_channel;}
	virtual void		SetTransmit(BOOL isTransmit){InterlockedExchange((PLONG)&m_isTransmit, isTransmit);}
	virtual BOOL		IsTransmiting(){return m_isTransmit;}

protected:
	CChannel*	m_channel;
	BOOL		m_isTransmit;
};

#endif // !defined(__PLUGIN_H_)
