//////////////////////////////////////////////////////////////////////
// Register.h: interface for the CRegister class.
// Techwell, 2008.10.10
//////////////////////////////////////////////////////////////////////

#if !defined(__REGISTER_H_)
#define __REGISTER_H_

class CRegister
{
public:	
	CRegister(CMemRange *pMem,ULONG BaseAddr);
	virtual ~CRegister();

	VOID RegBITSet(ULONG nValue, ULONG npos);
	VOID RegBYTESet(ULONG nValue, ULONG npos);
	VOID RegWORDSet(ULONG nValue, ULONG npos);
	VOID RegULONGSet(ULONG nValue, ULONG npos);

	VOID RegBITGet(ULONG &nValue, ULONG npos);
	VOID RegBYTEGet(ULONG &nValue, ULONG npos);
	VOID RegWORDGet(ULONG &nValue, ULONG npos);
	VOID RegULONGGet(ULONG &nValue, ULONG npos);

	VOID RegSet(ULONG nValue, ULONG nWidth, ULONG npos);
	VOID RegGet(ULONG &nValue, ULONG npos);

	VOID RegBYTEAndOrSet(UCHAR msk, UCHAR value);
	VOID RegULONGAndOrSet(ULONG msk, ULONG value);

protected:
	ULONG m_RegAdd;
	CMemRange *m_pMem;
};

class CCompoReg
{
protected:
	CMemRange* m_pMem;
	ULONG m_addrLSB;
	ULONG m_addrMSB;
	UCHAR m_lenLSB;
	UCHAR m_posMSB;
	UCHAR m_lenMSB;
public:
	CCompoReg(CMemRange* pMem, ULONG addrLSB, UCHAR lenLSB,
				  ULONG addrMSB, UCHAR posMSB, UCHAR lenMSB);
	virtual operator ULONG();
	virtual ULONG operator=(ULONG value);
};

//=================================================================================================
/*
typedef enum { RW, RO, WO, RR } TRegisterType;

class CRegBase
{
private:
	TRegisterType type_;
	DWORD        dwShadow_;
	unsigned int uOffset_;
	CMemRange*	 m_pMem;

	CRegBase();

protected:
	void  SetShadow(DWORD dwValue){dwShadow_ = dwValue;};
	DWORD GetShadow(){return dwShadow_;};
	
public:
	CRegBase(CMemRange* pMem, unsigned int uOff, TRegisterType aType) : type_(aType),uOffset_(uOff),m_pMem(pMem),dwShadow_(0){}
	virtual ~CRegBase() {}

	LPBYTE GetBaseAddress()			{return (LPBYTE)m_pMem->GetBaseAddress();}
	TRegisterType  GetRegisterType() {return type_;}
	unsigned int  GetOffset()		{return uOffset_;}

	virtual operator ULONG() = 0;
	virtual DWORD operator=(ULONG dwValue) = 0;
};

class CRegisterB : public CRegBase
{
private:
	CRegisterB();
public:
	CRegisterB(CMemRange* pMem, unsigned int uOff, TRegisterType aType) : CRegBase(pMem, uOff, aType) {};
	virtual ~CRegisterB(){};

	virtual operator ULONG();
	virtual DWORD operator=(ULONG dwValue);
};

class CRegisterW : public CRegBase
{
private:
	CRegisterW();
public:
	CRegisterW(CMemRange* pMem, unsigned int uOff, TRegisterType aType) : CRegBase(pMem, uOff, aType) {};
	virtual ~CRegisterW(){};

	virtual operator ULONG();
	virtual DWORD operator=(ULONG dwValue);
};

class CRegisterDW : public CRegBase
{
private:
	CRegisterDW();
public:
	CRegisterDW(CMemRange* pMem, unsigned int uOff, TRegisterType aType) : CRegBase(pMem, uOff, aType) {};
	virtual ~CRegisterDW(){};

	virtual operator ULONG();
	virtual DWORD operator=(ULONG dwValue);
};
*/
#endif // !defined(__REGISTER_H_)
