// SAA7113.h: interface for the CSAA7113 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__SAA7113_H_)
#define __SAA7113_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vDecoder.h"
#include "I2C.h"

class CSAA7113 : public CvDecoder  
{
public:
	CSAA7113();
	virtual ~CSAA7113();

	virtual void InitDecoder();
	virtual void UninitDecoder();
	virtual void SetStandard(int value, int ch=0);
	virtual void SetMux(TVideoInput vInput, int ch=0);
	virtual void SetFormat(int value, int ch=0);
	virtual void SetSize(int width, int height, int ch=0);
	virtual void SetBright(int value, int ch=0);
	virtual void SetContrast(int value, int ch=0);
	virtual void SetHue(int value, int ch=0);
	virtual void SetSaturation(int value, int ch=0);
	virtual void SetSharpness(int value, int ch=0);
	virtual BOOL GetSignal(int ch=0);

	void SetI2C(CI2C* i2c) { m_i2c=i2c; }

protected:
	virtual UCHAR  inb(ULONG Offset);
	virtual VOID   outb(ULONG Offset, UCHAR data);
	virtual USHORT inw(ULONG Offset);
	virtual VOID   outw(ULONG Offset, USHORT data);
	virtual ULONG  ind(ULONG Offset);
	virtual VOID   outd(ULONG Offset, ULONG data);

	CI2C*	m_i2c;
};

#endif // !defined(__SAA7113_H_)
