//////////////////////////////////////////////////////////////////////
// SafeVector.h: interface for the CSafeVector class.
// ̰߳ȫvector
//////////////////////////////////////////////////////////////////////

#if !defined(__SAFEVECTOR_H_)
#define __SAFEVECTOR_H_

#include "Thread.h"
#include <vector>
#include <deque>
#include <list>

using namespace std;

template <class _Ty> 
class CSafeVector  
{
public:
	CSafeVector() {};
	virtual ~CSafeVector(){};

	void SetNotifyEvent(HANDLE hEvt){
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_Evts.size(); i++) {
					if(hEvt == m_Evts[i]) { return; }
				}
				m_Evts.push_back(hEvt);
			}
	int  size(){CScopedLock autoLock(&m_lock); return (int)m_vector.size();}
	int  capacity(){CScopedLock autoLock(&m_lock); return m_vector.capacity();}
	void erase(int _P){CScopedLock autoLock(&m_lock); m_vector.erase(m_vector.begin()+_P);}
	bool empty(){CScopedLock autoLock(&m_lock); return m_vector.empty();}
	void push_back(const _Ty _X){
				UINT i;
				CScopedLock autoLock(&m_lock);
				for(i=0; i<m_vector.size(); i++) {
					if(m_vector[i] == _X) {
						break;
					}
				}
				if(i==m_vector.size()) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}
	void pop_back(){CScopedLock autoLock(&m_lock); m_vector.pop_back();}
	void clear(){CScopedLock autoLock(&m_lock);	m_vector.clear();}
	_Ty& front(){CScopedLock autoLock(&m_lock); return m_vector.front();}
	_Ty& back(){CScopedLock autoLock(&m_lock); return m_vector.back();}
	_Ty& at(int _P){CScopedLock autoLock(&m_lock); return m_vector.at(_P);}
	_Ty& operator[](int _P){CScopedLock autoLock(&m_lock); return m_vector[_P];}

	//ռһеԪ
	_Ty  usefor(ULONG forwhat, _Ty len=NULL) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if((*m_vector[i] == (ULONG)0x00000000) && (*m_vector[i] == len)) {
						ret = m_vector[i];
						*m_vector[i] |= forwhat;
						break;
					}
				}
				return ret;
			}
	
	//ǰߵԪ
	bool pop_front(_Ty& out_front) {
				bool ret = false;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					out_front = m_vector.front();
					m_vector.erase(m_vector.begin());
					ret = true;
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front() {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					ret = m_vector.front();
					m_vector.erase(m_vector.begin());
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front(ULONG flag) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if(*m_vector[i]==(PVOID)flag) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//ָԪ
	_Ty  pop_front(int item, ULONG flag) {
		_Ty ret = (_Ty)NULL;
		CScopedLock autoLock(&m_lock);
		for(UINT i=0; i<m_vector.size(); i++) {
			if((*m_vector[i] == item) && (*m_vector[i]==(PVOID)flag)) {
				ret = m_vector[i];
				m_vector.erase(m_vector.begin()+i);
				break;
			}
		}
		return ret;
	}
	
	//ָԪ
	_Ty  pop_item(int item) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if(*m_vector[i] == item) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//ָΧǰԪ
	_Ty  pop_item(int from, int to) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if((*m_vector[i]>=from) && (*m_vector[i]<=to)) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//
	void push_back(const _Ty _X, int item) {
				int pos = -1, num=0;
				CScopedLock autoLock(&m_lock);
				for(int i=m_vector.size()-1; i>=0; i--) {
					if(*m_vector[i]==item) {
						if(*m_vector[i]<*_X){
							if(num > 0) {
								pos = i+1;
								m_vector.insert(m_vector.begin()+pos, _X);
							}
							break;
						}
						else {
							num++;
						}
					}
				}
				if(pos < 0) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}

protected:
	vector<_Ty> m_vector;
	CLockCS		m_lock;
	vector<HANDLE> m_Evts;
};

template <class _Ty> 
class CSafeDeque
{
public:
	CSafeDeque() {};
	virtual ~CSafeDeque(){};

	void SetNotifyEvent(HANDLE hEvt){
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_Evts.size(); i++) {
					if(hEvt == m_Evts[i]) { return; }
				}
				m_Evts.push_back(hEvt);
			}
	int  size(){CScopedLock autoLock(&m_lock); return m_vector.size();}
	int  capacity(){CScopedLock autoLock(&m_lock); return m_vector.size();}
	void erase(int _P){CScopedLock autoLock(&m_lock); m_vector.erase(m_vector.begin()+_P);}
	bool empty(){CScopedLock autoLock(&m_lock); return m_vector.empty();}
	void push_back(const _Ty _X){
				UINT i;
				CScopedLock autoLock(&m_lock);
				for(i=0; i<m_vector.size(); i++) {
					if(m_vector[i] == _X) {
						break;
					}
				}
				if(i==m_vector.size()) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}
	void pop_back(){CScopedLock autoLock(&m_lock); m_vector.pop_back();}
	void clear(){CScopedLock autoLock(&m_lock);	m_vector.clear();}
	_Ty& front(){CScopedLock autoLock(&m_lock); return m_vector.front();}
	_Ty& back(){CScopedLock autoLock(&m_lock); return m_vector.back();}
	_Ty& at(int _P){CScopedLock autoLock(&m_lock); return m_vector.at(_P);}
	_Ty& operator[](int _P){CScopedLock autoLock(&m_lock); return m_vector[_P];}

	//ռһеԪ
	_Ty  usefor(ULONG forwhat) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if(*m_vector[i] == (ULONG)0x00000000) {
						ret = m_vector[i];
						*m_vector[i] |= forwhat;
						break;
					}
				}
				return ret;
			}
	
	//ǰߵԪ
	bool pop_front(_Ty& out_front) {
				bool ret = false;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					out_front = m_vector.front();
					m_vector.pop_front();
					ret = true;
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front() {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					ret = m_vector.front();
					m_vector.pop_front();
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front(ULONG flag) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if(*m_vector[i]==(PVOID)flag) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//ָԪ
	_Ty  pop_front(int item, ULONG flag) {
		_Ty ret = (_Ty)NULL;
		CScopedLock autoLock(&m_lock);
		for(UINT i=0; i<m_vector.size(); i++) {
			if((*m_vector[i] == item) && (*m_vector[i]==(PVOID)flag)) {
				ret = m_vector[i];
				m_vector.erase(m_vector.begin()+i);
				break;
			}
		}
		return ret;
	}
	
	//ָԪ
	_Ty  pop_item(int item) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if(*m_vector[i] == item) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//ָΧǰԪ
	_Ty  pop_item(int from, int to) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_vector.size(); i++) {
					if((*m_vector[i]>=from) && (*m_vector[i]<=to)) {
						ret = m_vector[i];
						m_vector.erase(m_vector.begin()+i);
						break;
					}
				}
				return ret;
			}

	//
	void push_back(const _Ty _X, int item) {
				int pos = -1, num=0;
				CScopedLock autoLock(&m_lock);
				for(int i=m_vector.size()-1; i>=0; i--) {
					if(*m_vector[i]==item) {
						if(*m_vector[i]<*_X){
							if(num > 0) {
								pos = i+1;
								m_vector.insert(m_vector.begin()+pos, _X);
							}
							break;
						}
						else {
							num++;
						}
					}
				}
				if(pos < 0) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}

protected:
	deque<_Ty>  m_vector;
	CLockCS		m_lock;
	vector<HANDLE> m_Evts;
};

template <class _Ty> 
class CSafeList
{
public:
	CSafeList() {};
	virtual ~CSafeList(){};
	typedef list<_Ty> _TList;

	void SetNotifyEvent(HANDLE hEvt){
				CScopedLock autoLock(&m_lock);
				for(UINT i=0; i<m_Evts.size(); i++) {
					if(hEvt == m_Evts[i]) { return; }
				}
				m_Evts.push_back(hEvt);
			}
	int  size(){CScopedLock autoLock(&m_lock); return m_vector.size();}
	int  capacity(){CScopedLock autoLock(&m_lock); return m_vector.max_size();}
	void erase(int _P){
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(UINT i=0; i<m_vector.size(); i++) {
					if(i == (UINT)_P) {
						m_vector.erase(it);
						break;
					}
					it++;
				}
			}
	bool empty(){CScopedLock autoLock(&m_lock); return m_vector.empty();}
	void push_back(const _Ty _X){
				UINT i;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(i=0; i<m_vector.size(); i++) {
					if(*it == _X) {
						break;
					}
					it++;
				}
				if(i==m_vector.size()) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}
	void pop_back(){CScopedLock autoLock(&m_lock); m_vector.pop_back();}
	void clear(){CScopedLock autoLock(&m_lock);	m_vector.clear();}
	_Ty& front(){CScopedLock autoLock(&m_lock); return m_vector.front();}
	_Ty& back(){CScopedLock autoLock(&m_lock); return m_vector.back();}
	_Ty& operator[](int _P){
			UINT i;
			CScopedLock autoLock(&m_lock); 
			_TList::iterator it = m_vector.begin();
			for(i=0; i<m_vector.size(); i++) {
				if(i == _P) {
					return *it;
				}
				it++;
			}
			return (_Ty)NULL;
		}
	_Ty& at(int _P){
		UINT i;
		CScopedLock autoLock(&m_lock); 
		_TList::iterator it = m_vector.begin();
		for(i=0; i<m_vector.size(); i++) {
			if(i == _P) {
				return *it;
			}
			it++;
		}
		return (_Ty)NULL;
	}

	//ռһеԪ
	_Ty  usefor(ULONG forwhat) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(UINT i=0; i<m_vector.size(); i++) {
					if(**it == (ULONG)0x00000000) {
						ret = *it;
						**it |= forwhat;
						break;
					}
					it++;
				}
				return ret;
			}
	
	//ǰߵԪ
	bool pop_front(_Ty& out_front) {
				bool ret = false;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					out_front = m_vector.front();
					m_vector.pop_front();
					ret = true;
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front() {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				if(m_vector.size() > 0) {
					ret = m_vector.front();
					m_vector.pop_front();
				}
				return ret;
			}

	//ǰߵԪ
	_Ty  pop_front(ULONG flag) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(UINT i=0; i<m_vector.size(); i++) {
					if(**it==(PVOID)flag) {
						ret = *it;
						m_vector.erase(it);
						break;
					}
					it++;
				}
				return ret;
			}

	//ָԪ
	_Ty  pop_front(int item, ULONG flag) {
		_Ty ret = (_Ty)NULL;
		CScopedLock autoLock(&m_lock);
		_TList::iterator it = m_vector.begin();
		for(UINT i=0; i<m_vector.size(); i++) {
			if((**it == item) && (**it==(PVOID)flag)) {
				ret = *it;
				m_vector.erase(it);
				break;
			}
			it++;
		}
		return ret;
	}
	
	//ָԪ
	_Ty  pop_item(int item) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(UINT i=0; i<m_vector.size(); i++) {
					if(**it == item) {
						ret = *it;
						m_vector.erase(it);
						break;
					}
					it++;
				}
				return ret;
			}

	//ָΧǰԪ
	_Ty  pop_item(int from, int to) {
				_Ty ret = (_Ty)NULL;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.begin();
				for(UINT i=0; i<m_vector.size(); i++) {
					if((**it>=from) && (**it<=to)) {
						ret = *it;
						m_vector.erase(it);
						break;
					}
					it++;
				}
				return ret;
			}

	//
	void push_back(const _Ty _X, int item) {
				int  pos = -1, num=0;
				UINT i;
				CScopedLock autoLock(&m_lock);
				_TList::iterator it = m_vector.end();
				for(i=m_vector.size()-1; i>=0; i--) {
					if(**it==item) {
						if(**it<*_X){
							if(num > 0) {
								pos = i+1;
								m_vector.insert(it, _X);
							}
							break;
						}
						else {
							num++;
						}
					}
					it--;
				}
				if(pos < 0) {
					m_vector.push_back(_X);
				}
				for(i=0; i<m_Evts.size(); i++) {
					SetEvent(m_Evts[i]);
				}
			}

protected:
	_TList		m_vector;
	CLockCS		m_lock;
	vector<HANDLE> m_Evts;
};

#endif // !defined(__SAFEVECTOR_H_)
