//////////////////////////////////////////////////////////////////////
// Sample.h: interface for the CSample class.
// ࣺ֡Raw data֡Plugin֡ѹ֡
//////////////////////////////////////////////////////////////////////

#if !defined(__SAMPLE_H_)
#define __SAMPLE_H_

#include "Channel.h"

class CSample  
{
public:
	CSample();
	virtual ~CSample();

	BOOL		Allocate(ULONG len);
	void		Free();
	BOOL		Append(TMemBlock mb);
	BOOL		IsAppend() { return m_bAppend; }
	BOOL		IsAllocated() { return m_bAlloc; }
	CChannel*	GetChannel(){/*CScopedLock autoLock(&m_lock);*/ return m_channel;}
	void		SetChannel(CChannel* chnl){/*CScopedLock autoLock(&m_lock);*/ m_channel=chnl;}
	TMemBlock*	Buffer(){return &m_memBuf;}
	LONG		BufferSize() { return m_memBuf.len; }
	ULONGLONG	TimeStamp(){return m_pts;}
	void		SetTimeStamp(ULONGLONG pts){m_pts=pts;}
	void		SetType(long stype){m_type=stype;}
	long		GetType(){return m_type;}
	long		DataSize(){return m_size;}
	PBYTE		DataPtr() {return ((PBYTE)m_memBuf.vaddr+m_offset);}
	void		SetDataSize(long dtsize){m_size=dtsize;}
	void		SetDataOffset(long dtOffset){m_offset=dtOffset;}
	ULONG		Flag(){/*CScopedLock autoLock(&m_lock);*/ return m_state;}
	void		SetFlag(LONG flag, ULONG clearFlag=0) {CScopedLock autoLock(&m_lock); m_state = (m_state|flag)&~clearFlag;}//InterlockedExchange((PLONG)&m_state, (m_state|flag)&~clearFlag);}
	void		ClearFlag(LONG flag) {CScopedLock autoLock(&m_lock); m_state &= ~flag;}//InterlockedExchange((PLONG)&m_state, m_state&~flag);}
	void		SetIndex(ULONG index){InterlockedExchange((PLONG)&m_index, index);}
	ULONG		Index(){return m_index;}
	void		operator |= (ULONG flag) {SetFlag(flag);}
	BOOL		operator == (ULONG flag) {/*CScopedLock autoLock(&m_lock);*/ return m_state==flag;}
	BOOL		operator == (int chlId) {
					//CScopedLock autoLock(&m_lock);
					if(m_channel==NULL) return FALSE;
					return (m_channel->ChannelId()==chlId);
				}
	BOOL		operator == (PVOID flag) {
					BOOL  ret = FALSE;
					CPlugin* plg = m_channel->Plugin((ULONG)flag);
					//CScopedLock autoLock(&m_lock);
					if(plg && !plg->IsTransmiting() && (m_state&(ULONG)flag)){
						plg->SetTransmit(TRUE);
						ret = TRUE;
					}
					return ret;
				}
	BOOL		operator == (CSample* len) {	//ȽbufferСǷ
					return (len==NULL) ? TRUE : (m_memBuf.len==(ULONG)len); 
				} 
	BOOL		operator > (int chlId) {
					//CScopedLock autoLock(&m_lock);
					if(m_channel==NULL) return FALSE;
					return (m_channel->ChannelId()>chlId);
				}
	BOOL		operator >= (int chlId) {
					//CScopedLock autoLock(&m_lock);
					if(m_channel==NULL) return FALSE;
					return (m_channel->ChannelId()>=chlId);
				}
	BOOL		operator < (int chlId) {
					//CScopedLock autoLock(&m_lock);
					if(m_channel==NULL) return FALSE;
					return (m_channel->ChannelId()<chlId);
				}
	BOOL		operator <= (int chlId) {		//ȽϴSampleڵͨŴС
					//CScopedLock autoLock(&m_lock);
					if(m_channel==NULL) return FALSE;
					return (m_channel->ChannelId()<=chlId);
				}
	BOOL		operator > (CSample& sample) {	//ȽͬһͨSampleСҲȺ˳
					//CScopedLock autoLock(&m_lock);
					if((m_channel==NULL)||(sample.m_channel==NULL)||
					   (m_channel->ChannelId()!=sample.m_channel->ChannelId())) return FALSE;
					return ((m_index>sample.m_index) ? ((m_index-sample.m_index)<100) : ((sample.m_index-m_index)>100));
				}
	BOOL		operator < (CSample& sample) {
					//CScopedLock autoLock(&m_lock);
					if((m_channel==NULL)||(sample.m_channel==NULL)||
					   (m_channel->ChannelId()!=sample.m_channel->ChannelId())) return FALSE;
					return ((m_index<sample.m_index) ? ((sample.m_index-m_index)<100) : ((m_index-sample.m_index)>100));
				}

protected:
	CChannel*	m_channel;
	TMemBlock	m_memBuf;
	BOOL		m_bAlloc;
	BOOL		m_bAppend;
	ULONG		m_state;
	ULONG		m_index;
	ULONGLONG	m_pts;
	long		m_type;
	long		m_size;
	long		m_offset;

	//static CLockCS m_lock;
	CLockCS		m_lock;
};

class CSamplePtr 
{
	CSamplePtr(CSample* pSample, ULONG flag) : m_pSample(pSample), m_flag(flag) {};
	virtual ~CSamplePtr() { if(m_pSample) m_pSample->ClearFlag(m_flag); }
	
protected:
	CSample* m_pSample;
	ULONG    m_flag;
};

#endif // !defined(__SAMPLE_H_)
