/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TAssist.cpp
 *  @brief		߳CTAssistʵ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/29
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TAssist.h"
#include <mmsystem.h>

#define TASSIST_TIMEOUT		200

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTAssist::CTAssist()
{

}

CTAssist::~CTAssist()
{

}

void CTAssist::AppendDevice(CDevBase* dev)
{
	for(UINT i=0; i<m_devList.size(); i++) {
		if(m_devList[i] == dev) {
			return;
		}
	}

	m_devList.push_back(dev);
}

//-----------------------------------------------------
//ɼ̹߳׼
//-----------------------------------------------------
UINT CTAssist::DoWork()
{
	CSample		splBlack;
	ULONG		dwWait = 0;
	CDevBase*	dev	 = NULL;
	BOOL		bExit= FALSE;
	int			i, iSignal=0;
	ULONG		uInterval=0, uSkip=0, tkNow=0;
	PULONG		yuv = NULL;
	TDeviceState devState;

	//һ֡ȫͼ
	if(!splBlack.Allocate(RAWV_LEN_4CIF)) {
		_trace(TEXT("[]Source̷߳Ƶź֡ڴʧ\n"));
		return 2;
	}
	splBlack.SetChannel(NULL);
	splBlack.SetDataSize(RAWV_LEN_4CIF);
	yuv = (PULONG)splBlack.Buffer()->vaddr;
	for(i=0; (ULONG)i<(RAWV_LEN_4CIF>>2); i++) {
		//*yuv++ = 0x00800080;	//UYVY
		*yuv++ = 0x80008000;	//YUY2
	}

	i = 0;
	while(!bExit) {
		dwWait = WaitForMultipleObjects(EVT_NUM, m_hEvt, FALSE, uInterval);
		bExit = IsExit();
		if(bExit || (dwWait == (WAIT_OBJECT_0+EVT_EXIT))) {
			break;
		}
		if(!m_devList.size()) continue;
		dwWait = timeGetTime();
		if(tkNow == 0) { tkNow = dwWait; }

		dev = m_devList[i];
		devState = dev->GetState();
		i = (i+1) % m_devList.size();
		if(i == 0) {
			uSkip = dwWait - tkNow;
			uInterval = TASSIST_TIMEOUT - min(uSkip,TASSIST_TIMEOUT);
			tkNow = 0;
		}
		else {
			uInterval = 0;
		}

		if(dev->DeviceCaps()->ddesc.nChannels <= 0)
		{
			continue;
		}

		iSignal = dev->HasSignal();

		if(devState <= DEVSTAT_readystop) { 
			continue; 
		}
		if(dev->DeviceCaps()->ddesc.iSwitch > 1) {
			dev->CheckLive(dwWait);
			if(iSignal != dev->DeviceCaps()->ddesc.iSwitch) {
				dev->InsertSample(&splBlack);
				if(!iSignal) {
					dev->NotifyLive(dwWait);
				}
			}
		}
		else {
			if(devState > DEVSTAT_readyrun) { 
				dev->CheckLive(dwWait);
			}
			else {	//no signal
				dev->InsertSample(&splBlack);
				dev->NotifyLive(dwWait);
			}
		}
	}

	return 0;
}

//-----------------------------------------------------
//source߳˳׼
//-----------------------------------------------------
UINT CTAssist::OnExit()
{
	_trace(TEXT("[Ϣ]CTAssist̰߳ȫ˳\n"));
	return 0;
}
