/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6801.cpp
 *  @brief		оƬCTW6801ʵ֣֧TW6801,TW6804
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6801.h"
#include "Dev6801.H"
#include "Dev600X.h"
#include "Dev610X.h"
#include "TW680X.H"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTW6801::CTW6801() :
m_gpio(NULL),
m_i2c(NULL)
{

}

CTW6801::~CTW6801()
{

}

/** 
 ***************************************************************************************
 *  ȡ豸Ŀ
 *
 *	@param[in] devType豸0 -- Video, 1 -- Video, 2 -- Video & Audio
 *
 *  @return ֵ֧豸
 ***************************************************************************************
 */
LONG CTW6801::Devices(int devType)
{
	if((devType==DEV_video) || (devType==DEV_av)) {
		return 1;
	}

	return 0;
}

/** 
 ***************************************************************************************
 *  ʼоƬ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6801::OnOpen()
{
	TCmdCrashInfo	crash;

	//crash, Զɾ
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_VDMAC;
	crash.lowMask = R_VDMAC_VDMAP_EN|R_VDMAC_VFIFO_EN;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_INTMASK;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_INTSTAT;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȷ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6801::OnOpen(PDeviceCapability devCaps, int iDev, int iType)
{
	devCaps->caps |= CAPS_4CIF|CAPS_FIELD2|CAPS_SWITCH;
	devCaps->ddesc.iSwitch = 1;
	devCaps->ddesc.nAudio  = 0;
	devCaps->ddesc.bField2 = FALSE;
	devCaps->ddesc.VideoInputMask = INPUT_MASK((int)viCompositeVideo1);
	devCaps->ddesc.reserved1 = viCompositeMax;
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ʼоƬ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6801::OnClose()
{
	SAFE_DELETE(m_i2c);
	SAFE_DELETE(m_gpio);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȡI2C豸
 *
 *  @return I2C豸
 ***************************************************************************************
 */
HANDLE CTW6801::GetI2C()
{
	if(m_i2c == NULL) {
		m_i2c = new CI2C680X(&m_Mem[0]);
		m_i2c->I2CInitSWMode(400000);
	}

	return m_i2c;
}

/** 
 ***************************************************************************************
 *  ȡGPIO豸
 *
 *  @return I2C豸
 ***************************************************************************************
 */
HANDLE CTW6801::GetGPIO()
{
	if(m_gpio == NULL) {
		m_gpio = new CGpio680X(&m_Mem[0]);
		m_gpio->InitGpio(GPIO_NORMAL);
	}

	return m_gpio;
}

/** 
 ***************************************************************************************
 *  оƬ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CTW6801::CreateDevices()
{
	CDevBase* dev = NULL;
	PDeviceCapability devCaps = NULL;
	
	devCaps = m_capsListV[0];
	if(devCaps->ddesc.bField2) {
		dev = new CDev600X();
	}
	else if(devCaps->ddesc.iSwitch > 1) {
		dev = new CDev610X();
	}
	else {
		dev = new CDev6801();
	}
	if(dev == NULL) {
		return FALSE;
	}
	m_devList.push_back(dev);
	g_devListV.push_back(dev);
	if(!dev->Open(this, devCaps, NULL, 0)) {
		return FALSE;
	}
	devCaps->device = dev;
	devCaps->ddesc.nFirstChannel = (int)g_chlList.size();
	if(devCaps->ddesc.VideoInputMask & INPUT_ALL)
	{
		devCaps->ddesc.nChannels = devCaps->ddesc.iSwitch;
		if(!dev->CreateChannels()) {
			return FALSE;
		}
	}
	else
	{
		devCaps->ddesc.nChannels = 0;
	}

	return TRUE;
}

//-------------------------------------------------------
//ʼTW6801
//-------------------------------------------------------
BOOL CTW6801::OnInit()
{
	m_Mem[0].outb(R_ACNTL,			0x80);
	m_Mem[0].outd(R_VBIC,			0x00);
	m_Mem[0].outd(R_INTSTAT,		0xFFFFFFFF);
	m_Mem[0].outd(R_INTMASK,		0x00000000);
	m_Mem[0].outd(R_GPIOC,			0x00003000);
	m_Mem[0].outb(R_VCAPCTL,		0xC3);
	m_Mem[0].outd(R_VFRAMEDROPCTL,	0x00);
	m_Mem[0].outb(R_VSTATUS1,		0x00);
	m_Mem[0].outb(R_INFORM,			0x40);
	m_Mem[0].outb(R_OPFORM,			0x04);//0x08);
	m_Mem[0].outb(R_GAMMAHDELAY,	0x00);
	m_Mem[0].outb(R_POLARITY,		0x00);
	m_Mem[0].outb(R_ACNTL,			0x00);	
	m_Mem[0].outb(R_CNTRL1,			0xCD);
	m_Mem[0].outb(R_BRIGHT,			0x00);
	m_Mem[0].outb(R_CONTRAST,		0x4C);
	m_Mem[0].outb(R_SHARPNESS,		0x11);//0x54);
	m_Mem[0].outb(R_SATU,			0x80);
	m_Mem[0].outb(R_SATV,			0x80);
	m_Mem[0].outb(R_HUE,			0x00);
	m_Mem[0].outb(R_SHARP2,			0x53);//0xC6);
	m_Mem[0].outb(R_VSHARP,			0x84);
	m_Mem[0].outb(R_CORING,			0xCC);//0x44);	//ˮ
	m_Mem[0].outb(R_VBICNTL,		0x00);
	m_Mem[0].outb(R_ACNTL2,			0x0A);
	m_Mem[0].outb(R_STD,			0x17);
	m_Mem[0].outb(R_STDR,			0x03);
	m_Mem[0].outb(R_CLMPG,			0x50);
	m_Mem[0].outb(R_IAGC,			0x42);//0x32);
	m_Mem[0].outb(R_AGCGAIN,		0xF0);//0x40);
	m_Mem[0].outb(R_PEAKWT,			0xD8);
	m_Mem[0].outb(R_CLMPL,			0xBC);
	m_Mem[0].outb(R_SYNCT,			0xB8);
	m_Mem[0].outb(R_MISSCNT,		0x44);	//ֵ44Ϊ14ͼȶһ֡ʽ
	m_Mem[0].outb(R_PCLAMP,			0x2A);//0x28);
	m_Mem[0].outb(R_VCNTL1,			0x08);//0x0C);
	m_Mem[0].outb(R_VCNTL2,			0x00);
	m_Mem[0].outb(R_CKILL,			0x78);//0x68);
	m_Mem[0].outb(R_COMB,			0x44);
	m_Mem[0].outb(R_LDLY,			0x30);//0xB0);
	m_Mem[0].outb(R_MISC1,			0x14);//0x54);
	m_Mem[0].outb(R_LOOP,			0xFD);//0x3D);
	m_Mem[0].outb(R_MISC2,			0xE0);//0xF0);	//ĴźʱǺ
	m_Mem[0].outb(R_CLMD,			0x05);//0x35);	//YNR -- Y HF noise reduction
	m_Mem[0].outb(R_IDCNTL,			0x00);
	m_Mem[0].outb(R_CLCNTL1,		0x20);	//YCLEN -- Y Clamp ƵӰܴdisableĻźżʧԼͼϷ
	
	m_Mem[0].outd(R_VBIC,			0x51900000);

	if(DEVICEID(DeviceInfo().HardwareId) == 0x6804) {
		m_Mem[0].outd(R_VDMAC,		0x0000A000);
	}
	else {
		m_Mem[0].outd(R_VDMAC,		0x00002000);
	}

	return TRUE;
}

//-------------------------------------------------------
//ʼTW6801
//-------------------------------------------------------
BOOL CTW6801::OnUninit()
{
	m_Mem[0].outd(R_VDMAP_SA,		0x00);
	m_Mem[0].outb(R_ACNTL,			0x0E);
	m_Mem[0].outb(R_ACNTL2,			0x40);

	return TRUE;
}
