/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6802.cpp
 *  @brief		оƬCTW6801ʵ֣֧TW6802,TW6805
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */


#include "stdafx.h"
#include "TW6802.h"
#include "Dev6802.h"
#include "PlgvSource.h"
#include "TW680X.H"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTW6802::CTW6802()
{

}

CTW6802::~CTW6802()
{

}

/** 
 ***************************************************************************************
 *  ȡ豸Ŀ
 *
 *	@param[in] devType豸0 -- Video, 1 -- Video, 2 -- Video & Audio
 *
 *  @return ֵ֧豸
 ***************************************************************************************
 */
LONG CTW6802::Devices(int devType)
{
	if((devType==DEV_audio) || (devType==DEV_av)) {
		return 1;
	}

	return 0;
}

/** 
 ***************************************************************************************
 *  ʼоƬ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6802::OnOpen()
{
	TCmdCrashInfo	crash;

	//crash, Զɾ
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_ADMAC;
	crash.lowMask = R_ADMAC_ADMAP_EN|R_ADMAC_AFIFO_EN;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_AINTMASK;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_AINTSTAT;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);

	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȷ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6802::OnOpen(PDeviceCapability devCaps, int iDev, int iType)
{
	devCaps->caps = 0;
	devCaps->ddesc.iSwitch = 1;
	devCaps->ddesc.nAudio  = 1;
	devCaps->ddesc.bField2 = FALSE;
	devCaps->ddesc.VideoInputMask = 0;
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  оƬ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CTW6802::CreateDevices()
{
	CDevBase* dev, *vDev = NULL;
	PDeviceCapability devCaps = NULL;
	CChannel* channel = NULL;
	CPlgvSource* vsource = NULL;
	TDeviceDesc vdesc;
	UINT		i = 0;
	ULONG		devId = 0;
	
	devCaps = m_capsListA[0];
	dev = new CDev6802();
	if(dev == NULL) {
		return FALSE;
	}
	m_devList.push_back(dev);
	g_devListA.push_back(dev);
	if(!dev->Open(this, devCaps, NULL, 0)) {
		return FALSE;
	}
	devCaps->device = dev;
	devId = DEVICEID(m_devInfo.HardwareId);

	for(i=0; i<g_chlList.size(); i++) {
		vsource = (CPlgvSource*)g_chlList[i]->Plugin(PLG_vsource);
		if(vsource==NULL) { continue; }
		vDev = vsource->Device();
		vdesc = vDev->Parent()->DeviceInfo();
		if((vdesc.nBoardId==m_devInfo.nBoardId) && (vdesc.DeviceNumber==m_devInfo.DeviceNumber)) {
			if((devId>=0x6814) && (devId<=0x6817)) {
				if(DEVICEID(vdesc.HardwareId)==(devId-4)) {
					channel = g_chlList[i];
					break;
				}
			}
			else if(vdesc.Function==0) {
				channel = g_chlList[i];
				break;
			}
		}
	}
	if(channel == NULL) { return FALSE; }

	devCaps->ddesc.nFirstChannel = i;
	if(vDev->DeviceCaps()->ddesc.nChannels > 0)
	{
		devCaps->ddesc.nChannels = devCaps->ddesc.iSwitch;
		vDev->DeviceCaps()->ddesc.nAudio = 1;

		return dev->Append2Channel(channel);
	}
	else
	{
		devCaps->ddesc.nChannels = 0;
		vDev->DeviceCaps()->ddesc.nAudio = 0;
		return TRUE;
	}
}

//--------------------------------------------------------------------
// ʼTW6802豸
//--------------------------------------------------------------------
BOOL CTW6802::OnInit()
{
	m_Mem[0].outd(R_ARSTN,	  0);
	m_Mem[0].outd(R_ACTL1,	  0x00080000);	//SIGN Ϊ1ĻݾҪÿֽڼ0x7f
	m_Mem[0].outd(R_ACTL2,	  0x00000100);
	m_Mem[0].outd(R_ACLKS,	  0x00000001);//0x00000048);
	m_Mem[0].outd(R_AANACTL,  0x00010810);	//Sound ADC GainСڼʱʱҲ֮С
	m_Mem[0].outd(R_AINTMASK, 0x00000000);
	m_Mem[0].outd(R_AINTSTAT, 0xFFFFFFFF);
	m_Mem[0].outd(R_ADMAC,	  0x00000000);
	m_Mem[0].outd(R_ACORE,	  0x00000000);
	m_Mem[0].outd(R_APCICLKR, 0x00800000);
	m_Mem[0].outd(R_AVCLKR,	  0x00800000);

	return TRUE;
}

//--------------------------------------------------------------------
// ʼTW6802豸
//--------------------------------------------------------------------
BOOL CTW6802::OnUninit()
{
	m_Mem[0].outd(R_APCICLKR, 0x00800000);
	m_Mem[0].outd(R_AVCLKR,   0x00800000);

	return TRUE;
}
