/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6803.cpp
 *  @brief		оƬCTW6803ʵ֣֧TW6803,TW6806
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6803.h"
#include "Dev6803.h"
#include "TW680X.H"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTW6803::CTW6803()
{

}

CTW6803::~CTW6803()
{

}

/** 
 ***************************************************************************************
 *  ȡ豸Ŀ
 *
 *	@param[in] devType豸0 -- Video, 1 -- Video, 2 -- Video & Audio
 *
 *  @return ֵ֧豸
 ***************************************************************************************
 */
LONG CTW6803::Devices(int devType)
{
	if((devType==DEV_audio) || (devType==DEV_av)) {
		return 1;
	}

	return 0;
}

/** 
 ***************************************************************************************
 *  ʼоƬ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6803::OnOpen()
{
	TCmdCrashInfo	crash;

	//crash, Զɾ
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_TDMAC;
	crash.lowMask = R_TDMAC_TDMAP_EN|R_TDMAC_TFIFO_EN;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_TINTMASK;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= R_TINTSTAT;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȷ豸
 *
 *  @return ɹTRUEʧܷFALSE
 ***************************************************************************************
 */
BOOL CTW6803::OnOpen(PDeviceCapability devCaps, int iDev, int iType)
{
	devCaps->caps = CAPS_4CIF;
	devCaps->ddesc.iSwitch = 1;
	devCaps->ddesc.nAudio  = 0;
	devCaps->ddesc.bField2 = FALSE;
	devCaps->ddesc.VideoInputMask = INPUT_MASK((int)viCompositeVideo1);
	devCaps->ddesc.reserved1 = viCompositeVideo2;
	
	return TRUE;
}

/** 
 ***************************************************************************************
 *  оƬ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CTW6803::CreateDevices()
{
	CDevBase* dev = NULL;
	PDeviceCapability devCaps = NULL;
	
	devCaps = m_capsListV[0];
	dev = new CDev6803();
	if(dev == NULL) {
		return FALSE;
	}
	m_devList.push_back(dev);
	g_devListV.push_back(dev);
	if(!dev->Open(this, devCaps, NULL, 0)) {
		return FALSE;
	}
	devCaps->device = dev;
	devCaps->ddesc.nFirstChannel = (int)g_chlList.size();
	devCaps->ddesc.nChannels = devCaps->ddesc.iSwitch;
	return dev->CreateChannels();
}

//-------------------------------------------------------
//ʼTW6803
//-------------------------------------------------------
BOOL CTW6803::OnInit()
{
	m_Mem[0].outd(R_TDMAC,	  0x00000000);
	m_Mem[0].outd(R_TSCTL,	  0x00FF06BC);	
	m_Mem[0].outd(R_TPACKET,  0x00000000);
	m_Mem[0].outd(R_TDMATRIG, 0x00000009);
	m_Mem[0].outd(R_TINTSTAT, 0xFFFFFFFF);
	m_Mem[0].outd(R_TINTMASK, 0x00000000);
	m_Mem[0].outd(R_ACLKS,	  0x0000009B);
	m_Mem[0].outd(R_TRSTN,	  0x00000001);	//enableʱҪܳʱƫƣ²ɼͼ13ֽƫ(ͼɫʲ)

	return TRUE;
}

//--------------------------------------------------------------------
// ʼTW6803豸
//--------------------------------------------------------------------
BOOL CTW6803::OnUninit()
{
	m_Mem[0].outd(R_TRSTN,	  0);

	return TRUE;
}
