//==================================================================
// tw680x.h
// TechWell 680x Ĵ
// Techwell, 2008.10.10
//==================================================================

#ifndef __TW680X_H_
#define __TW680X_H_

//-------------------------------------------------------------------------------------------
// Ƶ豸Ĵ
//-------------------------------------------------------------------------------------------

#define R_VDMAC					0x000			//DW, RW, video dma controller
#define		R_VDMAC_VDMATRIG	(0xFF<<8)		//DMA trigger point
#define		R_VDMAC_GAMMA		BIT(7)
#define		R_VDMAC_COLORF		(0x07<<4)
#define		R_VDMAC_BSWAP		(0x03<<2)
#define		R_VDMAC_VFIFO_EN	BIT(1)			//1 - enable video fifo, 0 - flush fifo
#define		R_VDMAC_VDMAP_EN	BIT(0)			//1 - enable risc
#define R_VDMAP_SA				0x004			//DW, RW, dma program (risc) start address
#define R_VDMAP_EXE				0x008			//DW, RO, ִеdmap
#define R_VDMAP_PP				0x00C			//DW, RO, һdmapĵַ
#define R_VBIC					0x010			//DW, RW, VBI controller
#define R_SBUSC					0x014			//DW, RW, I2C controller
#define		R_SBUSC_SBDEV		(0x7F<<25)		//I2C slave device address for hardware mode
#define		R_SBUSC_SBRW		BIT(24)			//I2C hardware read/write mode, 1--read, 0--write
#define		R_SBUSC_RDLEN		(0x07<<20)		//I2C read len, from 1 to 4
#define		R_SBUSC_WDLEN		(0x07<<16)		//I2C write len, from 1 to 4
#define		R_SBUSC_SBCLK		(0xFF<<8)		//I2C clock, 0xA6 -- 99.4khz, 0x26 -- 392.8khz
#define		R_SBUSC_SSDAT		BIT(7)			//I2C SDA
#define		R_SBUSC_SSCLK		BIT(6)			//I2C SCL
#define		R_SBUSC_SYNC		BIT(5)			//I2C sync
#define		R_SBUSC_BURSTEN		BIT(4)			//I2C burst enable/disable
#define		R_SBUSC_W3B			BIT(3)			//I2C w3b
#define		R_SBUSC_NOACK		BIT(2)			//I2C no ack
#define		R_SBUSC_WREN		BIT(1)			//I2C no stop
#define		R_SBUSC_SBMODE		BIT(0)			//I2C mode
#define R_SBUSSD				0x018			//DW, RW, I2C send data
#define		R_SBUSSD_WB4		(0xFF<<24)		//I2C recive byte 0, send byte 4, for hardware mode
#define		R_SBUSSD_WB2		(0xFF<<16)		//I2C send byte 3, for hardware mode
#define		R_SBUSSD_WB1		(0xFF<<8)		//I2C send byte 2, for hardware mode
#define		R_SBUSSD_WB0		0xFF			//I2C send byte 1, for hardware mode
#define R_INTSTAT				0x01C			//DW, RR, Interrupt status
#define		R_INT_SBERR			BIT(24)			//RACK
#define		R_INT_VDLOSS		BIT(23)
#define		R_INT_FIELD			BIT(20)
#define		R_INT_NOVIDEO		BIT(18)
#define		R_INT_PPERR			BIT(14)
#define		R_INT_PABORT		BIT(6)
#define		R_INT_DMAPERR		BIT(5)
#define		R_INT_FFIFO			BIT(3)
#define		R_INT_GPINT			BIT(2)
#define		R_INT_VDMAPI		BIT(1)
#define		R_INT_SBDONE		BIT(0)
#define	R_INTMASK				0x020			//DW, RW, Interrupt mask
#define R_GPIOC					0x024			//DW, RW, GPIO controller
#define		R_GPIOC_GPINTS		(BIT(12)|BIT(13))
#define		R_GPIOC_GPMODE		(BIT(0)|BIT(1)|BIT(2))
#define R_GPOE					0x028			//DW, RW, GPIO output enable
#define R_TESTREG				0x02C
#define R_SBUSRD				0x030			//DW, RO, I2C receive data
#define		R_SBUSRD_RB4		(0xFF<<24)		//I2C receive byte 4
#define		R_SBUSRD_RB3		(0xFF<<16)		//I2C receive byte 3
#define		R_SBUSRD_RB2		(0xFF<<8)		//I2C receive byte 2
#define		R_SBUSRD_RB1		(0xFF)			//I2C receive byte 1
#define R_SBUSTRIG				0x034
#define		R_SBUSTRIG_SBTRIG	BIT(0)
#define R_GPCLKCTL				0x038
#define R_VCAPCTL				0x040			//B, RW, video capture control
#define		R_VCAPCTL_ODDEVENSEP BIT(7)			//1:odd/even field data separate control
#define		R_VCAPCTL_COLORF2	(0x07<<4)		//only for even field
#define		R_VCAPCTL_BSWAP2	(BIT(2)|BIT(3))			//only for even field
#define		R_VCAPCTL_CAPEVEN	BIT(1)
#define		R_VCAPCTL_CAPODD	BIT(0)
#define	R_GP656_OUTCTL1			0x044
#define	R_GP656_OUTCTL2			0x048
#define R_VFRAMEDROPCTL			0x04C			//WD, RW, video frame drop control
#define R_VIDEOSVIDS			0x050
#define R_VIDEOSUBSYS			0x054
#define R_I2CRST				0x064			//DW, WO, reset I2C
#define		R_I2CRST_RST		BIT(0)			//write 1 reset I2C master block
#define R_REMOCONCTL			0x068				
#define R_REMOCONEN				0x06C
#define R_HTREG					0x070
#define R_UPDREG				0x074
#define R_REMPI					0x078
#define R_USAMPLE				0x07C
#define R_UPDCTL				0x080
#define R_GPDATA				0x100			//DW, RW, GPIO data
#define R_VSTATUS1				0x204			//DW, RO, Video decoder status register 1
#define		R_VSTATUS1_VDLOSS	BIT(7)			//0 - video detected
#define		R_VSTATUS1_HLOCK	BIT(6)			//0 - horizontal sync pll not locked, 1 - locked
#define		R_VSTATUS1_SLOCK	BIT(5)			//0 - Sub-carrier pll not locked, 1 - locked
#define		R_VSTATUS1_FIELD	BIT(4)			//0 - odd field is being decoded
#define		R_VSTATUS1_VLOCK	BIT(3)			//0 - vertical not lock, 1 - vertical locked
#define		R_VSTATUS1_NOVIDEO	BIT(2)			//0 - video, 1 - no vdieo
#define		R_VSTATUS1_MONO		BIT(1)
#define		R_VSTATUS1_DET50	BIT(0)			//0 - 60Hz
#define	R_INFORM				0x208			//DW, RW, Input format
#define		R_INFORM_FC27		BIT(6)			//1 - 27MHz
#define		R_INFORM_IFSEL		(BIT(4)|BIT(5))	//01 - S-video, 00 - Composite
#define		R_INFORM_YSEL		(BIT(2)|BIT(3))	//mux
#define		R_INFORM_CSEL		(BIT(0)|BIT(1))	//SIN
#define	R_OPFORM				0x20C			//B, RW, output format control register
#define R_GAMMAHDELAY			0x210			//GAMMA and HSYNC delay control
#define R_POLARITY				0x214
#define R_ACNTL					0x218			//B, RW, Analog control register
#define		R_ACNTL_SRESET		BIT(7)			//WO, write 1 to reset the device
#define		R_ACNTL_IREF		BIT(6)
#define		R_ACNTL_VREF		BIT(5)
#define		R_ACNTL_AGCEN		BIT(4)
#define		R_ACNTL_CLKPDN		BIT(3)			//1 - system clock in power down mode
#define		R_ACNTL_YPDN		BIT(2)			//1 - luma ADC in power down mode
#define		R_ACNTL_SPDN		BIT(1)			//1 - chroma ADC in power down mode
#define	R_CROPHI				0x21C			//B, RW, Cropping register high
#define		R_CROPHI_VDELAYHI	(BIT(6)|BIT(7))	//these bits are bit 9 to 8 of 10-bit VDELAY
#define		R_CROPHI_VACTIVEHI	(BIT(4)|BIT(5))	//these bits are bit 9 to 8 of 10-bit VACTIVE
#define		R_CROPHI_HDELAYHI	(BIT(2)|BIT(3))	//these bits are bit 9 to 8 of 10-bit HDELAY
#define		R_CROPHI_HACTIVEHI	(BIT(0)|BIT(1))	//these bits are bit 9 to 8 of 10-bit HACTIVE
#define R_VDELAYLO				0x220			//B, RW, vertical delay register low
#define R_VACTIVELO				0x224			//B, RW, vertical active register low
#define R_HDELAYLO				0x228			//B, RW, horizontal delay register low
#define R_HACTIVELO				0x22C			//B, RW, horizontal active register low
#define R_CNTRL1				0x230			//B, RW, control register 1
#define		R_CNTRL1_PBW		BIT(7)			//0 - normal chroma BPF BW
#define		R_CNTRL1_DEM		BIT(6)			//secam control
#define		R_CNTRL1_PALSW		BIT(5)			//1 - PAL switch sensitivity low
#define		R_CNTRL1_SET7		BIT(4)
#define		R_CNTRL1_COMB		BIT(3)			//0 - Notch filter, 1 - Adaptive comb filter for NTSC
#define		R_CNTRL1_HCOMB		BIT(2)
#define		R_CNTRL1_YCOMB		BIT(1)			//0 - no comb
#define		R_CNTRL1_PDLY		BIT(0)			//1 - PAL delay line enabled
#define	R_VSCALELO				0x234			//B, RW, vertical scaling register low
#define R_SCALEHI				0x238			//B, RW, scaling register high
#define		R_SCALEHI_VSCALEHI	0xF0			//VSCALE_HI
#define		R_SCALEHI_HSCALEHI	0x0F			//HSCALE_HI
#define R_HSCALELO				0x23C			//B, RW, horizontal scaling register low
#define R_BRIGHT				0x240			//B, RW, Bright
#define R_CONTRAST				0x244			//B, RW, Contrast
#define R_SHARPNESS				0x248			//B, RW, Sharpness
#define R_SATU					0x24C			//B, RW, chroma (U) gain register
#define R_SATV					0x250			//B, RW, chroma (V) gain register
#define R_HUE					0x254			//B, RW, Hue control, only for NTSC
#define R_SHARP2				0x258			//B, RW, Sharpness control 2
#define R_VSHARP				0x25C			//B, RW, vertical sharpness
#define R_CORING				0x260			//B, RW, coring control register
#define R_VBICNTL				0x264
#define R_ACNTL2				0x268			//B, RW, analog control 2
#define		R_ACNTL2_PLLPDN		BIT(6)			//1 - PLL in power down mode
#define		R_ACNTL2_YFLEN		BIT(3)			//1 - enable Y-Ch anti-alias filter control
#define		R_ACNTL2_YSV		BIT(2)			//1 - enable Y-Ch power saving mode
#define		R_ACNTL2_CFLEN		BIT(1)			//1 - enable C-Ch anti-alias filter control
#define		R_ACNTL2_CSV		BIT(0)			//1 - enable C-Ch power saving mode
#define	R_STD					0x270			//B, RW, standard selection
#define		R_STD_STDNOW		(BIT(4)|BIT(5)|BIT(6))
#define		R_STD_ATREG			BIT(3)
#define		R_STD_STD			(BIT(0)|BIT(1)|BIT(2))
#define	R_STDR					0x274			//B, RW, standard recognition
#define		R_STDR_ATSTART		BIT(7)
#define		R_STDR_PAL60		BIT(6)
#define		R_STDR_PALN			BIT(5)
#define		R_STDR_PALM			BIT(4)
#define		R_STDR_NT44			BIT(3)
#define		R_STDR_SECAM		BIT(2)
#define		R_STDR_PALB			BIT(1)
#define		R_STDR_NTSC			BIT(0)
#define	R_CLMPG					0x280			//B, RW, Clamping Gain
#define R_IAGC					0x284			//B, RW, Individual AGC Gain
#define R_AGCGAIN				0x288			//B, RW, AGC gain
#define R_PEAKWT				0x28C			//B, RW, White peak threshold
#define	R_CLMPL					0x290			//B, RW, Clamp level
#define R_SYNCT					0x294			//B, RW, Sync amplitude
#define R_MISSCNT				0x298			//B, RW, Sync miss count
#define R_PCLAMP				0x29C			//B, RW, Clamp Position
#define R_VCNTL1				0x2A0			//B, RW, Vertical control 1
#define		R_VCNTL1_VLCKI		(BIT(6)|BIT(7))	//vertical lock in time, 0 - fastest, 3 - lowest
#define		R_VCNTL1_VLCKO		(BIT(4)|BIT(5))	//vertical lock out time,0 - fastest
#define		R_VCNTL1_VMODE		BIT(3)			//vertical detection windwo, 1 - search mode, 0 - vertical count down mode
#define		R_VCNTL1_DETV		BIT(2)			//0 - normal vsync logic
#define		R_VCNTL1_AFLD		BIT(1)			//Auto field generation control 0 - off, 1 - on
#define		R_VCNTL1_VINT		BIT(0)			//vertical integration time control, 1 - long
#define R_VCNTL2				0x2A4			//B, RW, vertical control 2
#define	R_CKILL					0x2A8			//B, RW, Color kill level control
#define R_COMB					0x2AC			//B, RW, Comb filter control
#define R_LDLY					0x2B0			//B, RW, Luma delay and H filter control
#define R_MISC1					0x2B4			//B, RW, Miscellaneous control 1
#define	R_LOOP					0x2B8			//B, RW, Loop control
#define R_MISC2					0x2BC			//B, RW, Miscellaneous control 2
#define R_MVSN					0x2C0			//B, RO, Macrovision Detection
#define R_VSTATUS2				0x2C4			//B, RO, Decoder chip status 2
#define		R_VSTATUS2_VCR		BIT(7)			//1 - VCR signal
#define		R_VSTATUS2_WKAIR	BIT(6)			//1 - weak signal
#define		R_VSTATUS2_WKAIR1	BIT(5)			//weak signal indicator 2
#define		R_VSTATUS2_VSTD		BIT(4)			//1 - standard signal, 0 - non-standard signal
#define		R_VSTATUS2_NINTL	BIT(3)			//1 - non-interlaced signal, 0 - interlaced siganl
#define	R_HFREF					0x2C8			//B, RO, H monitor
#define	R_CLMD					0x2CC			//B, RW, Clamp mode
#define		R_CLMD_FRM			(BIT(6)|BIT(7))	//Free run mode control
#define		R_CLMD_YNR			(BIT(4)|BIT(5)) //Y HF noise reduction
#define		R_CLMD_CLMD			(BIT(2)|BIT(3))	//Clamping mode control
#define		R_CLMD_PSP			(BIT(0)|BIT(1))	//Slice level control
#define	R_IDCNTL				0x2D0			//B, RW, ID detection control
#define R_CLCNTL1				0x2D4			//B, RW, Clamp control 1
#define		R_CLCNTL1_YCLEN		BIT(6)			//1 - Y channel clamp disabled
#define		R_CLCNTL1_CCLEN		BIT(5)			//1 - C channel clamp disabled

#define	R_ACKI1					0x300			//B, RW, audio clock increment 1
#define R_ACKI2					0x304			//B, RW, audio clock increment 2
#define R_ACKI3					0x308			//B, RW, audio clock increment 3
#define R_ACKN1					0x30C			//B, RW, audio clock number 1, bit 0-7 of ACNK
#define R_ACKN2					0x310			//B, RW, audio clock number 2, bit 8-15 of ACNK
#define R_ACKN3					0x314			//B, RW, audio clock number 3, bit 16-17 of ACNK
#define R_SDIV					0x318			//B, RW, serial clock divider
#define R_LRDIV					0x31C			//B, RW, Left/Right clock divider
#define R_ACCNTL				0x320			//B, RW, audio clock control

#define R_VSCTL					0x3B8			//B, RW, VSCLALER control
#define R_CHROMAGVAL			0x3BC			//B, RW, Chroma/sound ADC gain control, only for S-Video
#define R_F2CROPHI				0x3DC			//B, RW, Field2 cropping high
#define R_F2VDELAYLO			0x3E0			//B, RW, Field2 vertical delay low
#define R_F2VACTIVELO			0x3E4			//B, RW, Field2 vertical active low
#define R_F2HDELAYLO			0x3E8			//B, RW, Filed2 horizontal delay low
#define R_F2HACTIVELO			0x3EC			//B, RW, Field2 horizontal active low
#define	R_F2CNTL				0x3F0			//B, RW, Field2 control
#define R_F2VSCALELO			0x3F4			//B, RW, Field2 vertical scaling low
#define	R_F2SCALEHI				0x3F8			//B, RW, Field2 scaling high
#define R_F2HSCALELO			0x3FC			//B, RW, Field2 horizontal scaling low

// dmap command
#define DMAP_WRITE				0x80000000		//write data
#define DMAP_JUMP				0xB0000000		//jump to
#define DMAP_SYNCO				0xC0000000		//sync odd field
#define DMAP_SYNCE				0xD0000000		//sync even field
#define DMAP_DUMMY				0xE0000000		//dummy

// dmap behavior
#define DMAP_SOL				0x10000000		//start of line
#define DMAP_MOL				0x20000000		//middle of line, or in line
#define DMAP_IRQ				0x08000000		//generate interrupt after transfered
#define DMAP_STARTINGBYTE(s)	((s)<<12)			//starting byte when write with in line mode

//-------------------------------------------------------------------------------------------
// ƵƵ豸Ĵ
//-------------------------------------------------------------------------------------------
#define R_ADMAC					0x000				//Audio dma program control
#define		R_ADMAC_AFIFO_EN	BIT(1)				//Set 1 to enable audio fifo
#define		R_ADMAC_ADMAP_EN	BIT(0)				//enable audio dma program
#define R_ADMAP_SA				0x004				//the starting address of audio dma program
#define R_ADMAP_EXE				0x008
#define R_ADMAP_PP				0x00C
#define R_ACTL1					0x010				//Audio control 1
#define		R_ACTL1_I2S16ORD	BIT(25)
#define		R_ACTL1_I2S24LR		BIT(24)
#define		R_ACTL1_SIGN		BIT(21)
#define		R_ACTL1_ALPFOFF		BIT(20)
#define		R_ACTL1_ACLIP		BIT(19)
#define		R_ACTL1_ACLAMP		BIT(18)
#define		R_ACTL1_AGAIN		(0xFF<<8)			//Audio data gain control
#define		R_ACTL1_CS5330		BIT(7)				//0 - normal I2S input mode, 1 - CS5330 input mode
#define		R_ACTL1_LRPOL		BIT(6)
#define		R_ACTL1_ASCLKPOL	BIT(5)
#define		R_ACTL1_DA_LMT		BIT(3)
#define		R_ACTL1_AGPIMODE	BIT(2)
#define	R_APACKET				0x014				//Audio packet
#define		R_APACKET_ALINE		(0xFFFF<<16)		//Number of audio lines (test purpose only)
#define		R_APACKET_ALENGTH	0xFFFF				//Number of bytes in audio line (test purpose only)
#define	R_ACTL2					0x018				//Audio control 2
#define		R_ACTL2_SILENT		BIT(15)				//I2S input data slient mode
#define		R_ACTL2_ACKGVMODE	(BIT(13)|BIT(14))	//Audio clock generation block frame mode
#define		R_ACTL2_ADMATRIG	(0x1F<<8)			//Audio fifo dma timing control
#define		R_ACTL2_AMODE		(0x0F<<4)			//Audio function mode
#define		R_ACTL2_ACKGLOOP	BIT(3)
#define		R_ACTL2_ADUMMYEN	BIT(2)
#define		R_ACTL2_I2STHR		BIT(1)
#define		R_ACTL2_I2SIOEN		BIT(0)
#define	R_AINTSTAT				0x01C				//Audio interrupt status
#define		R_AINT_PPERR		BIT(14)
#define		R_AINT_PABORT		BIT(6)
#define		R_AINT_ADMAPERR		BIT(5)				//Audio dma program error
#define		R_AINT_AFOVFI		BIT(3)				//Audio fifo overflowed
#define		R_AINT_ADMAPI		BIT(1)				//Audio dmap interrupt
#define	R_AINTMASK				0x020				//Audio interrupt mask
#define R_ARSTN					0x030				//Audio reset
#define		R_ARSTN_ARSTN		BIT(0)
#define	R_ACORE					0x034				//Audio coring
#define		R_ACORE_ACLEVEL		0x3F
#define	R_APCICLKR				0x038				//Audio pci clock ref
#define		R_APCICLKR_PACLKREF	0xFFFFFF
#define	R_AVCLKR				0x03C				//Audio video clock ref
#define		R_AVCLKR_VACLKREF	0xFFFFFF
#define	R_ACLKS					0x040				//Audio clock selection
#define		R_ACLKS_AMCLKIMODE	(BIT(6)|BIT(7))
#define		R_ACLKS_AMCLKSEL	(BIT(4)|BIT(5))
#define		R_ACLKS_AMCLKOEN	BIT(3)
#define		R_ACLKS_ACLKSEL		0x07
#define	R_AANACTL				0x048				//Audio analog control
#define		R_AANACTL_SCLEN		BIT(16)
#define		R_AANACTL_SEXTIREF	BIT(15)
#define		R_AANACTL_SEXTVREF	BIT(14)
#define		R_AANACTL_SSEL		(BIT(12)|BIT(13))	//select the audio input, 0=SIN0, 1=SIN1 ...
#define		R_AANACTL_SFLEN		BIT(11)
#define		R_AANACTL_SSV		BIT(10)
#define		R_AANACTL_S_PDN		BIT(9)				//Sound ADC power down
#define		R_AANACTL_SGVA		0x3F				//Sound ADC Gain

//-------------------------------------------------------------------------------------------
// TS豸Ĵ
//-------------------------------------------------------------------------------------------
#define R_TDMAC					0x000				//TS dma program control
#define		R_TDMAC_TFIFO_EN	BIT(1)				//Set 1 to enable TS fifo
#define		R_TDMAC_TDMAP_EN	BIT(0)				//enable TS dma program
#define R_TDMAP_SA				0x004				//the starting address of TS dma program
#define R_TDMAP_EXE				0x008
#define R_TDMAP_PP				0x00C
#define R_TSCTL					0x010				//TS control 1
#define		R_ACTL_TSCLKPOL		BIT(26)
#define		R_ACTL_TVALSEL		BIT(25)
#define		R_ACTL_TSMODE		BIT(24)
#define		R_ACTL_TSTBYTE		(0xFF<<16)
#define		R_ACTL_TPCMODE		(BIT(15)|BIT(14))
#define		R_ACTL_TSOPSEL		(BIT(13)|BIT(12))
#define		R_ACTL_TPKTLEN		0xFFF
#define R_TPACKET				0x014				//TS packet
#define		R_TPACKET_TLINE		(0xFFFF<<16)
#define		R_TPACKET_TLENGTH	0xFFFF
#define R_TDMATRIG				0x18
#define		R_TDMATRIG_TDMATRIG	(0x7F<<8)
#define		R_TDMATRIG_ACKGLOOP	BIT(3)
#define		R_TDMATRIG_TDUMMYEN	BIT(2)
#define		R_TDMATRIG_I2STHR	BIT(1)
#define		R_TDMATRIG_I2SIOEN	BIT(0)
#define R_TINTSTAT				0x1C
#define		R_TINTSTAT_PPERR	BIT(14)
#define		R_TINTSTAT_TIRQC	(0xF<<8)
#define		R_TINTSTAT_PABORT	BIT(6)
#define		R_TINTSTAT_TDMAPERR	BIT(5)
#define		R_TINTSTAT_TFOVFI	BIT(3)
#define		R_TINTSTAT_TDMAPI	BIT(1)
#define R_TINTMASK				0x20
#define R_TRSTN					0x30
#define		R_TRSTN_TRSTN		BIT(0)
#define R_AGAIN					0x4C
#define R_PCI66MSTAT			0x78
#define		R_PCI66MSTAT_M66EN	BIT(0)


#endif //__TW680X_H_