/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6864.cpp
 *  @brief		оƬCTW6864ʵ֣֧TW6864
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6864.h"
#include "Dev6864sg.h"
#include "Dev6864sg2f.h"
#include "Dev6864sgSw.h"
#include "Dev6864blk.h"
#include "Dev6864blkSw.h"
#include "Dev6864aud.h"
#include "TW686X.h"
#include "PlgvSource.h"
#include "vDec686X.h"
#include <mmsystem.h>

BOOL  CTW6864::m_bSG = FALSE;
BOOL  CTW6864::m_bDefault = FALSE;
ULONG CTW6864::m_uDaemonPeriod	  = DAEMON_PERIOD;
int	  CTW6864::m_uDaemonThreshold = DAEMON_THRESHOLD;
int	  CTW6864::m_uDaemonTolerance = DAEMON_TOLERANCE;
ULONG CTW6864::m_uDaemonFrames	  = DAEMON_FRAMES;
int	  CTW6864::m_iDeviceNum		  = 0;
int	  CTW6864::m_iDeviceBegin	  = 0;
int	  CTW6864::m_iSwitchDelay	  = TW6864_SWITCH_DELAY;
int	  CTW6864::m_iVcom			  = 0;
int	  CTW6864::m_iVcomNum		  = 0;
int	  CTW6864::m_iVcomBegin		  = 0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTW6864::CTW6864() :
m_PageB(NULL), m_PageP(NULL),
m_i2c(NULL),
m_gpio(NULL),
m_iSubs(0),
m_iFpsErr(0),
m_iDaemon(0),
m_tkDaemon(0),
m_iBadFrames(0),
m_i2cDriver(0)
{
	ZeroMemory(&m_memDmap, sizeof(TMemBlock));
	m_iFps = m_uDaemonFrames;
}

CTW6864::~CTW6864()
{

}

LONG CTW6864::Devices(int devType)
{
	if(devType == DEV_audio) {
		return m_iSubs;
	}
	
	if(devType == DEV_video) {
		return m_iSubs;
	}
	
	if(devType == DEV_av) {
		return m_iSubs;
	}
	
	return 0;
}

/** 
 ***************************************************************************************
 *  оƬ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CTW6864::CreateDevices()
{
	CDevBase* dev = NULL;
	PDeviceCapability devCaps = NULL;
	TCmdI2CInfo i2cInfo;
	int i = 0;

	ZeroMemory(&i2cInfo, sizeof(TCmdI2CInfo));
	
	for(i=0; i<m_devInfo.nSubDevice; i++) {
		devCaps = m_capsListV[i];
		if(i2cInfo.hwid==0) {
			i2cInfo.hwid = 0x6864;
			i2cInfo.memBase = (ULONG)m_Mem[0].CpuBaseAddress();
			i2cInfo.hLock= (HANDLE)m_i2c->i2cLock()->Object();
			if(!AppendI2C(i2cInfo)) {
				return FALSE;
			}
			m_i2cDriver = i2cInfo.i2cHandle;
		}
		if(m_bSG) {
			if(devCaps->ddesc.iSwitch > 1) {
				dev = new CDev6864sgSw();
			}
			else if(devCaps->ddesc.bField2) {
				dev = new CDev6864sg2f();
			}
			else {
				dev = new CDev6864sg();
			}
		}
		else {
			if(devCaps->ddesc.iSwitch > 1) {
				dev = new CDev6864blkSw();
			}
			else {
				dev = new CDev6864blk();
			}
		}
		if(dev == NULL) {
			return FALSE;
		}
		m_devList.push_back(dev);
		g_devListV.push_back(dev);
		if(!dev->Open(this, devCaps, NULL, i+m_iDeviceBegin)) {
			return FALSE;
		}
		devCaps->device = dev;
		devCaps->ddesc.nFirstChannel = (int)g_chlList.size();
		if(devCaps->ddesc.VideoInputMask & INPUT_ALL)
		{
			devCaps->ddesc.nChannels = devCaps->ddesc.iSwitch;
			if(!dev->CreateChannels()) {
				return FALSE;
			}
		}
		else
		{
			devCaps->ddesc.nChannels = 0;
		}

		if((m_iVcomNum>0) && (m_iVcom>0)) {
			if((i+m_iDeviceBegin >= m_iVcomBegin) && (i+m_iDeviceBegin < m_iVcomBegin+m_iVcomNum)) {
				CPlgvSource* vsource = NULL;
				TvSourceInfo vinfo;
				CSample*	 spl = NULL;
				CvDec686x*	 vDec= NULL;
				int j = 0;

				for(j=devCaps->ddesc.nFirstChannel; j<(int)g_chlList.size(); j++) {
					vsource = (CPlgvSource*)g_chlList[j]->Plugin(PLG_vsource);
					vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
					vinfo.vcom = m_iVcom;
					vsource->SetPluginInfo(&vinfo, VSRC_vcom);

					vDec = new CvDec686x();
					if(vDec != NULL) {
						g_chlList[i]->AppendPlugin(vDec);
					}
				}

				for(j=0; j<RAWV_NUM; j++) {
					spl = new CSample();
					if(spl == NULL) { break; }
					if(spl->Allocate(RAWV_LEN_4CIF)) {
						g_bufPlgV.push_back(spl);
					}
					else {
						delete spl;
						break;
					}
				}
			}
		}
	}

	if(Devices(DEV_audio) > 0) {
		for(i=0; i<m_devInfo.nSubDevice; i++) {
			devCaps = m_capsListA[i];
			dev = new CDev6864aud();
			if(dev == NULL) {
				return FALSE;
			}
			m_devList.push_back(dev);
			g_devListA.push_back(dev);
			if(!dev->Open(this, devCaps, NULL, i+m_iDeviceBegin+TW6864_DMA_NUM)) {
				return FALSE;
			}
			devCaps->device = dev;
			devCaps->ddesc.nFirstChannel = m_capsListV[i]->ddesc.nFirstChannel;
			if(m_capsListV[i]->ddesc.nChannels > 0)
			{
				devCaps->ddesc.nChannels = 1;
				if(!dev->Append2Channel(g_chlList[devCaps->ddesc.nFirstChannel])) {
					return FALSE;
				}
			}
			else
			{
				devCaps->ddesc.nChannels = 0;
			}
		}
	}

	return TRUE;
}

BOOL CTW6864::OnOpen()
{
	TCrashInfo	crash;
	int i=0, iDmapLen=TW6864_DMA_PAGETABLE_NUM*TW6864_DMA_PAGETABLE_UNIT;
	
	m_i2c = new CI2C6864();
	m_i2c->i2cInit(&m_Mem[0]);
	m_i2c->I2CInitSWMode(400000);
	if(m_iDeviceNum) {
		m_iSubs = Init286x() ? min(8,m_iDeviceNum) : min(4,m_iDeviceNum);
	}
	else {
		m_iSubs = Init286x() ? 8 : 4;
	}
	m_gpio = new CGpio686x(&m_Mem[0]);
	m_gpio->InitGpio(m_i2c->i2cLock());
	
// 	m_i2cg.Init(m_gpio, 7, 6);
// 	m_i2cg.I2CInitSWMode(400000);
	
	//crash, Զɾ
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= TW6864_R_DMA_CHANNEL_ENABLE;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= TW6864_R_DMA_CMD;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
		
	if(!AllocMemory(iDmapLen, &m_memDmap)) {
		return FALSE;
	}
	ZeroMemory(m_memDmap.vaddr, iDmapLen);
	m_PageP = (PDMADescriptor)m_memDmap.vaddr;
	m_PageB = (PDMADescriptor)((ULONG)m_PageP + TW6864_DMA_PAGETABLE_UNIT);
	
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE0, (ULONG)m_memDmap.pnodes[0].addr);
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE1, (ULONG)m_memDmap.pnodes[0].addr + TW6864_DMA_PAGETABLE_UNIT);

#define DMA_STATUS_HOST_NOT_AVAIABLE    0
	PDMADescriptor	pDesc = m_PageP;
	for(i=0;i<512;i++) {
		pDesc[i].ctrl = (DMA_STATUS_HOST_NOT_AVAIABLE&3)<<30;
	}
	pDesc = m_PageB;
	for(i=0;i<512;i++) {
		pDesc[i].ctrl = (DMA_STATUS_HOST_NOT_AVAIABLE&3)<<30;
	}
	
	return TRUE;
}

BOOL CTW6864::OnOpen(PDeviceCapability devCaps, int iDev, int iType)
{
	if(m_iDeviceNum) {
		iDev += m_iDeviceBegin;
	}
	if(iType == DEV_video) {
		devCaps->caps |= CAPS_4CIF|CAPS_FIELD2|CAPS_SWITCH;
		devCaps->ddesc.iSwitch = 1;
		devCaps->ddesc.nAudio  = TW6864_AUDIO;
		devCaps->ddesc.bField2 = FALSE;
		devCaps->ddesc.VideoInputMask = INPUT_MASK((int)viCompositeVideo1);
		devCaps->ddesc.reserved1 = (iDev<4) ? viCompositeMax : viCompositeVideo3;
	}
	else {
		devCaps->ddesc.iSwitch = 1;
		devCaps->ddesc.nAudio  = TW6864_AUDIO;
	}
	
	return TRUE;
}

BOOL CTW6864::OnClose()
{
	TCmdI2CInfo i2cInfo;

	ZeroMemory(&i2cInfo, sizeof(TCmdI2CInfo));
	i2cInfo.i2cHandle = m_i2cDriver;
	m_i2cDriver = 0;
	RemoveI2C(i2cInfo);

	SAFE_DELETE(m_i2c);
	SAFE_DELETE(m_gpio);
	
	FreeMemory(&m_memDmap);
	_trace(TEXT("[Ϣ]CTW6864::OnClose()ͷDMAP bufferɹ(slot %d,function 0,device %d)\n"), 
		m_cardInfo->nSlot, m_devInfo.DeviceNumber);
	
	return TRUE;
}

void CTW6864::OnDma(ULONG uStatus)
{
	ULONG	  tkNow = 0;
	int		  nTemp = 0, i=0;
	CDev6864* dev = NULL;
	int		  nDaemon = 0;

	if(uStatus) {
		m_iBadFrames++;
	}

	if(m_uDaemonPeriod == 0) {
		return;
	}

	tkNow = timeGetTime();
	if(m_tkDaemon == 0) { 
		m_tkDaemon = tkNow;
		return; 
	}

	if(m_iBadFrames>m_uDaemonThreshold) {
		nDaemon = -1;
		m_tkDaemon = tkNow;
		m_iBadFrames = 0;
	}
	else if((tkNow-m_tkDaemon) >= m_uDaemonPeriod) {
		nDaemon = (m_iBadFrames<=0);
		m_iBadFrames = 0;
		m_tkDaemon = tkNow;
		if(!nDaemon) {
			m_iDaemon = 0;
		}
	}
	if(nDaemon != 0) {
		uStatus = FALSE;
		if(nDaemon<0) { //(m_iBadFrames > m_uDaemonThreshold) {
			m_iDaemon = min(0, m_iDaemon);
			m_iDaemon--;
			if(-m_iDaemon >= m_uDaemonTolerance) {
				m_iFpsErr = m_iFps;
				if(m_iFps > DAEMON_MINFRAMES) {
					m_iFps--;
					uStatus = TRUE;
				}
				m_iDaemon = 0;
			}
		}
		else {
			m_iDaemon = max(0, m_iDaemon);
			m_iDaemon++;
			if(m_iDaemon >= m_uDaemonTolerance) {
				uStatus   = TRUE+TRUE;
				m_iDaemon = 0;
			}
		}

		if(uStatus>TRUE) {
#if(1)
			//ֻӵϴγbad frameСֵ
			nTemp = min((m_iFps+1), MAX_FRAMERATE(TvSourceInfo::default_standard));
			if((nTemp != m_iFps) && (nTemp!=m_iFpsErr)) {
				m_iFps = nTemp;
			}
			else {
				uStatus = FALSE;
			}
#else
			//ӵMAX_FRAMERATE(TvSourceInfo::default_standard)
			m_iFps = min((m_iFps+1), MAX_FRAMERATE(TvSourceInfo::default_standard));
#endif
		}
		if(uStatus) {
			_trace(TEXT("[Ϣ]豸%d(bus %d) fps token - %d\n"), m_devInfo.DeviceNumber, m_devInfo.nBus, m_iFps);
			for(i=m_iDeviceBegin; i<m_iSubs; i++) {
				dev = (CDev6864*)m_devList[i-m_iDeviceBegin];
				if(dev->DeviceCaps()->ddesc.iSwitch > 1) { continue; }
				dev->SetFrameRate(NULL);
			}
		}
	}
}

//-------------------------------------------------------
//ʼTW6864
//-------------------------------------------------------
BOOL CTW6864::OnInit()
{
	ULONG tmp;
	int   i = 0;

	if(ReadPciConfigSpace(0x04, 4, (BYTE*)&tmp)) {
		tmp |= 7;
		WritePciConfigSpace(0x04, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0x78, 4, (BYTE*)&tmp)) {
		tmp = (0x8<<5) | (tmp & 0xFFFFFE1F);		//8=128B, 9=256B, A=512B, B=1024B
		WritePciConfigSpace(0x78, 4, (BYTE*)&tmp);
	}

	//Software Reset
	m_Mem[0].outd(TW6864_R_SYS_SOFT_RST, 0x01);
	m_Mem[0].outd(TW6864_R_SYS_SOFT_RST, 0x0F);

	//S&G, Common Buffer DMA memory setup
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE0, 0x00000000);
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE1, 0x00000000);

	for(i=0;i<TW6864_MAX_NUM_DATA_DMA;i++) {
		m_Mem[0].outd(TW6864_R_CH8to15_CONFIG_REG_P(i),0);
		m_Mem[0].outd(TW6864_R_CH8to15_CONFIG_REG_B(i),0);
	}

	if(ReadPciConfigSpace(0x04, 4, (BYTE*)&tmp)) {
		tmp &= 0xFFFFFBFF;							// Enable INTx
		WritePciConfigSpace(0x04, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0x50, 4, (BYTE*)&tmp)) {	//CFG_MSI_CAP = 0x50
		tmp &= 0xFFFEFFFF;							//Disable MSI
		WritePciConfigSpace(0x50, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0xAC, 4, (BYTE*)&tmp)) {	//CFG_MSIX_CAP = 0xAC
		tmp &= 0x7FFFFFFF;							//Disable MSI-X
		WritePciConfigSpace(0xAC, 4, (BYTE*)&tmp);
	}

	m_Mem[0].outd(TW6864_R_AVSRST,0x3F);             //Reset Internal video decoders
	m_Mem[0].outd(TW6864_R_DMA_CMD, 0);			     //Reset all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_ENABLE, 0);	 //Disable all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_INT_REF,  0x4c4b6);	 //Set INT interval for 2.0ms	

	tmp = 0x00FF0004; //(TW6864_MAXSWITCH>1) ? 0x00000004 : 0x00FF0004;
	m_Mem[0].outd(TW6864_R_DMA_CONFIG,  tmp);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
												//little endian, bad/vsync protection on
	
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_TIMEOUT,  0x14FFFFFF);//0x140c8b08);
#ifdef DECIMATE_H
	tmp  = 5400*2;													//4740 ~ 5649, less means shorter line
#else
	tmp  = 0x15DC;													//512*(2*125)/(27*720/858)
#endif
	m_Mem[0].outd(TW6864_R_PHASE_REF_CONFIG,  tmp); 

	tmp = 1;
	tmp |= TW6864_R_VIDEO_CTRL1_STANDARDALL;		//pal, 4 D1 TDM format, 108MHz
	m_Mem[0].outd(TW6864_R_VIDEO_CTRL1,  tmp);	

	tmp = (ULONG)0x40a0;
	m_Mem[0].outd(TW6864_R_CSR_REG,tmp); 

	tmp = TW6864_R_VIDEO_CTRL2_GENRSTALL | (TW6864_VIDEO_GEN_PATTERNS <<8) | TW6864_R_VIDEO_CTRL2_GENALL;
	m_Mem[0].outd(TW6864_R_VIDEO_CTRL2,  tmp);	
	
	tmp = (TW6864_AUDIO_DMA_LENGTH << 19) |
		  (TW6864_AUDIO_SAMP_RATE_INT(TW6864_AUDIO_SAMPLE_RATE)<<5) |
		  (TW6864_AUDIO_GEN_PATTERN << 4) |
		  (TW6864_AUDIO_GEN_MIX_SEL <<1 ) |
		   TW6864_AUDIO_GEN;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);		
	
	tmp = (ULONG)TW6864_AUDIO_SAMP_RATE_EXT(TW6864_AUDIO_SAMPLE_RATE);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL2,  tmp);	
	
	tmp = 0x40;
	if(TW6864_AUDIO_SAMPLE_BIT == 8) {
		tmp |= BIT(8);
	}
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL3, tmp);

	//Show Blue background if no signal
	m_Mem[0].outd(TW6864_R_MISC_CTRLII1, 0xE0);//0xE7);

#ifdef TW6864B_BUG_WORKAROND
	tmp = 0x0;
#else
	tmp = 0x20;
#endif
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_0, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_1, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_2, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_3, tmp);

	m_Mem[0].outd(TW6864_R_VERTICAL_CTRL,0x00); //0x26 will cause ch0 and ch1 have dma_error.
	m_Mem[0].outd(TW6864_R_LOOP_CTRL,    0xa5);
	m_Mem[0].outd(TW6864_R_GPIO_REG,	 0xFFFF0000);
 	m_Mem[0].outd(TW6864_R_HFLT1,		 0x00);//0xBB);		//NOTE: ӰCIFȣCIF4CIFֱ
 	m_Mem[0].outd(TW6864_R_HFLT2,		 0x00);//0xBB);
	//m_Mem[0].outd(TW6864_R_MISC_CTRLII2, 0x05);//0x03);	//BIT[3..2] Clamping mode controlһΪAuto,Ӱźż

	return TRUE;
}

//-------------------------------------------------------
//ʼTW6864
//-------------------------------------------------------
BOOL CTW6864::OnUninit()
{
	m_Mem[0].outd(TW6864_R_DMA_CMD, 0);			     //Reset all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_ENABLE, 0);	 //Disable all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE0, 0x00000000);
	m_Mem[0].outd(TW6864_R_DMA_PAGE_TABLE1, 0x00000000);

	for(int i=0; i<8; i++) {
		m_Mem[0].outd(TW6864_R_VC_CTRL_REG(i), 0x00000000);
	}

	Uninit286x();

	return TRUE;
}

//-------------------------------------------------------
//ʼTW2864
//-------------------------------------------------------
bool CTW6864::Init286x()
{
	ULONG	tmp;

	tmp  = m_Mem[0].ind(TW6864_R_CSR_REG);
	tmp &= 0x7FFF;
	m_Mem[0].outd(TW6864_R_CSR_REG,tmp); 
	Sleep(100);
	tmp |= 0x8002;  // Pull out from reset and enable I2S
	m_Mem[0].outd(TW6864_R_CSR_REG,tmp); 

	tmp = DeviceRead2864(TW2864_R_DEV_REV_LO);
	if(((tmp>>3) != 0x18) && ((tmp>>3) != 0x19)) {
		return false;
	}

#ifdef ADC_DATA_IN
	m_Mem[0].outd(TW6864_R_CSR_REG,0x1ec0a1); 

	tmp = DeviceRead2864(TW2864_R_VIDEO_MISC);
	_trace("2864[VIDEO_MISC 0x%x]=0x%x\n",TW2864_R_VIDEO_MISC,tmp);	

	tmp = DeviceRead2864(TW2864_R_DEV_REV);
	_trace("2864[DEV_REV 0x%x]=0x%x\n",TW2864_R_DEV_REV,tmp);	

	DeviceWrite2864(TW2864_R_MIX_OUT_SEL,0x94); //VADCCK = 1
	tmp = DeviceRead2864(TW2864_R_MIX_OUT_SEL);
	_trace("2864[MIX_OUT_SEL 0x%x]=0x%x\n",TW2864_R_MIX_OUT_SEL,tmp);	

	tmp = 0x59; //VBI_FRAM = 1
	DeviceWrite2864(TW2864_R_VIDEO_MISC,tmp);

	tmp = 0x40;					// Out enable,27MHz
	DeviceWrite2864(TW2864_R_CLKOCTRL,tmp);
#else
	//////////////////////////////////////
	// 2864 #1/External, Muxed-656
	tmp  = 0x02;						
	DeviceWrite2864(TW2864_R_CLK_SEL_2865, tmp);	// if outside is TW2865 instead of TW2864
	tmp = DeviceRead2864(TW2864_R_CLK_SEL_2865);
	_trace(TEXT("2864[CLK_SEL_2865 0x%x]=0x%x\n"),TW2864_R_CLK_SEL_2865, tmp);	

	tmp = 0x73;					// CHID with 656 Sync code, 656 output even no video input
	if(!DeviceWrite2864(TW2864_R_NOVID,tmp)) {
		return false;
	}

	tmp = 0x80;					// Serial mode
	DeviceWrite2864(TW2864_R_SMD,tmp);

	tmp = 0xC1;					// I2S,8-bit,ASYNR is output,Slave
	if(TW6864_AUDIO_SAMPLE_BIT == 8) {
		tmp |= BIT(2);
	}
	else {
		tmp &= ~BIT(2);
	}
	DeviceWrite2864(TW2864_R_MASTER_CTRL,tmp);

	tmp = 0x66;					// Audio Gain, input 1, 2
	DeviceWrite2864(TW2864_R_AUDIO_GAIN0,tmp);

	tmp = 0x66;					// Audio Gain, input 3, 4
	DeviceWrite2864(TW2864_R_AUDIO_GAIN1,tmp);

	tmp  = 0x1;
	DeviceWrite2864(TW2864_R_NUM_ADUIOR,tmp);

	tmp  = 0x32;
	DeviceWrite2864(TW2864_R_SEQ_ADUIOR,tmp);

	tmp =  2 | (2<<2) | (2<<4) | (2<<6);
	DeviceWrite2864(TW2864_R_VIDEO_OUT_CTRL,tmp);

	tmp = 0x40 | ( 2 | (2<<2) ) ; // Out enable
	DeviceWrite2864(TW2864_R_CLKOCTRL,tmp);
	tmp=DeviceRead2864(TW2864_R_CLKOCTRL);
	_trace(TEXT("2864[CLKOCTRL 0x%x]=0x%x\n"),TW2864_R_CLKOCTRL,tmp);	

	DeviceWrite2864(0x6A,0x0F);
	DeviceWrite2864(0x6B,0x0F);
	DeviceWrite2864(0x6C,0x0F);
	DeviceWrite2864(0x60,0x45);
	DeviceWrite2864(0x4B,0x30);
	
#endif //ADC_DATA_IN

	DeviceWrite2864(TW2864_R_LOOP_CTRL, 0xa5);
	DeviceWrite2864(TW2864_R_VERTICAL_CTRL, 0x00);
	DeviceWrite2864(TW2864_R_VERTICAL_SHARPNESS, 0x80);
 	DeviceWrite2864(TW2864_R_HFLT1, 0x00);//0xBB);		//NOTE: ӰCIFȣCIF4CIFֱ
 	DeviceWrite2864(TW2864_R_HFLT2, 0x00);//0xBB);
	DeviceWrite2864(TW2864_R_MISC_CTRLII1, 0xE0);//0xE7);
	DeviceWrite2864(TW2864_R_MISC_CTRLII2, 0x05);//0x03);	//BIT[3..2] Clamping mode controlһΪAuto,Ӱźż

	return true;
}

//-------------------------------------------------------
//ʼTW2864
//-------------------------------------------------------
void CTW6864::Uninit286x()
{
}

//-------------------------------------------------------
// See DeviceWrite2864 for description of byte_addr
//-------------------------------------------------------
UCHAR CTW6864::DeviceRead2864(ULONG byte_addr)	
{
	UCHAR	Data;

	if(!m_i2c) return 0xFF;

	if(!m_i2c->i2cReadData(TW2864_R_I2C_ADDR0, UCHAR(byte_addr&0xFF), 1, &Data)) {
		return 0xFF;
	}
	
	return Data;
}

//-------------------------------------------------------
// See DeviceWrite2864 for description of byte_addr
//-------------------------------------------------------
bool CTW6864::DeviceWrite2864(ULONG byte_addr, ULONG dat)	
{
	UCHAR	Data[3];
	
	if(!m_i2c) return false;

	Data[0] = TW2864_R_I2C_ADDR0; 
	Data[1] = UCHAR(byte_addr&0xFF);								 //reg_addr
	Data[2] = UCHAR(dat&0xFF);										 //reg_val
	
	return m_i2c->i2cWriteData(3, Data);
}

void CTW6864::SetMux(int ch, TVideoInput vInput) 
{
	ULONG uConfig = m_Mem[0].ind(TW6864_R_CH0to7_CONFIG_REG(ch));
	uConfig &= ~(3 << 30);
	uConfig |= (vInput&3) << 30;
	m_Mem[0].outd(TW6864_R_CH0to7_CONFIG_REG(ch), uConfig);

	if(ch >= 4) {
		ch -= 4;
		uConfig = DeviceRead2864(TW2864_R_VERTICAL_SHARPNESS);
		uConfig&= ~(1<<ch);
		uConfig|= (vInput%2) << ch;
		DeviceWrite2864(TW2864_R_VERTICAL_SHARPNESS, (UCHAR)uConfig);
	}
}

void CTW6864::SetStandard(int ch, int value, BOOL bAuto)
{
	ULONG tmp = m_Mem[0].ind(TW6864_R_VIDEO_CTRL1);

	tmp &= ~TW6864_R_VIDEO_CTRL1_STANDARD(ch);
	if(value == vsStandardPAL) {
		tmp |= TW6864_R_VIDEO_CTRL1_STANDARD(ch);		//pal, 4 D1 TDM format, 108MHz
	}

	m_Mem[0].outd(TW6864_R_VIDEO_CTRL1,  tmp);	
	m_iFps = min(m_iFps, MAX_FRAMERATE(value));

	if(ch < 4) {
		if(bAuto) {
			tmp = 0x07;
		}
		else {
			tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_STANDARD_0, ch));
			tmp&= 0xF8;
			tmp|= (value==vsStandardPAL) ? 1 : 0;
		}
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_STANDARD_0, ch), tmp);
	}
	else {
		ch -= 4;
		if(bAuto) {
			tmp = 0x07;
		}
		else {
			tmp = DeviceRead2864(TW2864_R_CHANNEL(TW2864_R_STANDARD_0, ch));
			tmp&= 0xF8;
			tmp|= (value==vsStandardPAL) ? 1 : 0;
		}
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_STANDARD_0, ch), tmp);
	}
}

ULONG CTW6864::MapFormat(int nFormat)
{
	switch(nFormat) {
	case vpfYUV422Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_YUYV & 7);
		break;
	case vpfYUV420Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_YUV420 & 7);
		break;
	case vpfYUV411Planar : 
		nFormat = (TW6864_VIDEO_FORMAT_Y411 & 7);
		break;
	case vpfYUV411Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_Y41P & 7);
		break;
	case vpfRGB16:
		nFormat = (TW6864_VIDEO_FORMAT_RGB565 & 7);
		break;
	case vpfRGB15Alpha:
		nFormat = (TW6864_VIDEO_FORMAT_RGB555 & 7);
		break;
	default:
		nFormat = (TW6864_VIDEO_FORMAT_YUYV & 7);
	}

	return nFormat;
}

void CTW6864::SetFormat(int ch, int value)
{
	ULONG uConfig = m_Mem[0].ind(TW6864_R_CH0to7_CONFIG_REG(ch));
	uConfig &= ~(7 << 20);
	uConfig |= MapFormat(value) << 20;
	m_Mem[0].outd(TW6864_R_CH0to7_CONFIG_REG(ch), uConfig);
}

void CTW6864::SetSize(int ch, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG tmp, tmp1, tmp2;
	int	  width = vinfo->capture.width;
	int	  height= (IS_4CIF(*vinfo)||vinfo->optimize_cif) ? vinfo->capture.height/2 : vinfo->capture.height;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->capture.width>704)) ? 720 : 704;
	BOOL  isPal = (vinfo->standard==vsStandardPAL);

	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->capture.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
	vinfo->vdelay = min(vinfo->vdelay, isPal?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);
		
	//SH_Scaler
	//setup for Black stripe remover
	SetBlackStripe(ch, vinfo->vleft, vinfo->vright, width);

	tmp = (ULONG)TW6864_VIDEO_SIZE(width,height); 
	tmp1 = tmp2 = tmp;
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REGA, tmp);	
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG(ch), tmp); //for Rev.B or later only

	//H/V Scale
	tmp1 &= 0x7FF; 
	tmp2 = (tmp2>>16)&0x1FF;	 //V
	tmp1 = (maxWidth*256)/tmp1;  //H
	tmp2 = ((isPal?288:240)*256)/tmp2;
	tmp = tmp1 & 0xFF;

	SetHDelay(ch, abs(vinfo->hdelay));
	SetVDelay(ch, abs(vinfo->vdelay));

	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_0,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_0,ch),  tmp);		

		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_0,ch),  tmp);		
		
		if(m_bDefault) {
			tmp = 0x00;
		}
		else if(tmp1 > 1) {
			if(width==352)		{ tmp = 0x01; }
			else if(width==176)	{ tmp = 0x02; }
			else				{ tmp = 0x00; }
		}
		else					{ tmp = 0x0B; }
		tmp1 = m_Mem[0].ind(TW6864_R_HFLT1 + (ch/2)*4);
		tmp1&= ~(0x0F << ((ch%2)*4));
		tmp1|= ((tmp&0x0F) << ((ch%2)*4));
		m_Mem[0].outd(TW6864_R_HFLT1 + (ch/2)*4, tmp1);

		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_F2_CNT_0,ch), 0x00);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_HSCALE_LO_0+ch*3,tmp);
		
		tmp = tmp2 & 0xFF;
		DeviceWrite2864(TW2864_R_VSCALE_LO_0+ch*3,tmp);
		
		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		DeviceWrite2864(TW2864_R_VHSCALE_HI_0+ch*3,tmp);

		if(m_bDefault) {
			tmp = 0x00;
		}
		else if(tmp1 > 1) {
			if(width==352)		{ tmp = 0x01; }
			else if(width==176)	{ tmp = 0x02; }
			else				{ tmp = 0x00; }
		}
		else					{ tmp = 0x0B; }
		tmp1 = DeviceRead2864(TW2864_R_HFLT1 + ch/2);
		tmp1&= ~(0x0F << ((ch%2)*4));
		tmp1|= ((tmp&0x0F) << ((ch%2)*4));
		DeviceWrite2864(TW2864_R_HFLT1 + ch/2, tmp1);
	}
}

void CTW6864::SetSizeF2(int ch, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG tmp, tmp1, tmp2;
	int	  width = vinfo->capture.width;
	int	  height= (IS_4CIF(*vinfo)||vinfo->optimize_cif) ? vinfo->capture.height/2 : vinfo->capture.height;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->capture.width>704)) ? 720 : 704;		//remove black sptripe
	BOOL  isPal = (vinfo->standard==vsStandardPAL);
	
	tmp = (ULONG)TW6864_VIDEO_SIZE_F2(width,height); 
	tmp1 = tmp2 = tmp;
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG_F2(ch), tmp); //for Rev.B or later only
	
	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->capture.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
	vinfo->vdelay = min(vinfo->vdelay, isPal?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);

	if(ch < 4) {
		//H/V Scale
		tmp1 &= 0x7FF; 
		tmp2 = (tmp2>>16)&0x1FF;	 //V
		tmp1 = (maxWidth*256)/tmp1;  //H
		tmp2 = (((vinfo->standard==vsStandardPAL)?288:240)*256)/tmp2;
		tmp = tmp1 & 0xFF;
		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_F2_0,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_F2_0,ch),  tmp);		
		
		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_F2_0,ch),  tmp);		

		SetHDelay(ch, abs(vinfo->hdelay));
		SetVDelay(ch, abs(vinfo->vdelay));
	
		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_CROPPING_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_CROPPING_F2_0,ch), tmp);

		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_HACTIVE_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HACTIVE_F2_0,ch), tmp);

		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_VACTIVE_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VACTIVE_F2_0,ch), tmp);

		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_F2_CNT_0,ch), 0x1);
	}

	tmp  = m_Mem[0].ind(TW6864_R_VIDEO_SIZE_REG(ch));
	tmp |= (1 << 30);
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG(ch), tmp);
}

void CTW6864::SetVDelay(int ch, int value)
{
	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VDELAY_0,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VDELAY_F2_0,ch), (ULONG)value);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_VDELAY_0,ch), (ULONG)value);
	}
}

void CTW6864::SetHDelay(int ch, int value)
{
	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HDELAY_0,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HDELAY_F2_0,ch), (ULONG)value);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_HDELAY_0,ch), (ULONG)value);
	}
}

void CTW6864::SetBlackStripe(int ch, int start, int end, int width)
{
	ULONG tmp, tmp1, tmp2;
	BOOL  bRBS = (start >= 0);

	start = (start<0) ? -start : start;
	end   = (end<0) ? -end : end;

	//setup for Black stripe remover
	tmp1 = width-end;  //EndPos
	tmp2 = start;	   //StartPos	
	tmp = (tmp1 - tmp2)*(1<<16)/width;
	tmp = (tmp2 & 0x1F) | ((tmp1 & 0x3FF) << 5) | (tmp <<15);
	tmp |= bRBS ? TW6864_REMOVE_BLACKSTRIPE : 0;
	m_Mem[0].outd(TW6864_R_SHSCALER_REG(ch), tmp);		
}

void CTW6864::SetVcom(int ch, int width, int value)
{
	ULONG uVal = (ULONG)((width-1) & 0x3FF);

	if(value > 0) {
		uVal |= (1<<24) | (((value-1)&0x03)<<16);
	}

	m_Mem[0].outd(TW6864_R_VC_CTRL_REG(ch), uVal);
}

void CTW6864::SetBright(int ch, int value)
{
	int val = 0;
		
	g_util.map(B_MIN, B_MAX, value, B_MIN_6864, B_MAX_6864, &val);
	
	if(m_bDefault) { val = 0x00; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_BRIGHT(ch), val);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_BRIGHT_0,ch), val);
	}
}

void CTW6864::SetContrast(int ch, int value)
{
	int val = 0;
	
	g_util.map(C_MIN, C_MAX, value, C_MIN_6864, C_MAX_6864, &val);
	
	if(m_bDefault) { val = 0x64; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_CONTRAST(ch),  val);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_CONTRAST_0,ch), val);
	}
}

void CTW6864::SetHue(int ch, int value)
{
	int val = 0;
	
	g_util.map(H_MIN, H_MAX, value, H_MIN_6864, H_MAX_6864, &val);
	
	if(m_bDefault) { val = 0; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_HUE(ch),  val);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_HUE_0,ch), val);
	}
}

void CTW6864::SetSaturation(int ch, int value)
{
	int val = 0;
	
	g_util.map(S_MIN, S_MAX, value, S_MIN_6864, S_MAX_6864, &val);

	if(m_bDefault) { val = 0x80; }

	if(ch<4) {
		m_Mem[0].outd(TW6864_R_SAT_U(ch),  val);
		m_Mem[0].outd(TW6864_R_SAT_V(ch),  val);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_SAT_U_0,ch), val);
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_SAT_V_0,ch), val);
	}
}

void CTW6864::SetSharpness(int ch, int value)
{
	int val = 0;
	
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6864, SH_MAX_6864, &val);
	val &= 0x0F;
	val |= 0x10;//0xA0;

	
	if(m_bDefault) { val = 0x11; }

	if(ch<4) {
		m_Mem[0].outd(TW6864_R_SHARPNESS(ch),  val);
	}
	else {
		ch -= 4;
		DeviceWrite2864(TW2864_R_CHANNEL(TW2864_R_SHARPNESS_0,ch), val);
	}
}

void CTW6864::SetAudioDmaLength(int value)
{
    ULONG tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL1);
    tmp &= ~(0xFFF80000);
	tmp |= (value<<19) & 0xFFF80000;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);
}

void CTW6864::SetAudioParam(int samplerate, int bits, int channels)
{
    ULONG tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL1);
    samplerate /= 1000;
    tmp &= ~(0x0007FFE0);
	tmp |= ((TW6864_AUDIO_SAMP_RATE_INT(samplerate)<<5) & 0x0007FFE0);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);
	
	tmp = (ULONG)TW6864_AUDIO_SAMP_RATE_EXT(samplerate);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL2,  tmp);	
	
	tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL3);
	tmp &= ~BIT(8);
	tmp |= (bits==8) ? BIT(8) : 0;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL3, tmp);
}

void CTW6864::SetVolume(int nCh, int volume)
{
	ULONG tmp;

	volume &= 0xFF;
	if(nCh < 4) {
		m_Mem[0].outd(TW6864_R_AUDIO_GAIN_0+(nCh*4), (BYTE)volume);
	}
	else {
		nCh -= 4;
		tmp  = DeviceRead2864(TW2864_R_AUDIO_GAIN0+(nCh>1));
		if(nCh % 2) {
			tmp &= 0x0F;
			tmp |= (BYTE)((volume&0x0F) << 4);
		}
		else {
			tmp &= 0xF0;
			tmp |= (BYTE)(volume&0x0F);
		}
		DeviceWrite2864(TW2864_R_AUDIO_GAIN0+(nCh>1), tmp);
	}
}

ULONG CTW6864::GetDecoderStatus(int ch)
{
	if(ch < 4) {
		return m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_VSTATUS_0, ch));
	}

	return DeviceRead2864(TW2864_R_CHANNEL(TW2864_R_VSTATUS_0, ch-4));
}

void CTW6864::FILL_DESCRIPTOR(PDMADescriptor pDesc ,ULONG addr, UINT byte_len,UINT  field_start,UINT  next_filed_start,BOOLEAN bNewFrame, BOOLEAN bCheckPoint,UINT  status)
{
	pDesc->addr = addr; 
	pDesc->ctrl = ((status & 0x3) << 30)	| 
		((bNewFrame&1)<<29)					|
		((next_filed_start & 0xFF) << 21)	| 
		((field_start & 0x7F) << 14)		| 
		((bCheckPoint&1)<<13)				|
		(byte_len & 0x1FFF);
}

void CTW6864::DISABLE_DESCRIPTOR(PDMADescriptor pDesc)
{
	pDesc->ctrl &= 0x3FFFFFFF; //DMA_STATUS_HOST_NOT_AVAIABLE
	pDesc->ctrl |= 0x20000000; //New Flag
}

ULONG CTW6864::MapFieldRate(int nFieldRate, BOOL bNTSC)
{
	ULONG uRate = 0;

	if(!bNTSC) {
		switch(nFieldRate) {
		case 0:
			uRate = 0;
			break;
		case 1:
		case 2:	
			uRate = 0x00000001;
			break;
		case 3:
			uRate = 0x00004001;//0x10001000;
			break;
		case 4:
		case 5:
			uRate = 0x00104001;//0x10010010;
			break;
		case 6:
		case 7:
			uRate = 0x00404041;//0x10101010;
			break;
		case 8:
		case 9:
			uRate = 0x01041041;//0x11011010;
			break;
		case 10:
			uRate = 0x01104411;//0x11101110;
			break;
		case 11:
		case 12:
			uRate = 0x01111111;//0x11111110;
			break;
		case 13:
		case 14:
			uRate = 0x04444445;//0x11111111;
			break;
		case 15:
			uRate = 0x04511445;//0x15111111;
			break;
		case 16:
		case 17:
			uRate = 0x05145145;//0x15111511;
			break;
		case 18:
		case 19:
			uRate = 0x05151515;//0x15151511;
			break;
		case 20:
			uRate = 0x05515455;//0x15151515;
			break;
		case 21:
		case 22:
			uRate = 0x05551555;//0x15515515;
			break;
		case 23:
		case 24:
			uRate = 0x05555555;//0x15551555;
			break;
		default:
			uRate = 0x15555555;
			break;
		}
	}
	else {
		switch(nFieldRate) {
		case 0:
			uRate = 0;
			break;
		case 1:
		case 2:	
		case 3:
			uRate = 0x00000001;
			break;
		case 4:
		case 5:
			uRate = 0x00004001;//0x10001000;
			break;
		case 6:
		case 7:
			uRate = 0x00104001;//0x10010010;
			break;
		case 8:
		case 9:
			uRate = 0x00404041;//0x10101010;
			break;
		case 10:
		case 11:
			uRate = 0x01041041;//0x11011010;
			break;
		case 12:
		case 13:
			uRate = 0x01104411;//0x11101110;
			break;
		case 14:
		case 15:
			uRate = 0x01111111;//0x11111110;
			break;
		case 16:
		case 17:
			uRate = 0x04444445;//0x11111111;
			break;
		case 18:
		case 19:
			uRate = 0x04511445;//0x15111111;
			break;
		case 20:
		case 21:
			uRate = 0x05145145;//0x15111511;
			break;
		case 22:
		case 23:
			uRate = 0x05151515;//0x15151511;
			break;
		case 24:
		case 25:
			uRate = 0x05515455;//0x15151515;
			break;
		case 26:
		case 27:
			uRate = 0x05551555;//0x15551555;
			break;
		case 28:
		case 29:
			uRate = 0x05555555;//0x15551555;
			break;
		default:
			uRate = 0x15555555;
			break;
		}
	}

	return uRate;
}

ULONG CTW6864::MapFrameRate(int nFieldRate1, int nFieldRate2, BOOL bNTSC, BOOL b6864)
{
	ULONG uRate = 0;
	
	if(nFieldRate1 == 0) {
		uRate = MapFieldRate(nFieldRate2, bNTSC);
	}
	else if(nFieldRate2 == 0) {
		uRate = (MapFieldRate(nFieldRate1, bNTSC) << 1);
	}
	else {
		if(b6864) {
			uRate = bNTSC ? 30 : 25;
			if(nFieldRate1 > (int)uRate) nFieldRate1 = (int)uRate;
			if(nFieldRate2 > (int)uRate) nFieldRate2 = (int)uRate;
			if(uRate==nFieldRate1) {
				uRate = MapFieldRate(nFieldRate1, bNTSC) | (MapFieldRate(nFieldRate2, bNTSC) << 1);
			}
			else {
				uRate = (MapFieldRate(nFieldRate1, bNTSC)<<1) | (MapFieldRate(nFieldRate2, bNTSC) << 2);
			}
		}
		else {
			uRate = MapFieldRate(nFieldRate1, bNTSC) | (MapFieldRate(nFieldRate2, bNTSC) << 1);
		}
	}
	if(uRate > 0) {
		uRate |= 0x80000000;
	}
	
	return uRate;
}

HANDLE CTW6864::GetI2CuGpio(int sclGpio, int sdaGpio)
{
	if(m_i2cg == NULL) {
		m_i2cg = new CI2CuGpio686x();
		m_i2cg->Init(m_gpio, sclGpio, sdaGpio);
		m_i2cg->I2CInitSWMode(400000);
	}

	return m_i2cg;
}