/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6869.cpp
 *  @brief		оƬCTW6869ʵ֣֧TW6869
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TW6869.h"
#include "Dev6869sg.h"
#include "Dev6869sg2f.h"
#include "Dev6869sgSw.h"
#include "Dev6869blk.h"
#include "Dev6869blkSw.h"
#include "Dev6869aud.h"
#include "TW686X.h"
#include "PlgvSource.h"
#include "inifile.h"
#include <mmsystem.h>

BOOL  CTW6869::m_bSG = FALSE;
BOOL  CTW6869::m_bDefault = FALSE;
ULONG CTW6869::m_uDaemonPeriod	  = DAEMON_PERIOD;
int	  CTW6869::m_uDaemonThreshold = DAEMON_THRESHOLD;
int	  CTW6869::m_uDaemonTolerance = DAEMON_TOLERANCE;
ULONG CTW6869::m_uDaemonFrames	  = DAEMON_FRAMES;
int	  CTW6869::m_iDeviceNum		  = 0;
int	  CTW6869::m_iDeviceBegin	  = 0;
int	  CTW6869::m_iSwitchDelay	  = TW6864_SWITCH_DELAY;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTW6869::CTW6869() :
m_gpio(NULL),
m_i2cg(NULL),
m_iSubs(0),
m_iFpsErr(0),
m_iDaemon(0),
m_tkDaemon(0),
m_iBadFrames(0)
{
	ZeroMemory(&m_memDmap, sizeof(TMemBlock));
	m_iFps = m_uDaemonFrames;
}

CTW6869::~CTW6869()
{

}

LONG CTW6869::Devices(int devType)
{
	if(devType == DEV_audio) {
		return m_iSubs;
	}
	
	if(devType == DEV_video) {
		return m_iSubs;
	}
	
	if(devType == DEV_av) {
		return m_iSubs;
	}
	
	return 0;
}

/** 
 ***************************************************************************************
 *  оƬ豸
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL CTW6869::CreateDevices()
{
	CDevBase* dev = NULL;
	PDeviceCapability devCaps = NULL;
	int i = 0;

	for(i=0; i<m_devInfo.nSubDevice; i++) {
		devCaps = m_capsListV[i];
		if(m_bSG) {
			if(devCaps->ddesc.iSwitch > 1) {
				dev = new CDev6869sgSw();
			}
			else if(devCaps->ddesc.bField2) {
				dev = new CDev6869sg2f();
			}
			else {
				dev = new CDev6869sg();
			}
		}
		else {
			if(devCaps->ddesc.iSwitch > 1) {
				dev = new CDev6869blkSw();
			}
			else {
				dev = new CDev6869blk();
			}
		}
		if(dev == NULL) {
			return FALSE;
		}
		m_devList.push_back(dev);
		g_devListV.push_back(dev);
		if(!dev->Open(this, devCaps, NULL, i+m_iDeviceBegin)) {
			return FALSE;
		}
		devCaps->device = dev;
		devCaps->ddesc.nFirstChannel = (int)g_chlList.size();
		if(devCaps->ddesc.VideoInputMask & INPUT_ALL)
		{
			devCaps->ddesc.nChannels = devCaps->ddesc.iSwitch;
			if(!dev->CreateChannels()) {
				return FALSE;
			}
		}
		else
		{
			devCaps->ddesc.nChannels = 0;
		}
	}

#if(0) //liran for debug
	CSample* spl = NULL;
	for(i=0; i<RAWV_NUM; i++) {
		spl = new CSample();
		if(spl == NULL) { break; }
		if(spl->Allocate(RAWV_LEN_4CIF)) {
			g_bufPlgV.push_back(spl);
		}
		else {
			delete spl;
			break;
		}
	}
#endif

	if(Devices(DEV_audio) > 0) {
		for(i=0; i<m_devInfo.nSubDevice; i++) {
			devCaps = m_capsListA[i];
			dev = new CDev6869aud();
			if(dev == NULL) {
				return FALSE;
			}
			m_devList.push_back(dev);
			g_devListA.push_back(dev);
			if(!dev->Open(this, devCaps, NULL, i+m_iDeviceBegin+TW6864_DMA_NUM)) {
				return FALSE;
			}
			devCaps->device = dev;
			devCaps->ddesc.nFirstChannel = m_capsListV[i]->ddesc.nFirstChannel;
			if(m_capsListV[i]->ddesc.nChannels > 0)
			{
				devCaps->ddesc.nChannels = 1;
				if(!dev->Append2Channel(g_chlList[devCaps->ddesc.nFirstChannel])) {
					return FALSE;
				}
			}
			else
			{
				devCaps->ddesc.nChannels = 0;
			}
		}
	}

	return TRUE;
}

BOOL CTW6869::OnOpen()
{
	TCrashInfo	crash;
	int i=0, iDmapLen=TW6864_DMA_PAGETABLE_NUM*TW6864_DMA_PAGETABLE_UNIT;
	
	//zxx modified to support tw6865 -20120712
	CIniFile iniFile;
	TCHAR path[MAX_PATH];
	g_util.GetModulePath(g_hSelfDll, path);
	lstrcat(path, TEXT("TW68XX.ini"));
	iniFile.Create(path);
	int iChipID = iniFile.ReadInt(TEXT("Default"), TEXT("chip_id"), 6869);
	int iSubDevNum = TW6864_MAX_NUM_SG_DMA;
	if (iChipID == 6865)
		iSubDevNum = TW6864_MAX_NUM_SG_DMA / 2;
	
	if(m_iDeviceNum) {
		m_iSubs = min(iSubDevNum,m_iDeviceNum);
	}
	else {
		m_iSubs = iSubDevNum;
	}

	m_gpio = new CGpio6869(&m_Mem[0]);

	//m_gpio->InitGpio(m_i2c->i2cLock());

	//crash, Զɾ
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= TW6864_R_DMA_CHANNEL_ENABLE;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	crash.regBase = (ULONG)m_Mem[0].CpuBaseAddress();
	crash.regCrash= TW6864_R_DMA_CMD;
	crash.lowMask = 0xFFFFFFFF;
	crash.higMask = 0;
	AppendCrash(crash);
	
	return TRUE;
}

BOOL CTW6869::OnOpen(PDeviceCapability devCaps, int iDev, int iType)
{
	if(m_iDeviceNum) {
		iDev += m_iDeviceBegin;
	}
	if(iType == DEV_video) {
		devCaps->caps |= CAPS_4CIF|CAPS_FIELD2|CAPS_SWITCH;
		devCaps->ddesc.iSwitch = 1;
		devCaps->ddesc.nAudio  = TW6864_AUDIO;
		devCaps->ddesc.bField2 = FALSE;
		devCaps->ddesc.VideoInputMask = INPUT_MASK((int)viCompositeVideo1);
		devCaps->ddesc.reserved1 = viCompositeMax;
	}
	else {
		devCaps->ddesc.iSwitch = 1;
		devCaps->ddesc.nAudio  = TW6864_AUDIO;
	}
	
	return TRUE;
}

BOOL CTW6869::OnClose()
{
	SAFE_DELETE(m_i2cg);
	SAFE_DELETE(m_gpio);
	
	return TRUE;
}

void CTW6869::OnDma(ULONG uStatus)
{
	ULONG	  tkNow = 0;
	int		  nTemp = 0, i=0;
	CDev6869* dev = NULL;
	int		  nDaemon = 0;

	if(uStatus) {
		m_iBadFrames++;
	}

	if(m_uDaemonPeriod == 0) {
		return;
	}

	tkNow = timeGetTime();
	if(m_tkDaemon == 0) { 
		m_tkDaemon = tkNow;
		return; 
	}

	if(m_iBadFrames>m_uDaemonThreshold) {
		nDaemon = -1;
		m_tkDaemon = tkNow;
		m_iBadFrames = 0;
	}
	else if((tkNow-m_tkDaemon) >= m_uDaemonPeriod) {
		nDaemon = (m_iBadFrames<=0);
		m_iBadFrames = 0;
		m_tkDaemon = tkNow;
		if(!nDaemon) {
			m_iDaemon = 0;
		}
	}
	if(nDaemon != 0) {
		uStatus = FALSE;
		if(nDaemon<0) { //(m_iBadFrames > m_uDaemonThreshold) {
			m_iDaemon = min(0, m_iDaemon);
			m_iDaemon--;
			if(-m_iDaemon >= m_uDaemonTolerance) {
				m_iFpsErr = m_iFps;
				if(m_iFps > DAEMON_MINFRAMES) {
					m_iFps--;
					uStatus = TRUE;
				}
				m_iDaemon = 0;
			}
		}
		else {
			m_iDaemon = max(0, m_iDaemon);
			m_iDaemon++;
			if(m_iDaemon >= m_uDaemonTolerance) {
				uStatus   = TRUE+TRUE;
				m_iDaemon = 0;
			}
		}

		if(uStatus>TRUE) {
#if(0)
			//ֻӵϴγbad frameСֵ
			nTemp = min((m_iFps+1), MAX_FRAMERATE(TvSourceInfo::default_standard));
			if((nTemp != m_iFps) && (nTemp!=m_iFpsErr)) {
				m_iFps = nTemp;
			}
			else {
				uStatus = FALSE;
			}
#else
			//ӵMAX_FRAMERATE(TvSourceInfo::default_standard)
			nTemp = min((m_iFps+1), MAX_FRAMERATE(TvSourceInfo::default_standard));
			if(nTemp != m_iFps) {
				m_iFps = nTemp;
			}
			else {
				uStatus= FALSE;
			}
#endif
		}
		if(uStatus) {
			_trace(TEXT("[Ϣ]豸%d(bus %d) fps token - %d\n"), m_devInfo.DeviceNumber, m_devInfo.nBus, m_iFps);
			for(i=m_iDeviceBegin; i<m_iSubs; i++) {
				dev = (CDev6869*)m_devList[i-m_iDeviceBegin];
				if(dev->DeviceCaps()->ddesc.iSwitch > 1) { continue; }
				dev->SetFrameRate(NULL);
			}
		}
	}
}

void CTW6869::OnDmaTimeOut()
{
	size_t i;
	CScopedLock autoLock(&m_runLock);

	for(i=0; i<m_devList.size(); i++)
	{
		m_devList[i]->OnDmaTimeOut();
	}
}

//-------------------------------------------------------
//ʼTW6864
//-------------------------------------------------------
BOOL CTW6869::OnInit()
{
	ULONG tmp;
	int   i = 0;
	UINT page_table_p[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE0, TW6869_R_DMA_PAGE_TABLE2, TW6869_R_DMA_PAGE_TABLE4, TW6869_R_DMA_PAGE_TABLE6,
		TW6869_R_DMA_PAGE_TABLE8, TW6869_R_DMA_PAGE_TABLEA, TW6869_R_DMA_PAGE_TABLEC, TW6869_R_DMA_PAGE_TABLEE
	};
	UINT page_table_b[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE1, TW6869_R_DMA_PAGE_TABLE3, TW6869_R_DMA_PAGE_TABLE5, TW6869_R_DMA_PAGE_TABLE7,
			TW6869_R_DMA_PAGE_TABLE9, TW6869_R_DMA_PAGE_TABLEB, TW6869_R_DMA_PAGE_TABLED, TW6869_R_DMA_PAGE_TABLEF
	};

	if(ReadPciConfigSpace(0x04, 4, (BYTE*)&tmp)) {
		tmp |= 7;
		WritePciConfigSpace(0x04, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0x78, 4, (BYTE*)&tmp)) {
		tmp = (0x8<<5) | (tmp & 0xFFFFFE1F);		//8=128B, 9=256B, A=512B, B=1024B
		WritePciConfigSpace(0x78, 4, (BYTE*)&tmp);
	}

	//Software Reset
	m_Mem[0].outd(TW6864_R_SYS_SOFT_RST, 0x01);
	m_Mem[0].outd(TW6864_R_SYS_SOFT_RST, 0x0F);

	for(i=0;i<TW6864_MAX_NUM_SG_DMA;i++) {
		//S&G, Common Buffer DMA memory setup
		m_Mem[0].outd(page_table_p[i], 0x00000000);
		m_Mem[0].outd(page_table_b[i], 0x00000000);
	}

	for(i=0;i<TW6864_MAX_NUM_DATA_DMA;i++) {
		//S&G, Common Buffer DMA memory setup
		m_Mem[0].outd(TW6864_R_CH8to15_CONFIG_REG_P(i),0);
		m_Mem[0].outd(TW6864_R_CH8to15_CONFIG_REG_B(i),0);
	}

	if(ReadPciConfigSpace(0x04, 4, (BYTE*)&tmp)) {
		tmp &= 0xFFFFFBFF;							// Enable INTx
		WritePciConfigSpace(0x04, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0x50, 4, (BYTE*)&tmp)) {	//CFG_MSI_CAP = 0x50
		tmp &= 0xFFFEFFFF;							//Disable MSI
		WritePciConfigSpace(0x50, 4, (BYTE*)&tmp);
	}

	if(ReadPciConfigSpace(0xAC, 4, (BYTE*)&tmp)) {	//CFG_MSIX_CAP = 0xAC
		tmp &= 0x7FFFFFFF;							//Disable MSI-X
		WritePciConfigSpace(0xAC, 4, (BYTE*)&tmp);
	}

	m_Mem[0].outd(TW6864_R_AVSRST,0x3F);             //Reset Internal video decoders
	m_Mem[0].outd(TW6864_R_DMA_CMD, 0);			     //Reset all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_ENABLE, 0);	 //Disable all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_TIMEOUT,  0x14FF0FF0);//0x140c8b08);
	m_Mem[0].outd(TW6864_R_DMA_INT_REF,  0x4c4b6);	 //Set INT interval for 2.0ms	

	tmp = 0x00FF0004; //(TW6864_MAXSWITCH>1) ? 0x00000004 : 0x00FF0004;
	m_Mem[0].outd(TW6864_R_DMA_CONFIG,  tmp);	//enable vsync reset dma_operator fifo,INTx, MSI disabled,
												//little endian, bad/vsync protection on
	
#ifdef DECIMATE_H
	tmp  = 5400*2;													//4740 ~ 5649, less means shorter line
#else
	tmp  = 0x15DC;													//512*(2*125)/(27*720/858)
#endif
	m_Mem[0].outd(TW6864_R_PHASE_REF_CONFIG,  tmp); 

	tmp = 1;
	tmp |= TW6864_R_VIDEO_CTRL1_STANDARDALL;		//pal, 4 D1 TDM format, 108MHz
	m_Mem[0].outd(TW6864_R_VIDEO_CTRL1,  tmp);	

	tmp = m_Mem[0].ind(TW6869_R_PIN_CFG_CTRL);
	tmp&= ~0x03;
	tmp|= 0x02;
	m_Mem[0].outd(TW6869_R_PIN_CFG_CTRL,tmp); 

	m_Mem[0].outd(TW6864_R_CSR_REG,0x40a0); 

	tmp = TW6864_R_VIDEO_CTRL2_GENRSTALL | (TW6864_VIDEO_GEN_PATTERNS <<8) | TW6864_R_VIDEO_CTRL2_GENALL;
	m_Mem[0].outd(TW6864_R_VIDEO_CTRL2,  tmp);	
	
	tmp = (TW6864_AUDIO_DMA_LENGTH << 19) |
		  (TW6864_AUDIO_SAMP_RATE_INT(TW6864_AUDIO_SAMPLE_RATE)<<5) |
		  (TW6864_AUDIO_GEN_PATTERN << 4) |
		  (TW6864_AUDIO_GEN_MIX_SEL <<1 ) |
		   TW6864_AUDIO_GEN;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);		
	
	tmp = (ULONG)TW6864_AUDIO_SAMP_RATE_EXT(TW6864_AUDIO_SAMPLE_RATE);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL2,  tmp);	
	
	tmp = 0x40;
	if(TW6864_AUDIO_SAMPLE_BIT == 8) {
		tmp |= BIT(8);
	}
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL3, tmp);

	//Show Blue background if no signal
	m_Mem[0].outd(TW6864_R_MISC_CTRLII1, 0xE0);//0xE7);

	tmp = 0x40;					// Audio Gain, input 1, 2
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_0, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_1, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_2, tmp);
	m_Mem[0].outd(TW6864_R_AUDIO_GAIN_3, tmp);
	m_Mem[0].outd(TW6869_R_AUDIO_GAIN_4, tmp);
	m_Mem[0].outd(TW6869_R_AUDIO_GAIN_5, tmp);
	m_Mem[0].outd(TW6869_R_AUDIO_GAIN_6, tmp);
	m_Mem[0].outd(TW6869_R_AUDIO_GAIN_7, tmp);

	m_Mem[0].outd(TW6864_R_VERTICAL_CTRL,0x00); //0x26 will cause ch0 and ch1 have dma_error.
	m_Mem[0].outd(TW6864_R_LOOP_CTRL,    0xa5);
	m_Mem[0].outd(TW6869_R_VERTICAL_CTRL,0x00); //0x26 will cause ch0 and ch1 have dma_error.
	m_Mem[0].outd(TW6869_R_LOOP_CTRL,    0xa5);
	m_Mem[0].outd(TW6864_R_GPIO_REG,	 0xFFFF0000);
 	m_Mem[0].outd(TW6864_R_HFLT1,		 0x00);//0xBB);		//NOTE: ӰCIFȣCIF4CIFֱ
 	m_Mem[0].outd(TW6864_R_HFLT2,		 0x00);//0xBB);
	//m_Mem[0].outd(TW6864_R_MISC_CTRLII2, 0x05);//0x03);	//BIT[3..2] Clamping mode controlһΪAuto,Ӱźż

	return TRUE;
}

//-------------------------------------------------------
//ʼTW6864
//-------------------------------------------------------
BOOL CTW6869::OnUninit()
{
	int   i = 0;
	UINT page_table_p[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE0, TW6869_R_DMA_PAGE_TABLE2, TW6869_R_DMA_PAGE_TABLE4, TW6869_R_DMA_PAGE_TABLE6,
		TW6869_R_DMA_PAGE_TABLE8, TW6869_R_DMA_PAGE_TABLEA, TW6869_R_DMA_PAGE_TABLEC, TW6869_R_DMA_PAGE_TABLEE
	};
	UINT page_table_b[TW6864_MAX_NUM_SG_DMA] = {
		TW6869_R_DMA_PAGE_TABLE1, TW6869_R_DMA_PAGE_TABLE3, TW6869_R_DMA_PAGE_TABLE5, TW6869_R_DMA_PAGE_TABLE7,
		TW6869_R_DMA_PAGE_TABLE9, TW6869_R_DMA_PAGE_TABLEB, TW6869_R_DMA_PAGE_TABLED, TW6869_R_DMA_PAGE_TABLEF
	};

	m_Mem[0].outd(TW6864_R_DMA_CMD, 0);			     //Reset all DMA channels
	m_Mem[0].outd(TW6864_R_DMA_CHANNEL_ENABLE, 0);	 //Disable all DMA channels

	for(i=0; i<TW6864_MAX_NUM_SG_DMA; i++) {
		m_Mem[0].outd(page_table_p[i], 0x00000000);
		m_Mem[0].outd(page_table_b[i], 0x00000000);
	}

	return TRUE;
}

void CTW6869::SetMux(int ch, TVideoInput vInput) 
{
	ULONG uConfig = m_Mem[0].ind(TW6864_R_CH0to7_CONFIG_REG(ch));
	uConfig &= ~(3 << 30);
	uConfig |= (vInput&3) << 30;
	m_Mem[0].outd(TW6864_R_CH0to7_CONFIG_REG(ch), uConfig);
}

void CTW6869::SetStandard(int ch, int value, BOOL bAuto)
{
	ULONG tmp = m_Mem[0].ind(TW6864_R_VIDEO_CTRL1);

	tmp &= ~TW6864_R_VIDEO_CTRL1_STANDARD(ch);
	if(value == vsStandardPAL) {
		tmp |= TW6864_R_VIDEO_CTRL1_STANDARD(ch);		//pal, 4 D1 TDM format, 108MHz
	}

	m_Mem[0].outd(TW6864_R_VIDEO_CTRL1,  tmp);	
	m_iFps = min(m_iFps, MAX_FRAMERATE(value));

	if(ch < 4) {
		if(bAuto) {
			tmp = 0x07;
		}
		else {
			tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_STANDARD_0, ch));
			tmp&= 0xF8;
			tmp|= (value==vsStandardPAL) ? 1 : 0;
		}
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_STANDARD_0, ch), tmp);
	}
	else {
		ch -= 4;
		if(bAuto) {
			tmp = 0x07;
		}
		else {
			tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6869_R_STANDARD_4, ch));
			tmp&= 0xF8;
			tmp|= (value==vsStandardPAL) ? 1 : 0;
		}
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_STANDARD_4, ch), tmp);
	}
}

ULONG CTW6869::MapFormat(int nFormat)
{
	switch(nFormat) {
	case vpfYUV422Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_YUYV & 7);
		break;
	case vpfYUV420Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_YUV420 & 7);
		break;
	case vpfYUV411Planar : 
		nFormat = (TW6864_VIDEO_FORMAT_Y411 & 7);
		break;
	case vpfYUV411Interspersed : 
		nFormat = (TW6864_VIDEO_FORMAT_Y41P & 7);
		break;
	case vpfRGB16:
		nFormat = (TW6864_VIDEO_FORMAT_RGB565 & 7);
		break;
	case vpfRGB15Alpha:
		nFormat = (TW6864_VIDEO_FORMAT_RGB555 & 7);
		break;
	default:
		nFormat = (TW6864_VIDEO_FORMAT_YUYV & 7);
	}

	return nFormat;
}

void CTW6869::SetFormat(int ch, int value)
{
	ULONG uConfig = m_Mem[0].ind(TW6864_R_CH0to7_CONFIG_REG(ch));
	uConfig &= ~(7 << 20);
	uConfig |= MapFormat(value) << 20;
	m_Mem[0].outd(TW6864_R_CH0to7_CONFIG_REG(ch), uConfig);
}

void CTW6869::SetSize(int ch, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG tmp, tmp1, tmp2;
	int	  width = vinfo->capture.width;
	int	  height= (IS_4CIF(*vinfo)||vinfo->optimize_cif) ? vinfo->capture.height/2 : vinfo->capture.height;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->capture.width>704)) ? 720 : 704;
	BOOL  isPal = (vinfo->standard==vsStandardPAL);

	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->capture.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
	vinfo->vdelay = min(vinfo->vdelay, isPal?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);
		
	//SH_Scaler
	//setup for Black stripe remover
	SetBlackStripe(ch, vinfo->vleft, vinfo->vright, width);

#if(0)
	if(m_bDefault) {
		tmp = 0x00;
	}
	else if(tmp1 > 1) {
		if(width==352)		{ tmp = 0x01; }
		else if(width==176)	{ tmp = 0x02; }
		else				{ tmp = 0x00; }
	}
	else					{ tmp = 0x0B; }
	tmp1 = m_Mem[0].ind(TW6864_R_HFLT1 + (ch/2)*4);
	tmp1&= ~(0x0F << ((ch%2)*4));
	tmp1|= ((tmp&0x0F) << ((ch%2)*4));
	m_Mem[0].outd(TW6864_R_HFLT1 + (ch/2)*4, tmp1);
#endif

	tmp = (ULONG)TW6864_VIDEO_SIZE(width,height); 
	tmp1 = tmp2 = tmp;
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REGA, tmp);	
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG(ch), tmp); //for Rev.B or later only

	//H/V Scale
	tmp1 &= 0x7FF; 
	tmp2 = (tmp2>>16)&0x1FF;	 //V
	tmp1 = (maxWidth*256)/tmp1;  //H
	tmp2 = ((isPal?288:240)*256)/tmp2;
	tmp = tmp1 & 0xFF;

	SetHDelay(ch, abs(vinfo->hdelay));
	SetVDelay(ch, abs(vinfo->vdelay));

	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_0,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_0,ch),  tmp);		

		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_0,ch),  tmp);		

		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_F2_CNT_0,ch), 0x00);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HSCALE_LO_4,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VSCALE_LO_4,ch),  tmp);		

		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VHSCALE_HI_4,ch),  tmp);		

		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_F2_CNT_4,ch), 0x00);
	}
}

void CTW6869::SetSizeF2(int ch, void* ctx)
{
	PvSourceInfo vinfo = (PvSourceInfo)ctx;
	ULONG tmp, tmp1, tmp2;
	int	  width = vinfo->preview.width;
	int	  height= (IS_4CIF(*vinfo)||vinfo->optimize_cif) ? vinfo->preview.height/2 : vinfo->preview.height;
	int   maxWidth = ((vinfo->vleft>=0) || (vinfo->preview.width>704)) ? 720 : 704;		//remove black sptripe
	BOOL  isPal = (vinfo->standard==vsStandardPAL);
	
	if(vinfo->vleft < 0) vinfo->vleft = -TW686X_BS_LEFT;
	if(vinfo->vright< 0) vinfo->vright= -TW686X_BS_RIGHT;
	if(vinfo->hdelay< 0) vinfo->hdelay= -TW686X_HDELAY_DEFAULT(vinfo->preview.width);
	if(vinfo->vdelay< 0) vinfo->vdelay= isPal ? -TW686X_VDELAY_PAL : -TW686X_VDELAY_NTSC;
	vinfo->vdelay = min(vinfo->vdelay, isPal?TW686X_VDELAY_MAX_PAL:TW686X_VDELAY_MAX_NTSC);

	SetHDelay(ch, abs(vinfo->hdelay));
	SetVDelay(ch, abs(vinfo->vdelay));
	
	tmp = (ULONG)TW6864_VIDEO_SIZE_F2(width,height); 
	tmp1 = tmp2 = tmp;
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG_F2(ch), tmp); //for Rev.B or later only
	
	//H/V Scale
	tmp1 &= 0x7FF; 
	tmp2 = (tmp2>>16)&0x1FF;	 //V
	tmp1 = (maxWidth*256)/tmp1;  //H
	tmp2 = (((vinfo->standard==vsStandardPAL)?288:240)*256)/tmp2;
	tmp = tmp1 & 0xFF;
	
	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HSCALE_LO_F2_0,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VSCALE_LO_F2_0,ch),  tmp);		
		
		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VHSCALE_HI_F2_0,ch),  tmp);		

		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_CROPPING_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_CROPPING_F2_0,ch), tmp);

		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_HACTIVE_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HACTIVE_F2_0,ch), tmp);

		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_VACTIVE_0,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VACTIVE_F2_0,ch), tmp);

		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_F2_CNT_0,ch), 0x1);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HSCALE_LO_F2_4,ch),  tmp);	
		
		tmp = tmp2 & 0xFF;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VSCALE_LO_F2_4,ch),  tmp);		
		
		tmp = (((tmp2 >> 8)& 0xF) << 4) | ( (tmp1>>8) & 0xF );
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VHSCALE_HI_F2_4,ch),  tmp);		
		
		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6869_R_CROPPING_4,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_CROPPING_F2_4,ch), tmp);
		
		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6869_R_HACTIVE_4,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HACTIVE_F2_4,ch), tmp);
		
		tmp = m_Mem[0].ind(TW6864_R_CHANNEL(TW6869_R_VACTIVE_4,ch));
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VACTIVE_F2_4,ch), tmp);
		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_F2_CNT_4,ch), 0x1);
		ch += 4;
	}

	tmp  = m_Mem[0].ind(TW6864_R_VIDEO_SIZE_REG(ch));
	tmp |= (1 << 30);
	m_Mem[0].outd(TW6864_R_VIDEO_SIZE_REG(ch), tmp);
}

void CTW6869::SetVDelay(int ch, int value)
{
	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VDELAY_0,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_VDELAY_F2_0,ch), (ULONG)value);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VDELAY_4,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_VDELAY_F2_4,ch), (ULONG)value);
	}
}

void CTW6869::SetHDelay(int ch, int value)
{
	if(ch < 4) {
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HDELAY_0,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6864_R_HDELAY_F2_0,ch), (ULONG)value);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HDELAY_4,ch), (ULONG)value);		
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HDELAY_F2_4,ch), (ULONG)value);
	}
}

void CTW6869::SetBlackStripe(int ch, int start, int end, int width)
{
	ULONG tmp, tmp1, tmp2;
	BOOL  bRBS = (start >= 0);

	start = (start<0) ? -start : start;
	end   = (end<0) ? -end : end;

	//setup for Black stripe remover
	tmp1 = width-end;  //EndPos
	tmp2 = start;	   //StartPos	
	tmp = (tmp1 - tmp2)*(1<<16)/width;
	tmp = (tmp2 & 0x1F) | ((tmp1 & 0x3FF) << 5) | (tmp <<15);
	tmp |= bRBS ? TW6864_REMOVE_BLACKSTRIPE : 0;
	m_Mem[0].outd(TW6864_R_SHSCALER_REG(ch), tmp);		
}

void CTW6869::SetBright(int ch, int value)
{
	int val = 0;
		
	g_util.map(B_MIN, B_MAX, value, B_MIN_6864, B_MAX_6864, &val);
	
	if(m_bDefault) { val = 0x00; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_BRIGHT(ch), val);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_BRIGHT_4, ch),  val);
	}
}

void CTW6869::SetContrast(int ch, int value)
{
	int val = 0;
	
	g_util.map(C_MIN, C_MAX, value, C_MIN_6864, C_MAX_6864, &val);
	
	if(m_bDefault) { val = 0x64; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_CONTRAST(ch),  val);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_CONTRAST_4, ch),  val);
	}
}

void CTW6869::SetHue(int ch, int value)
{
	int val = 0;
	
	g_util.map(H_MIN, H_MAX, value, H_MIN_6864, H_MAX_6864, &val);
	
	if(m_bDefault) { val = 0; }
	
	if(ch<4) {
		m_Mem[0].outd(TW6864_R_HUE(ch),  val);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_HUE_4, ch),  val);
	}
}

void CTW6869::SetSaturation(int ch, int value)
{
	int val = 0;
	
	g_util.map(S_MIN, S_MAX, value, S_MIN_6864, S_MAX_6864, &val);

	if(m_bDefault) { val = 0x80; }

	if(ch<4) {
		m_Mem[0].outd(TW6864_R_SAT_U(ch),  val);
		m_Mem[0].outd(TW6864_R_SAT_V(ch),  val);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_SAT_U_4, ch),  val);
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_SAT_V_4, ch),  val);
	}
}

void CTW6869::SetSharpness(int ch, int value)
{
	int val = 0;
	
	g_util.map(SH_MIN, SH_MAX, value, SH_MIN_6864, SH_MAX_6864, &val);
	val &= 0x0F;
	val |= 0x10;//0xA0;

	
	if(m_bDefault) { val = 0x11; }

	if(ch<4) {
		m_Mem[0].outd(TW6864_R_SHARPNESS(ch),  val);
	}
	else {
		ch -= 4;
		m_Mem[0].outd(TW6864_R_CHANNEL(TW6869_R_SHARPNESS_4, ch),  val);
	}
}

void CTW6869::SetAudioDmaLength(int value)
{
    ULONG tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL1);
    tmp &= ~(0xFFF80000);
	tmp |= (value<<19) & 0xFFF80000;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);
}

void CTW6869::SetAudioParam(int samplerate, int bits, int channels)
{
    ULONG tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL1);
    samplerate /= 1000;
    tmp &= ~(0x0007FFE0);
	tmp |= ((TW6864_AUDIO_SAMP_RATE_INT(samplerate)<<5) & 0x0007FFE0);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL1,  tmp);
	
	tmp = (ULONG)TW6864_AUDIO_SAMP_RATE_EXT(samplerate);
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL2,  tmp);	
	
	tmp = m_Mem[0].ind(TW6864_R_AUDIO_CTRL3);
	tmp &= ~BIT(8);
	tmp |= (bits==8) ? BIT(8) : 0;
	m_Mem[0].outd(TW6864_R_AUDIO_CTRL3, tmp);
}

void CTW6869::SetVolume(int nCh, int volume)
{
	volume &= 0xFF;
	if(nCh < 4) {
		m_Mem[0].outd(TW6864_R_AUDIO_GAIN_0+(nCh*4), (BYTE)volume);
	}
	else {
		nCh -= 4;
		m_Mem[0].outd(TW6869_R_AUDIO_GAIN_4+(nCh*4), (BYTE)volume);
	}
}

ULONG CTW6869::GetDecoderStatus(int ch)
{
	if(ch < 4) {
		return m_Mem[0].ind(TW6864_R_CHANNEL(TW6864_R_VSTATUS_0, ch));
	}
	else {
		ch -= 4;
		return m_Mem[0].ind(TW6864_R_CHANNEL(TW6869_R_VSTATUS_4, ch));
	}
}

void CTW6869::FILL_DESCRIPTOR(PDMADescriptor pDesc ,ULONG addr, UINT byte_len,UINT  field_start,UINT  next_filed_start,BOOLEAN bNewFrame, BOOLEAN bCheckPoint,UINT  status)
{
	pDesc->addr = addr; 
	pDesc->ctrl = ((status & 0x3) << 30)	| 
		((bNewFrame&1)<<29)					|
		((next_filed_start & 0xFF) << 21)	| 
		((field_start & 0x7F) << 14)		| 
		((bCheckPoint&1)<<13)				|
		(byte_len & 0x1FFF);
}

void CTW6869::DISABLE_DESCRIPTOR(PDMADescriptor pDesc)
{
	pDesc->ctrl &= 0x3FFFFFFF; //DMA_STATUS_HOST_NOT_AVAIABLE
	pDesc->ctrl |= 0x20000000; //New Flag
}

ULONG CTW6869::MapFieldRate(int nFieldRate, BOOL bNTSC)
{
	ULONG uRate = 0;

	if(!bNTSC) {
		switch(nFieldRate) {
		case 0:
			uRate = 0;
			break;
		case 1:
		case 2:	
			uRate = 0x00000001;
			break;
		case 3:
			uRate = 0x00004001;//0x10001000;
			break;
		case 4:
		case 5:
			uRate = 0x00104001;//0x10010010;
			break;
		case 6:
		case 7:
			uRate = 0x00404041;//0x10101010;
			break;
		case 8:
		case 9:
			uRate = 0x01041041;//0x11011010;
			break;
		case 10:
			uRate = 0x01104411;//0x11101110;
			break;
		case 11:
		case 12:
			uRate = 0x01111111;//0x11111110;
			break;
		case 13:
		case 14:
			uRate = 0x04444445;//0x11111111;
			break;
		case 15:
			uRate = 0x04511445;//0x15111111;
			break;
		case 16:
		case 17:
			uRate = 0x05145145;//0x15111511;
			break;
		case 18:
		case 19:
			uRate = 0x05151515;//0x15151511;
			break;
		case 20:
			uRate = 0x05515455;//0x15151515;
			break;
		case 21:
		case 22:
			uRate = 0x05551555;//0x15515515;
			break;
		case 23:
		case 24:
			uRate = 0x05555555;//0x15551555;
			break;
		default:
			uRate = 0x15555555;
			break;
		}
	}
	else {
		switch(nFieldRate) {
		case 0:
			uRate = 0;
			break;
		case 1:
		case 2:	
		case 3:
			uRate = 0x00000001;
			break;
		case 4:
		case 5:
			uRate = 0x00004001;//0x10001000;
			break;
		case 6:
		case 7:
			uRate = 0x00104001;//0x10010010;
			break;
		case 8:
		case 9:
			uRate = 0x00404041;//0x10101010;
			break;
		case 10:
		case 11:
			uRate = 0x01041041;//0x11011010;
			break;
		case 12:
		case 13:
			uRate = 0x01104411;//0x11101110;
			break;
		case 14:
		case 15:
			uRate = 0x01111111;//0x11111110;
			break;
		case 16:
		case 17:
			uRate = 0x04444445;//0x11111111;
			break;
		case 18:
		case 19:
			uRate = 0x04511445;//0x15111111;
			break;
		case 20:
		case 21:
			uRate = 0x05145145;//0x15111511;
			break;
		case 22:
		case 23:
			uRate = 0x05151515;//0x15151511;
			break;
		case 24:
		case 25:
			uRate = 0x05515455;//0x15151515;
			break;
		case 26:
		case 27:
			uRate = 0x05551555;//0x15551555;
			break;
		case 28:
		case 29:
			uRate = 0x05555555;//0x15551555;
			break;
		default:
			uRate = 0x15555555;
			break;
		}
	}

	return uRate;
}

ULONG CTW6869::MapFrameRate(int nFieldRate1, int nFieldRate2, BOOL bNTSC, BOOL b6864)
{
	ULONG uRate = 0;
	
	if(nFieldRate1 == 0) {
		uRate = MapFieldRate(nFieldRate2, bNTSC);
	}
	else if(nFieldRate2 == 0) {
		uRate = (MapFieldRate(nFieldRate1, bNTSC) << 1);
	}
	else {
		if(b6864) {
			uRate = bNTSC ? 30 : 25;
			if(nFieldRate1 > (int)uRate) nFieldRate1 = (int)uRate;
			if(nFieldRate2 > (int)uRate) nFieldRate2 = (int)uRate;
			if(uRate==nFieldRate1) {
				uRate = MapFieldRate(nFieldRate1, bNTSC) | (MapFieldRate(nFieldRate2, bNTSC) << 1);
			}
			else {
				uRate = (MapFieldRate(nFieldRate1, bNTSC)<<1) | (MapFieldRate(nFieldRate2, bNTSC) << 2);
			}
		}
		else {
			uRate = MapFieldRate(nFieldRate1, bNTSC) | (MapFieldRate(nFieldRate2, bNTSC) << 1);
		}
	}
	if(uRate > 0) {
		uRate |= 0x80000000;
	}
	
	return uRate;
}

HANDLE CTW6869::GetI2CuGpio(int sclGpio, int sdaGpio)
{
	if(m_i2cg == NULL) {
		if(m_gpio == NULL)
		{
			m_gpio = new CGpio6869(&m_Mem[0]);
		}
		if(m_gpio != NULL)
		{
			m_i2cg = new CI2CuGpio686x();
			m_i2cg->Init(m_gpio, sclGpio, sdaGpio);
			m_i2cg->I2CInitSWMode(400000);
		}
	}
	
	return m_i2cg;
}

HANDLE CTW6869::CreateI2CuGpio(int sclGpio, int sdaGpio, int nSpeed)
{
	CI2CuGpio686x* i2cg = NULL;

	if((sclGpio<0) || (sdaGpio<0))
	{
		return NULL;
	}

	if((sclGpio>42) || (sdaGpio>42))
	{
		return NULL;
	}

	if(m_gpio == NULL)
	{
		m_gpio = new CGpio6869(&m_Mem[0]);
	}
	if(m_gpio != NULL)
	{
		i2cg = new CI2CuGpio686x();
		i2cg->Init(m_gpio, sclGpio, sdaGpio);
		i2cg->I2CInitSWMode(nSpeed);
	}
	
	return i2cg;
}