/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6869.h
 *  @brief		оƬCTW6869֧TW6869
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#if !defined(__TW6869_H_)
#define __TW6869_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Chipset.h"
#include "Gpio6869.h"
#include "I2CuGpio.h"
#include "Thread.h"
#include "TW686X.h"

class CTW6869 : public CChipset  
{
public:
	CTW6869();
	virtual ~CTW6869();

	virtual BOOL   CreateDevices();
	virtual LONG   Devices(int devType);
	virtual HANDLE GetI2C()   {return NULL;}
	virtual HANDLE GetGPIO()  {return m_gpio;}
	virtual HANDLE GetI2CuGpio(int sclGpio, int sdaGpio);
	virtual HANDLE CreateI2CuGpio(int sclGpio, int sdaGpio, int nSpeed);
	
	virtual void SetStandard(int nCh, int value, BOOL bAuto=TRUE);
	virtual void SetMux(int nCh, TVideoInput vInput);
	void  SetFormat(int nCh, int value);
	void  SetSize(int nCh, void* vinfo);
	void  SetSizeF2(int nCh, void* vinfo);
	void  SetBright(int nCh, int value);
	void  SetContrast(int nCh, int value);
	void  SetHue(int nCh, int value);
	void  SetSaturation(int nCh, int value);
	void  SetSharpness(int nCh, int value);
	void  SetVDelay(int nCh, int value);
	void  SetHDelay(int nCh, int value);
	void  SetBlackStripe(int nCh, int start, int end, int width);
	void  SetAudioDmaLength(int value);
	void  SetAudioParam(int samplerate, int bits, int channels);
	void  SetVolume(int nCh, int volume);
	ULONG GetDecoderStatus(int nCh);
	ULONG GetPageTablePhy() { return (ULONG)m_memDmap.pnodes[0].addr; }
	void FILL_DESCRIPTOR(PDMADescriptor pDesc ,ULONG addr, UINT byte_len,UINT  field_start,UINT  next_filed_start,
		BOOLEAN bNewFrame, BOOLEAN bCheckPoint, UINT  status) ;
	void DISABLE_DESCRIPTOR(PDMADescriptor pDesc);
	void OnDma(ULONG uStatus);
	void OnDmaTimeOut();
	int	 FpsToken(int iFps) { return min(m_iFps, iFps); }
	void ResetDaemon() { m_iFpsErr=0; m_iBadFrames=0; m_iDaemon=0; }
	
	//Ҫ̲ͬ߳TW6864Ĵ0x08--TW6864_R_DMA_CMD
	CLock* RunLock() { return &m_runLock; }
	
	static ULONG MapFormat(int nFormat);
	static ULONG MapFrameRate(int nFieldRate1, int nFieldRate2, BOOL bNTSC, BOOL b6864);
	static ULONG MapFieldRate(int nFieldRate, BOOL bNTSC);
	
	static BOOL	 m_bSG;		//scatter gather dma mode
	static ULONG m_uDaemonPeriod;
	static int	 m_uDaemonThreshold;
	static int	 m_uDaemonTolerance;
	static ULONG m_uDaemonFrames;
	static BOOL	 m_bDefault;
	static int	 m_iDeviceNum;
	static int	 m_iDeviceBegin;
	static int	 m_iSwitchDelay;
	
protected:
	virtual BOOL   OnInit();
	virtual BOOL   OnUninit();
	virtual BOOL   OnOpen();
	virtual BOOL   OnOpen(PDeviceCapability devCaps, int iDev, int iType);
	virtual BOOL   OnClose();
	
	CGpio6869*	   m_gpio;
	CI2CuGpio686x* m_i2cg;
	int			   m_iSubs;
//	PDMADescriptor m_PageB;
//	PDMADescriptor m_PageP;
	TMemBlock	   m_memDmap;
	CLockCS		   m_runLock;
	int			   m_iFps;
	int			   m_iFpsErr;
	int			   m_iBadFrames;
	int			   m_iDaemon;
	ULONG		   m_tkDaemon;
};

#endif // !defined(__TW6869_H_)
