/*!
*************************************************************************************
* \file TW68XX.CPP
*
* \brief
*    Techwell TW68XX capture sdk implimention
*
* \author
*    Jack
*************************************************************************************
*/

#include "stdafx.h"
#include "inifile.h"
#include "PlgvSource.h"
#include "PlgaSource.h"
#include "I2C.h"
#include "Gpio.h"
#include "TW6864.h"
#include "TW6869.h"

#define CHECK_HANDLE_RET(h, ret) {if((h==NULL) || (h==INVALID_HANDLE_VALUE)) {g_uLastError=TWERR_INVALID_PARAM; return ret;}}
#define CHECK_HANDLE(h) {if((h==NULL) || (h==INVALID_HANDLE_VALUE))   return;}
#define H_2_CARD(h) ((CChannel*)h)
#define TRY_BEGIN	try{
#define TRY_END(s)	}catch(...){_trace(s);}

/** 
 ***************************************************************************************
 *  ʼSDK
 *
 *  @return ɹTRUE򷵻FALSETwGetLastErrorȡ
 ***************************************************************************************
 */
TW68XX_API BOOL   __stdcall TwInitSDK()
{
	TRY_BEGIN

	CIniFile iniFile;
	TCHAR path[MAX_PATH];
	g_util.GetModulePath(g_hSelfDll, path);
	lstrcat(path, TEXT("TW68XX.ini"));
	iniFile.Create(path);
#if(defined(_DBG))
	g_dbgIsPrintFrameRate = iniFile.ReadInt(TEXT("SDK"), TEXT("print_framerate"), 0);
#endif
	CTW6864::m_bSG = iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_sg"), 0);
	CTW6864::m_bDefault = iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_default"), 0);
	CTW6864::m_uDaemonPeriod	= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_daemon_period"), DAEMON_PERIOD);
	CTW6864::m_uDaemonThreshold = iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_daemon_threshold"), DAEMON_THRESHOLD);
	CTW6864::m_uDaemonTolerance = iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_daemon_tolerance"), DAEMON_TOLERANCE);
	CTW6864::m_uDaemonFrames	= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_daemon_frames"), DAEMON_FRAMES);
	CTW6864::m_iDeviceNum		= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_device_num"), 0);
	CTW6864::m_iDeviceBegin		= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_device_begin"), 0);
	CTW6864::m_iSwitchDelay		= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_switch_delay"), TW6864_SWITCH_DELAY);
	CTW6864::m_iVcom			= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_vcom"), 0);
	CTW6864::m_iVcomNum			= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_vcom_num"), 0);
	CTW6864::m_iVcomBegin		= iniFile.ReadInt(TEXT("SDK"), TEXT("tw6864_vcom_begin"), 0);
	CDevBase::BufferType()		= iniFile.ReadInt(TEXT("SDK"), TEXT("buffer_type"), CDevBase::BufferType());
	CTW6869::m_bSG				= CTW6864::m_bSG;
	CTW6869::m_bDefault			= CTW6864::m_bDefault;
	CTW6869::m_uDaemonPeriod	= CTW6864::m_uDaemonPeriod;
	CTW6869::m_uDaemonThreshold = CTW6864::m_uDaemonThreshold;
	CTW6869::m_uDaemonTolerance = CTW6864::m_uDaemonTolerance;
	CTW6869::m_uDaemonFrames	= CTW6864::m_uDaemonFrames;
	CTW6869::m_iDeviceNum		= CTW6864::m_iDeviceNum;
	CTW6869::m_iDeviceBegin		= CTW6864::m_iDeviceBegin;
	CTW6869::m_iSwitchDelay		= CTW6864::m_iSwitchDelay;

	switch(CDevBase::BufferType()) {
	case vbtCIF:
		CDevBase::BufferLen() = RAWV_LEN/2;
		break;
	case vbtHalfD1:
	case vbtD1_preview:	
		CDevBase::BufferLen() = RAWV_LEN;
		break;
	default:
		CDevBase::BufferLen() = RAWV_LEN_4CIF;
		break;
	}

	if(!GClassifyCards()) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;
	return TRUE;

	TRY_END(TEXT("[쳣]TwInitSDK쳣\n"))

	return FALSE;
}

/** 
 ***************************************************************************************
 *  ʼSDKͷԴ
 ***************************************************************************************
 */
TW68XX_API VOID   __stdcall TwUninitSDK()
{
	CThread*  pThread;
	CChannel* channel;
	CDevBase* dev;
	CChipset* chp;
	CSample*  pSample;
	TBoardDesc* bd;
	UINT	  i;

	TRY_BEGIN
	//ֹͣƵ豸
	for(i=0; i<g_devListA.size(); i++) {
		g_devListA[i]->Stop();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK Stop audio device쳣\n"))

	TRY_BEGIN
	//ֹͣƵ豸
	for(i=0; i<g_devListV.size(); i++) {
		g_devListV[i]->Stop();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK Stop video device쳣\n"))

	TRY_BEGIN
	//ֹͣͨ
	for(i=0; i<g_chlList.size(); i++){
		channel = g_chlList[i];
		channel->EnablePlugin(0xFFFFFFFF, FALSE);
	}
	TRY_END(TEXT("[쳣]TwUninitSDK Stop all channels쳣\n"))

	TRY_BEGIN
	//ֹͣй߳
	while(g_assist.size() > 0) {
		pThread = g_assist.back();
		g_assist.pop_back();
		pThread->Exit();
		pThread->Clear();
		delete pThread;
	}
	while(g_source.size() > 0) {
		pThread = g_source.back();
		g_source.pop_back();
		pThread->Exit();
		pThread->Clear();
		delete pThread;
	}
	while(g_asource.size() > 0) {
		pThread = g_asource.back();
		g_asource.pop_back();
		pThread->Exit();
		pThread->Clear();
		delete pThread;
	}
	while(g_callback.size() > 0) {
		pThread = g_callback.back();
		g_callback.pop_back();
		pThread->Exit();
		pThread->Clear();
		delete pThread;
	}
	TRY_END(TEXT("[쳣]TwUninitSDK Stop all thread쳣\n"))

	TRY_BEGIN
	//ɾͨ
	while(g_chlList.size() > 0) {
		channel = g_chlList.back();
		channel->Uninit();
		delete channel;
		g_chlList.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK delete all channels쳣\n"))

	//ͷڴ֮ǰӲûȫֹͣDMA
	Sleep(40);

	TRY_BEGIN
	//ɾƵ豸
	while(g_devListV.size() > 0) {
		dev = g_devListV.back();
		dev->Close();
		delete dev;
		g_devListV.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK close video devices쳣\n"))
		
	TRY_BEGIN
	//ɾƵ豸
	while(g_devListA.size() > 0) {
		dev = g_devListA.back();
		dev->Close();
		delete dev;
		g_devListA.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK close audio devices쳣\n"))
			
	TRY_BEGIN
	//ɾƵ豸
	while(g_chpListV.size() > 0) {
		chp = g_chpListV.back();
		chp->Close();
		delete chp;
		g_chpListV.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK close video chips쳣\n"))
	
	TRY_BEGIN
	//ɾƵ豸
	while(g_chpListA.size() > 0) {
		chp = g_chpListA.back();
		chp->Close();
		delete chp;
		g_chpListA.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK close audio chips쳣\n"))
				
	TRY_BEGIN
	//ɾƵ豸
	while(g_cardList.size() > 0) {
		bd = g_cardList.back();
		if(bd->reserved1 != 0) {
			delete (PBridgeDesc)bd->reserved1;
		}
		delete bd;
		g_cardList.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK close cards쳣\n"))
			
	TRY_BEGIN
	//ɾƵڴ
	while(g_bufPlgA.size() > 0) {
		pSample = g_bufPlgA.back();
		delete pSample;
		g_bufPlgA.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK free audio plg buffer쳣\n"))

	TRY_BEGIN
	//ɾƵڴ
	while(g_bufPlgV.size() > 0) {
		pSample = g_bufPlgV.back();
		delete pSample;
		g_bufPlgV.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK free video plg buffer쳣\n"))
			
	TRY_BEGIN
	//ɾƵ豸
	while(g_capsListV.size() > 0) {
		delete g_capsListV.back();
		g_capsListV.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK free vcaps쳣\n"))
			
	TRY_BEGIN
	//ɾƵ豸
	while(g_capsListA.size() > 0) {
		delete g_capsListA.back();
		g_capsListA.pop_back();
	}
	TRY_END(TEXT("[쳣]TwUninitSDK free acaps쳣\n"))

	g_uLastError = TWERR_SUCCESS;
}

/** 
 ***************************************************************************************
 *  ȡ
 *
 *  @return ش
 ***************************************************************************************
 */
TW68XX_API ULONG  __stdcall TwGetLastError()
{
	return g_uLastError;
}

/** 
 ***************************************************************************************
 *  ȡϵͳеİ忨
 *
 *  @return ذ忨TwGetLastErrorȡ
 ***************************************************************************************
 */
TW68XX_API int    __stdcall TwGetBoardCount()
{
	g_uLastError = TWERR_SUCCESS;
	return (int)g_cardList.size();
}

TW68XX_API HANDLE   __stdcall TwGetBoardHandle(int nBoard)
{
	TRY_BEGIN
		
	if((nBoard<0) || (nBoard>=(int)g_cardList.size())) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return (HANDLE)g_cardList[nBoard];
	
	TRY_END(TEXT("[쳣]TwGetBoardHandle쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return NULL;
}

TW68XX_API BOOL   __stdcall TwGetBoardDetail(HANDLE hBoard, TBoardDesc *pBoardDesc)
{
	TRY_BEGIN

	if((hBoard==NULL) || (pBoardDesc==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	*pBoardDesc = *(TBoardDesc*)hBoard;
	g_uLastError = TWERR_SUCCESS;
	return TRUE;

	TRY_END(TEXT("[쳣]TwGetBoardDetail쳣\n"))
	g_uLastError = TWERR_EXCEPTION;

	return FALSE;
}

TW68XX_API int    __stdcall TwGetDeviceCount()
{
	g_uLastError = TWERR_SUCCESS;
	return (int)g_chpListV.size();
}

TW68XX_API BOOL   __stdcall TwGetDeviceDetail(HANDLE hDevice, TDeviceDesc *pDevDesc)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (g_chpListV.size()<=0) || (pDevDesc==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	*pDevDesc = ((CChipset*)hDevice)->DeviceInfo();
	g_uLastError = TWERR_SUCCESS;
	
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetDeviceDetail2쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API HANDLE __stdcall TwGetDeviceHandle(int nDevice)
{
	TRY_BEGIN
		
	if((nDevice<0) || ((UINT)nDevice>=g_chpListV.size()) || (g_chpListV.size()<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	
	return g_chpListV[nDevice];
	
	TRY_END(TEXT("[쳣]TwGetDeviceHandle쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API HANDLE __stdcall TwGetDeviceAudioHandle(int nDevice)
{
	TRY_BEGIN
		
	if((nDevice<0) || ((UINT)nDevice>=g_chpListA.size()) || (g_chpListA.size()<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;
	
	return g_chpListA[nDevice];
	
	TRY_END(TEXT("[쳣]TwGetDeviceAudioHandle쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetDeviceRegBYTE(HANDLE hDevice, ULONG uReg, BYTE* value)
{
	TRY_BEGIN

	if((hDevice==NULL) || (value==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}

	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uReg1 = uReg & ~0x03;		//DWORD
		ULONG uVal  = memRange->ind(uReg1);
		ULONG uTmp  = uReg & 0x03;
		uVal &= (0xFF << (uTmp*8));
		*value = (BYTE)(uVal >> (uTmp*8));
	}
	else {
		*value = memRange->inb(uReg);
	}

	g_uLastError = TWERR_SUCCESS;
	return TRUE;
		
	TRY_END(TEXT("[쳣]TwGetDeviceRegBYTE쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetDeviceRegWORD(HANDLE hDevice, ULONG uReg, USHORT* value)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (value==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uReg1 = uReg & ~0x03;		//DWORD
		ULONG uVal  = memRange->ind(uReg1);
		ULONG uTmp  = uReg & 0x03;
		if(uTmp < 3) {
			uVal &= (0xFFFF << (uTmp*8));
			*value = (USHORT)(uVal >> (uTmp*8));
		}
		else {
			uVal &= (0xFF << (uTmp*8));
			*value = (USHORT)(uVal >> (uTmp*8));

			uReg1+= 4;
			if((uReg1+4) <= memRange->GetLength()) {
				uVal = memRange->ind(uReg1);
				uVal &= 0xFF;
				*value |= (uVal << 8);
			}
		}
	}
	else {
		*value = memRange->inw(uReg);
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetDeviceRegWORD쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetDeviceRegDWORD(HANDLE hDevice, ULONG uReg, ULONG* value)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (value==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uReg1 = uReg & ~0x03;		//DWORD
		ULONG uVal  = memRange->ind(uReg1);
		ULONG uTmp  = uReg & 0x03;
		if(uTmp == 0) {
			*value = uVal;
		}
		else {
			uVal &= ~((1 << (uTmp*8)) - 1);
			*value = uVal >> (uTmp*8);
			
			uReg1+= 4;
			if((uReg1+4) <= memRange->GetLength()) {
				uVal = memRange->ind(uReg1);
				*value |= (uVal << ((4-uTmp)*8));
			}
		}
	}
	else {
		*value = memRange->ind(uReg);
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetDeviceRegDWORD쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetDeviceRegBYTE(HANDLE hDevice, ULONG uReg, BYTE value)
{
	TRY_BEGIN
		
	if(hDevice==NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uReg1 = uReg & ~0x03;		//DWORD
		ULONG uVal  = memRange->ind(uReg1);
		ULONG uTmp  = uReg & 0x03;
		uVal &= ~(0xFF << (uTmp*8));
		value&= 0xFF;
		uVal |= (value << (uTmp*8));
		memRange->outd(uReg1, uVal);
	}
	else {
		memRange->outb(uReg, value);
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetDeviceRegBYTE쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetDeviceRegWORD(HANDLE hDevice, ULONG uReg, USHORT value)
{
	TRY_BEGIN
		
	if(hDevice==NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uReg1 = uReg & ~0x03;		//DWORD
		ULONG uVal  = memRange->ind(uReg1);
		ULONG uTmp  = uReg & 0x03;
		if(uTmp < 3) {
			uVal &= ~(0xFFFF << (uTmp*8));
			value&= 0xFFFF;
			uVal |= (value << (uTmp*8));
			memRange->outd(uReg1, uVal);
		}
		else {
			uVal &= ~(0xFF << (uTmp*8));
			uVal |= ((value&0xFF) << (uTmp*8));
			memRange->outd(uReg1, uVal);

			uReg1 += 4;
			if((uReg1+4) <= memRange->GetLength()) {
				uVal = memRange->ind(uReg1);
				uVal&= ~0xFF;
				uVal|= ((value>>8) & 0xFF);
				memRange->outd(uReg1, uVal);
			}
		}
	}
	else {
		memRange->outw(uReg, value);
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetDeviceRegWORD쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetDeviceRegDWORD(HANDLE hDevice, ULONG uReg, ULONG value)
{
	TRY_BEGIN
		
	if(hDevice==NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CMemRange* memRange = ((CChipset*)hDevice)->PciMemory(0);
	if(memRange==NULL) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	ULONG hwid = DEVICEID(((CChipset*)hDevice)->DeviceInfo().HardwareId);
	if((hwid==0x6864) || (hwid==0x6869)) {
		CLock* pLock = (hwid==0x6869) ? ((CTW6869*)hDevice)->RunLock() : ((CTW6864*)hDevice)->RunLock();
		CScopedLock autoLock(pLock);
		ULONG uTmp  = uReg & 0x03;
		if(uTmp == 0) {
			memRange->outd(uReg, value);
		}
		else {
			ULONG uReg1 = uReg & ~0x03;		//DWORD
			ULONG uVal  = memRange->ind(uReg1);
			uVal &= ((1 << (uTmp*8)) - 1);
			uVal |= (value << (uTmp*8));
			memRange->outd(uReg1, uVal);
			
			uReg1 += 4;
			if((uReg1+4) <= memRange->GetLength()) {
				uVal = memRange->ind(uReg1);
				uVal&= ~((1 << (uTmp*8)) - 1);
				uVal|= (value >> ((4-uTmp)*8));
				memRange->outd(uReg1, uVal);
			}
		}
	}
	else {
		memRange->outd(uReg, value);
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetDeviceRegDWORD쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
		
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetDevicePciConfigSpace(HANDLE hDevice, int nOffset, int nBytes, BYTE* pData)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (pData==NULL) || (nOffset<0) || (nBytes<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	if(!((CChipset*)hDevice)->ReadPciConfigSpace(nOffset, nBytes, pData)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetDevicePciConfigSpace쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetDevicePciConfigSpace(HANDLE hDevice, int nOffset, int nBytes, BYTE* pData)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (pData==NULL) || (nOffset<0) || (nBytes<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	if(!((CChipset*)hDevice)->WritePciConfigSpace(nOffset, nBytes, pData)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetDevicePciConfigSpace쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetDevicePciConfigSpaceEx(HANDLE hBoard, int nOffset, int nBytes, BYTE* pData)
{
	TRY_BEGIN
		
	if((hBoard==NULL) || (pData==NULL) || (nOffset<0) || (nBytes<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	TBoardDesc* bd = (TBoardDesc*)hBoard;
	if(bd->reserved1 == 0) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}

	if(!g_chpListV[bd->nFirstDevice]->ReadPciConfigSpaceEx(nOffset, nBytes, pData)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetDevicePciConfigSpace쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetDevicePciConfigSpaceEx(HANDLE hBoard, int nOffset, int nBytes, BYTE* pData)
{
	TRY_BEGIN
		
	if((hBoard==NULL) || (pData==NULL) || (nOffset<0) || (nBytes<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	TBoardDesc* bd = (TBoardDesc*)hBoard;
	if(bd->reserved1 == 0) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	if(!g_chpListV[bd->nFirstDevice]->WritePciConfigSpaceEx(nOffset, nBytes, pData)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetDevicePciConfigSpace쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API int    __stdcall TwGetSubDeviceCount()
{
	TRY_BEGIN

	if(g_capsListV.size() <= 0) {
		g_uLastError = TWERR_NO_DEVICE;
		return 0;
	}

	g_uLastError = TWERR_SUCCESS;
	return (int)g_capsListV.size();

	TRY_END(TEXT("[쳣]TwGetSubDeviceCount쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return TWERR_EXCEPTION;
}

TW68XX_API HANDLE  __stdcall TwGetSubDeviceHandle(int nSubDevice)
{
	TRY_BEGIN
		
	if((nSubDevice<0) || ((UINT)nSubDevice>g_capsListV.size())) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return g_capsListV[nSubDevice];
	
	TRY_END(TEXT("[쳣]TwGetSubDeviceHandle쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return NULL;
}

TW68XX_API BOOL   __stdcall TwGetSubDeviceDetail(HANDLE hSubDevice, TSubDeviceDesc *pSubDevDesc)
{
	TRY_BEGIN
		
	if((hSubDevice==NULL) || (pSubDevDesc==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	*pSubDevDesc = ((PDeviceCapability)hSubDevice)->ddesc;
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetSubDeviceDetail2쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwEnableVideoInput(HANDLE hSubDevice, TVideoInput vInput, BOOL bEnable)
{
	TRY_BEGIN
		
	if((hSubDevice==NULL) || (vInput<viCompositeVideo1) || (vInput>viCompositeVideo4)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	PDeviceCapability devCaps = (PDeviceCapability)hSubDevice;
	if((ULONG)vInput >= devCaps->ddesc.reserved1) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	if((devCaps->caps&CAPS_SWITCH)) {
		if(bEnable) {
			if(!(devCaps->ddesc.VideoInputMask & INPUT_MASK((int)vInput))) {
				devCaps->ddesc.VideoInputMask |= INPUT_MASK((int)vInput);
				devCaps->ddesc.iSwitch++;
			}
		}
		else {
			if(devCaps->ddesc.VideoInputMask & INPUT_MASK((int)vInput)) {
				devCaps->ddesc.VideoInputMask &= ~INPUT_MASK((int)vInput);
				devCaps->ddesc.iSwitch--;
			}
		}
		if(devCaps->ddesc.iSwitch > 1) {
			devCaps->ddesc.bField2 = FALSE;
		}
	}
	else { 
		if(bEnable) {
			devCaps->ddesc.VideoInputMask = INPUT_MASK((int)vInput);
		}
		else if(devCaps->ddesc.VideoInputMask & INPUT_MASK((int)vInput))
		{
			devCaps->ddesc.VideoInputMask &= ~INPUT_MASK((int)vInput);
		}
		else {
			g_uLastError = TWERR_NOT_SUPPORT;
			return FALSE;
		}
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwEnableVideoInput쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwEnableVideoField2(HANDLE hSubDevice, BOOL bEnable)
{
	TRY_BEGIN
		
	if(hSubDevice==NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	if(g_chlList.size() > 0) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}

	PDeviceCapability devCaps = (PDeviceCapability)hSubDevice;
	if(!(devCaps->caps&CAPS_FIELD2)) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}

	devCaps->ddesc.bField2 = bEnable;
	if(bEnable) {
		devCaps->ddesc.iSwitch = 1;
	}

	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwEnableVideoField2쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwStartVideoField2(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	TRY_BEGIN
		
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}

	if(!(vsource->Device()->DeviceCaps()->caps & CAPS_FIELD2)) {
		g_uLastError = TWERR_NOT_SUPPORT;
		return FALSE;
	}
	
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_run |= frame_preview;
	vsource->SetPluginInfo(&vinfo, VSRC_frame_run);
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwStartVideoField2쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwStopVideoField2(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	TRY_BEGIN
		
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_run &= ~frame_preview;
	vsource->SetPluginInfo(&vinfo, VSRC_frame_run);
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwStopVideoField2쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API int    __stdcall TwGetChannelCount()
{
	TRY_BEGIN

	CIniFile iniFile;
	TCHAR path[MAX_PATH];
	g_util.GetModulePath(g_hSelfDll, path);
	lstrcat(path, TEXT("TW68XX.ini"));
	iniFile.Create(path);

	if(g_chpListV.size() == 0) {
		g_uLastError = TWERR_NO_DEVICE;
		return 0;
	}

	if(g_chlList.size() > 0) {
		g_uLastError = TWERR_SUCCESS;
		return (int)g_chlList.size();
	}

	ULONG i = 0;
	ULONG k = 0;
	ULONG iNum=0, iSwitch=0;
	CThread*  pThread = NULL;
	
	if(!GCreateDevices()) {
		g_uLastError = TWERR_CREATE_DEVICE;
		return 0;
	}

	//Ƶͨڴ
	int j;
	CDevBase* dev = NULL;
	CSample*  pSample= NULL;
	if(g_devListA.size() > 0) {
		ULONG hwid = 0;
		j=0;
		for(i=0; (UINT)i<g_devListA.size(); i++) {
			dev = g_devListA[i];
			hwid= DEVICEID(dev->Parent()->DeviceInfo().HardwareId);
			if(((hwid==0x6802) || (hwid==0x6805)) || ((hwid>=0x6814) && (hwid<=0x6817))) {
				for(k=0; k<RAWA_NUM; k++) {
					//Ƶbuffer
					pSample = new CSample();
					if(pSample == NULL) {
						j = -1;
						_trace(TEXT("[]TwGetChannelCount-ƵCSampleʧ\n"));
						break;
					}
					else if(pSample->Allocate(PLGA_LEN)) {
						g_bufPlgA.push_back(pSample);
					}
					else {
						SAFE_DELETE(pSample);
						j = -1;
						_trace(TEXT("[]TwGetChannelCount-ƵSampleڴʧ\n"));
						break;
					}
				}
				if(j != 0) {
					break;
				}
			}
		}
	}

#if(0) // for alone non-realtime thread
	for(i=0; i<g_devListV.size(); i++) {
		if(g_devListV[i]->DeviceCaps()->ddesc.iSwitch > 1) {
			iSwitch++;
		}
	}
	if(iSwitch==g_devListV.size()) { iSwitch=0; }
#endif

	//ƵSource߳
	iNum = iniFile.ReadInt(TEXT("SDK"), TEXT("vsource_thread_num"), SOURCE_THREAD_NUM);
	iNum = min(iNum, (ULONG)g_devListV.size()) + (iSwitch>0);
	for(i=0; i<iNum; i++) {
		pThread = new CTSource();
		if(pThread == NULL) {
			g_uLastError = TWERR_OUTOF_MEMORY;
			return 0;
		}
		g_source.push_back((CTSource*)pThread);
	}
	if(g_source.size() != iNum) {
		_trace(TEXT("[]TwGetChannelCount-source߳ʧ\n"));
		g_uLastError = TWERR_CREATE_THREAD;
		return 0;
	}
	if(iSwitch) {
		k = ((ULONG)g_devListV.size()-iSwitch) / (iNum-1);
		if(k == 0) { k=(ULONG)g_devListV.size(); }
		j=0;
		for(i=0; (UINT)i<g_devListV.size(); i++) {
			if((i>0) && ((i%k)==0)) {
				j++;
			}
			if(g_devListV[i]->DeviceCaps()->ddesc.iSwitch > 1) {
				g_source.back()->AppendDevice(g_devListV[i]);
			}
			else {
				g_source[j]->AppendDevice(g_devListV[i]);
			}
		}
	}
	else {
		k = (ULONG)g_devListV.size() / iNum;
		if(k == 0) { k=(ULONG)g_devListV.size(); }
		j=0;
		for(i=0; (UINT)i<g_devListV.size(); i++) {
			if((i>0) && ((i%k)==0)) {
				j++;
			}
			g_source[j]->AppendDevice(g_devListV[i]);
		}
	}
	for(k=0; k<g_source.size(); k++) {
		pThread = g_source[k];
		if(!pThread->Create()) {
			_trace(TEXT("[]TwGetChannelCount-source߳%dʧ\n"), k);
			g_uLastError = TWERR_CREATE_THREAD;
			return 0;
		}
	}
	
	//ƵSource߳
	iNum = iniFile.ReadInt(TEXT("SDK"), TEXT("asource_thread_num"), SOURCEA_THREAD_NUM);
	iNum = min(iNum, (ULONG)g_devListA.size());
	for(i=0; i<iNum; i++) {
		pThread = new CTSourceA();
		if(pThread != NULL) {
			g_asource.push_back((CTSourceA*)pThread);
		}
	}
	if(iNum > 0) {
		if(g_asource.size() == 0) {
			_trace(TEXT("[]TwGetChannelCount-asource߳ʧ\n"));
			g_uLastError = TWERR_CREATE_THREAD;
			return FALSE;
		}
		k = (ULONG)g_devListA.size() / iNum;
		if(k == 0) { k=(ULONG)g_devListA.size(); }
		j=0;
		for(i=0; (UINT)i<g_devListA.size(); i++) {
			if((i>0) && ((i%k)==0)) {
				j++;
			}
			g_asource[j]->AppendDevice(g_devListA[i]);
		}
	}
	for(k=0; k<g_asource.size(); k++) {
		pThread = g_asource[k];
		if(!pThread->Create()) {
			_trace(TEXT("[]TwGetChannelCount-asource߳%dʧ\n"), k);
			delete pThread;
			g_asource.erase(g_asource.begin()+k);
			k--;
			continue;
		}
	}

	//ص߳
	iNum = iniFile.ReadInt(TEXT("SDK"), TEXT("callback_thread_num"), CALLBACK_THREAD_NUM);
	for(i=0; i<iNum; i++) {
		pThread = new CTCallback();
		if(pThread != NULL) {
			g_callback.push_back((CTCallback*)pThread);
		}
	}
	for(k=0; k<g_callback.size(); k++) {
		pThread = g_callback[k];
		if(!pThread->Create()) {
			_trace(TEXT("[]TwGetChannelCount-ص߳%dʧ\n"), k);
			delete pThread;
			g_callback.erase(g_callback.begin()+k);
			k--;
			continue;
		}
	}
	if(g_callback.size() == 0) {
		_trace(TEXT("[]TwGetChannelCount-ص߳ʧ\n"));
		g_uLastError = TWERR_CREATE_THREAD;
		return FALSE;
	}
	
	//߳
	iNum = iniFile.ReadInt(TEXT("SDK"), TEXT("assist_thread_num"), ASSIST_THREAD_NUM);
	iNum = min(iNum, (ULONG)g_devListV.size());
	for(i=0; i<iNum; i++) {
		pThread = new CTAssist();
		if(pThread != NULL) {
			g_assist.push_back((CTAssist*)pThread);
		}
	}
	if(iNum > 0) {
		if(g_assist.size() == 0) {
			_trace(TEXT("[]TwGetChannelCount-assist߳ʧ\n"));
			g_uLastError = TWERR_CREATE_THREAD;
			return FALSE;
		}
		k = (ULONG)g_devListV.size() / iNum;
		if(k == 0) { k=(ULONG)g_devListV.size(); }
		j=0;
		for(i=0; (UINT)i<g_devListV.size(); i++) {
			if((i>0) && ((i%k)==0)) {
				j++;
			}
			g_assist[j]->AppendDevice(g_devListV[i]);
		}
	}
	for(k=0; k<g_assist.size(); k++) {
		pThread = g_assist[k];
		if(!pThread->Create()) {
			_trace(TEXT("[]TwGetChannelCount-߳%dʧ\n"), k);
			delete pThread;
			g_assist.erase(g_assist.begin()+k);
			k--;
			continue;
		}
	}
	if(g_assist.size() == 0) {
		_trace(TEXT("[]TwGetChannelCount-߳ʧ\n"));
		g_uLastError = TWERR_CREATE_THREAD;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;

	//GOrderChannels();	//for Hawell board

	return (int)g_chlList.size();

	TRY_END(TEXT("[쳣]TwGetChannelCount쳣\n"))
	g_uLastError = TWERR_EXCEPTION;

	return -1;	
}

TW68XX_API BOOL   __stdcall TwChangeChannelId(int nChannel, int nId)
{
	TRY_BEGIN
		
	if((nChannel<0) || ((ULONG)nChannel>=g_chlList.size())) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}

	g_chlList[nChannel]->Init(nId);

	g_uLastError = TWERR_SUCCESS;
	return TRUE;

	TRY_END(TEXT("[쳣]TwChangeChannelId쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;	
}

TW68XX_API BOOL   __stdcall TwGetChannelDetail(HANDLE hChannel, TChannelDesc *pChannelDesc)
{
	TRY_BEGIN
		
	if((hChannel==NULL) || (pChannelDesc==NULL)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	TvSourceInfo vinfo;
	CChannel*	 channel  = (CChannel*)hChannel;
	CChipset*	 vdev = NULL;
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	ZeroMemory(pChannelDesc, sizeof(TChannelDesc));
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vdev = vsource->Device()->Parent();
	pChannelDesc->nAudio = (channel->Plugin(PLG_asource) != NULL);
	pChannelDesc->nBoardId = vdev->CardInfo()->nBoardId;
	pChannelDesc->nDeviceId= vdev->DeviceInfo().nDeviceId;
	pChannelDesc->nSubDeviceId = vdev->DeviceInfo().nFirstSubDevice;
	pChannelDesc->nMaxFrameRate= vinfo.capture.frame_rate;

	g_uLastError = TWERR_SUCCESS;
	return TRUE;

	TRY_END(TEXT("[쳣]TwGetChannelDetail쳣\n"))

	g_uLastError = TWERR_EXCEPTION;
	return FALSE;
}

TW68XX_API HANDLE __stdcall TwI2COpen(HANDLE hDevice)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (g_chpListV.size()<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	HANDLE hI2C = ((CChipset*)hDevice)->GetI2C();

	g_uLastError = (hI2C==NULL) ? TWERR_SUCCESS : TWERR_NO_DEVICE;

	return hI2C;
	
	TRY_END(TEXT("[쳣]TwI2COpen쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return NULL;
}

TW68XX_API VOID   __stdcall TwI2CClose(HANDLE hI2C)
{
}

TW68XX_API BOOL   __stdcall TwI2CWrite(HANDLE hI2C, int nBytes, BYTE* cValue)
{
	TRY_BEGIN
		
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	CI2C* i2c = (CI2C*)hI2C;
	
	if(i2c->i2cWriteData(nBytes, cValue) == false) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwI2CWrite쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
			
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwI2CWriteNoStop(HANDLE hI2C, int nBytes, BYTE* cValue)
{
	TRY_BEGIN
		
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CI2C* i2c = (CI2C*)hI2C;
	
	if(i2c->i2cWriteDataNoStop(nBytes, cValue) == false) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwI2CWriteNoStop쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwI2CRead(HANDLE hI2C, int nWriteBytes, BYTE* cValue, int nReadBytes, BYTE* pValue)
{
	TRY_BEGIN
	
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CI2C* i2c = (CI2C*)hI2C;
	
	if(i2c->i2cReadData(nWriteBytes, cValue, nReadBytes, pValue) == false) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwI2CRead쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
		
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwI2CLock(HANDLE hI2C, ULONG uTimeout)
{
	TRY_BEGIN
		
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CI2C* i2c = (CI2C*)hI2C;
	BOOL  bRet= i2c->i2cLock()->Lock(uTimeout);

	g_uLastError = bRet ? TWERR_SUCCESS : TWERR_TIMEOUT;
	
	return bRet;
	
	TRY_END(TEXT("[쳣]TwI2CLock쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API VOID   __stdcall TwI2CUnlock(HANDLE hI2C)
{
	TRY_BEGIN
		
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return;
	}
	
	CI2C* i2c = (CI2C*)hI2C;
	i2c->i2cLock()->Unlock();
	
	g_uLastError = TWERR_SUCCESS;
	
	return;
	
	TRY_END(TEXT("[쳣]TwI2CUnlock쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
}

TW68XX_API BOOL  __stdcall TwI2CSetSpeed(HANDLE hI2C, ULONG uSpeed)
{
	TRY_BEGIN
		
	if(hI2C == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	
	CI2C* i2c = (CI2C*)hI2C;
	i2c->I2CInitSWMode((long)uSpeed);
	
	g_uLastError = TWERR_SUCCESS;
	
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwI2CUnlock쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	return FALSE;
}

TW68XX_API HANDLE __stdcall TwI2CCreate(HANDLE hDevice, int sclGpio, int sdaGpio, int nSpeed)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (g_chpListV.size()<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	HANDLE hI2C = ((CChipset*)hDevice)->CreateI2CuGpio(sclGpio, sdaGpio, nSpeed);

	g_uLastError = (hI2C==NULL) ? TWERR_SUCCESS : TWERR_NO_DEVICE;

	return hI2C;
	
	TRY_END(TEXT("[쳣]TwI2CgCreate쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return NULL;
}

TW68XX_API VOID   __stdcall TwI2CFree(HANDLE hI2C)
{
	TRY_BEGIN

	if(hI2C != NULL)
	{
		delete (CI2CuGpio*)hI2C;
	}

	g_uLastError = TWERR_SUCCESS;
	return;

	TRY_END(TEXT("[쳣]TwI2CgFree쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
}

TW68XX_API HANDLE __stdcall TwGPIOOpen(HANDLE hDevice)
{
	TRY_BEGIN
		
	if((hDevice==NULL) || (g_chpListV.size()<=0)) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	return ((CChipset*)hDevice)->GetGPIO();
	
	TRY_END(TEXT("[쳣]TwGPIOOpen쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return NULL;
}

TW68XX_API VOID   __stdcall TwGPIOClose(HANDLE hGpio)
{
}

TW68XX_API BOOL   __stdcall TwGPIOEnableOutput(HANDLE hGpio, int nGpio, int nBits, BOOL bEnable)
{
	TRY_BEGIN
		
	if(hGpio == NULL) {
		return FALSE;
	}
	
	CGpio* gpio = (CGpio*)hGpio;
	return gpio->EnableGpioOutput(bEnable ? true : false, nGpio, nBits );
	
	TRY_END(TEXT("[쳣]TwGPIOEnableOutput쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
			
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGPIOSetBits(HANDLE hGpio, int nGpio, int nBits, ULONG* ulValue)
{
	TRY_BEGIN
		
	if(hGpio == NULL) {
		return FALSE;
	}
	
	CGpio* gpio = (CGpio*)hGpio;
	return gpio->SetGpioBits(nGpio, nBits, ulValue);
	
	TRY_END(TEXT("[쳣]TwGPIOSetBits쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
			
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGPIOGetBits(HANDLE hGpio, int nGpio, int nBits, ULONG *pValue)
{
	TRY_BEGIN
		
	if(hGpio == NULL) {
		return FALSE;
	}
	
	CGpio* gpio = (CGpio*)hGpio;
	return gpio->GetGpioBits(nGpio, nBits, pValue);
	
	TRY_END(TEXT("[쳣]TwGPIOGetBits쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
		
	return FALSE;
}

TW68XX_API HANDLE __stdcall TwChannelOpen(int nChannel)
{
	ULONG i=0;
	
	if((nChannel<0) || ((ULONG)nChannel>=g_chlList.size())) {
		g_uLastError = TWERR_INVALID_PARAM;
		return NULL;
	}
	
	for(i=0; i<g_chlList.size(); i++) {
		if(g_chlList[i]->ChannelId() == nChannel) {
			nChannel = i;
			break;
		}
	}
	
	_trace(TEXT("[Ϣ]TwChannelOpenͨ%d\n"), nChannel);
	g_uLastError = TWERR_SUCCESS;
	
	return (HANDLE)g_chlList[nChannel];
}

TW68XX_API VOID   __stdcall TwChannelClose(HANDLE hChannel)
{
	TRY_BEGIN
// 	CHECK_HANDLE(hChannel);
// 	
// 	CChannel* channel = H_2_CARD(hChannel);
// 	if(!channel->EnablePlugin(0xFFFFFFFF, FALSE)) {
// 		return;
// 	}
	
	g_uLastError = TWERR_SUCCESS;
	return; 

	TRY_END(TEXT("[쳣]TwChannelClose쳣\n"))
		
	g_uLastError = TWERR_EXCEPTION;

	return;
}

TW68XX_API BOOL   __stdcall TwSetVideoPara(HANDLE hChannel, TVideoPara vPara, LONG lValue)
{
	TRY_BEGIN

	if(vPara == vpBufferType) {
		if(g_devListV.size() > 0) {
			g_uLastError = TWERR_FAILED;
			return FALSE;
		}

		if((lValue<vbtCIF) || (lValue>vbtD1_preview)) {
			g_uLastError = TWERR_INVALID_PARAM;
			return FALSE;
		}

		switch(lValue) {
		case vbtCIF:
			CDevBase::BufferLen() = RAWV_LEN/2;
			break;
		case vbtHalfD1:
		case vbtD1_preview:	
			CDevBase::BufferLen() = RAWV_LEN;
			break;
		default:
			CDevBase::BufferLen() = RAWV_LEN_4CIF;
			break;
		}
		
		CDevBase::BufferType() = lValue;
		g_uLastError = TWERR_SUCCESS;

		return TRUE;
	}
	if((vPara==vpStandard) && (hChannel==NULL)) {
		TvSourceInfo::default_standard = lValue;
		g_uLastError = TWERR_SUCCESS;
		return TRUE;
	}

	CHECK_HANDLE_RET(hChannel, FALSE);
	
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	ULONGLONG	 flag = 0;
	BOOL		 bCheck = FALSE;
	ULONG		 hwid = 0;
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}

	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	hwid  = DEVICEID(vsource->Device()->Parent()->DeviceInfo().HardwareId);

	if(vPara == vpOptimizedCIF1) {
		vsource->Device()->Optimized() = lValue;
		g_uLastError = TWERR_SUCCESS;
		return TRUE;
	}

	switch(vPara) {
	case vpBrightness:
		vinfo.brightness = lValue;
		flag = VSRC_brightness;
		break;
	case vpContrast:
		vinfo.contrast = lValue;
		flag = VSRC_contrast;
		break;
	case vpSaturation:
		vinfo.saturation = lValue;
		flag = VSRC_saturation;
		break;
	case vpHue:
		vinfo.hue = lValue;
		flag = VSRC_hue;
		break;
	case vpSharpness:
		vinfo.sharpness = lValue;
		flag = VSRC_sharpness;
		break;
	case vpOptimizedCIF:
		switch(hwid) {
		case 0x6801:
		case 0x6804:
		case 0x6864:
		case 0x6869:
		case 0x6810:
		case 0x6811:
		case 0x6812:
		case 0x6813:
			bCheck = FALSE;
			break;
		default:
			bCheck = TRUE;
			break;
		}
		if(!bCheck) {
			vinfo.optimize_cif = lValue;
			flag = VSRC_optimize_cif;
		}
		break;
	case vpStandard:
		vinfo.standard = lValue;
		TvSourceInfo::default_standard = lValue;
		flag = VSRC_standard;
		break;
	case vpPixelFormat:
		switch(hwid) {
		case 0x6801:
		case 0x6804:
			bCheck = ((lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar) || (lValue==vpfYUV411Interspersed));
			break;
		case 0x6864:
		case 0x6869:	
			bCheck = ((lValue==vpfRGB24) || (lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar));
			break;
		case 0x6810:
		case 0x6811:
		case 0x6812:
		case 0x6813:
			bCheck = ((lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar));
			break;
		}
		if(!bCheck) {
			vinfo.capture.pixel_format = lValue;
			vinfo.preview.pixel_format = lValue;
			flag = VSRC_c_pixel_format|VSRC_p_pixel_format;
		}
		break;
	case vpFrameRate:
		vinfo.capture.frame_rate = lValue;
		flag = VSRC_c_frame_rate;
		break;
	case vpWidth:
		bCheck = (CDevBase::BufferType()==vbtCIF) && (lValue>352);
		vinfo.capture.width = lValue;
		flag = VSRC_c_width;
		break;
	case vpHeight:
		bCheck = IS_PAL(vinfo.standard) ? (lValue>288) : (lValue>240);
		if(bCheck) {
			if(CDevBase::BufferType()==vbtD1_preview) {
				bCheck = CDevBase::IsBufferFull();
				if(!bCheck) {
					CDevBase::SetBufferFull(channel);
				}
			}
			else {
				bCheck = vsource->Device()->DeviceCaps()->ddesc.bField2 || (CDevBase::BufferType()!=vbtD1);
			}
		}
		vinfo.capture.height = lValue;
		flag = VSRC_c_height;
		break;
	case vpField:
		vinfo.field = lValue;
		flag = VSRC_field;
		break;
	case vpLeft:
		bCheck = ((hwid != 0x6864) && (hwid != 0x6869));
		if(!bCheck) {
			vinfo.vleft = lValue;
			flag = VSRC_vleft;
		}
		break;
	case vpRight:
		bCheck = ((hwid != 0x6864) && (hwid != 0x6869));
		if(!bCheck) {
			vinfo.vright = lValue;
			flag = VSRC_vright;
		}
		break;
	case vpHDelay:
		vinfo.hdelay = lValue;
		flag = VSRC_hdelay;
		break;
	case vpVDelay:
		vinfo.vdelay = lValue;
		flag = VSRC_vdelay;
		break;
	case vpPixelFormat2:
		switch(hwid) {
		case 0x6801:
		case 0x6804:
			bCheck = ((lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar) || (lValue==vpfYUV411Interspersed));
			break;
		case 0x6864:
		case 0x6869:
			bCheck = ((lValue==vpfRGB24) || (lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar));
			break;
		case 0x6810:
		case 0x6811:
		case 0x6812:
		case 0x6813:
			bCheck = ((lValue==vpfRGB24Alpha) || (lValue==vpfYUV411Planar) || (lValue==vpfYUV420Planar));
			break;
		}
		if(!bCheck) {
			vinfo.capture.pixel_format = lValue;
			vinfo.preview.pixel_format = lValue;
			flag = VSRC_c_pixel_format|VSRC_p_pixel_format;
		}
		break;
	case vpFrameRate2:
		vinfo.preview.frame_rate = lValue;
		flag = VSRC_p_frame_rate;
		break;
	case vpWidth2:
		bCheck = (CDevBase::BufferType()==vbtCIF) && (lValue>352);
		vinfo.preview.width = lValue;
		flag = VSRC_p_width;
		break;
	case vpHeight2:
		bCheck = IS_PAL(vinfo.standard) ? (lValue>288) : (lValue>240);
		bCheck = bCheck && vsource->Device()->DeviceCaps()->ddesc.bField2;
		vinfo.preview.height = lValue;
		flag = VSRC_p_height;
		break;
	default:
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
		break;
	}
	
	if(bCheck) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}
	if(!vsource->SetPluginInfo(&vinfo, flag)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
		
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwSetVideoPara쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
		
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwGetVideoPara(HANDLE hChannel, TVideoPara vPara, LONG *pValue)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	if(vPara == vpBufferType) {
		*pValue = CDevBase::BufferType();
		g_uLastError = TWERR_SUCCESS;
		return TRUE;
	}
	
	TRY_BEGIN
		
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	
	switch(vPara) {
	case vpBrightness:
		*pValue = vinfo.brightness;
		break;
	case vpContrast:
		*pValue = vinfo.contrast;
		break;
	case vpSaturation:
		*pValue = vinfo.saturation;
		break;
	case vpHue:
		*pValue = vinfo.hue;
		break;
	case vpSharpness:
		*pValue = vinfo.sharpness;
		break;
	case vpSignal:
		*pValue = vinfo.signal;
		break;
	case vpOptimizedCIF:
		*pValue = vinfo.optimize_cif;
		break;
	case vpOptimizedCIF1:
		*pValue = vsource->Device()->Optimized();
		break;
	case vpStandard:
		*pValue = vinfo.standard;
		break;
	case vpPixelFormat:
		*pValue = vinfo.capture.pixel_format;
		break;
	case vpFrameRate:
		*pValue = vinfo.capture.frame_rate;
		break;
	case vpWidth:
		*pValue = vinfo.capture.width;
		break;
	case vpHeight:
		*pValue = vinfo.capture.height;
		break;
	case vpField:
		*pValue = vinfo.field;
		break;
	case vpLeft:
		*pValue = vinfo.vleft;
		break;
	case vpRight:
		*pValue = vinfo.vright;
		break;
	case vpHDelay:
		*pValue = vinfo.hdelay;
		break;
	case vpVDelay:
		*pValue = vinfo.vdelay;
		break;
	case vpPixelFormat2:
		*pValue = vinfo.preview.pixel_format;
		break;
	case vpFrameRate2:
		*pValue = vinfo.preview.frame_rate;
		break;
	case vpWidth2:
		*pValue = vinfo.preview.width;
		break;
	case vpHeight2:
		*pValue = vinfo.preview.height;
		break;
	default:
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
		break;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwGetVideoPara쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
		
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwStartVideoCapture(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	TRY_BEGIN
		
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_run |= frame_capture;
	vsource->SetPluginInfo(&vinfo, VSRC_frame_run);
	if(!H_2_CARD(hChannel)->EnablePlugin(PLG_vrawcbk, TRUE)) {
		g_uLastError = TWERR_START_DEVICE;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;
	return TRUE;

	TRY_END(TEXT("[쳣]TwStartVideoCapture쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwStopVideoCapture(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	TRY_BEGIN
		
	TvSourceInfo vinfo;
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgvSource* vsource= (CPlgvSource*)channel->Plugin(PLG_vsource);
	
	if(vsource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
	vinfo.frame_run &= ~frame_capture;
	vsource->SetPluginInfo(&vinfo, VSRC_frame_run);
	if(!H_2_CARD(hChannel)->EnablePlugin(PLG_vrawcbk, FALSE)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}
	
	g_uLastError = TWERR_SUCCESS;
	return TRUE;
	
	TRY_END(TEXT("[쳣]TwStopVideoCapture쳣\n"))
	g_uLastError = TWERR_EXCEPTION;
	
	return FALSE;
}

TW68XX_API BOOL   __stdcall TwSetAudioPara(HANDLE hChannel, TAudioPara aPara, LONG lValue)
{
	if(aPara == apPacketLength) {
		if((lValue<=0) || (lValue>AUDIO_PAGE_LEN)) {
			g_uLastError = TWERR_INVALID_PARAM;
			return FALSE;
		}

		CDevBase::AudioPktLen() = lValue;
		g_uLastError = TWERR_SUCCESS;
		return TRUE;
	}

	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgaSource* asource= (CPlgaSource*)channel->Plugin(PLG_asource);
	TaSourceInfo ainfo;
	ULONGLONG	 aflag = 0;
	
	if(asource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	ainfo = *(PaSourceInfo)asource->GetPluginInfo();
	switch(aPara) {
	case apSamplesPerSecond:
		aflag = ASRC_samplerate;
		ainfo.samplerate = lValue;
		break;
	case apBitsPerSample:
		aflag = ASRC_bitcount;
		ainfo.bitcount = lValue;
		break;
	case apChannel:
		aflag = ASRC_channels;
		ainfo.channels = lValue;
		break;
	case apVolume:
		aflag = ASRC_volume;
		ainfo.volume = lValue;
		break;
	default:
		aflag = 0;
		break;
	}

	if(aflag == 0) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	if(!asource->SetPluginInfo(&ainfo, aflag)) {
		g_uLastError = TWERR_FAILED;
		return FALSE;
	}

	g_uLastError = TWERR_SUCCESS;
	
	return TRUE;
}

TW68XX_API BOOL   __stdcall TwGetAudioPara(HANDLE hChannel, TAudioPara aPara, LONG *pValue)
{
	if(pValue == NULL) {
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
	}

	if(aPara == apPacketLength) {
		*pValue = CDevBase::AudioPktLen();
		g_uLastError = TWERR_SUCCESS;
		return TRUE;
	}
	
	CChannel*	 channel  = H_2_CARD(hChannel);
	CPlgaSource* asource= (CPlgaSource*)channel->Plugin(PLG_asource);
	TaSourceInfo ainfo;
	
	if(asource == NULL) {
		g_uLastError = TWERR_NO_DEVICE;
		return FALSE;
	}
	
	ainfo = *(PaSourceInfo)asource->GetPluginInfo();
	switch(aPara) {
	case apSamplesPerSecond:
		*pValue = ainfo.samplerate;
		break;
	case apBitsPerSample:
		*pValue = ainfo.bitcount;
		break;
	case apChannel:
		*pValue = ainfo.channels;
		break;
	case apVolume:
		*pValue = ainfo.volume;
		break;
	default:
		g_uLastError = TWERR_INVALID_PARAM;
		return FALSE;
		break;
	}
	
	g_uLastError =  TWERR_SUCCESS;

	return TRUE;
}

TW68XX_API BOOL   __stdcall TwStartAudioCapture(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	return H_2_CARD(hChannel)->EnablePlugin(PLG_arawcbk, TRUE);
}

TW68XX_API BOOL   __stdcall TwStopAudioCapture(HANDLE hChannel)
{
	CHECK_HANDLE_RET(hChannel, FALSE);
	
	return H_2_CARD(hChannel)->EnablePlugin(PLG_arawcbk, FALSE);
}

TW68XX_API BOOL   __stdcall TwRegisterVideoStreamCallback(TwVideoStreamCallback VideoStreamCallback, VOID *Context)
{
	CTCallback::m_fnStreamV = VideoStreamCallback;
	CTCallback::m_cxStreamV = Context;

	return TRUE;
}

TW68XX_API BOOL   __stdcall TwRegisterAudioStreamCallback(TwAudioStreamCallback AudioStreamCallback, VOID *Context)
{
	CTCallback::m_fnStreamA = AudioStreamCallback;
	CTCallback::m_cxStreamA = Context;
	
	return TRUE;
}
