// Util.h: interface for the CUtil class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__EEOUTIL_H_)
#define __EEOUTIL_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define CYB			6416	//int(0.114*219/255*65536+0.5)
#define CYG			33039	//int(0.587*219/255*65536+0.5)
#define CYR			16829	//int(0.299*219/255*65536+0.5)
#define SCALED_Y	38155	//int(255.0/219.0*32768+0.5);
#define CLIP_U		507		//(1/2.018*1024+0.5);
#define CLIP_V		642		//(1/1.596*1024+0.5);

class CUtil
{
public:
	CUtil() {}
	virtual ~CUtil() {}

	static HANDLE	OpenByInterface(GUID* pClassGuid, DWORD instance, TDeviceDesc* devInfo, TBoardDesc* cardInfo);
	static BOOL		ParsePciLocation(TCHAR* strLocation, ULONG* bus, ULONG* device, ULONG* function);
	static BOOL		ParsePciLocationW(WCHAR* strLocation, ULONG* bus, ULONG* device, ULONG* function);

	static void		ReverseBGR888(PBYTE src, PBYTE dst, UINT widthbytes, UINT height);
	static void		ReverseImage(PBYTE src, PBYTE dst, UINT widthbytes, UINT height);
	static PBYTE	C_RGBtoYUV(BYTE *dest, BYTE *src, DWORD w, DWORD h);
	static PBYTE	bgr888_to_YUY2_c(PBYTE src, PBYTE dst, UINT src_stride, UINT dest_stride, UINT width, UINT height);

	static LPCTSTR	GetModulePath(HANDLE hModule, LPTSTR path, int len=MAX_PATH);
	static void		MMXSpecpy(BYTE *pSrc, BYTE *pDrc, DWORD dwCapWidth, DWORD dwWidth, DWORD dwHeight);

#if( !defined(WIN64) && !defined(_VC6))
	static void		MMXDecCPY(BYTE *Dest, BYTE *Src, DWORD nBytes);
	static void		memcpySSE(void* Dest, void* Src, size_t nBytes);
	static void		memcpy_sse(void *dst, void *src, int nQWORDs);
	static void		memcpyMMX(void *Dest, void *Src, size_t nBytes);
	static void		DownScale(BYTE *pIn,BYTE *pOut, int width, int height, int stride);
#endif

	static void		DownHalfHeight(BYTE* pIn, BYTE *pOut, int height, int stride, int dst_pitch=0);
	static DWORD	DownFrameRate(int from, int to);
	static int		map(int srcMin, int srcMax, int  srcVal, int dstMin, int dstMax, int* dstVal );
	static BYTE		rgb2y(BYTE r, BYTE g, BYTE b);
	static ULONG	rgb2yuy2(BYTE r, BYTE g, BYTE b);
};

inline BYTE CUtil::rgb2y(BYTE r, BYTE g, BYTE b)
{
#define clip(x) (((x) & 0xffffff00) ? ((x) & 0x80000000) ? 0 : 255 : (x))

    int Y = (r * 9798 + g * 19235 + b * 3736) >> 15;
	return clip(Y);

#undef clip

//	return (CYB*rgb[0] + CYG*rgb[1] + CYR*rgb[2] + 0x108000) >> 16;
}

inline ULONG CUtil::rgb2yuy2(BYTE r, BYTE g, BYTE b)
{
#define clip(x) (((x) & 0xffffff00) ? ((x) & 0x80000000) ? 0 : 255 : (x))

	long Y = (r * 9798 + g * 19235 + b * 3736) >> 15;
	long U = ((r * (-5505) + g * (-10879) + b * 16384) >> 15) + 128;
	long V = ((r * 16384 + g * -13730 + b * -2654) >> 15) + 128;

	Y = clip(Y);
	U = clip(U) << 8;
	V = clip(V) << 24;

	return (Y | U | (Y<<16) | V);

#undef clip

//	return (CYB*rgb[0] + CYG*rgb[1] + CYR*rgb[2] + 0x108000) >> 16;
}

#endif // !defined(__EEOUTIL_H_)
