/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		vDec686x.cpp
 *  @brief		Vcom decCvDec686xʵ֣֧TW686X Vcom data
 *
 *  @version	0.0.0.1
 *  @author		Carl
 *  @date		2009/11/16
 ***************************************************************************************
 */

#include "stdafx.h"
#include "vDec686x.h"
#include "PlgvSource.h"
#include "Channel.h"

int		calc_step_idx_2b(int index_i, BYTE code);
int		calc_step_idx_3b(int index_i, BYTE code);
int		calc_step_idx_4b(int index_i, BYTE code);
BYTE	adpcm_dec_2b(BYTE code, int step, BYTE pixel_est);
BYTE	adpcm_dec_3b(BYTE code, int step, BYTE pixel_est);
BYTE	adpcm_dec_4b(BYTE code, int step, BYTE pixel_est);

/*
#define calc_step_idx_4b_m(code_x, step_xi, step_xn)							\
{																				\
	code_x &= m_info.mask;														\
	if( code_x == 7 ){															\
		step_xi = (step_xi < step_s[0]) ? (step_xi + step_s[0]) : (step_xi<<1) ;\
	}																			\
	else if( code_x > 3) {														\
		pixel_int =  7 - code_x;												\
		step_xi = ((step_xi>>pixel_int) < step_s[pixel_int]) ? (step_xi + step_s[pixel_int]) : (step_xi + (step_xi>>pixel_int));	\
	}																							\
	else if( code_x > 1) {																		\
		pixel_int =  7 - code_x;																\
		step_xi = ((step_xi>>code_x) < (-step_s[pixel_int])) ? (step_xi + step_s[pixel_int]) : (step_xi - (step_xi>>code_x));	\
	}																							\
	else if( code_x == 1) {																		\
		step_xi = ((step_xi>>2) < (-step_s[6])) ? (step_xi + step_s[6]) : (step_xi - (step_xi>>2));	\
	}																							\
	else {																						\
		step_xi = ((step_xi>>1) < (-step_s[7])) ? (step_xi + step_s[7]) : (step_xi - (step_xi>>1));	\
	}																							\
	if( step_xi < 0 )		step_xi = 0;														\
	else if( step_xi > 63 ) step_xi = 63;														\
	step_xn = step_tab[step_xi];																\
}
*/

const static int step_tab[64] = {
//	0, 1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 
	4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64,
//	16, 17, 18, 19, 20, 21, 22, 23, 24,  25,  26,  27,  28,  29,  30,  31,
	68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120, 124, 128,
//	32,   33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,  45,  46,  47,  
	132, 136, 140, 144, 148, 152, 156, 160, 164, 168, 172, 176, 180, 184, 188, 192,
//	48,   49,  50,  51,  52,  53,  54,  55,  56,  57,  58,  59,  60,  61,  62,  63
	196, 200, 204, 208, 212, 216, 220, 224, 228, 232, 236, 240, 244, 248, 252, 255
};
// const static int step_s[8] = {1, 1, 1, 1, -1, -1, -1, -1};
// const static int step_s[8] = {4, 3, 2, 1, -1, -1, -1, -1};
// const static int step_s[8] = {7, 5, 3, 1, -1, -1, -1, -1};
// const static int step_s[8] = {8, 6, 4, 2, -1, 1, -1, -1};
const static int step_s[8] = {12, 8, 4, 2, -1, -1, -1, -1};
//const static int step_s[8] = {16, 12, 8, 4, -2, -2, -2, -2};
// const static int step_s[8] = {12, 8, 4, 2, -1, -1, -1, -2};
// const static int step_s[8] = {12, 8, 8, 4, -2, -2, -2, -2};
// const static int step_s[8] = {28, 16, 8, 4, -2, -2, -2, -2};

CvDec686x::CvDec686x()
{
	SetTargetBit(TARGET_4BIT);
}

CvDec686x::~CvDec686x()
{

}

BOOL CvDec686x::Transmit(CSample* pSampleIn, CSample* pSampleOut)
{
	CChannel* chl = pSampleIn->GetChannel();
	CPlgvSource* vsource = (CPlgvSource*)chl->Plugin(PLG_vsource);
	PvSourceInfo vinfo = (PvSourceInfo)vsource->GetPluginInfo();

	if(pSampleIn->GetType() == pktVideo) {
		return DecompressFrame(pSampleOut->DataPtr(), pSampleIn->DataPtr(), vinfo->capture.width, vinfo->capture.height);
	}

	return DecompressFrame(pSampleOut->DataPtr(), pSampleIn->DataPtr(), vinfo->preview.width, vinfo->preview.height);
}

void CvDec686x::SetTargetBit(BYTE nBit)
{
	m_info.target_nbit = nBit;
	m_info.mask = (1<<(nBit-1)) - 1;
	
	if( nBit == TARGET_2BIT ){
		adpcm_dec_nb = adpcm_dec_2b;
		calc_step_idx_nb = calc_step_idx_2b;
	}
	else if( nBit == TARGET_3BIT ){
		adpcm_dec_nb = adpcm_dec_3b;
		calc_step_idx_nb = calc_step_idx_3b;
	}
	else{
		adpcm_dec_nb = adpcm_dec_4b;
		calc_step_idx_nb = calc_step_idx_4b;
	}
}

void CvDec686x::INIT_BUF()	
{
	m_bit_pos = 0; m_bit_buf = 0; m_buf_pos = 0;
}

void CvDec686x::FLUSH_BUF()	
{
	m_bit_pos = 0; m_bit_buf = 0;
}

BYTE CvDec686x::read_buf(BYTE nbit,UINT* code_b)
{
	BYTE	bitso;
	BYTE	i;

	bitso = 0;
	i = 0;

	if( m_bit_pos < nbit ) {
		bitso <<= m_bit_pos;
		bitso |= (m_bit_buf>>(32-m_bit_pos));

		m_bit_buf = code_b[m_buf_pos++];
		i = m_bit_pos;
		m_bit_pos = 32;
	}

	bitso <<= (nbit-i);	
	bitso |= (m_bit_buf>>(32-nbit+i));
	m_bit_buf <<= (nbit-i);
	m_bit_pos -= (nbit-i);

	return	bitso;
}

#define adpcm_dec_4b_m(code_x, step_xn, x_est)									\
{																				\
	pdiff = 0;																	\
	if( code_x & 0x4 )	pdiff = step_xn;										\
	if( code_x & 0x2 )	pdiff += (step_xn >> 1);								\
	if( code_x & 0x1 )	pdiff += (step_xn >> 2);								\
	pdiff += (step_xn >> 3);													\
	if( code_x & 0x8 )	pdiff = -pdiff;											\
	pixel_int = ((int) x_est) + pdiff;											\
	x_est = (pixel_int<0) ? 0 : (pixel_int>255) ? 255 : (BYTE) pixel_int;		\
	pDestBuffer[out_ptr++] = x_est;												\
}

#define calc_step_idx_4b_m(code_x, step_xi, step_xn)									\
{																				\
	code_x &= m_info.mask;														\
	if( code_x == 7 ){															\
		step_xi = (step_xi < step_s[0]) ? (step_xi + step_s[0]) : (step_xi<<1) ;	\
	}																			\
	else if( code_x == 6) {														\
		step_xi = ((step_xi>>1) < step_s[1]) ? (step_xi + step_s[1]) : (step_xi + (step_xi>>1));	\
	}																							\
	else if( code_x == 5) {																		\
		step_xi = ((step_xi>>2) < step_s[2]) ? (step_xi + step_s[2]) : (step_xi + (step_xi>>2));	\
	}																							\
	else if( code_x == 4) {																		\
		step_xi = ((step_xi>>3) < step_s[3]) ? (step_xi + step_s[3]) : (step_xi + (step_xi>>3));	\
	}																							\
	else if( code_x == 3) {																		\
		step_xi = ((step_xi>>3) < (-step_s[4])) ? (step_xi + step_s[4]) : (step_xi - (step_xi>>3));	\
	}																							\
	else if( code_x == 2) {																		\
		step_xi = ((step_xi>>2) < (-step_s[5])) ? (step_xi + step_s[5]) : (step_xi - (step_xi>>2));	\
	}																							\
	else if( code_x == 1) {																		\
		step_xi = ((step_xi>>2) < (-step_s[6])) ? (step_xi + step_s[6]) : (step_xi - (step_xi>>2));	\
	}																							\
	else {																						\
		step_xi = ((step_xi>>1) < (-step_s[7])) ? (step_xi + step_s[7]) : (step_xi - (step_xi>>1));	\
	}																							\
	if( step_xi < 0 )		step_xi = 0;														\
	else if( step_xi > 63 ) step_xi = 63;														\
	step_xn = step_tab[step_xi];																\
}

BOOL CvDec686x::DecompressFrame(PBYTE pDestBuffer,PBYTE pSourceBuffer, int width, int height)
{
	int		step_yi, step_ui, step_vi;
	int		step_yn, step_un, step_vn;
	BYTE	y_est, u_est, v_est;
	
	int		i,j;
	int		out_ptr = 0;
	BYTE 	code[8];

	int		pixel_int;
	int		pdiff = 0;
	
	INIT_BUF();
	for(j=0;j<height;j++) {
		step_yi = step_ui = step_vi = 0;
		step_yn = step_un = step_vn = step_tab[0];
		y_est   = u_est   = v_est   = 0x80;
		for(i=0; i<width/4; i++) {
			m_bit_buf = ((UINT*)pSourceBuffer)[i];
			code[0]  = (BYTE)(m_bit_buf >> 28);
			code[1]  = (BYTE)(m_bit_buf >> 24) & 0x0F;
			code[2]  = (BYTE)(m_bit_buf >> 20) & 0x0F;
			code[3]  = (BYTE)(m_bit_buf >> 16) & 0x0F;
			code[4]  = (BYTE)(m_bit_buf >> 12) & 0x0F;
			code[5]  = (BYTE)(m_bit_buf >> 8) & 0x0F;
			code[6]  = (BYTE)(m_bit_buf >> 4) & 0x0F;
			code[7]  = (BYTE)m_bit_buf & 0x0F;
			
			adpcm_dec_4b_m(code[0], step_un, u_est);
			adpcm_dec_4b_m(code[1], step_yn, y_est);
			adpcm_dec_4b_m(code[2], step_vn, v_est);
			calc_step_idx_4b_m(code[0], step_ui, step_un);
			calc_step_idx_4b_m(code[1], step_yi, step_yn);
			calc_step_idx_4b_m(code[2], step_vi, step_vn);

			adpcm_dec_4b_m(code[3], step_yn, y_est);
			adpcm_dec_4b_m(code[4], step_un, u_est);
			calc_step_idx_4b_m(code[3], step_yi, step_yn);
			calc_step_idx_4b_m(code[4], step_ui, step_un);

			adpcm_dec_4b_m(code[5], step_yn, y_est);
			adpcm_dec_4b_m(code[6], step_vn, v_est);
			calc_step_idx_4b_m(code[5], step_yi, step_yn);
			calc_step_idx_4b_m(code[6], step_vi, step_vn);

			adpcm_dec_4b_m(code[7], step_yn, y_est);
			calc_step_idx_4b_m(code[7], step_yi, step_yn);
		}	// for i

		pSourceBuffer += width;

		FLUSH_BUF();
	} // for j

	return TRUE;
}

int	calc_step_idx_2b(int index_i, BYTE code)
{
	int		index_o;

	if( code & 0x1 )
		index_o = ((index_i>>3)<step_s[3]) ? (index_i+step_s[3]) : (index_i + (index_i>>3));
	// index_o = (index_i<32) ? (index_i + 4) : (index_i + index_i/8);		// ((2*index_i)<16) ? 16 : 2*index_i;
	else
		index_o = ((index_i>>3)<(-step_s[4])) ? (index_i+step_s[4]) : (index_i - (index_i>>3));
	// index_o = (index_i<16) ? (index_i - 2) : (index_i - index_i/8);
	index_o = (index_o < 0) ? 0 : (index_o > 63) ? 63 : index_o;

	return index_o;
}

int	calc_step_idx_3b(int index_i, BYTE code)
{
	int		index_o;

	switch( code ){
	case 3:
		if( (index_i/4) < step_s[2] )
			index_o = index_i + step_s[2];
		else
			index_o = index_i + index_i/4;
		break;
	case 2:
		if( (index_i/8) < step_s[3] )
			index_o = index_i + step_s[3];
		else
			index_o = index_i + index_i/8;
		break;
	case 1:
		if( (index_i/8) < (-step_s[4]) )
			index_o = index_i + step_s[4];
		else
			index_o = index_i - index_i/8;
		break;
	default:
		if( (index_i/4) < (-step_s[5]) )
			index_o = index_i + step_s[5];
		else
			index_o = index_i - index_i/4;
	}

	index_o = (index_o < 0) ? 0 : (index_o > 63) ? 63 : index_o;

	return index_o;
}

int	calc_step_idx_4b(int index_i, BYTE code)
{
	int		index_o;

	if( code == 7 ){
		if( index_i < step_s[0] )
			index_o = index_i + step_s[0];
		else
			index_o = 2*index_i;
	}
	else if( code == 6) {
		if( (index_i/2) < step_s[1]  )
			index_o = index_i + step_s[1];
		else
			index_o = index_i + index_i/2;
	}
	else if( code == 5) {
		if( (index_i/4) < step_s[2] )
			index_o = index_i + step_s[2];
		else
			index_o = index_i + index_i/4;
	}
	else if( code == 4) {
		if( (index_i/8) < step_s[3] )
			index_o = index_i + step_s[3];
		else
			index_o = index_i + index_i/8;
	}
	else if( code == 3) {
		if( (index_i/8) < (-step_s[4]) )
			index_o = index_i + step_s[4] ;
		else
			index_o = index_i - index_i/8;
	}
	else if( code == 2) {
		if( (index_i/4) < (-step_s[5]) )
			index_o = index_i + step_s[5];
		else
			index_o = index_i - index_i/4;
	}
	else if( code == 1) {
		if( (index_i/4) < (-step_s[6]) )
			index_o = index_i + step_s[6];
		else
			index_o = index_i - index_i/4;
	}
	else {
		if( (index_i/2) < (-step_s[7]) )
			index_o = index_i + step_s[7];
		else
			index_o = index_i - (index_i/2);
	}
	
	index_o = (index_o < 0) ? 0 : (index_o > 63) ? 63 : index_o;
	
	return index_o;
}


BYTE	adpcm_dec_2b(BYTE code, int step, BYTE pixel_est)
{

	BYTE	pixel_dec;
	int		pixel_int;
	int		pdiff = 0;

	if( code & 0x1 )
		pdiff = step;
		
	pdiff += (step >> 1);

	pdiff = (code & 0x2) ? -pdiff : pdiff;

	pixel_int = ((int) pixel_est) + pdiff;
	pixel_dec = (pixel_int<0) ? 0 : (pixel_int>255) ? 255 : (BYTE) pixel_int;

	return pixel_dec;
}

BYTE	adpcm_dec_3b(BYTE code, int step, BYTE pixel_est)
{

	BYTE	pixel_dec;
	int		pixel_int;
	int		pdiff = 0;

	if( code & 0x2 )
		pdiff = step;
	if( code & 0x1 )
		pdiff += (step >> 1);
	pdiff += (step >> 2);

	pdiff = (code & 0x4) ? -pdiff : pdiff;

	pixel_int = ((int) pixel_est) + pdiff;
	pixel_dec = (pixel_int<0) ? 0 : (pixel_int>255) ? 255 : (BYTE) pixel_int;

	return pixel_dec;
}

BYTE	adpcm_dec_4b(BYTE code, int step, BYTE pixel_est)
{

	BYTE	pixel_dec;
	int		pixel_int;
	int		pdiff = 0;

	if( code & 0x4 )
		pdiff = step;
	if( code & 0x2 )
		pdiff += (step >> 1);
	if( code & 0x1 )
		pdiff += (step >> 2);
	pdiff += (step >> 3);

	pdiff = (code & 0x8) ? -pdiff : pdiff;

	pixel_int = ((int) pixel_est) + pdiff;
	pixel_dec = (pixel_int<0) ? 0 : (pixel_int>255) ? 255 : (BYTE) pixel_int;

	return pixel_dec;
}

// BOOL CvDec686x::DecompressFrame(PBYTE pDestBuffer,PBYTE pSourceBuffer, int width, int height)
// {
// 	int		step_yi, step_ui, step_vi;
// 	int		step_yn, step_un, step_vn;
// 	BYTE	y_est, u_est, v_est;
// 	
// 	int		i,j;
// 	int		out_ptr = 0;
// 	int		in_ptr  = 0;
// 	BYTE 	code_0;
// 	
// 	in_ptr  = 0;
// 	out_ptr = 0;
// 	INIT_BUF();
// 	for(j=0;j<height;j++) {
// 		step_yi = step_ui = step_vi = 0;
// 		step_yn = step_un = step_vn = step_tab[0];
// 		y_est   = u_est   = v_est   = 0x80;
// 		for(i=0; i<width; i++) {
// 			if( i & 0x1 ){
// 				code_0  = read_buf(m_info.target_nbit,(UINT*)pSourceBuffer);
// 				v_est   = adpcm_dec_nb(code_0, step_vn, v_est);
// 				step_vi = calc_step_idx_nb(step_vi, (code_0 & m_info.mask));
// 				step_vn = step_tab[step_vi];
// 				pDestBuffer[out_ptr++] = v_est;
// 			}
// 			else{
// 				code_0  = read_buf(m_info.target_nbit,(UINT*)pSourceBuffer);
// 				u_est   = adpcm_dec_nb(code_0, step_un, u_est);
// 				step_ui = calc_step_idx_nb(step_ui, (code_0 & m_info.mask));
// 				step_un = step_tab[step_ui];
// 				pDestBuffer[out_ptr++] = u_est;
// 			}
// 			// FOR Y
// 			code_0 = read_buf(m_info.target_nbit,(UINT*)pSourceBuffer);
// 			y_est  = adpcm_dec_nb(code_0, step_yn, y_est);
// 			step_yi = calc_step_idx_nb(step_yi, (code_0 & m_info.mask));
// 			step_yn = step_tab[step_yi];
// 			pDestBuffer[out_ptr++] = y_est;
// 		}	// for i
// 		FLUSH_BUF();
// 	} // for j
// 	
// 	return TRUE;
// }
