//////////////////////////////////////////////////////////////////////////
//file debug.cpp
// Ϣ
//////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <windows.h>
#include <mmsystem.h>
#include "dbg.h"

#ifdef _DBG

#include <stdio.h>
#include <stdarg.h>

#ifndef _vstprintf
#if(defined(_UNICODE)||defined(UNICODE))
#define _vstprintf  vswprintf
#else
#define _vstprintf  vsprintf
#endif
#endif


//---------------------------------------------
// Ϣ
//---------------------------------------------
void __trace(LPCTSTR fmt, ...)
{
	TCHAR  out[1024];
	va_list body;
	va_start(body, fmt);
	_vstprintf(out, fmt, body);
	va_end(body);
	OutputDebugString(out);
}

//---------------------------------------------
// ļĵϢ
//---------------------------------------------
void __traced(LPCTSTR file, int line, LPCTSTR fmt, ...)
{
	TCHAR   out[1024];
	va_list body;
	va_start(body, fmt);
	_vstprintf(out, fmt, body);
	va_end(body);
	if(file && (lstrlen(file))>0) {
		wsprintf(out+lstrlen(out), TEXT(" [file]%s [line]%d\n"), file, line);
	}
	OutputDebugString(out);
}

//-----------------------------------------
// ʼ
//-----------------------------------------
void __cstart(PCount cnt, ULONG interval)
{
	if(cnt) {
		cnt->nInterval = interval;
		cnt->nCount = 0;
		cnt->tStart = timeGetTime();
	}
}

//-----------------------------------------
// 
//-----------------------------------------
void __ccount(PCount cnt, LPCTSTR fmt, ...)
{
	if(cnt) {
		ULONG tNow = timeGetTime();
		cnt->nCount++;
		if((tNow-cnt->tStart) >= cnt->nInterval) {
			TCHAR  out[1024];
			va_list body;
			va_start(body, fmt);
			vsprintf((char*)out, (char*)fmt, body);
			va_end(body);
			wsprintf(out+lstrlen(out), TEXT("[count=%d interval=%d]\n"), cnt->nCount, (tNow-cnt->tStart));
			OutputDebugString(out);

			cnt->tStart = tNow;
			cnt->nCount = 0;
		}
	}
}

//-----------------------------------------
// кźļ
//-----------------------------------------
void __ccountd(PCount cnt, LPCTSTR file, int line, LPCTSTR fmt, ...)
{
	if(cnt) {
		ULONG tNow = timeGetTime();
		cnt->nCount++;
		if((tNow-cnt->tStart) >= cnt->nInterval) {
			TCHAR  out[1024];
			va_list body;
			va_start(body, fmt);
			vsprintf((char*)out, (char*)fmt, body);
			va_end(body);
			wsprintf(out+lstrlen(out), TEXT("[count=%d interval=%d]"), cnt->nCount, (tNow-cnt->tStart));
			if(file && (lstrlen(file))>0) {
				wsprintf(out+lstrlen(out), TEXT(" [file]%s [line]%d\n"), file, line);
			}
			OutputDebugString(out);

			cnt->tStart = tNow;
			cnt->nCount = 0;
		}
	}
}

#endif