/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		dllmain.cpp
 *  @brief		DLLڵԼȫָ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "dllmain.h"
#include "TW6801.h"
#include "TW6802.h"
#include "TW6803.h"
#include "TW6864.h"
#include "TW6869.h"
#include "Dev6801.h"
#include "Dev6802.h"
#include "Dev6803.h"
#include "Dev610X.h"
#include "Dev600X.h"
#include "Dev6864.h"
#include "PlgvSource.h"
#include "PlgaSource.h"

CUtil						g_util;
vector<CTSource*>			g_source;
vector<CTSourceA*>			g_asource;
vector<CTCallback*>			g_callback;
vector<CTAssist*>			g_assist;
vector<TBoardDesc*>			g_cardList;
vector<PDeviceCapability>	g_capsListV;
vector<PDeviceCapability>	g_capsListA;

TSafeSampleList				g_cbkList;		//ص
TSafeSampleList				g_cbkListA;		//Ƶص
vector<CChipset*>			g_chpListV;		//ƵоƬб
vector<CChipset*>			g_chpListA;		//ƵоƬб
vector<CDevBase*>			g_devListV;		//Ƶ豸б
vector<CDevBase*>			g_devListA;		//Ƶ豸б
vector<CChannel*>			g_chlList;		//ͨб(ƵƵ)
CSafeVector<CSample*>		g_bufPlgA;		//Ƶplugin data
CSafeVector<CSample*>		g_bufPlgV;		//Ƶplugin data
ULONG						g_uLastError= TWERR_SUCCESS;
HANDLE						g_hSelfDll	= NULL;	//̬

#ifdef _DBG
long g_dbgIsPrintFrameRate = 0;
_cObjs(g_dbgFrameRate, 48);
#endif

typedef struct tagDeviceInfoEx {
	TDeviceDesc devInfo;
	HANDLE		hDevice;
}TDeviceInfoEx, *PDeviceInfoEx;
typedef struct tagDeviceFunction {
	int			  iFunction;
	TDeviceInfoEx devInfoEx;
}TDeviceFunction, *PDeviceFunction;
typedef struct tagDeviceNumber {
	int			  iNumber;
	vector<PDeviceFunction> funcList;
}TDeviceNumber, *PDeviceNumber;
typedef struct tagBusInfo {
	int			  iBus;
	vector<PDeviceNumber> devList;
}TBusInfo, *PBusInfo;
typedef struct tagSlotInfo {
	int			  iSlot;
	int			  iDeviceNum;
	vector<PBusInfo> busList;
}TSlotInfo, *PSlotInfo;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		g_hSelfDll = hModule;
		//CoInitialize(NULL);
#ifdef _DBG
		{
			for(int i=0; i<48; i++) {
				__cstart(_cParam(&g_dbgFrameRate[i]) 1000);
			}
		}
#endif
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		//CoUninitialize();
		break;
	}
	return TRUE;
}

/** 
 ***************************************************************************************
 *  ȡп
 ***************************************************************************************
 */
BOOL GClassifyCards() 
{
	GUID vGuid = TW68XXDevice_CLASS_GUID;
	CChipset*	  dev;
	ULONG		  i=0, j=0, k=0, m=0;
	vector<PSlotInfo> slotList;
	TDeviceInfoEx exInfo;
	PDeviceFunction df;
	PDeviceNumber	dn;
	PBusInfo		bi;
	PSlotInfo		si;
	TBoardDesc	  cardDesc;
	TBoardDesc*	  cardInfo = NULL;
	TBridgeDesc	  brgInfo;
	PBridgeDesc	  pBrg = NULL;
	LONG		  iBoard = 0;
	ULONG		  hwid = 0;

	i = 0;
	do {
		//ʵ
		ZeroMemory(&cardDesc, sizeof(TBoardDesc));
		exInfo.hDevice = g_util.OpenByInterface(&vGuid, i, &exInfo.devInfo, &cardDesc);
		if(exInfo.hDevice == INVALID_HANDLE_VALUE) {
			break;
		}
		si = NULL;
		bi = NULL;
		dn = NULL;
		df = NULL;
		for(j=0; j<slotList.size(); j++) {
			if(cardDesc.nSlot == slotList[j]->iSlot) {
				si = slotList[j];
				break;
			}
		}
		if(si == NULL) {
			si = new TSlotInfo;
			si->iDeviceNum = 0;
			si->iSlot = cardDesc.nSlot;
			for(j=0; j<slotList.size(); j++) {
				if(si->iSlot < slotList[j]->iSlot) {
					slotList.insert(slotList.begin()+j, si);
					break;
				}
			}
			if(j >= slotList.size()) {
				slotList.push_back(si);
			}
		}
		for(j=0; j<si->busList.size(); j++) {
			if(exInfo.devInfo.nBus == si->busList[j]->iBus) {
				bi = si->busList[j];
				break;
			}
		}
		if(bi == NULL) {
			bi = new TBusInfo;
			bi->iBus = exInfo.devInfo.nBus;
			for(j=0; j<si->busList.size(); j++) {
				if(bi->iBus < si->busList[j]->iBus) {
					si->busList.insert(si->busList.begin()+j, bi);
					break;
				}
			}
			if(j >= si->busList.size()) {
				si->busList.push_back(bi);
			}
		}
		for(j=0; j<bi->devList.size(); j++) {
			if(exInfo.devInfo.DeviceNumber == bi->devList[j]->iNumber) {
				dn = bi->devList[j];
				break;
			}
		}
		if(dn == NULL) {
			dn = new TDeviceNumber;
			dn->iNumber = exInfo.devInfo.DeviceNumber;
			for(j=0; j<bi->devList.size(); j++) {
				if(dn->iNumber < bi->devList[j]->iNumber) {
					bi->devList.insert(bi->devList.begin()+j, dn);
					break;
				}
			}
			if(j >= bi->devList.size()) {
				bi->devList.push_back(dn);
			}
		}
		for(j=0; j<dn->funcList.size(); j++) {
			if(exInfo.devInfo.Function == dn->funcList[j]->iFunction) {
				df = dn->funcList[j];
				break;
			}
		}
		if(df == NULL) {
			df = new TDeviceFunction;
			df->iFunction = exInfo.devInfo.Function;
			df->devInfoEx = exInfo;
			for(j=0; j<dn->funcList.size(); j++) {
				if(df->iFunction < dn->funcList[j]->iFunction) {
					dn->funcList.insert(dn->funcList.begin()+j, df);
					break;
				}
			}
			if(j >= dn->funcList.size()) {
				dn->funcList.push_back(df);
			}
		}
		hwid = DEVICEID(exInfo.devInfo.HardwareId);
		if((hwid>=0x6810) && (hwid<0x6814)) {
			si->iDeviceNum++;
		}
		else if(exInfo.devInfo.Function==0) {
			si->iDeviceNum++;
		}
		i++;
	}while(TRUE);

	for(i=0; i<slotList.size(); i++) {
		si = slotList[i];
		cardInfo = new TBoardDesc;
		ZeroMemory(cardInfo, sizeof(TBoardDesc));
		cardInfo->nSlot = si->iSlot;
		cardInfo->nDeviceCount = si->iDeviceNum;
		cardInfo->nFirstDevice = (int)g_chpListV.size();
		cardInfo->nBoardId	   = (int)g_cardList.size();
		g_cardList.push_back(cardInfo);
		for(m=0; m<si->busList.size(); m++) {
			bi = si->busList[m];
			for(j=0; j<bi->devList.size(); j++) {
				dn = bi->devList[j];
				for(k=0; k<dn->funcList.size(); k++) {
					df = dn->funcList[k];
					dev = NULL;
					df->devInfoEx.devInfo.nBoardId = cardInfo->nBoardId;
					switch(DEVICEID(df->devInfoEx.devInfo.HardwareId))
					{
					case 0x6801: 
					case 0x6804: 
					case 0x6810:
					case 0x6811:
					case 0x6812:
					case 0x6813:
						df->devInfoEx.devInfo.nDeviceId = (int)g_chpListV.size();
						dev = new CTW6801();
						if(dev && dev->Open(df->devInfoEx.hDevice, cardInfo, df->devInfoEx.devInfo)) {
							df->devInfoEx.hDevice = NULL;
							g_chpListV.push_back(dev);
						}
						else if(dev) {
							dev->Close();
							delete dev;
						}
						break;
					case 0x6802:
					case 0x6805:
					case 0x6814:
					case 0x6815:
					case 0x6816:
					case 0x6817:
						df->devInfoEx.devInfo.nDeviceId = (int)g_chpListA.size();
						dev = new CTW6802();
						if(dev && dev->Open(df->devInfoEx.hDevice, cardInfo, df->devInfoEx.devInfo)) {
							df->devInfoEx.hDevice = NULL;
							g_chpListA.push_back(dev);
						}
						else if(dev) {
							dev->Close();
							delete dev;
						}
						break;
					case 0x6803: 
					case 0x6806: 
						df->devInfoEx.devInfo.nDeviceId = (int)g_chpListV.size();
						dev = new CTW6803();
						if(dev && dev->Open(df->devInfoEx.hDevice, cardInfo, df->devInfoEx.devInfo)) {
							df->devInfoEx.hDevice = NULL;
							g_chpListV.push_back(dev);
						}
						else if(dev) {
							dev->Close();
							delete dev;
						}
						break;
					case 0x6864:
						df->devInfoEx.devInfo.nDeviceId = (int)g_chpListV.size();
						dev = new CTW6864();
						if(dev && dev->Open(df->devInfoEx.hDevice, cardInfo, df->devInfoEx.devInfo)) {
							df->devInfoEx.hDevice = NULL;
							g_chpListV.push_back(dev);
						}
						else if(dev) {
							dev->Close();
							delete dev;
						}
						break;
					case 0x6869:
						df->devInfoEx.devInfo.nDeviceId = (int)g_chpListV.size();
						dev = new CTW6869();
						if(dev && dev->Open(df->devInfoEx.hDevice, cardInfo, df->devInfoEx.devInfo)) {
							df->devInfoEx.hDevice = NULL;
							g_chpListV.push_back(dev);
						}
						else if(dev) {
							dev->Close();
							delete dev;
						}
						break;
					default:
						break;
					}
				}
			}
		}

		OSVERSIONINFO osvi;
		BOOL bWin2k = FALSE;
		ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
		osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		if(GetVersionEx(&osvi))
		{
			if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
			{
				bWin2k = (osvi.dwMajorVersion==5) && (osvi.dwMinorVersion==0);
			}
		}
		if(bWin2k)
		{
		}
		else

		//windows 2000֧²ϵͳ
		if(cardInfo->nFirstDevice < (int)g_chpListV.size()) {
			//ҵƬ
			ZeroMemory(&brgInfo, sizeof(TBridgeDesc));
			dev = g_chpListV[cardInfo->nFirstDevice];
			if(dev->FindBridge(&brgInfo)) {
				pBrg = new TBridgeDesc;
				memcpy(pBrg, &brgInfo, sizeof(brgInfo));
				cardInfo->reserved1 = (ULONG)pBrg;
				if(dev->ReadPciConfigSpaceEx(0x0C, 2, (PBYTE)&m)) {
					if((m&0xFF)<0x08) {
						m &= ~0xFF;
						m |= 0x08;
					}
					if((m>>8)<0x20) {
						m &= ~0xFF00;
						m |= 0x2000;
					}
					dev->WritePciConfigSpaceEx(0x0C, 2, (PBYTE)&m);
				}
			}
		}
	}

	while(slotList.size() > 0) {
		si = slotList.back();
		while(si->busList.size() > 0) {
			bi = si->busList.back();
			while(bi->devList.size() > 0) {
				dn = bi->devList.back();
				while(dn->funcList.size() > 0) {
					delete dn->funcList.back();
					dn->funcList.pop_back();
				}
				bi->devList.pop_back();
				delete dn;
			}
			si->busList.pop_back();
			delete bi;
		}
		slotList.pop_back();
		delete si;
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  豸Ϣ豸ʵ
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL GCreateDevices()
{
	UINT  i = 0;
	CChipset*	chp = NULL;
	
	for(i=0; i<g_chpListV.size(); i++) {
		//豸Ϣ豸
		chp = g_chpListV[i];
		if(!chp->CreateDevices()) {
			_trace(TEXT("[Ϣ]GCreateDevices-豸ʧ(slot %d%d豸%d)\n"), 
				chp->CardInfo()->nSlot, chp->DeviceInfo().Function, chp->DeviceInfo().DeviceNumber);
			return FALSE;
		}
	}
	
	for(i=0; i<g_chpListA.size(); i++) {
		chp = g_chpListA[i];
		if(!chp->CreateDevices()) {
			_trace(TEXT("[Ϣ]GCreateDevices-豸ʧ(slot %d%d豸%d)\n"), 
				chp->CardInfo()->nSlot, chp->DeviceInfo().Function, chp->DeviceInfo().DeviceNumber);
		}
	}

	return TRUE;
}

/** 
 ***************************************************************************************
 *  Ҫͨ˳
 *
 *  @return ɹTRUE򷵻FALSE
 ***************************************************************************************
 */
BOOL GOrderChannels()
{
	CChipset*	 chp = NULL;
	TDeviceDesc  devInfo;
	TBoardDesc*	 cardInfo;
	int			 j, k, nCount=0, nFirstDevice=0, nFirstChannel, nChannels;
	ULONG		 i;
	ULONG		 hwid = 0;

	for(i=0; i<g_cardList.size(); i++) {
		cardInfo = g_cardList[i];
		chp = g_chpListV[cardInfo->nFirstDevice];
		devInfo = chp->DeviceInfo();
		hwid = DEVICEID(devInfo.HardwareId);
		if((hwid<0x6810) || (hwid>=0x6814)) { continue; }
		if(cardInfo->nDeviceCount > 8) { continue; }		//16·ʵʱҪ

		for(j=0; j<cardInfo->nDeviceCount/4; j++) {
			nFirstDevice = cardInfo->nFirstDevice + j*4;
			chp = g_chpListV[nFirstDevice];
			devInfo = chp->DeviceInfo();
			nFirstChannel = g_capsListV[devInfo.nFirstSubDevice]->ddesc.nFirstChannel;
			nChannels = 0;
			for(k=nFirstDevice; k<nFirstDevice+4; k++) {
				chp = g_chpListV[k];
				devInfo = chp->DeviceInfo();
				nChannels += g_capsListV[devInfo.nFirstSubDevice]->ddesc.nChannels;
			}
			if(nChannels <= 4) { continue; }	//ʵʱ
			for(k=nFirstChannel; k<nFirstChannel+nChannels; k++) {
				nCount = k - nFirstChannel;
				if(nCount % 2) {
					nCount = nFirstChannel + 4 + (nCount-1)/2;
				}
				else {
					nCount = nFirstChannel + nCount/2;
				}
				g_chlList[k]->Init(nCount);
			}
		}
	}

	return TRUE;
}