/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		dllmain.h
 *  @brief		DLLڵԼȫֱ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#pragma once

#ifndef __DLLMAIN_H_
#define __DLLMAIN_H_

#include <winioctl.h>

#include "TWSDK.h"
#include "util.h"
#include "SafeVector.h"
#include "TW68XXioctl.h"
#include "TSource.h"
#include "TSourceA.h"
#include "TAssist.h"
#include "Plugin.h"
#include "TCallback.h"
#include "Chipset.h"
#include "DevBase.h"
#include "Sample.h"
#include "Channel.h"
#include "dbg.h"

#define SAFE_CLOSE_HANDLE(h)  {if((h) && (h)!=(HANDLE)-1) {CloseHandle(h);h=NULL;}}
#define SAFE_DELETEOBJECT(h)  {if(h) {DeleteObject(h);h=NULL;}}
#define SAFE_RELEASEDC(hw, h) {if(h) {ReleaseDC(hw,h);h=NULL;}}
#define SAFE_DELETEDC(h)	  {if(h) {DeleteDC(h);h=NULL;}}
#define SAFE_DELETE(h)		  {if(h) {delete h; h=NULL;}}
#define SAFE_DELETE_ARRAY(h)  {if(h) {delete[] h; h=NULL;}}

#define RAWV_LEN			0x66000	//720x288x2		//0xD8000		//768x576x2
#define RAWV_LEN_4CIF		0xD8000	//768x576x2
#define RAWA_LEN			(RAWA_NUM*AUDIO_LINE_NUM*AUDIO_PAGE_LEN)//RAWA_NUM * 8*4096	
#define PLGA_LEN			AUDIO_PAGE_LEN
#define MAX_RETRY			2
#define AUDIO_PAGE_LEN		4096
#define AUDIO_LINE_LEN		1000
#define AUDIO_LINE_NUM		1
#define	AUDIO_PACKET_LEN	(AUDIO_LINE_LEN*AUDIO_LINE_NUM)
#define SAMPLE_RATE			8000

#define RAWV_NUM			2
#define RAWA_NUM			4

#define SOURCE_THREAD_NUM	1		//CTSource߳
#define SOURCEA_THREAD_NUM	1		//CTSourceA߳
#define CALLBACK_THREAD_NUM	1		//CTCallback߳
#define ASSIST_THREAD_NUM	1		//CTAssist߳

#define NOSIGNAL_CHECK		5		//һо·ɼʱƵźͨźżƵ
#define MAX_610X_SWITCH		4		//лͨ
#define MAX_FRAMERATE(standard)		((standard)==vsStandardNTSC ? 30 : 25)
#define MAX_FIELD_HEIGHT(standard)	((standard)==vsStandardNTSC ? 240 : 288)
#define IS_PAL(standard)			((standard)==vsStandardPAL)
#define IS_PLANAR(pixfmt)			((pixfmt)==vpfYUV420Planar || (pixfmt)==vpfYUV411Planar)
#define IS_4CIF(vinfo)				((vinfo).capture.height>MAX_FIELD_HEIGHT((vinfo).standard))
#define INIT_IRQINFO(irq)			{memset((irq).irqInfo.regRead, 0xFF, sizeof(ULONG)*MAX_RW_NUM);		\
									 memset((irq).irqInfo.regWrite,0xFF, sizeof(ULONG)*MAX_RW_NUM);		\
									 memset((irq).irqInfo.mskWrite,0xFF, sizeof(ULONG)*MAX_RW_NUM);		\
									 memset((irq).irqInfo.mask,0, sizeof(ULONG)*MAX_INTSTATUS);			\
									 memset((irq).irqInfo.regMask,0xFF, sizeof(ULONG)*MAX_INTSTATUS);	\
									 memset((irq).irqInfo.regStatus,0xFF, sizeof(ULONG)*MAX_INTSTATUS);	\
									 memset((irq).irqInfo.regClear,0xFF, sizeof(ULONG)*MAX_INTSTATUS);	\
									 (irq).deviceId= 0; (irq).irqInfo.freqWrite=0;						\
									 (irq).irqInfo.timerId = (ULONG)-1; (irq).irqInfo.mskCopy = 0;		\
									 (irq).irqInfo.regI2C  = 0; (irq).irqInfo.devCopy = 0;				\
									 }										
#define INIT_TIMERINFO(tmi)			{memset((tmi).tmiInfo.regRead, 0xFF, sizeof(ULONG)*MAX_RW_TIMER);	\
									 memset((tmi).tmiInfo.regWrite,0xFF, sizeof(ULONG)*MAX_RW_TIMER);	\
									 memset((tmi).tmiInfo.mskWrite,0xFF, sizeof(ULONG)*MAX_RW_TIMER);	\
									 (tmi).timerId = (ULONG)-1; (tmi).deviceId= 0;						\
									 (tmi).tmiInfo.dueTime=(LONGLONG)-1;}
#define BIT(x)				(1<<(x))

//ӿȵֵķΧ
#define B_MAX	255
#define B_MIN	0
#define C_MAX	127
#define C_MIN	0
#define S_MAX	127
#define S_MIN	0
#define H_MAX	255
#define H_MIN	0
#define SH_MAX	15
#define SH_MIN	0

typedef enum { VF_Even=1, VF_Odd, VF_Both } TVideoField;

//(sample״̬)
typedef enum {
	PLG_none		= 0x00000000,
	PLG_vsource		= (PLG_none			+  1),		//0x00000001
	PLG_vdecom		= (PLG_vsource		<< 1),		//0x00000002

	PLG_vmotion		= (PLG_vdecom		<< 1),		//0x00000004
	PLG_vdeinterlace= (PLG_vmotion		<< 1),		//0x00000008
	PLG_vdenoise	= (PLG_vdeinterlace << 1),		//0x00000010
	PLG_vmask		= (PLG_vdenoise		<< 1),		//0x00000020
	PLG_vlogo		= (PLG_vmask		<< 1),		//0x00000040
	PLG_vosd		= (PLG_vlogo		<< 1),		//0x00000080
	PLG_vsnap		= (PLG_vosd			<< 1),		//0x00000100
	PLG_vrender		= (PLG_vsnap		<< 1),		//0x00000200
	PLG_vcompression= (PLG_vrender		<< 1),		//0x00000400
	PLG_vcompresssub= (PLG_vcompression	<< 1),		//0x00000800
	PLG_vend		= (PLG_vcompresssub),
	
	PLG_asource		= (PLG_vend			<< 1),		//0x00001000
	PLG_acompression= (PLG_asource		<< 1),		//0x00002000
	PLG_aend		= (PLG_acompression),
	
	PLG_file		= (PLG_aend			<< 1),		//0x00004000
	PLG_filesub		= (PLG_file			<< 1),		//0x00008000
	
	//ռһλ
	PLG_end			= (PLG_filesub		<< 1),		//0x00010000
	
	//ûʵĲ
	PLG_vrawcbk		= (PLG_end			<< 1),		//0x00020000
	PLG_arawcbk		= (PLG_vrawcbk		<< 1),		//0x00040000

	PLG_vmotioncbk	= (PLG_arawcbk		<< 1),		//0x00080000
	PLG_vplgcbk		= (PLG_vmotioncbk	<< 1),		//0x00100000
	PLG_venccbk		= (PLG_vplgcbk		<< 1),		//0x00200000
	PLG_venccbksub	= (PLG_venccbk		<< 1),		//0x00400000
	PLG_aplgcbk		= (PLG_venccbksub	<< 1),		//0x00800000
	PLG_aenccbk		= (PLG_aplgcbk		<< 1),		//0x01000000
	PLG_arender		= (PLG_aenccbk		<< 1),		//0x02000000
	PLG_vcapture	= (PLG_arender		<< 1),		//0x04000000
	PLG_acapture	= (PLG_vcapture		<< 1),		//0x08000000
	
	//豸״̬
	PLG_RunVideoDevice	  = PLG_vrawcbk|PLG_vcapture,
	PLG_RunAudioDevice	  = PLG_arawcbk|PLG_acapture,

	PLG_vsink		= (PLG_vrender|PLG_vmotion|PLG_vplgcbk|PLG_vcompression),
	PLG_asink		= (PLG_arender|PLG_aplgcbk),
	
	PLG_video		= (PLG_vmotion|PLG_vdeinterlace|PLG_vdenoise|PLG_vmask|
					   PLG_vlogo|PLG_vosd|PLG_vrender|PLG_vcompression|PLG_vsnap|
					   PLG_vmotioncbk|PLG_vplgcbk|PLG_venccbk),
	PLG_audio		= (PLG_acompression|PLG_aplgcbk|PLG_aenccbk|PLG_arender),
		 
	//ʵ
	PLG_virtual		= (PLG_vmotioncbk|PLG_vrawcbk|PLG_vplgcbk|PLG_venccbk|PLG_venccbksub|PLG_aenccbk|PLG_arawcbk|PLG_aplgcbk|PLG_vcapture|PLG_acapture),
}TPluginType;

typedef enum {
	pktVideo,
	pktAudio,
	pktField2,
}TPacketType;

enum {frame_invalid, frame_capture, frame_preview, frame_both};

typedef CSafeList<CSample*> TSafeSampleList;

extern CUtil					g_util;
extern vector<CTSource*>		g_source;
extern vector<CTSourceA*>		g_asource;
extern vector<CTCallback*>		g_callback;
extern vector<CTAssist*>		g_assist;
extern vector<TBoardDesc*>		g_cardList;
extern vector<PDeviceCapability>g_capsListV;
extern vector<PDeviceCapability>g_capsListA;

extern TSafeSampleList			g_cbkList;		//Ƶص
extern TSafeSampleList			g_cbkListA;		//Ƶص
extern vector<CChipset*>		g_chpListV;		//ƵоƬб
extern vector<CChipset*>		g_chpListA;		//ƵоƬб
extern vector<CDevBase*>		g_devListV;		//Ƶ豸б
extern vector<CDevBase*>		g_devListA;		//Ƶ豸б
extern vector<CChannel*>		g_chlList;		//Ƶͨб
extern CSafeVector<CSample*>	g_bufPlgA;		//Ƶplugin data
extern CSafeVector<CSample*>	g_bufPlgV;		//Ƶplugin data
extern ULONG					g_uLastError;
extern HANDLE					g_hSelfDll;		//̬

#if(defined(_DBG))
extern long g_dbgIsPrintFrameRate;
extern _cObjs(g_dbgFrameRate, 48);
#endif

BOOL GClassifyCards();
BOOL GCreateDevices();
BOOL GOrderChannels();
BOOL GAppendAudioToChannel(CChannel* chl, CDevBase* adev);

#endif