/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		vDec686x.h
 *  @brief		Vcom decCvDec686x֧TW686X Vcom data
 *
 *  @version	0.0.0.1
 *  @author		Carl
 *  @date		2009/11/16
 ***************************************************************************************
 */

#ifndef __VDEC686X_H__
#define __VDEC686X_H__

#include "Plugin.h"

#define		TARGET_2BIT 2
#define		TARGET_3BIT	3
#define		TARGET_4BIT	4

#define		SWAPHILOW(x) ((((x)&0xFFFF)<<16) | (((x)>>16)&0xFFFF))

typedef		BYTE (*func_dec) (BYTE code, int step, BYTE pixel_est);
typedef		int  (*func_step)(int index_i, BYTE code);

struct tagvDec686xInfo : public TPluginInfo {
	BYTE		target_nbit;
	BYTE		mask;
};
typedef struct tagvDec686xInfo TvDec686xInfo, *PvDec686xInfo;

class CvDec686x : public CPlugin
{
protected:
	BYTE		m_bit_pos;
	UINT		m_bit_buf, m_buf_pos;

	TvDec686xInfo m_info;

public:
	CvDec686x();
	virtual ~CvDec686x();

	virtual ULONG	PluginId(){return PLG_vdecom;}
	virtual PPluginInfo GetPluginInfo(){ return &m_info; }
	virtual BOOL	SetPluginInfo(PPluginInfo plgInfo, ULONGLONG flag) { m_info=*(PvDec686xInfo)plgInfo; return TRUE; }
	virtual BOOL	Transmit(CSample* pSampleIn, CSample* pSampleOut);

	void		INIT_BUF();
	void		FLUSH_BUF();
	BYTE		read_buf(BYTE nbit,UINT* code_b);
	void		SetTargetBit(BYTE nBit);
	BYTE   		GetTargetBit() { return m_info.target_nbit; }

	BOOL		DecompressFrame(PBYTE pDestBuffer,PBYTE pSourceBuffer, int width, int height);

	func_dec	adpcm_dec_nb;
	func_step	calc_step_idx_nb;
};

#endif //__VDEC686X_H__
