//////////////////////////////////////////////////////////////////////
// vDecoder.h: interface for the CvDecoder class.
// for external video decoder
// Jack, 2008-12-24
//////////////////////////////////////////////////////////////////////

#if !defined(__VDECODER_H_)
#define __VDECODER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CvDecoder  
{
public:
	CvDecoder() {}
	virtual ~CvDecoder() {}

	virtual void InitDecoder() = 0;
	virtual void UninitDecoder() = 0;
	virtual void SetStandard(int value, int ch=0) = 0;
	virtual void SetMux(TVideoInput vInput, int ch=0) = 0;
	virtual void SetFormat(int value, int ch=0) = 0;
	virtual void SetSize(int width, int height, int ch=0) = 0;
	virtual void SetBright(int value, int ch=0) = 0;
	virtual void SetContrast(int value, int ch=0) = 0;
	virtual void SetHue(int value, int ch=0) = 0;
	virtual void SetSaturation(int value, int ch=0) = 0;
	virtual void SetSharpness(int value, int ch=0) = 0;
	virtual BOOL GetSignal(int ch=0) = 0;

protected:
	virtual UCHAR  inb(ULONG Offset) = 0;
	virtual VOID   outb(ULONG Offset, UCHAR data) = 0;
	
	virtual USHORT inw(ULONG Offset) = 0;
	virtual VOID   outw(ULONG Offset, USHORT data) = 0;
	
	virtual ULONG  ind(ULONG Offset) = 0;
	virtual VOID   outd(ULONG Offset, ULONG data) = 0;
};

#endif // !defined(__VDECODER_H_)
